#include maps\mp\_utility;

loadAdmin()
{ 
   if(getdvar("bro_match") == "0")
   {
      self setclientdvars("ui_admin_defenders",0);
      self setclientdvars("ui_admin_matchtext","Enable Match Mode");
   }
   else
   {
      if(game["isMatch"] && game["preMatch"] && getdvar("g_gametype") == "sd")
         self setclientdvars("ui_admin_defenders",1);
      else
         self setclientdvars("ui_admin_defenders",0);
      
      self setclientdvars("ui_admin_matchtext","Disable Match Mode");
   } 
}

setAdminSpectate()
{
   if(!game["isMatch"] && level.admin_spectate)
   {
      self allowSpectateTeam("allies", true );
      self allowSpectateTeam( "axis", true );
      self allowSpectateTeam( "freelook", true );
      self allowSpectateTeam( "none", true );
   }
}

loadTeamIcons()
{
   self endon("disconnect");
   
   self setclientdvars("ui_admin_next",0);
   self setclientdvars("ui_admin_previous",0);
   
   fullpage = true;
   
   for(i=1 + self.pers["admin_teamicons_offset"]; i <= self.pers["admin_teamicons_offset"] + 20 ; i++)
   {
      if(!isdefined(level.clanIconText[i]))
      {
         fullpage = false;
         self setclientdvars("ui_admin_teamicon" + (i - self.pers["admin_teamicons_offset"]),"");
         self setclientdvars("ui_admin_teamname" + (i - self.pers["admin_teamicons_offset"]),"");
      }
      else
      {   
         self setclientdvars("ui_admin_teamicon" + (i - self.pers["admin_teamicons_offset"]),level.clanIcons[level.clanIconTag[i]]);
         self setclientdvars("ui_admin_teamname" + (i - self.pers["admin_teamicons_offset"]),level.clanIconText[i]);
      }
      wait 0.05;
   }
   
   if(fullpage)
      self setclientdvars("ui_admin_next",1);
   
   if(self.pers["admin_teamicons_offset"] >=20) 
      self setclientdvars("ui_admin_previous",1);
}

savePickedIcon(response)
{
   setdvar("admin_pickedicon",GetSubStr( response, 18 ));
   setdvar("admin_pickedicon_offset",self.pers["admin_teamicons_offset"]);
}

setIcon(team)
{
   if(getdvar("admin_pickedicon") == "")
      return;
      
   if(getdvar("admin_pickedicon_offset")== "")
      return;
   
   dvarVal = getdvarint("admin_pickedicon") + getdvarint("admin_pickedicon_offset");
   
   if(!isdefined(level.clanIconTag[dvarVal]))
      return;

   if(team == "allies")
      setdvar("bro_clanIcon_" + game["allies"],level.clanIconTag[dvarVal]);
   else
      setdvar("bro_clanIcon_" + game["axis"],level.clanIconTag[dvarVal]);
   
}

fastRestart()
{
   if(isdefined(game["fastrestarting"]))
      return;
      
   game["fastrestarting"] = true;
   level notify ("comp_map_restarting");
    
   iprintlnbold(&"MSBRM_ADMIN_MAPRESTARTING");
   wait 1;
   level notify ("comp_map_restarting");
   
   logprint("ADMIN ACTION: " + self.name + " fast restarted the map\n");
   
   if(!(game["state"] == "postgame") && !level.gameEnded )
   {
      wait 5;
   }
   game["fastrestarting"] = undefined;
   
   if(game["preMatch"] == false && game["isMatch"] == true)
      game["preMatch"] = true;
      
   maps\mp\gametypes\_competition::resetParams(true,true);         
   map_restart(true);
}

loadPlayerList()
{
   self endon("disconnect");
   
   self setclientdvars("ui_admin_next",0);
   self setclientdvars("ui_admin_previous",0);
   
   fullpage = true;
   self.pers["admin_playerlist_keys"] = [];
 //  loadarray = getSortedPlayers();
 
   loadarray = level.players;
   
   alliedIcon = getdvar("g_TeamIcon_Allies");
   axisIcon = getdvar("g_TeamIcon_Axis");
  
   
   for(i=0 + self.pers["admin_playerlist_offset"]; i < self.pers["admin_playerlist_offset"] + 20 ; i++)
   {
      if(!isdefined(loadarray[i]))
      {
         fullpage = false;
         self.pers["admin_playerlist_keys"][i] = undefined;
         self setclientdvars("ui_admin_playername" + (i - self.pers["admin_playerlist_offset"] + 1),"",
                              "ui_admin_playericon" + (i - self.pers["admin_playerlist_offset"] + 1),"");         
      }
      else
      {   
         self.pers["admin_playerlist_keys"][i] = loadarray[i];
          if(isdefined(loadarray[i].isConnectingToServer) && loadarray[i].isConnectingToServer == true)
          {
            self setclientdvars("ui_admin_playericon" + (i - self.pers["admin_playerlist_offset"] + 1),"hud_status_connecting");
            self setclientdvars("ui_admin_playername" + (i - self.pers["admin_playerlist_offset"] + 1),loadarray[i].name + " ^3Connecting...");
            wait 0.05;
            continue;
          }
                  
          //  self setclientdvars("ui_admin_playername" + (i - self.pers["admin_playerlist_offset"] + 1),loadarray[i].name);
            
            if(loadarray[i].pers["team"] == "allies")
            {
               self setclientdvars("ui_admin_playericon" + (i - self.pers["admin_playerlist_offset"] + 1),alliedIcon);
               self setclientdvars("ui_admin_playername" + (i - self.pers["admin_playerlist_offset"] + 1),loadarray[i].name);
            }
            else if(loadarray[i].pers["team"] == "axis")
            {
               self setclientdvars("ui_admin_playericon" + (i - self.pers["admin_playerlist_offset"] + 1),axisIcon);
               self setclientdvars("ui_admin_playername" + (i - self.pers["admin_playerlist_offset"] + 1),loadarray[i].name);
            }
            else
            {
               self setclientdvars("ui_admin_playericon" + (i - self.pers["admin_playerlist_offset"] + 1),""); 
               self setclientdvars("ui_admin_playername" + (i - self.pers["admin_playerlist_offset"] + 1),loadarray[i].name + "  ^2(spectating)");
            }
         
      }
      wait 0.05;
   }
      
   
   if(fullpage && isdefined(loadarray[i+1]))
      self setclientdvars("ui_admin_next",1);
   
   if(self.pers["admin_playerlist_offset"] >=20) 
      self setclientdvars("ui_admin_previous",1);
}

savePickedPlayer(response)
{
   self.pers["admin_pickedplayer"] = self.pers["admin_playerlist_keys"][int(GetSubStr( response, 20 )) - 1 + self.pers["admin_playerlist_offset"]];
   target = self.pers["admin_pickedplayer"];
   
 //  iprintln("picked player: " + target.name + " num: #" + (int(GetSubStr( response, 20 )) - 1));
   
   if(!isdefined(target.pers["team"]))
   {
      return;
   }
   
   if(game["isMatch"] && !game["preMatch"])
   {
      self setclientdvars("ui_admin_switchplayer_spec",0,
                           "ui_admin_switchplayer_allies",0,
                           "ui_admin_switchplayer_axis",0);
   }
   else if(target.pers["team"] == "spectator")
   {
      self setclientdvars("ui_admin_switchplayer_spec",0,
                           "ui_admin_switchplayer_allies",0,
                           "ui_admin_switchplayer_axis",0);
   }
   else if(target.pers["team"] == "allies")
   {
      self setclientdvars("ui_admin_switchplayer_spec",1,
                           "ui_admin_switchplayer_allies",0,
                           "ui_admin_switchplayer_axis",1);
   }
   else if(target.pers["team"] == "axis")
   {
      self setclientdvars("ui_admin_switchplayer_spec",1,
                           "ui_admin_switchplayer_allies",1,
                           "ui_admin_switchplayer_axis",0);
   }

 //  iprintln("Picked: # " + (self.pers["admin_playerlist_keys"][self.pers["admin_pickedplayer_id"]] getentitynumber())  + " Name: " + self.pers["admin_playerlist_keys"][self.pers["admin_pickedplayer_id"]].name);
 //  iprintln("Picked: # " + (self.pers["admin_playerlist_keys"][1] getentitynumber())  + " Name: " + self.pers["admin_playerlist_keys"][1].name);
}

switchPlayerTeam(response)
{
   if(isdefined(self.pers["admin_pickedplayer"]) && isdefined(self.pers["admin_pickedplayer"].pers["team"]))
      target = self.pers["admin_pickedplayer"];
   else
      return;
            
   if(response == "admin_player_switchteam_allies" && target.pers["team"] == "axis")
   {
      iprintln(&"MSBRM_ADMIN_PLAYER_SWITCH_ALLIES",target,self); // let everyone know about it
      logprint("ADMIN ACTION: " + self.name + " switched " + target.name + " to the allied team\n");
      target thread maps\mp\gametypes\_weaponlimiter::setWeaponUIPlayer();
		target [[level.leavesquad]]();
		target [[level.allies]]();
   }
   else if(response == "admin_player_switchteam_axis" && target.pers["team"] == "allies")
   {
      iprintln(&"MSBRM_ADMIN_PLAYER_SWITCH_AXIS",target,self); // let everyone know about it
      logprint("ADMIN ACTION: " + self.name + " switched " + target.name + " to the axis team\n");
      target thread maps\mp\gametypes\_weaponlimiter::setWeaponUIPlayer();
		target [[level.leavesquad]]();
		target [[level.axis]]();
   }
   else if(response == "admin_player_switchteam_spec" && target.pers["team"] != "spectator")
   {
      iprintln(&"MSBRM_ADMIN_PLAYER_SWITCH_SPEC",target,self); // let everyone know about it
      logprint("ADMIN ACTION: " + self.name + " switched " + target.name + " to spectate\n");
      target [[level.leavesquad]]();
      target [[level.spectator]]();
	}  
}

kickPlayer()
{
   wait 2;
   
   if(!isdefined(self.pers["admin_pickedplayer"])) // do we have a valid picked player?
      return;
   
   victim = self.pers["admin_pickedplayer"];
   name = victim.name;
   
   if(self == victim)
   {
      self iprintln(&"MSBRM_ADMIN_KICK_YOURSELF");
      return;
   }
   
   kick( victim getentitynumber() ); // Kick the bugger
   
   iprintln(&"MSBRM_ADMIN_KICK_PLR", name, self); // let everyone know about it
   logprint("ADMIN ACTION: " + self.name + " kicked " + name + "\n");
   
   
}

switchDefenders(response)
{


}

getSortedPlayers()
{
   //level.players;
   
   allies = [];
   axis = [];
   
}

sortByScore(array)
{
   dist = []; 
	index = []; 
	for( i = 0;i < array.size;i ++ )
	{					
		if(isdefined(array[i].score))
         dist[ dist.size ] = array[i].score;
		else
         dist[ dist.size ] = 0;
         
		index[ index.size ] = i;
	}
	
   for( ;; )
	{
		change = false; 
		for( i = 0;i < array.size - 1;i ++ )
			{
			if( dist[ i ] <= dist[ i + 1 ] )
				continue; 
			change = true; 
			temp = dist[ i ];
			dist[ i ] = dist[ i + 1 ];
			dist[ i + 1 ] = temp;
			temp = index[ i ];
			index[ i ] = index[ i + 1 ];
			index[ i + 1 ] = temp;
		}
		if( !change )
			break; 
	}
	
   newArray = []; 
 
	for( i = 0;i < dist.size;i ++ )
		newArray[ i ] = array[ index[ i ] ];
		
	return newArray; 


}

loadClanMenu()
{
   self setClientDvars("bro_ui_admin_clanmode",getDvarint("bro_clanmode"),
                        "ui_admin_clanteam", getDvarInt("bro_clanteam"),
                        "ui_admin_pubteam", getDvarInt("bro_pubteam"));
   /*
   if(getdvar("bro_match") == "0")
   {
      self setclientdvars("ui_admin_defenders",0);
      self setclientdvars("ui_admin_matchtext","Enable Match Mode");
   }
   else
   {
      if(game["isMatch"] && game["preMatch"] && getdvar("g_gametype") == "sd")
         self setclientdvars("ui_admin_defenders",1);
      else
         self setclientdvars("ui_admin_defenders",0);
      
      self setclientdvars("ui_admin_matchtext","Disable Match Mode");
   } 
   */

}

changeClanMode(enable)
{
   if(enable)
   {
      setdvar("bro_clanmode",1);
      self thread printMsg("^3Clan Mode Will be enabled next round",8,false);
   }
   else
   {
      setdvar("bro_clanmode",0);
      self thread printMsg("^4Clan Mode Will be disabled next round",8,false);
   }
   
   self loadClanMenu();

}

setTeam(team,response)
{
   
   setdvar("bro_" + team + "team",convClanString(GetSubStr( response, 20 )));
   
   self loadClanMenu();
} 

// ======= ADMIN MAP SWITCHING ============= //

loadMapMenu()
{
   self setclientdvars("ui_admin_maps_currentgt",level._adminGametypeList["english"][level._adminGametypeIdx[level.gametype]],
                        "ui_admin_maps_showgt",0,
                        "ui_admin_maps_showmaps",0);
   
   if(isDefined(level._adminStockMapIdx[level.script]))
      self setclientdvars("ui_admin_maps_currentmap",level._adminMapListStock["english"][level._adminStockMapIdx[level.script]]);
   else
      self setclientdvars("ui_admin_maps_currentmap",level.script);
      
  // if(game["b3_setnextmapgametype"] != "")
  //    self setclientdvars("ui_admin_maps_nextgt",level._adminGametypeList["english"][level._adminGametypeIdx[game["b3_setnextmapgametype"]]]);
 //  else
      self setclientdvars("ui_admin_maps_nextgt",getNextGametype());
      
   self setclientdvars("ui_admin_maps_nextmap",getNextMap());   
      
   
   self.showingGtList = undefined;                    
   self.showingMapList = undefined;                    
                                                
   for(i=0; i < level._adminGametypeList["english"].size; i++)
   {
      self setclientdvars("ui_admin_maps_gt_"+i,level._adminGametypeList["english"][i]);
      wait 0.05;
   }
}

showHideGtList()
{
   if(!isDefined(self.showingGtList))
   {
      self setclientdvars("ui_admin_maps_showgt",1,
                          "ui_admin_maps_showmaps",0 );
      self.showingGtList = true;
      self.showingMapList = undefined;
   }
   else
   {
      self setclientdvars("ui_admin_maps_showgt",0,
                        "ui_admin_maps_showmaps",0);
      self.showingGtList = undefined;
      self.showingMapList = undefined;
   }
}

showHideMapList(forceShow)
{
   if(!isDefined(forceShow))
      forceShow = false;
      
   if(!isDefined(self.showingMapList) || forceShow)
   {
      self setclientdvars("ui_admin_maps_showgt",0);
      
                        
      self.showingGtList = undefined;
      self.showingMapList = true;
      
      if(!isDefined(self.pers["admin_viewingcustommaps"]))
         self.pers["admin_viewingcustommaps"] = false;
      
      if(self.pers["admin_viewingcustommaps"])
      {
         self setclientdvars("ui_admin_maps_showmaps",2);
         
         for(i=0; i<38;i++)
         {
            if(isDefined(level._adminMapListCustom[i]))
               self setclientdvars("ui_admin_maps_" + i,level._adminMapListCustom[i]);
            else
               self setclientdvars("ui_admin_maps_" + i,"");
               
            wait 0.05;
         }
      }
      else
      {
         self setclientdvars("ui_admin_maps_showmaps",1);
         
         for(i=0; i<38;i++)
         {
            if(isDefined(level._adminMapListStock["english"][i]))
               self setclientdvars("ui_admin_maps_" + i,level._adminMapListStock["english"][i]);
            else
               self setclientdvars("ui_admin_maps_" + i,"");
               
            wait 0.05;
         }
      }
   }
   else
   {
      self setclientdvars("ui_admin_maps_showgt",0,
                        "ui_admin_maps_showmaps",0);
      
      self.showingGtList = undefined;
      self.showingMapList = undefined;
   }
}

toggleCustomMapList()
{
   if(!isDefined(self.pers["admin_viewingcustommaps"]))
      self.pers["admin_viewingcustommaps"] = false;
   
   if(!self.pers["admin_viewingcustommaps"])
   {
      self.pers["admin_viewingcustommaps"] = true;
   }
   else
   {
      self.pers["admin_viewingcustommaps"] = false;
   }
   self thread showHideMapList(true);
}

selectGametype(response)
{
   idx = int(GetSubStr( response, 20 ));
   
   if(!isDefined(level._adminGametypeList["english"][idx]))
      return;
   
   if(level._adminGametypeList["gametype"][idx] == getNextGametype())
      return;
      
   game["b3_setnextmapgametype"] = level._adminGametypeList["gametype"][idx];
   
   if(game["b3_setnextmap"] != "")
      setdvar("b3_setnextmap",game["b3_setnextmap"]);
   else
      setdvar("b3_setnextmap",level.script);
      
   b3\_b3_poweradmin::_b3_setnextmap();
      
   wait 0.15;
   
   self setclientdvars("ui_admin_maps_nextgt",getNextGametype());  
}

selectMap(response)
{
   idx = int(GetSubStr( response, 21 ));
   
   if(!isDefined(self.pers["admin_viewingcustommaps"]))
      self.pers["admin_viewingcustommaps"] = false;
   
   if(self.pers["admin_viewingcustommaps"])
   {
      if(!isDefined(level._adminMapListCustom[idx]))
         return;
      else 
         map = level._adminMapListCustom[idx];
   }
   else
   {
      if(!isDefined(level._adminMapListStock["mapname"][idx]))
         return;
      else 
         map = level._adminMapListStock["mapname"][idx];
   }
   
   
   setdvar("b3_setnextmap",map);
   
   b3\_b3_poweradmin::_b3_setnextmap();
   
   wait 0.15;
   
   self setclientdvars("ui_admin_maps_nextmap",getNextMap()); 
   
   /*
   game["b3_setnextmap"] = level._adminMapListStock["mapname"][idx];
   
   if(game["b3_setnextmapgametype"] == "")
      game["b3_setnextmapgametype"] = level.gametype;
      */
   
}

resetMap()
{
   setdvar("b3_setnextmap","reset");
   
   wait 0.15;
   
   self setclientdvars("ui_admin_maps_nextmap",getNextMap(),
                     "ui_admin_maps_nextgt",getNextGametype());
}

mapRotate()
{
   level.forcedEnd = true;
   maps\mp\gametypes\_globallogic::endGame("unknown","Admin Ended Map");

}

// ======= ADMIN TOOLS ============= //

getAdmins()
{
   level thread generateMapList();

   level.adminList = [];
   level.modList = [];
   
   _adminlist::init();
   
   level.admins = [];
      
   for(i=0; i < level.adminList.size; i++)
   {
      if(isDefined(level.adminList[i]))
         level.admins[tolower(level.adminList[i])] = true;
   }
   
   level.adminList = [];
   
   level.moderators = [];
   
   generateValidPerms();
   
   for(i=0; i < level.modList.size; i++)
   {
      parts = strtok(level.modList[i],";");
      
      if(parts.size < 2 || parts[0].size < 4)
         continue;
      
      modrights = [];
      modname = tolower(parts[0]);
      
      for(y=1; y < parts.size; y++)
      {
         perm = tolower(parts[y]);
         
         if(isValid(perm))
            modrights[perm] = true;   
      }
      
      if(modrights.size > 0)
      {
         level.moderators[modname] = [];
         level.moderators[modname] = modrights;
      }
   }
   
   level.modList = [];

   while(1)
   {
      level waittill("connected",player);
      if(!isdefined(player.pers["admin"]))
      {
         player.pers["admin"] = false;
         player setClientDvars("ui_allow_adminoptions",0);
         player thread lookupName();
      }
   } 
}

generateValidPerms()
{
   level._adminValidperms = [];
   level._adminValidperms[0] = "warnings";
   level._adminValidperms[1] = "fastrestart";
   level._adminValidperms[2] = "matchmode";
   level._adminValidperms[3] = "teamicons";
   level._adminValidperms[4] = "playercontrol";
   level._adminValidperms[5] = "adminspec";
   level._adminValidperms[6] = "clanmode";
   level._adminValidperms[7] = "mapcontrol";
}

isValid(perm)
{
   switch(perm)
   {
      case "warnings":
      case "fastrestart":
      case "matchmode":
      case "teamicons":
      case "playercontrol":
      case "adminspec":
      case "clanmode":
      case "mapcontrol":
         return true;
      default:
         return false;
   }
}

lookupName()
{	
   wait 1;
   
	if(!isdefined(self.pers["admin"]))
      self.pers["admin"] = false;
      
   name = tolower(self.name);
   
   if(isDefined(level.admins[name])) 
   {
      self.pers["admin"] = true;
      self.pers["admin_all"] = true;

         self setClientDvars("ui_allow_adminoptions",1,
                           "ui_admin_clanteam_tm",(getdvarint("bro_clanteam") * level.clanmode));
        // self thread printMsg("You have been added as an admin, " + self.name,25,false,true);
   }
   
   if(isDefined(level.moderators[name]) && !self.pers["admin"])
   {      
      self.pers["admin"] = true;
      self setClientDvars("ui_allow_adminoptions",2);
      
      for(i=0; i < level._adminValidperms.size; i++)
      {
         if(isDefined(level.moderators[name][level._adminValidperms[i]]))
         {
            self.pers["admin_" + level._adminValidperms[i]] = true;
            self setClientDvars("ui_allow_adminoptions_" + level._adminValidperms[i],1);
         }
         else
            self setClientDvars("ui_allow_adminoptions_" + level._adminValidperms[i],0);
      }
     
      self.pers["admin"] = true;
   }

}

adminSwitch(msgType, player, target)
{
   switch(msgType)
   {
      case "hipshoot":
         level thread adminHipShoot(player, target);
         break;
      case "badjump":
         level thread adminBadJump(player);
         break;
      case "jumpshoot":
         level thread adminJumpShoot(player, target);
         break;
      default:
         break;
   
   }
}

adminHipShoot(player, target)
{
   player endon("disconnect");
   
   player.warndelay["hipshooting"] = 30;
   
   dist = int(distance(player.origin,target.origin) / 36);
   
   if(dist < getdvarint("bro_warnHipshotMinDist"))
      return;
   
   weapon = player getcurrentweapon();
   
   if(!isdefined(player.isbeingwarned["hipshooting"])) 
   {
      player.isbeingwarned["hipshooting"] = true;
   }
   else 
      return;
      
   if(!isdefined(player.pers["hipshootwarnings"])) player.pers["hipshootwarnings"] = 1;
   else player.pers["hipshootwarnings"]++;
  
   
   while(player.warndelay["hipshooting"] > 0)
   {
      player.warndelay["hipshooting"]--;
      wait 0.05;
   
   }
   ext = getExt(player.pers["hipshootwarnings"]);
   warnings = player.pers["hipshootwarnings"] + getExt(player.pers["hipshootwarnings"]) + " warning";
   
   logPrint("ADMIN_WARNING: HIPSHOT; PLAYER: " + player.name + "; DISTANCE: " + dist + " yds; WEAPON: " + weapon + "; WARNINGS: " + warnings + "\n");

   if(getdvar("bro_warnHipshot") == "0")
      return;
      
   player iprintlnbold(&"MSBRM_WARNING_HIPSHOOTING");
   player iprintlnbold("^3" + warnings + "!");
  
   weaponEnglish = maps\mp\gametypes\_weapons::convertWeaponName(weapon);
   
   for(i=0; i < level.players.size; i++)
   {
      plr = level.players[i];
      
      if(isdefined(plr.pers["admin"]) && plr.pers["admin"] == true 
      && (isDefined(plr.pers["admin_all"]) || isDefined(plr.pers["admin_warnings"])))
      {
         plr iprintln (&"MSBRM_ADMIN_WARNING_HIPSHOOTING",player,weaponEnglish,dist);
         plr iprintln ("^3" + warnings + "!"); 
      }
   
   }
   player.isbeingwarned["hipshooting"] = undefined;
}

adminBadJump(player)
{        
   player endon("disconnect");
   
   if(!isdefined(player.pers["badjumpwarnings"])) player.pers["badjumpwarnings"] = 1;
   else player.pers["badjumpwarnings"]++;
  
   ext = getExt(player.pers["badjumpwarnings"]);
   warnings = player.pers["badjumpwarnings"] + getExt(player.pers["badjumpwarnings"]) + " warning";
     
   logPrint("ADMIN_WARNING: BADJUMP; PLAYER: " + player.name + "; WARNINGS: " + warnings + "\n");

   if(getdvar("bro_warnBadjump") == "0")
      return;
      
   player iprintlnbold(&"MSBRM_WARNING_FALLDMG");
 //  player iprintlnbold("^3" + warnings + "!");
   
   for(i=0; i < level.players.size; i++)
   {  
      plr = level.players[i];

      if(isdefined(plr.pers["admin"]) && plr.pers["admin"] == true 
      && (isDefined(plr.pers["admin_all"]) || isDefined(plr.pers["admin_warnings"])))
      {
         plr iprintln (&"MSBRM_ADMIN_WARNING_FALLDMG", player);
    //     level.players[i] iprintln ("^3" + warnings + "!"); 
      }  
   }
}

adminJumpShoot(player, target)
{  
   player endon("disconnect");
      
   player.warndelay["jumpshooting"] = 10;
   
   dist = int(distance(player.origin,target.origin) / 36);
   weapon = player getcurrentweapon();
   
   if(!isdefined(player.isbeingwarned["jumpshooting"])) 
   {
      player.isbeingwarned["jumpshooting"] = true;
   }
   else 
      return;
      
   if(!isdefined(player.pers["jumpshootwarnings"])) player.pers["jumpshootwarnings"] = 1;
   else player.pers["jumpshootwarnings"]++;
  
   
   while(player.warndelay["jumpshooting"] > 0)
   {
      player.warndelay["jumpshooting"]--;
      wait 0.05;
   
   }
     
   ext = getExt(player.pers["jumpshootwarnings"]);
   warnings = player.pers["jumpshootwarnings"] + getExt(player.pers["jumpshootwarnings"]) + " warning";
        
   logPrint("ADMIN_WARNING: JUMPSHOT; PLAYER: " + player.name + "; DISTANCE: " + dist + " yds; WEAPON: " + weapon + "; WARNINGS: " + warnings + "\n");
   
   if(getdvar("bro_warnJumpshot") == "0")
      return;
      
   player iprintlnbold(&"MSBRM_WARNING_JUMPSHOOTING");
   player iprintlnbold("^3" + warnings + "!");
   
   weaponEnglish = maps\mp\gametypes\_weapons::convertWeaponName(weapon);

   for(i=0; i < level.players.size; i++)
   {
      plr = level.players[i];
      
      if(isdefined(plr.pers["admin"]) && plr.pers["admin"] == true 
      && (isDefined(plr.pers["admin_all"]) || isDefined(plr.pers["admin_warnings"])))
      {
         plr iprintln (&"MSBRM_ADMIN_WARNING_JUMPSHOOTING",player, weaponEnglish, dist);
         plr iprintln ("^3" + warnings + "!"); 
      }  
   }
   
   player.isbeingwarned["jumpshooting"] = undefined;
}

///////////////////////////////

generateMapList()
{
   
   vetoMaps();
   
   incGtypes();
   incStockMaps();
   
   level._adminMapListCustom = [];
  // level._adminMapListCustomIdx = [];
  
   level._adminCustomMapIdx = [];

            
 //  rotationMapsIdx = [];
   /*
//   rotationMaps = parseMapRotation("sv_maprotation");
    
   for(i=0; i < rotationMaps.size; i++)
   {
      level._adminMapListCustom[level._adminMapListCustom.size] = rotationMaps[i];
      rotationMapsIdx[rotationMaps[i]] = i;
   }
   
   if(getdvarint("bro_playerbasedrotations") > 0)
   {
      rotationMaps = parseMapRotation("bro_maprotation_small");
       
      for(i=0; i < rotationMaps.size; i++)
      {
         rotationMapsIdx[rotationMaps[i]] = level._adminMapListCustom.size;
         level._adminMapListCustom[level._adminMapListCustom.size] = rotationMaps[i];
         
      }
      
      rotationMaps = parseMapRotation("bro_maprotation_medium");
       
      for(i=0; i < rotationMaps.size; i++)
      {
         rotationMapsIdx[rotationMaps[i]] = level._adminMapListCustom.size;
         level._adminMapListCustom[level._adminMapListCustom.size] = rotationMaps[i];
         
      }
      
      rotationMaps = parseMapRotation("bro_maprotation_large");
       
      for(i=0; i < rotationMaps.size; i++)
      {
         rotationMapsIdx[rotationMaps[i]] = level._adminMapListCustom.size;
         level._adminMapListCustom[level._adminMapListCustom.size] = rotationMaps[i];
      }
   }   
   */
   
   parseMapRotation("sv_maprotation");
   
   if(getdvarint("bro_playerbasedrotations") > 0)
   {
      parseMapRotation("bro_maprotation_small");
      parseMapRotation("bro_maprotation_medium");
      parseMapRotation("bro_maprotation_large");
   }
  /* 
   if(!isDefined(rotationMapsIdx[level.script]) && !isDefined(level._adminStockMapIdx[level.script]))
   {
      rotationMapsIdx[level.script] = level._adminMapListCustom.size;
      level._adminMapListCustom[level._adminMapListCustom.size] = level.script;
   }
   */
   addCustomMap(level.script);
   
   curList = getdvar("bro_admin_maplist"); // this dvar is self populating but can be configured in the server config. BRM B3 plugin will auto configure? (directory search)
   // should loop through map rotation - similar result but much quicker
   
   if(curList != "")
   {
      maps = strtok(curList,";");
      
      for(i=0; i < maps.size; i++)
      {
         addCustomMap(maps[i]);
      }
   }
    /* 
   str = "";
   
   if(level._adminCustomMapIdx.size > 0)
   {
      str = level._adminMapListCustom[0];
      for(i=1; i < level._adminMapListCustom.size; i++)
      {
         str += ";"+level._adminMapListCustom[i];
      }
   }
   setdvar("bro_admin_maplist",str); */
}

incStockMaps()
{
   level._adminMapListStock = [];
   level._adminMapListStock["english"] = [];
   level._adminMapListStock["mapname"] = [];
   level._adminStockMapIdx = [];
   
   addStockMap("mp_airfield","Airfield");
   addStockMap("mp_asylum","Asylum");
   addStockMap("mp_drum","Battery");
   addStockMap("mp_kwai","Banzai");
   addStockMap("mp_bgate","Breach");
   addStockMap("mp_castle","Castle");
   addStockMap("mp_shrine","Cliffside");
   addStockMap("mp_stalingrad","Corrosion");
   addStockMap("mp_courtyard","Courtyard");
   addStockMap("mp_dome","Dome");
   addStockMap("mp_downfall","Downfall");  
   addStockMap("mp_hangar","Hangar");
   addStockMap("mp_kneedeep","Kneedeep"); 
   addStockMap("mp_makin_day","Makin (Day)");
   addStockMap("mp_makin","Makin (Night)");
   addStockMap("mp_nachtfeuer","Nightfire");
   addStockMap("mp_outskirts","Outskirts");
   addStockMap("mp_vodka","Revolution");
   addStockMap("mp_roundhouse","Roundhouse");
   addStockMap("mp_seelow","Seelow");
   addStockMap("mp_subway","Station");
   addStockMap("mp_docks","Subpens");
   addStockMap("mp_suburban","Upheaval");
}

vetoMaps()
{
   level._adminVetoMaps = [];

   badMaps = getdvar("bro_admin_badmaps");
   
   if(badMaps == "")
      return;
   
   maps = strtok(badMaps,";");
   
   for(i=0; i < maps.size; i++)
   {
      level._adminVetoMaps[maps[i]] = true;
   }
}

addStockMap(mapName,englishName)
{
   if(isDefined(level._adminVetoMaps[mapname]))
      return;
      
   level._adminStockMapIdx[mapName] = level._adminMapListStock["mapname"].size;
   
   level._adminMapListStock["mapname"][level._adminMapListStock["mapname"].size] = mapName;
      
   if(isDefined(englishName))
      level._adminMapListStock["english"][level._adminMapListStock["english"].size] = englishName;
   else
      level._adminMapListStock["english"][level._adminMapListStock["english"].size] = mapName;
}

incGtypes()
{
   level._adminGametypeList = [];
   level._adminGametypeList["gametype"] = [];
   level._adminGametypeList["english"] = [];
   level._adminGametypeIdx = [];
   
   addGt("ctf","Capture the Flag"); 
   addGt("dm","Death Match"); 
   addGt("dom","Domination"); 
   addGt("koth","Headquarters"); 
   addGt("ret","Retrieval"); 
   addGt("sab","Sabotage"); 
   addGt("sd","Search and Destroy"); 
   addGt("tdm","Team Deathmatch"); 
   addGt("twar","War");    
}

addGt(gametype,english)
{ 
   level._adminGametypeIdx[gametype] = level._adminGametypeList["gametype"].size;
   level._adminGametypeList["gametype"][level._adminGametypeList["gametype"].size] = gametype;
   level._adminGametypeList["english"][level._adminGametypeList["english"].size] = english;
}

getNextGametype(mapString)
{
   if(isDefined(mapString))
      curRot = mapString;
   else
      curRot = getdvar("sv_maprotationcurrent");
   
   if(curRot != "")
   {
      parts = strtok(curRot," ");
      
      if(parts.size > 0)
      {
         if(isDefined(mapString))
         {
            if(parts[0] == "gametype")
               return parts[1];
            else
               return level.gametype;
         }
         
         if(parts[0] == "gametype")
            return level._adminGametypeList["english"][level._adminGametypeIdx[parts[1]]];
         else
            return level._adminGametypeList["english"][level._adminGametypeIdx[level.gametype]];
      }
   }
   
   if(isDefined(mapString))
      return level.gametype;
   
   curRot = getdvar("sv_maprotation");
   
   if(curRot != "")
   {
      parts = strtok(curRot," ");
      
      if(parts.size > 0)
      {
         if(parts[0] == "gametype")
            return level._adminGametypeList["english"][level._adminGametypeIdx[parts[1]]];
         else
            return level._adminGametypeList["english"][level._adminGametypeIdx[level.gametype]];
      }
   }
   
   return "<unknown>";
}

getNextMap(mapString)
{
   if(isDefined(mapString))
      curRot = mapString;
   else
      curRot = getdvar("sv_maprotationcurrent");
   
   if(curRot != "")
   {
      parts = strtok(curRot," ");
      
      if(parts.size > 0)
      {
         if(parts[0] == "map")
         {
            if(isDefined(level._adminStockMapIdx[parts[1]]) && !isDefined(mapString))
               return level._adminMapListStock["english"][level._adminStockMapIdx[parts[1]]];
            else
               return parts[1];
         }
         else if(parts[2] == "map")
         {
            if(isDefined(level._adminStockMapIdx[parts[3]]) && !isDefined(mapString))
               return level._adminMapListStock["english"][level._adminStockMapIdx[parts[3]]];
            else
               return parts[3];
         }
         else if(!isDefined(mapString))
            return "<unknown>";

      }
   }
   
   if(isDefined(mapString))
      return "na";
   
   curRot = getdvar("sv_maprotation");
   
   if(curRot != "")
   {
      parts = strtok(curRot," ");
      
      if(parts.size > 0)
      {
         if(parts[0] == "map")
         {
            if(isDefined(level._adminStockMapIdx[parts[1]]))
               return level._adminMapListStock["english"][level._adminStockMapIdx[parts[1]]];
            else
               return parts[1];
         }
         else if(parts[2] == "map")
         {
            if(isDefined(level._adminStockMapIdx[parts[3]]))
               return level._adminMapListStock["english"][level._adminStockMapIdx[parts[3]]];
            else
               return parts[3];
         }
         else
            return "<unknown>";
      }
   }
   
   return "<unknown>";
}

parseMapRotation(dvarName)
{
   rotation = getdvar(dvarName);
   
   parts = strtok(rotation," ");

   for(i=0; i < parts.size; i++)
   {
      if(parts[i] == "map" && i < (parts.size - 1) && !isDefined(level._adminStockMapIdx[parts[i+1]]))
      {
         addCustomMap(parts[i+1]);

         i++;
      }
   }
}

addCustomMap(mName)
{
   if(!isDefined(level._adminStockMapIdx[mName]) && !isDefined(level._adminCustomMapIdx[mName]) && !isDefined(level._adminVetoMaps[mName]))
   {
      level._adminCustomMapIdx[mName] = level._adminMapListCustom.size;
      level._adminMapListCustom[level._adminMapListCustom.size] = mName; 
   }
}

