#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;

init()
{
   precacheString(&"BRM_DEPLOY_BIPOD");
   precacheString(&"BRM2_PRONETO_DEPLOY_BIPOD");
   precacheString(&"BRM_PICKUP_BIPOD");
   precacheString(&"BRM_HOLD_TO_RELOAD");

  PreCacheTurret( "ptrs_bipod_prone_mp" );
   PreCacheModel( "mounted_ptrs_bipod" );
   
   level.maxDeployedTurrets = 10;
   
   level.deployedTurretArray = [];
   
   thread cleanupRoutine();
    
}

deployBipod()
{
   if(self getstance() != "prone")
      return;
      
   weapon = self GetCurrentWeapon();
   
   info = getRelatedTurret(weapon);
   
   plantPos = self getPlantPosition(20);
      
   if(!validPos(plantPos,self))
   {
      return;
   }
   else if(isDefined(info))
   {
      turret = spawnTurret("misc_turret", plantPos, info["weapon"]);
      turret setModel(info["model"]);
      turret.name = info["name"];
      turret.type = info["weapon"];
      turret.angles = (0,self.angles[1],0);
      turret.user = undefined;
      turret.ammo = self GetWeaponAmmoClip( weapon);
      turret.lastused = maps\mp\gametypes\_globallogic::getTimePassed();
      
      if(weapon == "ptrs41_mp")
         info["clips"] = int(ceil(self getWeaponAmmoStock("ptrs41_mp") / 5));
      else
         info["clips"] = self.numFullClips[weapon] - 1;
     
      turret.clips = info["clips"];
      turret.info = info;
      
      turret SetTopArc(10);
      turret SetBottomArc(40);
      turret SetLeftArc(40);

      turret SetRightArc(40);

      turret thread watchUsage();
           
      turret.lookup = level.deployedTurretArray.size;
      level.deployedTurretArray[level.deployedTurretArray.size] = turret;
      
      self.curStock[weapon] = undefined;   
      self.weaponClips[weapon] = undefined;
      self.currentClipId[weapon] = undefined;
      self.currentClipAmmo[weapon] = undefined;
      self.numFullClips[weapon] = undefined;
      self.ammoIcon[weapon] = undefined;
      self.weaponState[weapon] = undefined;
      self.clipSize[weapon] = undefined;
            
      self takeWeapon(self GetCurrentWeapon());
      
      curWeaps = self maps\mp\gametypes\_weapons::getPlayerWeapons(true, false);
      
      if(curWeaps.size > 0)
         self SwitchToWeapon(curWeaps[0]);   
      else
      {
       //  self iprintln("^3No other weapons :-(");
         self giveWeapon("mgcarry_mp");
         self SwitchToWeapon("mgcarry_mp");
      }
      
      self.moveSpeedDefault = 1.15;	
      self SetMoveSpeedScale(self.moveSpeedDefault);
         
   }
   else
      self iprintln("Something has Failed :-(!");
}

pickupBipod()
{
   self endon("death_or_disconnect");
   
   if(isDefined(self.targetTurret))
   { 

      if(!isDefined(self.targetTurret.user)) // nobody is on it so can pickup
      {
         // Get related weapon         
         giveWeap = self.targetTurret.name;
         
         curClip = self.targetTurret.ammo;
         remainClips = self.targetTurret.clips;
         
       //  iprintln(remainClips);
         
         self maps\mp\gametypes\_magazines::setupNewWeapon(giveWeap,curClip,remainClips);
         
        
         
         // run cleanup (remove from array)
         cleanDeployedArray(self.targetTurret.lookup);
            
         if(self hasWeapon("mgcarry_mp"))
         {
            self takeWeapon("mgcarry_mp");
         }
         
         self giveWeapon(giveWeap);
         
         if(giveWeap == "ptrs41_mp")
         {         
            
            self setWeaponAmmoStock(giveWeap,remainClips * 5);
            self setWeaponAmmoClip(giveWeap, curClip); 
         }
         
         self playLocalSound("ammo_pickup_plr");
         
         self.moveSpeedDefault = maps\mp\gametypes\_mod_core::getPlayerSpeedScale(self.pers["curClass"]);
         self SetMoveSpeedScale(self.moveSpeedDefault);
         
         wait 0.15;
         
         if(self hasWeapon(giveWeap))
            self switchToWeapon(giveWeap);
      }
   }
}

cleanupRoutine()
{
   level endon("intermission");
	level endon("game_ended");

	if(level.numLives == 1)
   {   
     return; // run only on > 1 life games?
   }
   
   wait 8;
	
   for(;;)
   {
      if(level.deployedTurretArray.size > level.maxDeployedTurrets)
      {
         // search for unused - take empty turrets before older ones

         oldestTurret = undefined;
         emptyTurret = undefined;
         
         curTimeBias = maps\mp\gametypes\_globallogic::getTimePassed() - (15000);
         
         for(i=0; i < level.deployedTurretArray.size; i++)
         {
            turret = level.deployedTurretArray[i];
            
            if(!isDefined(turret.user))
            {
               if(turret.clips <= 0 && turret.clip <= 0 && turret.lastused < curTimeBias)
               {
                  if(!isDefined(emptyTurret))
                     emptyTurret = turret;
                  else if(turret.lastused < emptyTurret.lastused)
                     emptyTurret = turret;
               }
                  
               if(!isDefined(oldestTurret) && turret.lastused < curTimeBias) 
                  oldestTurret = turret;
               else if(turret.lastused < oldestTurret.lastused)
                  oldestTurret = turret;
            }
         }
         
         if(isDefined(emptyTurret))
            cleanDeployedArray(emptyTurret.lookup);
         else if(isDefined(oldestTurret))
            cleanDeployedArray(oldestTurret.lookup);
      }
      wait 4;
   }
}

cleanDeployedArray(removeID)
{
   tmpArray = [];
   
   level.deployedTurretArray[removeID] notify("removed");
   
   level.deployedTurretArray[removeID] delete();
   
   for(i=0; i < level.deployedTurretArray.size; i++)
   {
      if(i != removeID)
      { 
         id = tmpArray.size;
         tmpArray[id] = level.deployedTurretArray[i];
         tmpArray[id].lookup = id;
      }
   }
   
   level.deployedTurretArray = tmpArray;
}  
/*
getPlantPosition()
{
   targPos = self.origin + vector_scale(anglesToForward((0,self.angles[1],0)),20) + (0,0,15);
   trace = bulletTrace(targPos,targPos - (0,0,300),false,undefined);
   
   return trace["position"];
}
*/
validPos(origin,player) // to do the side swing as well
{
   plrOffset = 12;
      
      
   if(player.origin[2] > origin[2] && (player.origin[2] - origin[2]) > 15)
   {
      player iprintln(&"MSBRM_GROUND_NOT_FLAT");
      return false;
   }
   
   tracePoint = origin + (0,0,40);
   
  // backPoint = tracePoint + vector_scale(anglesToForward((0,player.angles[1] + 180,0)),100);
   backPoint = tracePoint + vector_scale(anglesToForward((0,player.angles[1] + 150,0)),100);
      
   trace = BulletTracePassed(tracePoint, backPoint,false, undefined );
   
   if(!trace)
   {
      player iprintln(&"MSBRM_CLOSE_TO_WALL");
      return false;
   }
      
   heightTrace = bullettrace(backPoint, backPoint - (0,0,700), false, undefined);
   
   if(abs(backPoint[2] - 40 - heightTrace["position"][2]) > 28)
   {
      player iprintln(&"MSBRM_GROUND_NOT_FLAT");
      return false;
   }
   
   groundTrace = bulletTracePassed(heightTrace["position"] + (0,0,16) , origin + (0,0,16), false, undefined);
   
   if(!groundTrace)
   {
       player iprintln(&"MSBRM_GROUND_NOT_FLAT");
      return false;
   }
   
   /*
   feetPoint = tracePoint + vector_scale(anglesToForward((0,player.angles[1] + 150,0)),85);
  
   heightTrace = bullettracePassed(feetPoint, feetPoint - (0,0,70), false, undefined);
  
   if(!heightTrace)
   {
      player iprintln("^1Can't deploy: ^3Ground area not large enough");
      return false;
   }
   */
   /*
   midPoint = tracePoint + vector_scale(anglesToForward((0,player.angles[1] + 180,0)),40);
   
     
   sideVectorPoint = vector_scale(anglesToForward((0,player.angles[1] + 90,0)),100);
   
   leftTrace1 = bulletTrace(backPoint, backPoint + sideVectorPoint,false,undefined);
   leftTrace2 = bulletTrace(midPoint, midPoint + sideVectorPoint,false,undefined);
   
   fraction1 = (leftTrace1["fraction"] * 100) - plrOffset;
   fraction2 = (leftTrace2["fraction"] * 100) - plrOffset;
   
   
   frac1Ang = atan(fraction1/100);
   frac2Ang = atan(fraction2/40);
   
   if(frac1Ang < frac2Ang)
      player.depAngleRight = frac1Ang;
   else if(frac2Ang < frac1Ang)
      player.depAngleRight = frac2Ang;
   else
      player.depAngleRight = 45;
   
   iprintln(leftTrace1["fraction"]);
   iprintln(leftTrace2["fraction"]);
   
   */
   
   return true;   
}

getRelatedTurret(weapon)
{
   data = [];
   
   switch(weapon)
   {
      case "30cal_bipod_mp":
         data["model"] = "mounted_mp_30cal_bipod_lmg";
         data["weapon"] = "30cal_bipod_prone_mp";
         data["name"] = "30cal_bipod_mp";
         data["clipsize"] = WeaponClipSize( weapon );
         data["reloadtime"] = 6.45;
         data["reloadsound"] = "gr_30cal_3p_full";
         data["pausetime"] = 0.1;
         data["fullauto"] = 1;
         data["staticangle"] = -8;
         return data; 
      
      case "ptrs41_mp":
         data["model"] = "mounted_ptrs_bipod";
         data["weapon"] = "ptrs_bipod_prone_mp";
         data["name"] = "ptrs41_mp";
         data["clipsize"] = WeaponClipSize( weapon );
         data["reloadtime"] = 3.5;
         data["reloadsound"] = "gr_smg_reload_empty_3p";
         data["pausetime"] = 1;
         data["fullauto"] = 0;
         data["staticangle"] = -5;
         return data; 
                   
      case "mg42_bipod_mp":
         data["model"] = "mounted_mp_mg42_bipod_mg";
         data["weapon"] = "mg42_bipod_prone_mp";
         data["name"] = "mg42_bipod_mp";
         data["clipsize"] = WeaponClipSize( weapon );
         data["reloadtime"] = 6;
         data["reloadsound"] = "gr_smg_reload_empty_3p";
         data["pausetime"] = 0.05;
         data["fullauto"] = 1;
         data["staticangle"] = -10;
         return data;
         
      case "bar_bipod_mp":
         data["model"] = "mounted_mp_bar_bipod_lmg";
         data["weapon"] = "bar_bipod_prone_mp";
         data["name"] = "bar_bipod_mp";
         data["clipsize"] = WeaponClipSize( weapon );
         data["reloadtime"] = 2.75;
         data["reloadsound"] = "gr_smg_reload_empty_3p";
         data["pausetime"] = 0.1;
         data["fullauto"] = 1;
         data["staticangle"] = -5;
         return data;
         
      case "bar_bipod_semi_mp":    
         data["model"] = "mounted_mp_bar_bipod_lmg";
         data["weapon"] = "bar_bipod_semi_prone_mp";
         data["name"] = "bar_bipod_semi_mp";
         data["clipsize"] = WeaponClipSize( weapon );
         data["reloadtime"] = 2.75;
         data["reloadsound"] = "gr_smg_reload_empty_3p";
         data["pausetime"] = 0.2;
         data["fullauto"] = 1;
         data["staticangle"] = -5;
         return data;
         
      case "dp28_bipod_mp":
         data["model"] = "mounted_mp_dp28_bipod_lmg";
         data["weapon"] = "dp28_bipod_prone_mp";
         data["name"] = "dp28_bipod_mp";
         data["clipsize"] = WeaponClipSize( weapon );
         data["reloadtime"] = 3.3;
         data["reloadsound"] = "gr_smg_reload_empty_3p";
         data["pausetime"] = 0.15;
         data["fullauto"] = 1;
         data["staticangle"] = -7;
         return data;
         
      case "type99lmg_bipod_mp":
      case "type99lmg_bipod_bayonet_mp":
         data["model"] = "mounted_mp_type99_bipod_lmg";
         data["weapon"] = "type99_lmg_bipod_prone_mp";
         data["name"] = "type99lmg_bipod_mp";
         data["clipsize"] = WeaponClipSize( weapon );
         data["reloadtime"] = 3.75;
         data["reloadsound"] = "gr_smg_reload_empty_3p";
         data["pausetime"] = 0.1;
         data["fullauto"] = 1;
         data["staticangle"] = -5;
         return data;
   
      default: 
         return undefined;
   }
}

watchUsage()
{
   self endon("removed");
   
   while(1)
   {
      self waittill("trigger",player);
   
      self.user = player;
      
      player thread watchPlrUsage(self);
      player thread firingMonitor(self);
      
      self waittill("hasbeenreleased");
      
      self.lastused = maps\mp\gametypes\_globallogic::getTimePassed();
      self.user = undefined;

   }
}

firingMonitor(turret)
{
   turret endon("hasbeenreleased");
   
   while(1)
   {
      while(self AttackButtonPressed())
      {
         turret.ammo--;
         self thread maps\mp\gametypes\_weapons::runSuppression("mg",true,false);
         
         if(turret.ammo <=0)
         {
            self disableWeapons();
            wait 0.05;
            
            self iprintln(&"MSBRM_BIPOD_OUT_OF_AMMO"); // kick off + go prone
           // self iPrintlnBold("^1Get off Gitface!");
            turret replaceStatic();
            self thread kickOffTurret();
            return;
         }
         else
            wait turret.info["pausetime"];
         
         if(turret.info["fullauto"] == 0)
            break;
      } 
      
      while(self AttackButtonPressed())
         wait 0.05;
         
      wait 0.05;
   }
}

replaceStatic()
{
   info = self.info;
   pos = self.origin;
   angles = self.angles;
   lookup = self.lookup;
   self delete();
   
 //  emptyTurret = spawnTurret("misc_turret", pos, "none_" + info["weapon"]);
   emptyTurret = spawn("script_model", pos);
   emptyTurret setModel(info["model"]);
   emptyTurret.name = info["name"];
   emptyTurret.type = info["weapon"];
   emptyTurret.angles = angles + (info["staticangle"],0,0);
   emptyTurret.user = undefined;
   emptyTurret.ammo = 0;
   emptyTurret.clips = info["clips"];
   emptyTurret.lastused = maps\mp\gametypes\_globallogic::getTimePassed();
   

   
   emptyTurret.lookup = lookup;
   
   emptyTurret.info = info;

   level.deployedTurretArray[emptyTurret.lookup] = emptyTurret;
   
   if(info["clips"] > 0)
      emptyTurret thread testForReload();
}

createTurret()
{
   info = self.info;
   pos = self.origin;
   angles = self.angles;
   lookup = self.lookup;
   self delete();
   
   turret = spawnTurret("misc_turret", pos, info["weapon"]);
   turret setModel(info["model"]);
   turret.name = info["name"];
   turret.type = info["weapon"];
   turret.angles = angles - (info["staticangle"],0,0);
   turret.user = undefined;
   turret.ammo = info["clipsize"];
   info["clips"]--;
   turret.clips = info["clips"];
   turret.lastused = maps\mp\gametypes\_globallogic::getTimePassed();
   
   turret SetTopArc(10);
   turret SetBottomArc(40);
   turret SetLeftArc(45);
   turret SetRightArc(45);
   
   turret.lookup = lookup;
   
   turret.info = info;

   level.deployedTurretArray[turret.lookup] = turret;
   
   turret thread watchUsage();
}

testForReload()
{
   dist = 3600;
   
   self endon("reloaded");
   self endon("removed");
   
   while(1)
   {
      for(i=0; i < level.players.size; i++)
      {
         plr = level.players[i];
         
         if(isAlive(plr) && isDefined(plr.origin) && !isDefined(plr.canReloadMG) && distanceSquared(plr.origin,self.origin) < dist)
         {
            plr thread showReload(self,dist);
         }      
      }
      wait 0.4;
   }
}

showReload(turret,dist)
{
  // self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	self endon("death_or_disconnect");
	level endon("game_ended");
	
	turret endon("reloaded");
	
	self.canReloadMG = true;
	
	if(!isdefined(self.useBarText))
       self.useBarText = createPrimaryProgressBarText();
       
	while(isDefined(self.canReloadMG) && isDefined(turret) && distanceSquared(self.origin,turret.origin) < dist )
	{
      if(!((isdefined(self.isDefusing) && self.isDefusing == true) || (isDefined(self.isPlanting) && self.isPlanting == true)) && !isdefined(self.standingNrBox) && !self.isBandaging) 
      {
         self.useBarText showElem(); 
      
         self.useBarText setText( &"BRM_HOLD_TO_RELOAD" );
      
         if(self usebuttonPressed())
         {  
            self.canReloadMG = undefined;
            self.processMGTurretReload = undefined;
            
            self thread processReload(turret);
                     
            if(isdefined(self.useBarText))
               self.useBarText hideElem();
               
            turret notify("reloaded");
            
            return;
         }
      }
	
      wait 0.1;
	}
	
	if(isdefined(self.useBarText))
      self.useBarText hideElem();
      
   self.canReloadMG = undefined;
}

processReload(turret)
{
   turret endon("removed");
   
   self iprintlnBold(&"MSBRM_BIPOD_RELOADING");
         
   turret playSound(turret.info["reloadsound"]);
         
   //   wait turret.info["reloadtime"];
   wait 3;
   
 //  self iprintlnBold("Complete!");
   
   turret createTurret();
}


kickOffTurret()
{
   self endon("death_or_disconnect");
   
/*
   self ExecClientCommand("+activate");
   wait 0.05;
   self ExecClientCommand("-activate");
   wait 0.05;
*/
/*
   if(self attackButtonPressed())
   {
      self ExecClientCommand("-attack");
      wait 0.05;
   }
   */
   while(self attackButtonPressed())
      wait 0.05;
   
   self enableweapons();
   
   self ExecClientCommand("goprone");
}

watchPlrUsage(turret)
{
   turret endon("hasbeenreleased");
   turret endon("removed");
   
	self thread endUsageOn( "death",turret );
	self thread endUsageOn( "disconnect",turret );
   
	self thread endUsageOnGameEnd(turret);
	
	while(self useButtonPressed())
      wait 0.05;
      
	while(isDefined(self) && !self useButtonPressed())
      wait 0.05;

   turret notify("hasbeenreleased");
}

endUsageOn( waitfor,turret )
{
	turret endon("hasbeenreleased");
	turret endon("removed");
	
	self waittill( waitfor );
   
	turret notify("hasbeenreleased");
}

endUsageOnGameEnd(turret)
{
   turret endon("hasbeenreleased");
   turret endon("removed");
	
	level waittill( "game_ended" );
	
	turret notify("hasbeenreleased");	
}

