#include maps\mp\_utility;
#include common_scripts\utility;
#include maps\mp\_burnplayer;
#include maps\mp\gametypes\_airsupport;

setupPlane(team,idx)
{
  
   plane = level.airPlanes[team][idx];
//   plane.bomb = [];
   tag = [];
   
   if(!isdefined(plane.bomb))
      plane.bomb = [];
      
	tag[0] = (0,100,-2);
	tag[1] = (0,200,-2);
	tag[2] = (0,-100,-2);
	tag[3] = (0,-200,-2);
	tagname = "tag_origin";

  // println("### Model: " + self.model);

   switch(level.plane[team])
   {
      case "vehicle_usa_aircraft_f4ucorsair_dist":
         tagname = "tag_body";
         tag[0] = (70,85,-36);
         tag[1] = (70,105,-34);
         tag[2] = (70,-85,-36);
         tag[3] = (70,-105,-34);
         break;
      case "vehicle_jap_airplane_zero2_fly":
         
         tag[0] = (70,50,1);
         tag[1] = (70,75,6);
         tag[2] = (70,-50,1);
         tag[3] = (70,-75,6);
         break;
      case "vehicle_rus_airplane_il2":
         tag[0] = (70,30,-29);
         tag[1] = (70,45,-29);
         tag[2] = (70,-30,-29);
         tag[3] = (70,-45,-29);
         break;
      case "vehicle_stuka_flying":
         tagname = "tag_body";
         tag[0] = (50,100,-7);
         tag[1] = (50,115,-5);
         tag[2] = (50,-100,-7);
         tag[3] = (50,-115,-5);
         break;
         
      case "vehicle_p51_mustang":
         
         tag[0] = (35,80,-12);
         tag[1] = (35,95,-11);
         tag[2] = (35,-80,-12);
         tag[3] = (35,-95,-11);
         break; 
   }

	for( i = 0; i < tag.size; i++ )
	{
      if(!isdefined(plane.bomb[i]))
      {
         plane.bomb[i] = Spawn( "script_model", ( plane.origin ) );
         plane.bomb[i] SetModel( "aircraft_bomb" );
		}
		
		plane.bomb[i] hide();
		
		plane.bomb[i].dropped = false;
		plane.bomb[i].owner = plane;
      wait 0.05;

		plane.bomb[i] LinkTo( plane, tagname, tag[i], ( 0, 0, 0 ) );
		
	//	println("### Bomb #" + i + " Tag: " + tag[i]);
		
	
   }
   
   for(i=0; i<plane.bomb.size; i++)
      plane.bomb[i] show();
}

//flyPastBomb(team, positionData, type,idx, sideOffset,owner)
flyPastBomb(team, positionData,idx, sideOffset,owner)
{
   xDist = (positionData["entrypos"][1] - positionData["targetpos"][1]);
   
   if( abs(xDist) < 1) 
      xDist = 1;
      
   strafeAngle = int(atan((positionData["entrypos"][0] - positionData["targetpos"][0]) / xDist));
      
   if(positionData["targetpos"][1] < positionData["entrypos"][1])
      strafeAngle += 180;
   else if(strafeAngle < 0 && strafeAngle > -90) 
      strafeAngle += 360;
   
   if(strafeAngle == 270)
      strafeAngle = 271;

   flightLength = 11500;
   
   cosVal = cos(strafeAngle);
   sinVal = sin(strafeAngle);
   
   if(cosVal < 0.001 && cosVal > -0.001)
   {
      yVar = 0;
      xVar = flightLength;
   }
   else
   {
      yVar = flightLength * cosVal;
      xVar = flightLength * (sinVal);
   }
   
  // midpoint = (positionData["targetpos"][0],positionData["targetpos"][1],0) + ((randomint(400) - 200),(randomint(400) - 200),level.mapMidPoint[2]);
   midpoint = (positionData["targetpos"][0] + (cosVal * sideOffset) + (randomint(400) - 200),positionData["targetpos"][1] + (sinVal * sideOffset) + (randomint(400) - 200),level.mapMidPoint[2]);
 //  midpoint = (positionData["targetpos"][0] + (cosVal * sideOffset),positionData["targetpos"][1] + (sinVal * sideOffset),level.mapMidPoint[2]);
   
   strafeStart = midpoint - (xVar, yVar, 0); 
   strafeEnd = midpoint + (xVar, yVar, 0); 
   
   level.airPlanes[team][idx] hide();
   wait 0.05;  
   
   level.airPlanes[team][idx] moveto(strafeStart, 0.05);
   level.airPlanes[team][idx].angles = (0,(90-strafeAngle),0);
       
   level.airPlanes[team][idx] waittill("movedone");
   level.airPlanes[team][idx] thread play_loop_sound_on_entity( "ambient_corsair" );
   
   wait 2;
   
   for(i=0;i < level.airPlanes[team][idx].bomb.size ;i++)
      level.airPlanes[team][idx].bomb[i] show();
   
   level.airPlanes[team][idx] thread drop_bombs(2.25, 0.2, 0, 4096, positionData["type"], team, idx, owner );
     
   level.airPlanes[team][idx] show();
   level.airPlanes[team][idx] moveto(strafeEnd,8.5);
   
   level.airPlanes[team][idx] waittill("movedone");
   
   level.airPlanes[team][idx] notify ( "stop sound" + "ambient_corsair" );
  
   level.airPlanes[team][idx] hide();
}

drop_bombs(predelay, delay, delay_trace, trace_dist, type, team, idx, owner )
{
	self endon( "reached_end_node" );
	self endon ("death");
	total_bomb_count = self.bomb.size;

	user_delay = undefined;
   wait (predelay);
	if( IsDefined( delay ) )
	{
		user_delay = delay;
		//println( "user_delay ", user_delay );
	}

   for( i = 0; i < self.bomb.size; i++ )
   {

      total_bomb_count--;
   //   self.bomb_count--;
      forward = AnglesToForward( self.angles );
      vec = vectorScale( forward, 2700 );

      // Compensates for the frame delay when "unlinked."
      vec_predict = self.bomb[i].origin + vectorScale( forward, (2700 * 0.06 ) );

      vec = ( ( vec[0] +( -20 + RandomFloat( 40 ) ) ), ( vec[1] +( -20 + RandomFloat( 40 ) ) ), vec[2] );

      self.bomb[i] UnLink();
      self.bomb[i].origin = vec_predict; // Compensates for the frame delay when "unlink" is called.
      self.bomb[i] MoveGravity( ( vec ), 10 );
      self.bomb[i] thread bomb_wiggle();

      self.bomb[i] thread bomb_trace( delay_trace, trace_dist, type, team,idx, owner );

      if( IsDefined( user_delay ) )
      {
         delay = user_delay;
      }
      else
      {
         delay = 0.1 + RandomFloat( 0.5 );
      }
      wait( delay );
   }
}

// self = da bomb
bomb_wiggle()
{
	self endon( "death" );

	original_angles = self.angles;
	while( 1 )
	{
		roll = 10 + RandomFloat( 20 );
		yaw = 4 + RandomFloat( 3 );
		time = 0.25 + RandomFloat( 0.25 );
		time_in_half = time/3;

		self bomb_pitch( time );
		self RotateTo( ( self.pitch, ( original_angles[1] +( yaw * -2 ) ), ( roll * -2 ) ), ( time * 2 ), ( time_in_half * 2 ), ( time_in_half * 2 ) );
		self waittill( "rotatedone" );

		self bomb_pitch( time );
		self RotateTo( ( self.pitch, ( original_angles[1] +( yaw * 2 ) ), ( roll * 2 ) ), ( time * 2 ), ( time_in_half * 2 ), ( time_in_half * 2 ) );
		self waittill( "rotatedone" );
	}
}

// self = da bomb
bomb_pitch( time_of_rotation )
{
	self endon( "death" );

	if( !IsDefined( self.pitch ) )
	{
		original_pitch = self.angles;
		self.pitch = original_pitch[0];
		time = 15 + RandomFloat( 5 );
	}

	if( self.pitch < 80 )
	{
		self.pitch = ( self.pitch +( 40 * time_of_rotation ) );
		if( self.pitch > 80 )
		{
			self.pitch = 80;
		}
	}
	return;
}

// self = da bomb
bomb_trace(delay_trace, trace_dist, type, team, idx, owner )
{
	//old_dist = undefined;

	self endon( "death" );
	
	startZ = self.origin[2];
	
	if( IsDefined( delay_trace ) )
	{
		wait( delay_trace );
	}

	if( !IsDefined( trace_dist ) )
	{
		trace_dist = 4096;
	}

	while( 1 )
	{
      
		vec1 = self.origin;
		
		if(vec1[2] < (startZ - 200))
		{
         direction = AnglesToForward( ( 90, 0, 0 ) );
         vec2 = vec1 + vectorScale( direction, 10000 );
         trace_result = BulletTrace( vec1, vec2, false, undefined );

         dist = DistanceSquared( self.origin, trace_result["position"] );

         // Check the distance, in order to blow up... Failsafe, if the bomb happened to go through the ground
         // the >= 100000000 should pickup and blowup.
         if( dist < trace_dist || dist >= 100000000 )
         {
               self thread bomb_explosion( type,team, trace_result, idx, owner );
               return;
         }
		}
		wait( 0.05 );
	}
}

// self = da bomb
bomb_explosion( type, team, trace,idx, owner )
{

   if(type == "phos")
      self thread phosStrike();
   else if(type == "napalm")
      self thread napalmStrike(team,owner);
   else
      self thread bombStrike(team,trace,idx,owner);

	self hide();
}

phosStrike()
{
   maxdist = 250000;
	mindist = 49000000;
	range = maxdist - mindist;
	
	
	PlayFx( level._effect["plane_phostrike"], self.origin );	
	
	
	
	for(i=0; i<level.players.size; i++)
	{
      plr = level.players[i];
      
      dist = distanceSquared(plr.origin + (0,0,40), self.origin);
      
      trig = spawn("trigger_radius", self.origin + (0,0,50), 0, 500, 500);
  /*    
      if(dist <= mindist)
      {
         los = maps\mp\gametypes\_weapons::weaponDamageTracePassed(self.origin, (plr.origin + (0,0,40)), 5, undefined);
      
         if(los)
            plr burnPhos(1);
         else
            plr burnPhos(0.5);
      }
      else */
     // if(dist < maxdist && plr playersighttrace( self.origin + (0,0,100), 7000, 0 ) >= 0 )
     st = trig SightConeTrace( plr getEye(), plr );
    // iprintln(st);
      if(dist < maxdist && st > 0)
      {
         
         
         if(dist < maxdist)
         {  
            if(dist <= mindist)
               frac = 1;
            else
               frac = 1 - ((dist - mindist) / range);
               
            plr burnPhos(frac);
     
         }
         
         
     
 //     if( plr isLookingAtTarget(self.origin))
  //       plr burnPhos(0.5);
   /*
      dist = distanceSquared(plr.origin + (0,0,40), self.origin);
      
      if(dist < maxdist)
      {
         if(dist <= mindist)
            frac = 1;
         else
            frac = 1 - ((dist - mindist) / range);
        
         los = maps\mp\gametypes\_weapons::weaponDamageTracePassed(self.origin, (plr.origin + (0,0,40)), 5, undefined);
      
         if(los)
            plr burnPhos(frac);
         else
            plr burnPhos(frac * 0.5);
      }
      
    */
      }
   }   
	
}

isLookingAtTarget(target_origin)
{
    forward = anglesToForward(self.angles + (0,45,0));
    a = (vectordot(forward, target_origin - self.origin) > 0);
    forward = anglesToForward(self.angles - (0,45,0));
    b = (vectordot(forward, target_origin - self.origin) > 0);
    
    if (a && b)
    {
 //Check Players View
     forward = anglesToForward(self.angles + (0,65,0));
     c = (vectordot(forward, target_origin - self.origin) > 0);
     forward = anglesToForward(self.angles - (0,65,0));
     d = (vectordot(forward, target_origin- self.origin) > 0);
 // If both c & d are defined, then player's horizontal view
 // is lined up with the origin(target_origin)
     if (c && d)
    {
        return 1;
    }
    else
        return 0;
    }
}

burnPhos(frac)
{
 //  self endon("killed_player");
	self endon("spawned");
	//self endon("disconnect");
	self endon("death_or_disconnect");
	
   self VisionSetLerpRatio( 1 );

   for(i=0; i < 20; i++)
   {   
      wait 1;
   
   }  
   self VisionSetLerpRatio( 0 );
}

napalmStrike(team,officer)
{
   maxdist = 360000;
	mindist = 90000;
	range = maxdist - mindist;
	
	PlayFx( level._effect["plane_napalmstrike"], self.origin );	
	
	
	thread playSoundinSpace("napalm_impact_1", self.origin, 5);
	
	thread bomb_ambient_fires(self.origin);
	
	for(i=0; i<level.players.size; i++)
	{
      plr = level.players[i];
      if(!isAlive(plr))
         continue;
      dist = distanceSquared(plr.origin + (0,0,40), self.origin);
      
      if(dist < maxdist)
      {
         if(dist <= mindist)
            frac = 1;
         else
            frac = 1 - ((dist - mindist) / range);
        
         los1 = maps\mp\gametypes\_weapons::weaponDamageTracePassed(self.origin, (plr.origin + (0,0,40)), 5, undefined);
         los2 = maps\mp\gametypes\_weapons::weaponDamageTracePassed(self.origin, (plr.eyemarker.origin), 5, undefined);
      //   los3 = maps\mp\gametypes\_weapons::weaponDamageTracePassed(self.origin, (plr.origin + (0,0,40)), 5, undefined);
      
        // locRadiusDamage(self.origin + (0,0,4), maxdist * maxdist, 220, 10, team, self.owner, self.origin, "MOD_BURNED", "napalmbomb_mp");
         
         if(los1 || los2)
            plr thread burnNapalm(frac, team, self.owner, self.origin, officer);
      //   else
      //      plr thread burnNapalm((frac * 0.5), team, self.owner, self.origin, officer);
      }
   }   
}

bomb_ambient_fires(impactLoc)
{
   maxLumps = 27;
   maxDist = 400;
   
   for(i=0; i<maxLumps; i++)
   {
      loc = impactLoc + (randomIntRange((-1 * maxDist),maxDist),randomIntRange((-1 * maxDist),maxDist),50);
      
      trace = BulletTrace( loc, loc +(0,0,-1000), true, undefined );
      
      thread groundFire(trace["position"], trace["surfacetype"]);
      
      wait 0.05;
   }
}

groundFire(loc, surface)
{
   switch(surface)
   {
      case "water":
      case "snow":
      case "ice":
      case "default":
      case "flesh":
         return;
      
      case "concrete":
      case "mud":
      case "rock":
      case "ceramic":
      case "gravel":
      case "asphalt":
      case "brick":
      case "plaster":
      case "paintedmetal":
      case "metal":
      case "sand":
      case "glass":
      case "fruit":
      case "rubber":
         time = 10;
         break;
      
      case "cloth":
      case "cushion":
      case "bark":
      case "foliage":
      case "grass":
      case "paper":
      case "plastic":
      case "tallgrass":
      case "wood":
         time = 30;
         break;
      
      default:
         time = 10;
         break;
   }
   
   for(i=0; i<time; i++)
   {
      PlayFx( level._effect["plane_napalmstrike_groundfire"], loc );
      wait (randomfloat(3) + 0.3);
   }
}

burnNapalm(time, team, owner, bombloc,officer)
{	
	// no more effects if we are already on fire
//	if ( isdefined( self.burning ) )
	//	return;
		
	self endon("killed_player");
	self endon("spawned");
	self endon("disconnect");
	
	waittillframeend;
	
	self.burning = true;
	
	self thread startBurnDmg(time * 0.9, team, owner, bombloc,officer);
	self thread burn_blocker2(14.0 * time);
	
	
	
	burnLoops = ceil((15.0 * time) / 3);
	
	tagArray = [];
	if ( isai( self ) )
	{
		tagArray[0] = "J_Spine1";
		tagArray[1] = "J_Elbow_LE";
		tagArray[2] = "J_Elbow_RI";
		tagArray[3] = "J_Head";
		tagArray[4] = "j_knee_ri";
		tagArray[5] = "j_knee_le";
	}
	else
	{
		tagArray[0] = "j_spinelower";
		tagArray[1] = "J_Elbow_RI";
		tagArray[2] = "J_Head";
		tagArray[3] = "j_knee_ri";
		tagArray[4] = "j_knee_le";

		// Need set burn
//		if ( isplayer( self ) )
       //  self setburn( 15.0 * time);
	}

	self startTanning(  ); // wewt sizzle.
	
	if( IsDefined( level._effect["character_fire_player_sm"] ) )
	{
		for (arrayIndex = 0; arrayIndex < tagArray.size;  arrayIndex++)
		{
			PlayFxOnTag( level._effect["character_fire_player_sm"] , self, tagArray[arrayIndex] );
		}
	}

	if ( isplayer( self ) )
	{
		self thread watchForWater( 20 * time);
		self thread watchForDeath();
	}
	
	for(i=0; (i < burnLoops) && isdefined(self.burning); i++)
	{
      if ( isplayer( self ) )
         self setburn( 3);
      else
         break;
         
      wait 3;
	}
}

startBurnDmg(time, team, owner, bombloc,officer)
{
   self endon("killed_player");
	self endon("spawned");
	self endon("disconnect");
	
	self doNapalmDmg((time * self.maxhealth * 0.7), team, owner, bombloc);
	
   if(isdefined(self.runningBurn))
   {
       self.burntime += time;
       return;
   }
   self.runningBurn = true;
   self.burntime = time;
 //  iprintln(self.burntime);
   for(i=0; i < (30 * self.burntime) && isdefined(self.burning); i++)
   {
      if(self.burntime > 1)
      {
         self doNapalmDmg(self.maxhealth, team, owner, bombloc,officer);
         
         break;
      }

      self doNapalmDmg(2, team, owner, bombloc,officer);
      
      wait 0.5;
   
   }
      
   self.runningBurn = undefined;
   
}

doNapalmDmg(dmg, team, owner, bombloc,officer)
{
      self.hasBeenTanned = true;
		self thread [[level.callbackPlayerDamage]](
			owner, // eInflictor The entity that causes the damage.(e.g. a turret)
			officer, // eAttacker The entity that is attacking.
			int(dmg), // iDamage Integer specifying the amount of damage done
			0, // iDFlags Integer specifying flags that are to be applied to the damage
			"MOD_BURNED", // sMeansOfDeath Integer specifying the method of death
			"napalmbomb_mp", // sWeapon The weapon number of the weapon used to inflict the damage
			bombloc, // vPoint The point the damage is from?
			vectornormalize(self.origin - bombloc), // vDir The direction of the damage
			"none", // sHitLoc The location of the hit
			0 // psOffsetTime The time offset for the damage
		);
}

burn_blocker2(len)
{
	self endon("disconnect");
	self endon ( "death" );
	
	wait( len );
	
	self.burning = undefined;
}

// self = the spawned script_origin that plays the bomb sound
bomb_sound_delete()
{
	wait( 5 );
	self Delete();
}


bombStrike(team,trace,idx, owner)
{
   if(trace["surfacetype"] == "water")
   {
      PlayFx( level._effect["plane_bombexplosion_water"], self.origin );
   }
   else
   {
      PlayFx( level._effect["plane_bombexplosion"], self.origin );
      PlayFx( level._effect["plane_bombexplosion1"], self.origin );
   }
   
  // thread playSoundinSpace("brm_bombing_explo", self.origin, 5);
   thread playSoundinSpace("artillery_impact", self.origin, 5);
   
   brm_quake( 1, 3.7, self.origin, 1400 );
   
   //thread maps/mp/gametypes/_hardpoints::losRadiusDamage( self.origin + (0,0,16), 512, 200, 30, owner, bomb );
   
 //  thread locRadiusDamage(self.origin + (0,0,16), (512 * 512), 300, 40, team, level.airPlanes[team][idx], self.origin, "MOD_PROJECTILE_SPLASH", "bombingplane_mp",owner);
   thread locRadiusDamage(self.origin + (0,0,16), (512 * 512), 300, 40, team, self, self.origin, "MOD_PROJECTILE_SPLASH", "bombingplane_mp",owner);

}

