#include maps\mp\_utility;

init()
{   
   if(mfDvars("bro_mortardisable",0,"int") != 0)
      level.noDelployableMortars = true;
   else  
      level.noDelployableMortars = false;
      
   if(mfDvars("bro_atweaponsdisable",0,"int") != 0)
      level.noATWeapons = true;
   else  
      level.noATWeapons = false;
   
   weaponTags();

   level thread classWatcher();
   
   if(getdvarint("bro_tint_smokegrenades") > 0)
   {
      level.smokeGrenade["allies"] = "m8_green_smoke_mp";
      level.smokeGrenade["axis"] = "m8_red_smoke_mp";
   }
   else
   {
      
      level.smokeGrenade["allies"] = "m8_white_smoke_mp";  
      level.smokeGrenade["axis"] = "m8_white_smoke_mp";
   }
   
   if(!isDefined(game["classsystem"]))
   {
      game["classsystem"] = [];
   }      
   else if(game["classsystem"]["loaded"] == true)
   {
      println("## BRM DEBUG: ALREADY LOADED");
      return;
   }
   
   println("## BRM DEBUG: LOADING....");
   
   level._tempWeaponArray = [];
   level._tempWeaponidxArray = [];
    
   game["classsystem"]["alliesclasses"] = 0;
   game["classsystem"]["axisclasses"] = 0;
      
   setupClasses("allies");
   setupClasses("axis");
      
   addWeapon(level.smokeGrenade["allies"]);
   addWeapon(level.smokeGrenade["axis"]);
   
   addWeapon("bayonet_mp");
   
   if(level.gametype == "sd" || level.gametype == "esd")  
      addWeapon("bomb_drop_mp");  
   
   if(level.gametype == "ret")
      addWeapon("radio_drop_mp");
      
   addWeapon("satchel_charge_mp");  
   addWeapon("binoculars_mp");
   addWeapon("m2_flamethrower_mp");
   addWeapon("arty_radio_mp");
   addWeapon("mine_bouncing_betty_mp");
   addWeapon("firemode_mp");
   addWeapon("mgcarry_mp");
   addWeapon("357magnum_mp");
   
   if(isdefined(level.fortbhc2_initialized))
   {
      addWeapon("dp28_bipod_mp");
   }
   
   addWeapon(maps\mp\gametypes\_weapons::factionGrenade(game["allies"]));
   addWeapon(maps\mp\gametypes\_weapons::factionGrenade(game["axis"]));
   
   addWeapon(maps\mp\gametypes\_weapons::factionPistol(game["allies"]));
   addWeapon(maps\mp\gametypes\_weapons::factionPistol(game["axis"]));
      
   game["classsystem"]["weapons"] = level._tempWeaponidxArray;

   level._tempWeaponidxArray = [];
   level._tempWeaponArray = [];
 
   game["classsystem"]["loaded"] = true;  
}

setupClasses(team)
{
   if(!isDefined(game["classsystem"][team]))
   {
      game["classsystem"][team] = [];
   }
   
   switch(game[team])
   {
      case "russian":
         classes\_russianclasses::russianClasses(team);
         game["classsystem"][team + "_grenadetype"] = 2;
         defaultWeaponIdx = 13;
         break;
      case "german":
         classes\_germanclasses::germanClasses(team);
         game["classsystem"][team + "_grenadetype"] = 1; 
         defaultWeaponIdx = 8;
         break;
      case "japanese":
         classes\_japaneseclasses::japaneseClasses(team);            
         game["classsystem"][team + "_grenadetype"] = 3;
         defaultWeaponIdx = 29;
         break;
      case "marines":
      default:
         classes\_americanclasses::americanClasses(team);  
         game["classsystem"][team + "_grenadetype"] = 0;
         defaultWeaponIdx = 11;
   }
   
   offset = 0;
   
   for(idx=1; idx <= 12; idx++)
   {
      i = idx-offset;
     
      if(!isDefined(game["classsystem"][team][idx]))
      {
         printLn("## BRM DEDUG: No more " + game[team] + " classs after #"+ (idx-1));
         break;
      }
      
      game["classsystem"][team][i] = game["classsystem"][team][idx];
      
      
      if(isDefined(game["classsystem"][team][i].active) && game["classsystem"][team][i].active == true)
      {
         game["classsystem"][team + "classes"]++;
      }
      else
      {
         game["classsystem"][team][i] = [];
         game["classsystem"][team][i]["active"] = false;
         offset++;
         continue;
      }
      
      if(!isDefined(game["classsystem"][team][i].players))
         game["classsystem"][team][i].players = 0;
         
      if(isDefined(game["classsystem"][team][i].name))
      {
         printLn("## BRM DEDUG: " + game[team] + " Class #"+idx + " " + game["classsystem"][team][i].name);
      }
      else
      {
         printLn("## BRM WARNING: " + game[team] + " Class #"+ idx + " No Name Set");
         game["classsystem"][team][i].name = "Class #" + i;  
      }    
      
      if(!isDefined(game["classsystem"][team][i].primaries) || game["classsystem"][team][i].primaries == "")
         game["classsystem"][team][i].primaries = defaultWeaponIdx;
         
      if(!isDefined(game["classsystem"][team][i].extras))
         game["classsystem"][team][i].extras = "";
         
      weapons = StrTok(game["classsystem"][team][i].primaries,",");
      extras = StrTok(game["classsystem"][team][i].extras,",");
      
      game["classsystem"][team][i].primaries = [];
      game["classsystem"][team][i].extras = [];
      
      idxOffset = 0;
       
      for(w=0; w < weapons.size && w < 5; w++)
      {
         weap = int(weapons[w]);
         
                 
         if(weap == 44 && level.noDelployableMortars)
         {
            println("## BRM DEBUG: disabling mortar in " + team + " class #" + idx);
            idxOffset++;
            continue;
         }
         
         if((weap == 2 || weap == 17) && level.noATWeapons)
         {
            println("## BRM DEBUG: disabling AT Weapon in " + team + " class #" + idx);
            idxOffset++;
            continue;
         }
         
         if(weapons[w] != "" && isdefined(level.squadSystemWeapons[weap]))
         {
            game["classsystem"][team][i].primaries[game["classsystem"][team][i].primaries.size] = weap;
            
            addWeapon(weap);
            
            if(isdefined(extras[w]) && extras[w] != " ")
               game["classsystem"][team][i].extras[w-idxOffset] = int(extras[w]);
            else
               game["classsystem"][team][i].extras[w-idxOffset] = 0;    
         }
         else
         {
            idxOffset++;
         }
      }
      /*
      println("## BRM DEBUG: " + game["classsystem"][team][i].name + " Extras: ");
      
      for(i =0; i < game["classsystem"][team][i].extras.size; i++)
         println("\t extras["+i+"] => '" + game["classsystem"][team][i].extras[i]+"'");
      */
      if(game["classsystem"][team][i].primaries.size == 0)
      {
         game["classsystem"][team][i].active = false;
         game["classsystem"][team][i] = [];
         game["classsystem"][team][i]["active"] = false;
         game["classsystem"][team + "classes"]--;
         offset++;
         continue;
      }
      
      if(!isDefined(game["classsystem"][team][i].frags))
      {
         game["classsystem"][team][i].frags = 0;
      }
      else
      {
         game["classsystem"][team][i].frags = int(game["classsystem"][team][i].frags);    
         game["classsystem"][team][i].frags = limitVar(game["classsystem"][team][i].frags,0,3);
      }
      
      if(!isDefined(game["classsystem"][team][i].smokes))
      {
         game["classsystem"][team][i].smokes = 0;
      }
      else
      {
         game["classsystem"][team][i].smokes = int(game["classsystem"][team][i].smokes);    
         game["classsystem"][team][i].smokes = limitVar(game["classsystem"][team][i].smokes,0,3);
      }

      if(!isDefined(game["classsystem"][team][i].hasPistol))
      {
         game["classsystem"][team][i].hasPistol = true;
      }
      
      if(!isDefined(game["classsystem"][team][i].slots))
         game["classsystem"][team][i].slots = 10;
         
      if(!isDefined(game["classsystem"][team][i].slots))
      {
         game["classsystem"][team][i].slots = 10;
      }
      else
      {
         game["classsystem"][team][i].slots = int(game["classsystem"][team][i].slots);    
         game["classsystem"][team][i].slots = limitVar(game["classsystem"][team][i].slots,0,100);
      }
      
      tmp = [];
      
      tmp["active"] = game["classsystem"][team][i].active;
      tmp["name"] = game["classsystem"][team][i].name;
      tmp["primaries"] = game["classsystem"][team][i].primaries;
      tmp["extras"] = game["classsystem"][team][i].extras;
      tmp["hasPistol"] = game["classsystem"][team][i].hasPistol;
      tmp["slots"] = game["classsystem"][team][i].slots;
      tmp["frags"] = game["classsystem"][team][i].frags;
      tmp["smokes"] = game["classsystem"][team][i].smokes;
      tmp["players"] = game["classsystem"][team][i].players;
      
      game["classsystem"][team][i] = [];
      game["classsystem"][team][i] = tmp;
   }   
}

classWatcher()
{
   level endon("game_ended");
   level endon("comp_map_restarting");
   data = [];
   wait 0.15;
   
   if(!isDefined(game["classsystem"]["allies"]))
      println("## BRM DEBUG game[\"classsystem\"][\"allies\"] not defined");
   else if(!isDefined(game["classsystem"]["allies"][1]))
      println("## BRM DEBUG game[\"classsystem\"][\"allies\"][1] not defined");
   
   
   while(1)
   {
      data["allies"] = [];
      data["axis"] = [];
      
      for (i = 0; i < level.players.size; i++)
      {
         if(isdefined(level.players[i].pers["team"]) && (level.players[i].pers["team"] == "allies" || level.players[i].pers["team"] == "axis") && isdefined(level.players[i].pers["chosenclass"]))
         {
            if(!isdefined(data[level.players[i].pers["team"]][level.players[i].pers["chosenclass"]]))
            {
               data[level.players[i].pers["team"]][level.players[i].pers["chosenclass"]] = 1;
            }
            else
            {
               data[level.players[i].pers["team"]][level.players[i].pers["chosenclass"]]++;
            }
         }   
      }
      
      for(i=1; i<=game["classsystem"]["alliesclasses"]; i++)
      {
         if(isdefined(data["allies"][i]))
            game["classsystem"]["allies"][i]["players"] = data["allies"][i];
         else
            game["classsystem"]["allies"][i]["players"] = 0;
      }
      
      for(i=1; i<=game["classsystem"]["axisclasses"]; i++)
      {
         if(isdefined(data["axis"][i]))
            game["classsystem"]["axis"][i]["players"] = data["axis"][i];
         else
            game["classsystem"]["axis"][i]["players"] = 0;
      } 
      wait 0.4; 
   }
}

menuLoad()
{
   self endon("disconnect");
   self endon("classselected");
   team = self.pers["team"];
 
   self setclientdvars("ui_maxnum_classes",game["classsystem"][team + "classes"]);
   
   wait 0.05;
                  
   
     
   if(isDefined(self.pers["loadoutsubmitted"]))
   {
      self.pers["tempclass"] = self.pers["chosenclass"];
      self.pers["tempweapon"] = self.pers["chosenweapon"];
      
      class = self.pers["chosenclass"];
      weapon = self.pers["chosenweapon"];
      
      for(i=1;i<=game["classsystem"][team + "classes"]; i++)
      {
         if(game["classsystem"][team][i]["active"])
         {
            classCount = game["classsystem"][team][i]["players"];
         
            if(game["classsystem"][team][i]["slots"] > 30)
               playerStr = "(" + classCount + ")";
            else
               playerStr = "(" + classCount + "/" + game["classsystem"][team][i]["slots"] + ")";
               
           // isFull = (classCount < game["classsystem"][team][i]["slots"]);
            
            isAvilable = (classCount < game["classsystem"][team][i]["slots"]) || (isDefined(self.pers["chosenclass"]) && self.pers["chosenclass"] == i);
                        
            self setclientdvars("ui_class" + i + "_players",playerStr,
                           "ui_class" + i + "_active",isAvilable);
         }
         
         if(i == 6)
            wait 0.05;
      }
      
      self setclientdvars("ui_selectedClass", class);
      
      self setClientDvars("ui_selectedClassName",game["classsystem"][team][class]["name"]);
                    //    "ui_maxnum_primaries",0,
                   //     "ui_selectedWeapon",99);
   
      for(i=0; i<game["classsystem"][team][class]["primaries"].size; i++)
      {
         self setclientdvars("ui_primary_" + i, game["classsystem"][team][class]["primaries"][i]);
         wait 0.05;
      }
         
      self setclientdvars("ui_maxnum_primaries",game["classsystem"][team][class]["primaries"].size);
      
      self setclientdvars(
      //"ui_selectedWeapon",game["classsystem"][team][class].primaries[weapon],
      "ui_selectedWeapon",weapon,
                           "ui_numfrags",game["classsystem"][team][class]["frags"],
                           "ui_numsmokes",game["classsystem"][team][class]["smokes"],
                           "ui_extras", game["classsystem"][team][class]["extras"][weapon]);    
                           
      if(game["classsystem"][team][class]["hasPistol"])
         self setclientdvars("ui_hassecondary",level.squadSystemSecondary[game[team]]);
      else 
         self setclientdvars("ui_hassecondary",-1);
                            
   }
   else
   {
      self setclientdvars("ui_selectedClass", -1);
      
      for(i=1;i<=game["classsystem"][team + "classes"]; i++)
      {
         if(game["classsystem"][team][i]["active"])
         {
         
            classCount = game["classsystem"][team][i]["players"];
            
            if(game["classsystem"][team][i]["slots"] > 30)
               playerStr = "(" + classCount + ")";
            else
               playerStr = "(" + classCount + "/" + game["classsystem"][team][i]["slots"] + ")";
               
            isFull = (classCount < game["classsystem"][team][i]["slots"]);
                    
            self setclientdvars("ui_class" + i + "_players",playerStr,
                              "ui_class" + i + "_active",isFull,
                              "ui_classname_" + i, game["classsystem"][team][i]["name"]);                 
         }
         else
         {
            self setclientdvars("ui_class" + i + "_players","",
                              "ui_class" + i + "_active",0,
                              "ui_classname_" + i, game["classsystem"][team][i]["name"]);
         }
         
         if(i == 6)
            wait 0.05;
      }
   }
   
   wait 0.05;
   self setclientdvars("ui_grenadetype",game["classsystem"][team + "_grenadetype"]);
   
   self thread refreshAvailClasses(false);
}


refreshAvailClasses(once)
{
   self endon("classselected");
   self endon("kill_class_thread");
   self endon("disconnect");
   self endon("spawned");
   
   team = self.pers["team"];
   
   wait 0.3;
   
   while(1)
   {
      for(i=1;i<=game["classsystem"][team + "classes"]; i++)
      {
         if(game["classsystem"][team][i]["active"])
         {
            classCount = game["classsystem"][team][i]["players"];
         
            if(game["classsystem"][team][i]["slots"] > 30)
               playerStr = "(" + classCount + ")";
            else
               playerStr = "(" + classCount + "/" + game["classsystem"][team][i]["slots"] + ")";
            
            isAvilable = (classCount < game["classsystem"][team][i]["slots"]) || (isDefined(self.pers["chosenclass"]) && self.pers["chosenclass"] == i);
            
            self setclientdvars("ui_class" + i + "_players",playerStr,
                           "ui_class" + i + "_active",isAvilable);
         }
         
         if(i == 6)
            wait 0.1;
      }
   
      wait 0.3;
      
      if(once == true)
         break;
   }
}

class_select(response)
{
   self endon("disconnect");
   
   team = self.pers["team"];

   selected = limitvar(int(getsubstr(response,12)),1,game["classsystem"][team + "classes"]);
   
   if(isDefined(self.pers["chosenclass"]))
   {
      if(game["classsystem"][team][selected]["players"] >= game["classsystem"][team][selected]["slots"] && self.pers["chosenclass"] != selected)
      {
         self setclientdvars("ui_classactive_" + selected,false);
         self iprintln("^1Class not active");
         return;
      }
   }
   else
   {
      if(game["classsystem"][team][selected]["players"] >= game["classsystem"][team][selected]["slots"])
      {
         self setclientdvars("ui_classactive_" + selected,false);
         self iprintln("^1Class not active");
         return;
      }
   }
  
   
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {
      if(isdefined(self.pers["chosenclass"]))
      {
      //   if(game["classsystem"][team][self.pers["chosenclass"]].players > 1)
      //      game["classsystem"][team][self.pers["chosenclass"]].players--;
      }
       
      self.pers["chosenclass"] = selected;
            
      game["classsystem"][team][self.pers["chosenclass"]]["players"]++;
  /*    
      if(game["squadsystem"][team]["classactive"][self.pers["previoussquad"]][selected] == 0 && isDefined(level._squadWatcherData[team][self.pers["previoussquad"]][selected]) && level._squadWatcherData[team][self.pers["previoussquad"]][selected] != self)
      {
         self setclientdvars("ui_classactive_" + selected,0);
         return;
      }
  */
   }
   else
   {         
      self.pers["tempclass"] = selected;
   /*      
      if(game["squadsystem"][team]["classactive"][self.pers["tempsquad"]][selected] == 0 && !(self.pers["tempsquad"] == self.pers["chosensquad"] && self.pers["chosenclass"] == selected))
      {
         self setclientdvars("ui_classactive_" + selected,0);
         self iprintln("^1Class not active");
         return;
      }
   */
   }   

   self setclientdvars("ui_selectedClass", selected,
                        "ui_maxnum_primaries",0,
                        "ui_selectedWeapon",99);
   
   self setclientdvars("ui_selectedClassName",game["classsystem"][team][selected]["name"]);
   
   for(i=0; i<game["classsystem"][team][selected]["primaries"].size; i++)
   {
      self setclientdvars("ui_primary_" + i, game["classsystem"][team][selected]["primaries"][i]);
      wait 0.05;
   }
      
   self setclientdvars("ui_maxnum_primaries",game["classsystem"][team][selected]["primaries"].size);
   
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {
      self.pers["chosenweapon"] = 0;
   }
   else
   {
      self.pers["tempweapon"] = 0;
   }
   
   self setclientdvars(//"ui_selectedWeapon",game["classsystem"][team][selected].primaries[0],
            "ui_selectedWeapon",0,
                           "ui_numfrags",game["classsystem"][team][selected]["frags"],
                           "ui_numsmokes",game["classsystem"][team][selected]["smokes"],
                           "ui_extras", game["classsystem"][team][selected]["extras"][0]); 
                           
   if(game["classsystem"][team][selected]["hasPistol"])
      self setclientdvars("ui_hassecondary",level.squadSystemSecondary[game[team]]);
   else 
      self setclientdvars("ui_hassecondary",-1);
}

weapon_select(response)
{
   weapon = int(getsubstr(response,13));
   
   team = self.pers["team"];
   
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {
      selectedclass = self.pers["chosenclass"];
      self.pers["chosenweapon"] = weapon;
   }
   else
   {  
      selectedclass = self.pers["tempclass"];
      self.pers["tempweapon"] = weapon;
   }
   
   self setclientdvars( // "ui_selectedWeapon",game["classsystem"][team][selectedclass].primaries[weapon],
                     "ui_selectedWeapon",weapon,
                        "ui_extras", int(game["classsystem"][team][selectedclass]["extras"][weapon]));
}



loadout_confirm()
{
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {
      selectedclass = self.pers["chosenclass"];
      selectedweapon = self.pers["chosenweapon"];
   }
   else
   {  
      selectedclass = self.pers["tempclass"];
      selectedweapon = self.pers["tempweapon"];
   }
   
   if(!isdefined(selectedweapon))
   {
      return;
   }

   self notify("classselected");
   
   team = self.pers["team"];
   
   posWeapon = game["classsystem"][team][selectedclass]["primaries"][selectedweapon];
   
   if(isdefined(level.squadSystemWeapons[posWeapon]))
   {
      if(!isDefined(self.pers["loadoutsubmitted"]))
         self.pers["loadoutsubmitted"] = true;
      else
      {
       // this lot needs sorting out - need previous vars for class as well as squad
    //     if(isdefined(self.pers["chosenclass"]))
   //         game["squadsystem"][team]["classactive"][selectedsquad][self.pers["chosenclass"]] = 1;
      
       //  game["squadsystem"][team]["classactive"][self.pers["previoussquad"]][self.pers["chosenclass"]] = 1;
     //    game["classsystem"][team][self.pers["previoussquad"]][self.pers["chosenclass"]] = 1;
               
         self.pers["previousclass"] = selectedclass;
         self.pers["chosenclass"] = selectedclass;
         self.pers["chosenweapon"] = selectedweapon;
         
         game["classsystem"][team][selectedclass]["players"]++;
      }
         
      self.selectedClass = true;
      self [[level.class]](level.squadSystemWeapons[posWeapon]);
      
   //  createsquad(self);
	}
}

weaponTags()
{
   for( i = 0; i <= 44; i++ )
	{
		weapon_name = tablelookup( "mp/weapondata.csv", 0, i, 5 );
		
		if(weapon_name != "")
         level.squadSystemWeapons[i] = weapon_name;	
   }
   
   level.squadSystemSecondary["marines"] = 4;
   level.squadSystemSecondary["german"] = 32;
   level.squadSystemSecondary["russian"] = 27;
   level.squadSystemSecondary["japanese"] = 16;   
}

addWeapon(weapId)
{
   if(!isDefined(level.squadSystemWeapons[weapId]))
   {
      level._tempWeaponArray[weapId] = true;
      level._tempWeaponidxArray[level._tempWeaponidxArray.size] = weapId;
   }
   else if(!isDefined(level._tempWeaponArray[level.squadSystemWeapons[weapId]]))
   {
      level._tempWeaponArray[level.squadSystemWeapons[weapId]] = true;
      level._tempWeaponidxArray[level._tempWeaponidxArray.size] = level.squadSystemWeapons[weapId];
      
      // get variants

      weapon_attachments = tablelookup( "mp/weapondata.csv", 0, weapId, 6 );

      if(weapon_attachments != "")
      {
         attachments = strtok(weapon_attachments," ");
         
         baseWeap = getSubStr(level.squadSystemWeapons[weapId],0,level.squadSystemWeapons[weapId].size - 2);
              
         for(i=0; i < attachments.size; i++)
         {
            w = baseWeap + attachments[i] + "_mp";
            level._tempWeaponArray[w] = true;
            level._tempWeaponidxArray[level._tempWeaponidxArray.size] = w;
         }
      }
   }
}

resetClass()
{
    
   self.pers["loadoutsubmitted"] = undefined;
   self.pers["previoussquad"] = undefined;
   self.pers["chosenclass"] = undefined;
   self.pers["chosenweapon"] = undefined;
   self.pers["tempclass"] = undefined;
   self.pers["tempweapon"] = undefined;

}
