initComp()
{
   precacheString(&"BRM_PLAYER_UNREADY");
   precacheString(&"BRM_PLAYER_READY");
   precacheShader("readyup_background");
   precacheString(&"BRM_WAITING_ON");
   precacheString(&"BRM_NO_PASSWORD");
   precacheHeadIcon("waypoint_second_chance");
   
   level thread checkForMatch();
   
   level thread readyUpStart();
      
}

checkForMatch()
{   
   if(!isdefined(game["isMatch"])) game["isMatch"] = false;
   if(!isdefined(game["preMatch"])) game["preMatch"] = false;
   
   
   if(getdvar("bro_match") == "") setdvar("bro_match","0");
   if(getdvar("bro_defenders") == "") setdvar("bro_defenders","axis");
   if(getdvar("bro_stratTime") == "") setdvar("bro_stratTime",5);
   if(getdvar("bro_match_forcerecord") == "") setdvar("bro_match_forcerecord","0");
   
   if(getdvarint("bro_stratTime") <= 0 ) setdvar("bro_stratTime",0);
   else if(getdvarint("bro_stratTime") <= 3 ) setdvar("bro_stratTime",3);
   
   if(level.gametype == "sd" || level.gametype == "ret")
      game["strattime"] = getdvarint("bro_stratTime");
   else
       game["strattime"] = 0;
       
   wait 0.2;
   
   while(1)
   {      
       if(getdvar("bro_match") == "0" && game["isMatch"])
       {
         
            game["isMatch"] = false;
            game["preMatch"] = false;
            iprintlnbold(&"MSBRM_COMP_CHANGE_PUB");
            
            wait 5;
            resetParams(true,true);
            println("###loading public mode");
            map_restart(true);
         
      }
      else if(getdvar("bro_match") != "0" && !game["isMatch"])
      {
         game["isMatch"] = true;
         game["preMatch"] = true;
         println("###loading match mode");
         
         if(getdvar("bro_match")=="tcl")
         {
            iprintlnbold("^5Loaded ^1TCL ^5Official League Settings");
            wait 1;
            level thread maps\mp\rulesets\tcl::ruleSet();
            wait 1;
         }
         
         iprintlnbold(&"MSBRM_COMP_CHANGE_MATCH");

         wait 5;
         resetParams(false,true);
            
         map_restart(true);
      }
      if(getdvar("g_gametype") == "sd")
      {
         if(getdvar("bro_defenders") == "axis" && game["defenders"] == "allies" && game["preMatch"])
         {
            iprintlnbold(&"MSBRM_COMP_SWITCH_DEF_AXIS");
              println("###switching axis");
            wait 5;
            resetParams(true,true);
            
            game["defenders"] = "axis";
               
            map_restart(true);
         }
         else if(getdvar("bro_defenders") == "allies" && game["defenders"] == "axis" && game["preMatch"])
         {
            iprintlnbold(&"MSBRM_COMP_SWITCH_DEF_ALLIES");
                println("###switching allies");
            wait 5;
            
            resetParams(true,true);
            game["defenders"] = "allies";
               
            map_restart(true);
            
         }       
      }
      wait 5;
   }
}



readyUpStart()
{

   wait 1;

   if(game["isMatch"]==false || game["preMatch"] == false)
   {
      if(isdefined(level.readyupBackground)) level.readyupBackground destroy();
      if(isdefined(level.readyupRemaining)) level.readyupRemaining destroy();
      
      for(i=0;i<level.players.size; i++)
         if(isdefined(level.players[i].readyupHud)) level.players[i].readyupHud destroy();

      return;
   }
   
   visionSetNaked( getDvar( "mapname" ), 1.0 );
   
   
   if(!isdefined(level.readyupBackground))
   {

      level.readyupBackground = newHudElem();
      level.readyupBackground.horzAlign = "right";
      level.readyupBackground.vertAlign = "top";
      level.readyupBackground.x = 0;
      level.readyupBackground.y = 0;
      level.readyupBackground.alignX = "right";
      level.readyupBackground.alignY = "top";
   }
   
   level.readyupBackground setshader("readyup_background",150,128);
   
   if(!isdefined(level.readyupRemaining))
   {
      level.readyupRemaining = newHudElem();
      level.readyupRemaining.horzAlign = "right";
      level.readyupRemaining.vertAlign = "top";
      level.readyupRemaining.x = -70;
      level.readyupRemaining.y = 70;
      level.readyupRemaining.alignX = "center";
      level.readyupRemaining.alignY = "top";
      level.readyupRemaining.color = (0.92,0.8,0);
      level.readyupRemaining.font = "default";
      level.readyupRemaining.fontscale = 1.4;
      level.readyupRemaining.sort = 4;
   }
   
   level.readyupRemaining settext(&"BRM_WAITING_ON",0);
   
   if(!isdefined(level.passwordReminder))
   {
      level.passwordReminder = newHudElem();
      level.passwordReminder.horzAlign = "center";
      level.passwordReminder.vertAlign = "top";
      level.passwordReminder.alignX = "center";
      level.passwordReminder.alignY = "top";
      level.passwordReminder.y = 18;
      level.passwordReminder.X = 0;
   //   level.passwordReminder.color = (0.92,0.8,0);
      level.passwordReminder.font = "default";
      level.passwordReminder.fontscale = 1.4;
      level.passwordReminder.sort = 4;
   }
   
   
   level.passwordReminder settext(&"BRM_NO_PASSWORD");
   

   while(game["preMatch"])
   {
      playersReady=0;
      
      for(i=0;i<level.players.size; i++)
      {
         if(isdefined(level.players[i].isReady) && level.players[i].isReady == true)
            playersReady++;
      
      }
      
      if(getdvar("g_password") == "")
         level.passwordReminder.alpha = 1;
      else
         level.passwordReminder.alpha = 0;

      level.readyupRemaining settext(&"BRM_WAITING_ON", level.players.size - playersReady);
      
      if(playersReady == level.players.size)
      {
         level checkForMatchStart();   
      }         
      wait 0.5;
   }
   
  
}

onPlayerSpawn()
{
   self endon("disconnect");
      
   for(;;)
   {
      self waittill("spawned_player");
			
      if(!isdefined(self.isReady))
         self thread initReadyUp();
   
   }
}

initReadyUp()
{
   if(game["isMatch"]==false || game["preMatch"] == false) 
      return;
   
   self endon("disconnect");
     
   self.statusicon = "statusicon_unready";
   
   self.isReady = false;
   
   self waittill("spawned_player");

   wait 0.1;

   
   self.protected = true;
   
   self thread spawnProtection();
   
   wait 5;
   
   if(!isdefined(self.readyupHud))
   {
      self.readyupHud = newClientHudElem(self);
      self.readyupHud.horzAlign = "right";
      self.readyupHud.vertAlign = "top";
      self.readyupHud.x = -70;
      self.readyupHud.y = 20;
      self.readyupHud.alignX = "center";
      self.readyupHud.alignY = "top";
      self.readyupHud.color = (0.66,0,0);
      self.readyupHud.font = "default";
      self.readyupHud.fontscale = 1.4;
   
   }
   
   
   if(getdvar("bro_match")=="tcl")
      self iprintlnbold(&"MSBRM_COMP_INTRO_TCL");
   
   wait 2;
   
   self iprintlnbold(&"MSBRM_COMP_PRESS_USE");
   wait 2;
   self iprintlnbold("^2by readying up you are agreeing to the terms of this match");
   
   wait 2;
   
   self.readyupHud settext( &"BRM_PLAYER_UNREADY" );
   
   
     
   while(game["preMatch"])
   {
      self setClientDvars( "ui_hud_hardcore", 0);
      
      while(!self useButtonPressed() || !isdefined(self.pers["team"])) 
      {
         if(!isdefined(self.pers["team"]))
         {
            self.statusicon = "statusicon_unready";
            self.readyupHud settext( &"BRM_PLAYER_UNREADY" );
            self.readyupHud.color = (0.66,0,0);
            self.isReady = false;
         }
         else if(self.pers["team"] == "spectator")
         {
            self.statusicon = "statusicon_unready";
            self.readyupHud settext( &"BRM_PLAYER_UNREADY" );
            self.readyupHud.color = (0.66,0,0);
            self.isReady = false;
            
            while(self.pers["team"] == "spectator")
               wait 0.05;            
         }
         wait 0.05;  
      }  					
			
      if(self.isReady)
      {
         self.statusicon = "statusicon_unready";
         self.readyupHud settext( &"BRM_PLAYER_UNREADY" );
         self.readyupHud.color = (0.66,0,0);
         self.isReady = false;
      }
      else
      {
         self.statusicon = "statusicon_ready";
         self.readyupHud settext( &"BRM_PLAYER_READY" ); 
         self.readyupHud.color = (0,0.55,0);
         self.isReady = true;
         wait 0.1;
   /*      if(getdvar("bro_match_forcerecord") == "1")
         {
            self iprintln("^3You are now ^1Auto Recording");
            self openmenunomouse(game["menu_forcerecord"]);
         }
   */
      }

      wait 2;
   }
}

spawnProtection()
{
   self endon("disconnect");
   
   while(1)
   {
      if(self.protected && game["preMatch"])
      {
         self.headicon = "waypoint_second_chance";
      }
      else
      {
         self.headicon = "";
      }
   
      wait 0.5;
   }
  

}

checkForMatchStart()
{
   // Check if there are players on both teams
   countdownTime = 6;
   teams["allies"] = 0;
   teams["axis"] = 0;
   wait 1;
   
   for(time=countdownTime; time >= 0; time--)
   {
      teams["allies"] = 0;
      teams["axis"] = 0;
   
      for(i=0;i<level.players.size;i++)
      {
         player = level.players[i];
         // valid conditions: must be on a team, not spectate, must be ready
         
         if(!isdefined(player.pers["team"])) 
         {
         //   iprintlnbold(player.name + " has not got a team");
            return;
         }
         
         if(!(player.pers["team"] == "axis" || player.pers["team"] == "allies")) 
         {
         //   iprintlnbold(player.name + " is in spec");
            return;
         }
         else
            teams[player.pers["team"]]++;
         
         if(isdefined(player.isReady) && player.isReady == false)
         {
            iprintlnbold(&"MSBRM_COMP_PLR_NOT_READY",player);
            return;
         }
      }
      
      if(teams["allies"] == 0 || teams["axis"] == 0)
      {
      //   iprintlnbold("Not players on each team");
         return; 
      }
      
      iprintlnbold(&"MSBRM_COMP_STARTING_IN", time);
   
      wait 1;
      
    
   }
   game["preMatch"] = false;
 //  setdvar("bro_defenders","");
 
 println("###starting match");
 
   resetParams(true,false);
   
   map_restart(true);
      
   // Check that all are ready.
   
   // Countdown, checking each half second.
   
   // Cancel if someone not ready or in spec
 }
 
 resetParams(grace,chooseTeams)
 {
   level notify ("comp_map_restarting");
   
   if( game["state"] == "postgame" || level.gameEnded )
   {
      game["state"] = "playing";
   }
     
   if(isdefined(level.readyupBackground)) level.readyupBackground destroy();
   if(isdefined(level.readyupRemaining)) level.readyupRemaining destroy();
   if(isdefined(level.passwordReminder)) level.passwordReminder destroy();
   
   game["teamScores"]["allies"] = 0;
   game["teamScores"]["axis"] = 0;
   game["roundsplayed"] = 0;
   game["switchedsides"] = false;
   
   game["savescore"] = [];
   game["savekills"] = [];
   game["savedeaths"] = [];
   game["saveassists"] = [];
   
   if(chooseTeams)
   {
      println("###reseting squad system");
      game["squadsystem"] = undefined;
      game["squadsystem"]["setup"] = false;
   }
   
   if(grace) game["gamestarted"] = undefined;
  
   for(i=0;i<level.players.size; i++)
   {
      if(isdefined(level.players[i].readyupHud)) level.players[i].readyupHud destroy();
      
     if( game["state"] == "postgame" || level.gameEnded )
      {
         
         level.players[i] setclientdvar( "g_scriptMainMenu", game["menu_team"] );

      }

      
      if(chooseTeams)
      {
         level.players[i].pers["team"] = undefined;
         level.players[i].pers["weapon"] = undefined;
         level.players[i].pers["pickweapon"] = undefined;
         
         level.players[i].pers["loadoutsubmitted"] = undefined;
         level.players[i].pers["previoussquad"] = undefined;
         level.players[i].pers["chosensquad"] = undefined;
         level.players[i].pers["chosenclass"] = undefined;
         level.players[i].pers["chosenweapon"] = undefined;
         
         level.players[i].pers["admin"] = undefined;
         
      }
      
         level.players[i].pers["tempdeaths"] = 0;
         level.players[i].pers["tempkills"] = 0;
         level.players[i].pers["tempassists"] = 0;
         level.players[i].pers["tempscore"] = 0;
      
      level.players[i].pers["deaths"] = 0;
      level.players[i].pers["kills"] = 0;
      level.players[i].pers["assists"] = 0;
      level.players[i].pers["score"] = 0;
      
      level.players[i].deaths = 0;
      level.players[i].kills = 0;
      level.players[i].assists = 0;
      level.players[i].score = 0; 
      
   } 
 }
