#include maps\mp\_utility;

runSetup()
{
   defaultDvars();
   clanModeSetup();
   assignLevelVars();
}

initDvar(dvarName, dVal)
{
   if(getdvar(dvarName) == "")
      setdvar(dvarName,dVal);
}

defaultDvars()
{

   
    // Client Side Stuff 
   setdvar("sv_clientside", "0"); 
   setdvar("sv_clientArchive", "1");
   setdvar("sv_clientSideBullets", "1"); 
   setdvar("sv_clientSideVehicles", "1"); 
   setdvar("g_client_side_lights", "1"); 
   
   // Forced settings
   
   setdvar("scr_game_hardpoints", "0");
   setdvar("scr_game_suicidepointloss", "0" );
   setdvar("scr_hardcore","0");
   setdvar("scr_oldschool", "0");
   
   initDvar("scr_dom_capturetime",10.0);
    
    //////////
    
    // HUD Settings
       
   initDvar("bro_hideObits",1); 
   initDvar("bro_cleanHud","1");
   initDvar("bro_noDogtags","1");
   initDvar("bro_noCrosshair","1");
   initDvar("bro_noPlayerNames","1");
   initDvar("bro_noHitBlip","1");
   initDvar("bro_thirdPSpec","1");
   initDvar("ui_hud_showdeathicons","0");
   initDvar("bro_blackScreen","1");
   initDvar("bro_hiteffect_blur","0.25");
   initDvar("bro_hidescores_sd",1);
   initDvar("bro_hidescores_ret",1);
   
   initDvar("bro_hidescores",0);
   
   initDvar("bro_hidescores_" + level.gametype,getdvar("bro_hidescores"));
   
   initDvar("bro_showMinimap","1");
   initDvar("bro_movechatpos","5 200");
   
      setdvar("scr_showperksonspawn",0);
      
   // Suppression Settings
   
   initDvar("bro_bulletsuppression",2);
   initDvar("bro_bulletsuppressionrange",28);
   initDvar("bro_bulletsuppressionviewkick",1);
   
   initDvar("bro_bulletsuppression_smg",1);
   initDvar("bro_bulletsuppression_rifle",1);
   initDvar("bro_bulletsuppression_pistol",0);
   initDvar("bro_bulletsuppression_mg",1);
   initDvar("bro_bulletsuppression_shotgun",0);
   
   // Gameplay Settings
   
   initDvar("bro_forceAutoAssign","0");
   initDvar("bro_tint_smokegrenades","0");
   initDvar("bro_teamkillcam",1);
   initDvar("bro_squads_autojoin",1);
   initDvar("bro_tanks_givecoax",1);
   
   // Effect Settings
   
   initDvar("bro_scaleearthquake_strength",1);
   initDvar("bro_scaleearthquake_duration",1);
   initDvar("bro_scaleearthquake_radius",1);
   
   
   // Sound Settings
   
   initDvar("bro_betterSound","1"); 
   initDvar("bro_noMusic","1");
   initDvar("bro_noTinkles","1");
   
   // Health and Bleeding
   
   initDvar("bro_noRegen","1");
   
   // Sprint Settings
   
   initDvar("bro_sprintscale",1.3);
   initDvar("bro_sprintrechargepause",5);
   
   initDvar("bro_scaleSpeed_boltaction",1);
   initDvar("bro_scaleSpeed_sniper",1);
   initDvar("bro_scaleSpeed_semiauto",1);
   initDvar("bro_scaleSpeed_smg",1);
   initDvar("bro_scaleSpeed_lmg",0.9);
   initDvar("bro_scaleSpeed_hmg",0.85);
   initDvar("bro_scaleSpeed_shotgun",1);
   initDvar("bro_scaleSpeed_antitank",0.9);
   
   // Weapon Settings
   
   initDvar("bro_dropWeapHit",2); // 0 = no drop, 1 = drop on hand hit, 2 = drop on lower arm hit, 3 = drop on arm hit -1 = no drops
   
   initDvar("bro_impactTimeScale",0.7);
   initDvar("bro_impactWeaponDropScale",0.4);
   
   initDvar("bro_hitSpinAmount",1.2);
   initDvar("bro_rearmPistols","0");
	initDvar("bro_rearmMaxAmmo",100);
	
	initDvar("bro_officer_revolver",1);
	
   initDvar("bro_onePrimaryWeapon","1");
   
      // Smokes and frags
      initDvar("bro_dropfrags",1);
      
      initDvar("bro_dropfrags_" + level.gametype,getdvar("bro_dropfrags"));
         
      initDvar("bro_dropsmokes_sd",1);
         
      initDvar("bro_dropsmokes",0);
      
      initDvar("bro_dropsmokes_" + level.gametype,getdvar("bro_dropsmokes"));
  
   initDvar("bro_gunJamming","1");
      
      // Weapon jamming modifier chance is 1 in #
      
      initDvar("bro_jamchance_boltaction",200);
      initDvar("bro_jamchance_pistol",300);
      initDvar("bro_jamchance_semiauto",450);
      initDvar("bro_jamchance_smg",750);
      initDvar("bro_jamchance_lmg",1000);
      initDvar("bro_jamchance_hmg",1400);
      initDvar("bro_jamchance_shotgun",1000);
   

   // Mortars
   
         
   initDvar("bro_dropmortars_sd",1);  
   initDvar("bro_dropmortars",0);
   
   initDvar("bro_dropmortars_" + level.gametype,getdvar("bro_dropmortars"));
      
   initDvar("bro_destroyable_mortars",1);
   
   // S&D Settings
   
   initDvar("bro_sd_noPlantWarning","1");
   initDvar("bro_sd_giveBomb","0");
   initDvar("bro_sd_nadeDelay",20);
   initDvar("bro_sd_noDefuseSound","0"); 
   initDvar("bro_sd_startDamagePrevention",10);
   initDvar("bro_sd_startRoundWeaponDisable",0);
   
   
 
   // Fall Damage
   
   initDvar("bro_minFallHeight",80);
   initDvar("bro_maxFallHeight",250);
   initDvar("bro_fallPunish",1);
   initDvar("bro_minFallPunishThreshold",15); // damage points for min punish
   initDvar("bro_maxFallPunishThreshold",60); // apply max punishment at this dmg.
   initDvar("bro_fallPunishCrouch",0); // Time for force crouch over punish threshold
   initDvar("bro_fallPunishSprint",80); // Time for no sprint over punish threshold
   setdvar("bg_fallDamageMaxHeight", getdvarint("bro_maxFallHeight"));
	setdvar("bg_fallDamageMinHeight", getdvarint("bro_minFallHeight"));
	
   // Admin System

   initDvar("bro_warnHipshot","1");
   initDvar("bro_warnHipshotMinDist",0);
   initDvar("bro_warnJumpshot","1");
   initDvar("bro_warnBadjump","1");
   initDvar("bro_admin_spectateall",1);
   
   // Welcome Screen
   
   initDvar("bro_clanicon","clan_brothers");
   initDvar("bro_welcomescreen_header","Welcome");
   initDvar("bro_clanmsg","Welcome to this |^4BRM^7| Server");
   
   initDvar("bro_clanrulestitle","Welcome to the |^4BRM^7| Mod!");
	initDvar("bro_clanrules1","Thank you for setting up BRM on your server.");
	initDvar("bro_clanrules2"," ");
	initDvar("bro_clanrules3","You can configure the text on this screen by editing the brm.cfg file.");
	initDvar("bro_clanrules4"," ");
	initDvar("bro_clanrules5","Please feel free to contact |Brothers|-Robinson if you require any help.");
	initDvar("bro_clanrules6","(xfire: tee699)");
	initDvar("bro_clanrules7"," ");
	initDvar("bro_clanrules8","Support is also available on the Brothers Forums.");
	initDvar("bro_clanrules9"," ");
	initDvar("bro_clanrules10","Thanks,");
	initDvar("bro_clanrules11","|^4Brothers^7|-^12Lt^7.Robinson");
	initDvar("bro_clanrules12"," ");
	initDvar("bro_clanrules13"," ");
	initDvar("bro_clanrules14","www.codbrothers.co.uk");
	initDvar("bro_clanrules15"," ");
	initDvar("bro_clanrules16"," ");
	initDvar("bro_clanrules17"," ");
	initDvar("bro_clanrules18"," ");
   
   // Message Centre
   
   initDvar("bro_messageDelay","0");
   
   // Weapon Limiter
   
	initDvar("bro_limitWeapons","1");
	
	// allowed weapon defaults
	
	// Bolts
	initDvar("bro_allow_arisaka",99);
	initDvar("bro_allow_kar98k",99);
	initDvar("bro_allow_nagant",99);
	initDvar("bro_allow_springfield",99);
		
	// Semi Autos
	initDvar("bro_allow_gewehr43",2);
	initDvar("bro_allow_m1carbine",1);
	initDvar("bro_allow_svt40",2);
	initDvar("bro_allow_m1garand",2);
	
	// SMGs
	initDvar("bro_allow_mp40",2);
	initDvar("bro_allow_ppsh_drum",1);
	initDvar("bro_allow_ppsh_stick",2);
	initDvar("bro_allow_stg44",1);
	initDvar("bro_allow_fg42",0); 
	initDvar("bro_allow_thompson",1);
	initDvar("bro_allow_type100",3);
	initDvar("bro_allow_greasegun",1);
	
	initDvar("bro_merge_fg42_stg44",1); // merges limit for Stg44 and fg42 - number is total of both
	initDvar("bro_merge_thompson_greasegun",0); // merges limit for Stg44 and fg42 - number is total of both

	// LMG
	initDvar("bro_allow_bar",1);	
   initDvar("bro_allow_type99",2);
      
	// HMG
	initDvar("bro_allow_30cal",1);
	initDvar("bro_allow_dp28",1);
	initDvar("bro_allow_mg42",1);
	
	// Scopes
	initDvar("bro_allow_arisaka_scoped",1);
	initDvar("bro_allow_kar98k_scoped",1);
	initDvar("bro_allow_nagant_scoped",1);
	initDvar("bro_allow_springfield_scoped",1);
	
	// Shotguns
	initDvar("bro_allow_trenchgun_marines",1);
	initDvar("bro_allow_trenchgun_german",1);
   initDvar("bro_allow_trenchgun_japanese",1);
   initDvar("bro_allow_trenchgun_russian",1);
   
   
   // Grenade Loadout Settings
   
   // Frags
   
   initDvar("bro_randomFragChance",70); // Percentage chance of getting a frag - set to 100 to give everyone a nade
      
   initDvar("bro_frags_boltaction",1); // max number of frags for this class. To force nades use values greater than 9. 10 forces 1, 20 forces 2 etc
   initDvar("bro_frags_sniper",1);
   initDvar("bro_frags_semiauto",1);
   initDvar("bro_frags_smg",1);
   initDvar("bro_frags_lmg",1);
   initDvar("bro_frags_hmg",1);
   initDvar("bro_frags_shotgun",1);
   
   // Smoke Grenades
   
   initDvar("bro_randomSmokeChance",70); // Percentage chance of getting a Smoke - set to 100 to give everyone a smoke
   
   initDvar("bro_smokes_boltaction",1); // max number of smoke grenades for this class. To force grenade use values greater than 9. 10 forces 1, 20 forces 2 etc
   initDvar("bro_smokes_sniper",0);
   initDvar("bro_smokes_semiauto",1);
   initDvar("bro_smokes_smg",10);
   initDvar("bro_smokes_lmg",0);
   initDvar("bro_smokes_hmg",0);
   initDvar("bro_smokes_shotgun",1);
   
   // Run Limiter
   
   
   initDvar("scr_limit_run",0); // 1 = speed halving 2 = advanced punish
   initDvar("scr_run_interval",8);
   
  
   
   // DEBUG
   
   initDvar("bro_DebugWeapLimit",0);
   initDvar("bro_DebugOBit",0);
   initDvar("bro_DebugHealth",0);
   initDvar("bro_DebugBleeding",0);
   initDvar("bro_noDamage",0);

}

clanModeSetup()
{
   // Clan vs mode settings
	
	initDvar("bro_clanmode",0); 
	initDvar("bro_clanstring","[Bro]-");
	initDvar("bro_clanstringposition",1); // 0 = anywhere, 1 = start, 2 = end 
     
   level.clanmode = limitVar(getDvarInt("bro_clanmode"),0,1);
   level.clantagstring = getDvar("bro_clanstring");
   level.clanstringposition = getDvarInt("bro_clanstringposition");
      
   initDvar("bro_pubteam","2");   // 0 (or "both") = Pubs get free choice
                                                                  // 1 (or "allies") = Pubs forced allies
                                                                  // 2 (or "axis") = Pubs forced Axis
         
   
   initDvar("bro_clanteam","1"); // 0 (or "both") = Clan get free choice
                                                                  // 1 (or "allies") = Clan forced allies
                                                                  // 2 (or "axis") = Clan forced Axis
   
   setdvar("bro_clanteam",validateClanModeDvar(getDvar("bro_clanteam")));                                                              
   setdvar("bro_pubteam",validateClanModeDvar(getDvar("bro_pubteam")));                                                              
                                                                  
   ct = getDvarInt("bro_clanteam");
                                                                  
   if(ct == getDvarInt("bro_pubteam") && ct != 0)
   {
      logprint("CLAN MODE ERROR: Pubs and Clan forced same team - relaxing settings\n");
      setdvar("bro_clanteam",0);
   }
                                                                  
   initDvar("bro_clanforce","0");  // 0 = Allows players to switch team once on the correct one (allows players to balance teams)
                                                                     // 1 = Team choice never available (as set by bro_clantype)

   level.clanforce = limitVar(getdvarint("bro_clanforce"),0,1);
   
}

assignLevelVars()
{
   level.admin_spectate = getdvarint("bro_admin_spectateall");

   level.dropWeapStatus = getdvarint("bro_dropWeapHit");

   level.bandageDist = 60;
   
   level.maxRearmAmmo = getDvarInt("bro_rearmMaxAmmo");
   
   level.obitStatus = getdvarint("bro_hideObits"); // 0 - show all obits, 1 - show teamkill obits, 2 - show no obits
   
   level.dropfrags = getdvarint("bro_dropfrags_" + level.gametype);
   level.dropsmokes = getdvarint("bro_dropsmokes_" + level.gametype);
   
   level.dropmortars = getdvarint("bro_dropmortars_" + level.gametype);
   
   level.brmShownBlackScreen = getdvarint("bro_blackScreen");
   level.brmShownHitBlur = getdvarfloat("bro_hiteffect_blur");
   
   level._bulletsuppression = limitVar(getdvarint("bro_bulletsuppression"),0,2);
   level._bulletsuppressionKick = limitVar(getdvarint("bro_bulletsuppressionviewkick"),0,1);
   level._bulletsuppressionRange = limitVar(getdvarint("bro_bulletsuppressionrange"),0,300);
   level._bulletsuppressionRange *= level._bulletsuppressionRange;
   
   level._bulletsuppressionWeap = [];
   
   level._bulletsuppressionWeap["smg"] = getdvarint("bro_bulletsuppression_smg");
   level._bulletsuppressionWeap["rifle"] = getdvarint("bro_bulletsuppression_rifle");
   level._bulletsuppressionWeap["pistol"] = getdvarint("bro_bulletsuppression_pistol");
   level._bulletsuppressionWeap["mg"] = getdvarint("bro_bulletsuppression_mg");
   level._bulletsuppressionWeap["spread"] = getdvarint("bro_bulletsuppression_shotgun");
   
   level.classSpeedMod = [];
   
   level.classSpeedMod["boltaction"] = getdvarfloat("bro_scaleSpeed_boltaction");
   level.classSpeedMod["sniper"] = getdvarfloat("bro_scaleSpeed_sniper");
   level.classSpeedMod["semiauto"] = getdvarfloat("bro_scaleSpeed_semiauto");
   level.classSpeedMod["smg"] = getdvarfloat("bro_scaleSpeed_smg");
   level.classSpeedMod["lmg"] = getdvarfloat("bro_scaleSpeed_lmg");
   level.classSpeedMod["hmg"] = getdvarfloat("bro_scaleSpeed_hmg");
   level.classSpeedMod["shotgun"] = getdvarfloat("bro_scaleSpeed_shotgun");
   level.classSpeedMod["antitank"] = getdvarfloat("bro_scaleSpeed_antitank");
   
   level.gunJamStatus = getDvarInt("bro_gunJamming");
   
   level.classJamChance = [];
   
   level.classJamChance["boltaction"] = getdvarint("bro_jamchance_boltaction");
   level.classJamChance["pistol"] = getdvarint("bro_jamchance_pistol");
   level.classJamChance["semiauto"] = getdvarint("bro_jamchance_semiauto");
   level.classJamChance["smg"] = getdvarint("bro_jamchance_smg");
   level.classJamChance["lmg"] = getdvarint("bro_jamchance_lmg");
   level.classJamChance["hmg"] = getdvarint("bro_jamchance_hmg");
   level.classJamChance["shotgun"] = getdvarint("bro_jamchance_shotgun");
   level.classJamChance["antitank"] = 1000000;
   
   level._impactTimeScale = abs(getdvarfloat("bro_impactTimeScale"));
   level._impactWeaponDropScale = abs(getdvarfloat("bro_impactWeaponDropScale"));
      
   level.hitSpinAmount = getDvarFloat("bro_hitSpinAmount");
   
   if(level.hitSpinAmount < 0)
      level.hitSpinAmount = 0;
      
   level.fg42stg44Merge = getdvarint("bro_merge_fg42_stg44"); 
	level.thompsonGreasegunMerge = getdvarint("bro_merge_thompson_greasegun");
	
   level.scr_run_interval = limitVar(getdvarint("scr_run_interval"), 0, 150);
   level.scr_limit_run = limitVar(getdvarint("scr_limit_run"), 0, 2);
   
   if(level.gametype == "sd" || level.gametype == "ret")
      level._roundWeaponDisable = abs(getdvarfloat("bro_sd_startRoundWeaponDisable")); 
   else
      level._roundWeaponDisable = 0;
 
}

force_dvars_slow()
{
   level.forceDvars = [];
   level.forceDvarVal = [];
   level.forceDvarsFast = [];
   level.forceDvarFastVal = [];
   level.dvarKey=0;
   level.dvarFastKey=0;
   
   if(getDvar("bro_noCrosshair")=="1") 
   {
      //thread force_dvars("cg_drawCrosshair",0);
      //thread force_dvars("cg_drawTurretCrosshair",0);
      addDvar("cg_drawCrosshair",0,"fast");
      addDvar("cg_drawTurretCrosshair",0,"fast");
      
   }
   if(getDvar("bro_noPlayerNames")=="1") //thread force_dvars("cg_drawCrosshairNames",0); 
       addDvar("cg_drawCrosshairNames",0,"normal");
   if(getDvar("bro_cleanHud")=="1") //thread force_dvars("cg_hudGrenadeIconMaxRangeFrag", 0 );
      addDvar("cg_hudGrenadeIconMaxRangeFrag",0,"normal");
      
   if(getDvar("bro_betterSound") == "1") //thread force_dvars("snd_occlusion_attenuation",-15);
   {
      addDvar("snd_occlusion_attenuation",-15,"normal");
      addDvar("snd_global_attenuation",-5,"normal");
      addDvar("snd_losocclusion",0,"normal");
   }
   
   if(getDvar("bro_thirdPSpec") == "0")
      thread thirdpDvarForcer();
   
   thread force_dvars();
   thread force_dvars_fast();
   

   thread maps\mp\gametypes\_mortars::force_mortar_dvar();
   
   thread maps\mp\gametypes\_mod_core::loadConnectThreads();
}

addDvar(dvar,val, priority)
{
   if(priority == "fast")
   {
      level.forceDvarsFast[level.dvarFastKey] = dvar;
      level.forceDvarFastVal[level.dvarFastKey] = val;
      level.dvarFastKey++;
   }
   else
   {
      level.forceDvars[level.dvarKey] = dvar;
      level.forceDvarVal[level.dvarKey] = val;
      level.dvarKey++;
   }
}

force_dvars()
{
   if(level.forceDvars.size <= 0)
      return;
      
   while(!isdefined(level.players))   
      wait 0.1;
   
   for(;;)
   {

      for(y=0; y<level.forceDvars.size; y++)
      {
         for (i = 0; i < level.players.size; i++)
         {     
            if(level.players[i].pers["hasfullyconnected"])
            {
               level.players[i] setClientDvars(level.forceDvars[y],level.forceDvarVal[y]);
            }
         }
         wait 0.5;
      }
     wait 0.3;
   }
}

force_dvars_fast()
{
   if(level.forceDvarsFast.size <= 0)
      return;
   
   while(!isdefined(level.players))   
      wait 0.1;
      
   for(;;)
   {   
      for(y=0; y<level.forceDvarsFast.size; y++)
      {
         for (i = 0; i < level.players.size; i++)
         {    
            if(level.players[i].pers["hasfullyconnected"])
            {
               level.players[i] setClientDvars(level.forceDvarsFast[y],level.forceDvarFastVal[y]);
            }
         }
         wait 0.05;
      }
      wait 0.05;
   }
}

thirdpDvarForcer()
{
   while(!isdefined(level.players))   
      wait 0.1;
      
   for(;;)
   {   
      for (i = 0; i < level.players.size; i++)
      {    
         if(level.players[i].pers["hasfullyconnected"] && level.players[i].sessionstate != "playing")
         {
            level.players[i] setClientDvars("cg_thirdperson","0");
         }
      }
      wait 0.05;
   }
}