initSquadRelations()
{
   if(level.squadSystem["active"] == 1 && (level.gametype == "sd" || level.gametype == "ret"))
   {
      level._squadsAutoJoin = getDvarInt("bro_squads_autojoin");
   }
   else
   {
      level._squadsAutoJoin = 0;
   }
   setdvar("ui_squads_autojoin",level._squadsAutoJoin);
   makedvarserverinfo("ui_squads_autojoin");
   
   if(!level._squadsAutoJoin)
      return;
      
   if(!isDefined(game["_squads"]))
   {
      game["_squads"] = [];
      game["_squads"]["allies"] = [];
      game["_squads"]["axis"] = [];
   }
   
   thread squadConsolidate();
//   thread printSquads();
}

classSelected(prevSquad, newSquad)
{
 //  if(true)
 //     return;
   team = self.sessionteam;

     // level.squads[team][newSquad][0]
     
   if(isDefined(prevSquad)) //already in a squad
   {
      if(prevSquad == newSquad)
      {
     //    if(team == "allies")
           // iprintln("^3" + self.name + " has changed class within squad #" + prevSquad);
         return;
      }
      
      
      if(issquadleader( self )) // he's the squad leader
      {
         leaveSquad(self);
         found = false;
         for(i=0; i<level.players.size; i++)
         {
            plr = level.players[i];
            
            if(plr != self && plr.pers["chosensquad"] == prevSquad && issquadleader( plr ))
            {
             //  if(team == "allies")
              //    iprintln("^3Found new Leader: " + plr.name + " for squad #" + prevSquad);
               game["_squads"][team][prevSquad-1] = plr;
               found = true;
               break;
            } 
         } 
         if(!found)
            game["_squads"][team][prevSquad-1] = undefined; 
      }
      else
      {
         leaveSquad(self);
      //   level._squads[team][prevSquad-1] = undefined;    
      }
   }  
      
   newSquad--;
   
   if(isDefined(game["_squads"][team][newSquad])) 
   {
      lId = game["_squads"][team][newSquad] GetEntityNumber();
      joinSquad(self, lId);
    //  if(team == "allies")
     //    iprintln("^3" + self.name + " joined squad # " + (newSquad + 1));
   }  
   else
   {
      createSquad(self);
    //  if(team == "allies")
    //     iprintln("^3Created Squad #" + (newSquad + 1) + ", leader: " + self.name);    
      game["_squads"][team][newSquad] = self;
   }
      
}

applySquad() // run on spawn - reassign player to correct squad
{
   self endon("spawned");
   
   wait 1;
  /* 
   if(self isBRMSquadLeader())
      self iprintln("^2You are the squad Leader");
   else
      self iprintln("^1You are not the squad leader");
      */
}

isBRMSquadLeader()
{
   if(self.pers["chosenclass"] == 0)
      return true;
      
   team = self.pers["team"];
   
 //  game["squadsystem"][team]["classactive"][selectedsquad][selectedclass] = 0;
      
   for(i=(self.pers["chosenclass"]-1); i >= 0; i--)
   {
      if(!game["squadsystem"][team]["classactive"][self.pers["chosensquad"]][i])
         return false;
   }
   
   return true;

}

buildSquadList()
{
  // if(level.gametype != "sd" && level.gametype != "ret")
  if(!level._squadsAutoJoin)
      return;
   
  // iprintln("Waiting to build list...");
   data["allies"] = [];
   data["axis"] = [];
   squadList["allies"] = [];
   squadList["axis"] = [];
   
   wait 1;
   
   for(i=0; i < game["squadsystem"]["alliessquads"]; i++)
   {
      data["allies"][i] = [];
      squadList["allies"][i] = [];
   }
      
   for(i=0; i < game["squadsystem"]["axissquads"]; i++)
   {
      data["axis"][i] = [];
      squadList["axis"][i] = [];
   }
   
   for(i=0; i < level.players.size; i++)
   {
      plr = level.players[i];
      
      if(plr.pers["team"] != "spectator" && isDefined(plr.pers["chosensquad"]) && isDefined(plr.pers["loadoutsubmitted"]))
      {
         data[plr.pers["team"]][plr.pers["chosensquad"]-1][plr.pers["chosenclass"]] = plr;
         
      }
   }
   
   for(i=0; i<game["squadsystem"]["alliessquads"]; i++)
   {
      for(y=0; y < game["squadsystem"]["allies"][i+1]["classdetails"].size; y++)
      {
         if(isDefined(data["allies"][i][y]))
            squadList["allies"][i][squadList["allies"][i].size] = data["allies"][i][y];          
      }
   }
   
   for(i=0; i<game["squadsystem"]["axissquads"]; i++)
   {
      for(y=0; y < game["squadsystem"]["axis"][i+1]["classdetails"].size; y++)
      {
         if(isDefined(data["axis"][i][y]))
            squadList["axis"][i][squadList["axis"][i].size] = data["axis"][i][y];          
      }
   }
   
   level._squadList = squadList;
   
   for(i=0; i<level._squadList["allies"].size; i++)
   {
      for(y=0; y<level._squadList["allies"][i].size; y++)
      {
         plr = level._squadList["allies"][i][y];
         
         if(getplayersquad( plr ))
            leaveSquad(plr);
            
         if(!y)
         {
           // iprintln("^3Creating Squad, leader: " + plr.name);
            createSquad(plr);
         }
         else
         {  
          //  iprintln("^4" + plr.name + " Joining squad #" + (i+1));
            joinSquad(plr,level._squadList["allies"][i][0] GetEntityNumber());
         }
      }
   }
   
   for(i=0; i<level._squadList["axis"].size; i++)
   {
      for(y=0; y<level._squadList["axis"][i].size; y++)
      {
         plr = level._squadList["axis"][i][y];
         
         if(getplayersquad( plr ))
            leaveSquad(plr);
            
         if(!y)
         {
            createSquad(plr);
         }
         else
         {
            joinSquad(plr,level._squadList["axis"][i][0] GetEntityNumber());
         }
      }
   }
  // iprintln("^2List Built");
   forceSquadConsolidate();
}

joinLate()
{
 //  if(!isDefined(level._squadList) || (level.gametype != "sd" && level.gametype != "ret")) // waiting for squad list to be built
   if(!isDefined(level._squadList) || !level._squadsAutoJoin) // waiting for squad list to be built
      return; 
      
   team = self.sessionteam;
   
   forceSquadConsolidate();
   
   newSquad = self.pers["chosensquad"]-1;
   
   if(isDefined(game["_squads"][team][newSquad])) 
   {
      lId = game["_squads"][team][newSquad] GetEntityNumber();
      joinSquad(self, lId);
     // if(team == "allies")
    //     iprintln("^3" + self.name + " joined squad # " + (newSquad + 1));
   }  
   else
   {
      createSquad(self);
  //    if(team == "allies")
  //       iprintln("^3Created Squad #" + (newSquad + 1) + ", leader: " + self.name);    
      game["_squads"][team][newSquad] = self;
   }
}

preSpawnReset()
{
   if(!level._squadsAutoJoin)
      return;
      
   if(level.gametype != "sd" && level.gametype != "ret")
      return;
      
   if(getplayersquad( self ))
      leaveSquad(self);
}


handleDisconnect()
{
   if(true)
      return;
      
   team = self.pers["team"];
   squad = self.pers["chosensquad"];
 //  println("## BRM DEBUG: SQUAD REASSIGN: " + self.name + " for squad #");
 //  println("## BRM DEBUG: SQUAD REASSIGN: " + self.pers["team"] + " for squad #");
   println("## BRM DEBUG: Player Dropped From Squad #" + squad);
   
   found = false;
   for(i=0; i < level.players.size; i++)
   {  
      plr = level.players[i];
      if(plr != self && plr.pers["chosensquad"] == squad)
      {
         if(issquadleader(plr))
         {
            println("## BRM DEBUG: Found new Leader: " + plr.name + " for squad #" + squad);
               game["_squads"][team][squad-1] = plr;
                found = true;
                break;
         }
      }
   }
   
   if(!found)
   {
      println("## BRM DEBUG: No new Leader found for squad #" + squad);
      game["_squads"][team][squad-1] = undefined;
   }
}

squadConsolidate()
{
   data = [];
   
   while(1)
   {  
      wait 0.5;
      
      data["allies"] = [];
      data["axis"] = [];
      
      for(i=0; i < level.players.size; i++)
      {
         plr = level.players[i];
         
         if(plr.pers["team"] != "spectator" && isDefined(plr.pers["chosensquad"]) && isDefined(plr.pers["loadoutsubmitted"]) && issquadleader(plr))
         {
            data[plr.pers["team"]][plr.pers["chosensquad"]-1] = plr;
         }
      }
      
      game["_squads"]["allies"] = data["allies"];
      game["_squads"]["axis"] = data["axis"];
   }
}

forceSquadConsolidate()
{
   data = [];

   data["allies"] = [];
   data["axis"] = [];
   
   for(i=0; i < level.players.size; i++)
   {
      plr = level.players[i];
      
      if(plr.pers["team"] != "spectator" && isDefined(plr.pers["chosensquad"]) && isDefined(plr.pers["loadoutsubmitted"]) && issquadleader(plr))
      {
         data[plr.pers["team"]][plr.pers["chosensquad"]-1] = plr;
      }
   }
   
   game["_squads"]["allies"] = data["allies"];
   game["_squads"]["axis"] = data["axis"];
}

printSquads()
{
   
   while(1)
   {
      for(i=0; i < 5; i++)
      {
         if(isDefined(game["_squads"]["allies"][i]))
            iprintln("^2Squad #" + (i+1) + " Leader: " + game["_squads"]["allies"][i].name);
         else
            iprintln("^3Squad #" + (i+1) + " Leader: Undefined");
      }
      wait 3;
   }
}

