#include maps\mp\_utility;

/*=======================================//

   Magazine Handling Script
   
   Created by |Brothers|-Robinson
 
   Simulates magazine based reloading
   
//=======================================*/



init()
{
   // precache stuff nubs
   
   // This needs cleaning - no longer using all these icons
 /*  
   level.clipIcons[0] = "clip_30cal";
//   level.clipIcons[1] = "clip_bar";
   level.clipIcons[2] = "clip_dp28";
   level.clipIcons[3] = "clip_g43";
   level.clipIcons[4] = "clip_m1carbine";
   level.clipIcons[5] = "clip_m1garand";
   level.clipIcons[6] = "clip_mg42";
   level.clipIcons[7] = "clip_mp40";
   level.clipIcons[8] = "clip_pistolclip";
   level.clipIcons[9] = "clip_ppshdrum";
//   level.clipIcons[10] = "clip_stg44";
   level.clipIcons[11] = "clip_stripperclip";
   level.clipIcons[12] = "clip_trenchgun";
   level.clipIcons[13] = "clip_type99";
   level.clipIcons[14] = "clip_single"; */
   
   level.clipIcons[0] = "clip_30cal";
   level.clipIcons[1] = "clip_ppshdrum";
   level.clipIcons[2] = "clip_g43";
   level.clipIcons[3] = "clip_m1carbine";
   level.clipIcons[4] = "clip_m1garand";
   level.clipIcons[5] = "clip_mg42";
   level.clipIcons[6] = "clip_mp40";
   level.clipIcons[7] = "clip_pistolclip";
   level.clipIcons[8] = "clip_stripperclip";
   level.clipIcons[9] = "clip_trenchgun";
   level.clipIcons[10] = "clip_type99";
   level.clipIcons[11] = "clip_single";
   level.clipIcons[12] = "ammo_counter_rocket";
   level.clipIcons[13] = "hud_icon_flamethrower_dpad";

   level.jamOverlay = "compass_objpoint_dogs"; // red cross shows when jammed - woof!
 
   precacheString( &"BRM_MAGAZINE_HEAVY" );
   precacheString( &"BRM_Magazine_LIGHT" );
   precacheString( &"BRM_MAGAZINE_VERY_LIGHT" );

}

pickupAmmo(player, weap)
{
   if(!isDefined(weap) || weap.weaponState != "magazine")
   {
      return;
   }

   name = weap.weapName;
  // iprintln("^4" + name);
   curWeaps = player maps\mp\gametypes\_weapons::getPlayerWeapons(true, false);
   
   w = undefined;
   
   for(i = 0; i<curWeaps.size; i++)
   {
      if(isDefined(player.curStock[curWeaps[i]]) && player.curStock[curWeaps[i]] < player GetWeaponAmmoStock(curWeaps[i]))
         w = curWeaps[i]; 
   }
     
   inp = strtok(name,"_");
   if(!isDefined(w))
   {
  //    iprintln("^3Pickup up a new weapon!");
      return;
   }
   fnd = strtok(w,"_");
   
   if(!isDefined(w) || inp[0] != fnd[0])
      return;
      

 //  iprintln("^3Picked up for: " + w);
//   iprintln("Current Ammo: " + player.curStock[w]);
//   iprintln("New Ammo: " + (player GetWeaponAmmoStock(w)));
   
   
   numClips = int((player GetWeaponAmmoStock(w) / player.clipSize[w]) + 0.5) - player.numFullClips[w];

//   iprintln("Adding: " + numClips);
   
   if(numClips < 1)
      return;
    
   clips = sortClips(weap.weaponClips);
   
   for(i=0; i < numClips; i++)
   {
      if(clips[i] > 0)
      {
         player.weaponClips[w][player.weaponClips[w].size] = clips[i];
         player.numFullClips[w]++;
      }     
   }
   
//   self.curStock[currentWeapon] = clipSize * (self.numFullClips[currentWeapon] - 1);
   
   player.curStock[w] = player.clipSize[w] * (player.numFullClips[w] - 1);

   player SetWeaponAmmoStock(w, player.curStock[w] );

}

sortClips(clips)
{   
   for(i=0; i < clips.size; i++)
   {
      biggest = i;
      for(x=i+1; x < clips.size; x++)
      {
         if(clips[x] > clips[biggest])
            biggest = x;
      }
      
      if(i != biggest)
      {
         tmp = clips[i];
         clips[i] = clips[biggest];
         clips[biggest] = tmp;
      }
   }
   
   return clips;
}

magazineSetup()
{
   // runs on player spawn - sets up teh clips boy'o!
   
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	self endon("death_or_disconnect");
	
   self.curWeaps = self maps\mp\gametypes\_weapons::getPlayerWeapons(true, false);
   
   self.weaponClips = [];
   
   for(i=0; i < self.curWeaps.size; i++)
   {     
      clipSize = WeaponClipSize(self.curWeaps[i]);
      
      if(clipSize <= 0)
         continue;

      maxAmmo = self GetWeaponAmmoStock( self.curWeaps[i]) + clipSize;
      
      numClips = int(maxAmmo / clipSize);
      
      for(y=0; y<numClips; y++)      
         self.weaponClips[self.curWeaps[i]][y] = clipSize;
         
      self.currentClipId[self.curWeaps[i]] = 0;
  //    self.shotsFired[self.curWeaps[i]] = 0;
      self.numFullClips[self.curWeaps[i]] = numClips;
      self.currentClipAmmo[self.curWeaps[i]] = clipSize;
      self.ammoIcon[self.curWeaps[i]] = magazineIcon2(self.curWeaps[i]);
      self.weaponState[self.curWeaps[i]] = weaponState(self.curWeaps[i]);
      self.clipSize[self.curWeaps[i]] = clipSize; 
      
      self.hasJam[self.curWeaps[i]] = false;
          
   //   self iprintln("Has Weapon: " + self.curWeaps[i] + " with " + numClips + " (maxAmmo: " + maxAmmo + " clipsize: " + clipSize + ")");
  //    self iprintln("State: " + self.weaponState[self.curWeaps[i]]);
   }
}

//********************************//
/*

- Monitors magazines and ammunition on reload
- inspired by code from Gautier

*///*******************************//

magazine_monitor()
{
//   self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
   self endon("death_or_disconnect");
	level endon("game_ended");
	 
   self.curStock = [];
   self.weaponClips = [];
   self.currentClipId = [];
 //  self.shotsFired = [];
   self.currentClipAmmo = [];
   self.numFullClips = [];
   self.ammoIcon = [];
   self.weaponState = [];
   self.clipSize = [];
   
   self magazineSetup();
   
   for(i=0; i< self.curWeaps.size; i++)
      self.curStock[self.curWeaps[i]] = self GetWeaponAmmoStock(self.curWeaps[i]);
   
   wait 0.1;
   
   self.equipedweapon = self GetCurrentWeapon();
   self.currentPrimary = self.equipedweapon;

   self thread shelltracker();
   self thread update_hud();
   
   if(getdvarint("bro_tint_smokegrenades") > 0)
      self thread watchGrenades(); // disabled at the moment due to some major glitchyness - maybe the ammo types need to be different or sommat QQ
   
   if(getdvarint("bro_onePrimaryWeapon"))
      self thread hasWeaponTracker();
   
   while(1)
   {
      currentWeapon = self GetCurrentWeapon();
      // weapon jamming - this should nuke it all
      if((isdefined(self.hasJam[currentWeapon]) && self.hasJam[currentWeapon] == true) 
      || (isdefined(self.clearingJam[currentWeapon]) && self.clearingJam[currentWeapon] == true) || (isdefined(self.fixingBayonet) && self.fixingBayonet == true) || (isdefined(self.switchingFireMode) && self.switchingFireMode == true))
    //  || (isdefined(self.clearingJam[currentWeapon]) && self.clearingJam[currentWeapon] == true) )
      {
         if(self.equipedweapon != currentWeapon ) // && ((!isdefined(self.fixingBayonet) || self.fixingBayonet == false) || (!isdefined(self.switchingFireMode) || self.switchingFireMode == false)))
         {
            self maps\mp\gametypes\_mod_core::giveBayonet(currentWeapon);         
            self.equipedweapon = currentWeapon;
         }
         
         wait 0.05;
         continue;      
      }
      
       // picking up same weapon again - hand drop - que?
      
      if(self.equipedweapon != currentWeapon)
      {
         // check for bayonet weapon on weap switch
       //  iprintln("^3Firemode from magazines regular " + currentWeapon + " ("+ self.equipedweapon + ")");
         self maps\mp\gametypes\_mod_core::giveBayonet(currentWeapon);

         if(isdefined(self.currentClipId[currentWeapon]) && currentWeapon!="none" && notSpecial(currentWeapon) )
         {
            
            // if weap picked up again reset ammo to old values
            if(!(isdefined(self.clearingJam[currentWeapon]) && self.clearingJam[currentWeapon] == true) && self.weaponState[currentWeapon] == "magazine")
            {
               self SetWeaponAmmoStock(currentWeapon, self.curStock[currentWeapon] );
               self SetWeaponAmmoClip(currentWeapon, self.weaponClips[currentWeapon][self.currentClipId[currentWeapon]] );
            }

            // Is this even needed anymore?
            if(isprimary(currentWeapon))
               self.currentPrimary = currentWeapon;
               
            
            
            if(isPrimary(currentWeapon))
            {
               self.pers["curClass"] = maps\mp\gametypes\_mod_core::getWeaponClass(currentWeapon);
      
               self.moveSpeedDefault = maps\mp\gametypes\_mod_core::getPlayerSpeedScale(self.pers["curClass"]);
      
               self SetMoveSpeedScale(self.moveSpeedDefault);
            }
         } 
         self.equipedweapon = currentWeapon;
      }
            
      currentWeaponStock = self GetWeaponAmmoStock(currentWeapon);
      
      if(currentWeapon != "none" && isdefined(self.currentClipId[currentWeapon]) && self.weaponState[currentWeapon]!="single" && self.weaponState[currentWeapon]!="fullclip" && notSpecial(currentWeapon) && (!(isdefined(self.clearingJam[currentWeapon]) && self.clearingJam[currentWeapon] == true)))
      {
         if(currentWeaponStock < self.curStock[currentWeapon])
         {
            if(self.numFullClips[currentWeapon] > 0) // Reload detected
            {
               nextClipId = self getNextClip(currentWeapon);
            
               self.currentClipId[currentWeapon] = nextClipId;
               self.currentClipAmmo[currentWeapon] = self.weaponClips[currentWeapon][nextClipId];
            
            //   self.shotsFired[currentWeapon] = 0;

               clipSize = self.clipSize[currentWeapon];
               self SetWeaponAmmoClip(currentWeapon, self.weaponClips[currentWeapon][nextClipId] );
               self.curStock[currentWeapon] = clipSize * (self.numFullClips[currentWeapon] - 1);
               self SetWeaponAmmoStock( currentWeapon, self.curStock[currentWeapon] );
               
               self thread printWeight((self.weaponClips[currentWeapon][nextClipId] / clipSize));
				
            }
            else // exception handling
            {
               self iprintln("^3Got into the invalid state - report to Robbo!");
            }
         }
         else if(currentWeaponStock > self.curStock[currentWeapon]) // picked up more ammo
         {
           // iprintln("^2Picked up ammo");
         //   clipSize = WeaponClipSize(currentWeapon);
            clipSize = self.clipSize[currentWeapon];
            extraAmmo = currentWeaponStock - self.curStock[currentWeapon];
            extraClips = int(extraAmmo / clipSize);
            
            self modifyClips(extraClips, currentWeapon, clipSize,false);

            self.curStock[currentWeapon] = clipSize * (self.numFullClips[currentWeapon] - 1);
            self SetWeaponAmmoStock(currentWeapon, self.curStock[currentWeapon] );
         }  
      }
      else if(currentWeapon != "none" && !isdefined(self.currentClipId[currentWeapon]) && notSpecial(currentWeapon)) // picked up new weapon
      {
     //    iprintln("^3Setting up new weapon");
         self setupNewWeapon(currentWeapon);
         self maps\mp\gametypes\_mod_core::giveBayonet(currentWeapon);
      }
      else if(currentWeapon != "none" && isdefined(self.currentClipId[currentWeapon]) && notSpecial(currentWeapon))
      {
         if(self.weaponState[currentWeapon]!="single" || self.weaponState[currentWeapon]!="fullclip")
         {
            self.weaponClips[currentWeapon][self.currentClipId[currentWeapon]] = self GetWeaponAmmoClip(currentWeapon);
            self.curStock[currentWeapon] = currentWeaponStock;
         }     
      }     
      wait 0.05;
   }  
}

/*===========================//

   Tracks dual primaries   

//===========================*/

hasWeaponTracker()
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	
	self endon("death_or_disconnect");

	level endon("game_ended");
	
   wait 0.1;
   
   prevWeapons = [];

   while(1)
   {  
      playerWeapons = self maps\mp\gametypes\_weapons::getPlayerWeapons(true, false);
      
      found = [];
      
      for(i=0; i<playerWeapons.size; i++)
      {   
         if(playerWeapons[i]!="none" && notSpecial(playerWeapons[i]))
         {
            if(isPrimary(playerWeapons[i]))
            {
               found[found.size] = playerWeapons[i];
            }
         }
      }
      
      current = self GetCurrentWeapon();
      
      if(found.size > 1 && isPrimary(current))
      {
         dropWeap = 0;
         
         for(i=0; i < prevWeapons.size; i++)
         {
            if(found[1] == prevWeapons[i])
            {
               dropWeap = 1;
               break;
            }
         }
         self.lastDroppableWeapon = found[dropWeap];
        // iprintln("^2Mag: " + self.lastDroppableWeapon);
        
         self maps\mp\gametypes\_weapons::dropWeaponForDeath(self, true);
         
         self thread printMsg("^3You cannot carry 2 primary weapons",0.05,true);
         
         if(self hasWeapon(found[dropWeap])) // weapon did not get dropped (for whatever reason) - failsafe
         {
            self takeweapon(found[dropWeap]);
         }
         
         prevWeapons = [];
         
         if(dropWeap == 0)
         {
            prevWeapons[0] = found[1];
            self switchtoweapon(found[1]);
         }
         else
         {
            prevWeapons[0] = found[0];
            self switchtoweapon(found[0]);
         }
         
         if(maps\mp\gametypes\_weapons::mayDropWeapon(current))
            self.lastDroppableWeapon = current;
         else
            self.lastDroppableWeapon = undefined;
      }
      else
      {
         prevWeapons = found;
      }   
          
      wait 0.25;
   }   
}

/*===========================//

   Excludes 'non-gun' weapons

//===========================*/

notSpecial(weapon)
{
   switch(weapon)
   {
      case "briefcase_bomb_defuse_mp":
      case "briefcase_bomb_mp":
      case "binoculars_mp":
      case "artillery_mp":
      case "frag_grenade_mp_":
      case "frag_grenade_short_mp":
      case "dogs_mp":
      case "ger_grenade_mp":
      case "jap_grenade_mp":
      case "russian_grenade_mp":
      case "usa_grenade_mp":
      case "m8_white_smoke_mp":
      case "m8_green_smoke_mp":
      case "m8_red_smoke_mp":
      case "radar_mp":
      case "squadcommand_mp":
      case "mine_bouncing_betty_mp":
      case "mine_showbox_mp":
      case "molotov_mp":
      case "napalmblob_mp":
      case "satchel_charge_mp":
      case "signal_flare_mp":
      case "sticky_grenade_mp":
      case "syrette_mp":
      case "tabun_gas_mp":
      case "bayonet_mp":
      case "satchel_demo_mp":
      case "m2_flamethrower_mp":
      case "arty_radio_mp":
      case "at_ammo_mp":
      case "support_ammo_mp":
      case "firemode_mp":
      case "mgcarry_mp":
      case "gl_m1garand_mp":
      case "bomb_drop_mp":
      case "radio_drop_mp":
         return false;
         
      default:
         return true;    
   }
}

/*===========================//

   Creates Required vars
   for new weapon

//===========================*/

setupNewWeapon(weapon, clip, magazines)
{
   if(isSubStr(weapon,"_bipod_") || weapon == "ptrs41_mp")
      self.startedWithDeployableMG = true;
   
   if(weapon == "mortar_mp")
   {
      self.startedWithDeployableMortar = true;
      
      if(!isDefined(self.coordinates))
      {
         self.coordinates = [];
         self.coordinates["mortarbarrage"] = undefined;
      }
      
      if(!isDefined(self.mortarShells))
         self.mortarShells = randomint(getdvarint("bro_deploymortar_shells")+1);
   }         
   if(isDefined(clip) && isDefined(magazines))
   {
      clipSize = WeaponClipSize(weapon);
      
      curClip = clip;
                
      self.weaponClips[weapon][0] = curClip; 
      self.currentClipId[weapon] = 0;
   //   self.shotsFired[weapon] = clipSize - curClip;
      self.numFullClips[weapon] = 1;
      self.currentClipAmmo[weapon] = curClip;
      self.ammoIcon[weapon] = magazineIcon2(weapon);
      self.weaponState[weapon] = weaponState(weapon);
      self.clipSize[weapon] = clipSize; 
      
    //  iprintln(magazines);
    //  iprintln(self.numFullClips[weapon]);
      
      self modifyClips(magazines, weapon, clipSize,true);

    //  iprintln(self.numFullClips[weapon]);
      self.curStock[weapon] = clipSize * (self.numFullClips[weapon] - 1);
      

      self SetWeaponAmmoClip( weapon, clip );
      self SetWeaponAmmoStock( weapon, self.curStock[weapon] );
      
      if(isPrimary(weapon))
      {
         self.pers["curClass"] = maps\mp\gametypes\_mod_core::getWeaponClass(weapon);

         self.moveSpeedDefault = maps\mp\gametypes\_mod_core::getPlayerSpeedScale(self.pers["curClass"]);

         self SetMoveSpeedScale(self.moveSpeedDefault);
      }
   }
   else
   {
      
      clipSize = WeaponClipSize(weapon);
      maxAmmo = self GetWeaponAmmoStock(weapon);
      
      curClip = self GetWeaponAmmoClip(weapon);
      
      numClips = int(floor(maxAmmo / clipSize));
          
      self.weaponClips[weapon][0] = curClip; //randomintrange(2,clipSize);
         
      self.currentClipId[weapon] = 0;
   //   self.shotsFired[weapon] = clipSize - curClip;
      self.numFullClips[weapon] = 1;
      self.currentClipAmmo[weapon] = curClip;
     // self.ammoIcon[weapon] = magazineIcon(weapon);
      self.ammoIcon[weapon] = magazineIcon2(weapon);
      self.weaponState[weapon] = weaponState(weapon);
      self.clipSize[weapon] = clipSize; 
      
      
      self modifyClips(numClips, weapon, clipSize,false);
      
      self.curStock[weapon] = clipSize * (self.numFullClips[weapon] - 1);
      self SetWeaponAmmoStock( weapon, self.curStock[weapon] );
      
      if(isPrimary(weapon))
      {
         self.pers["curClass"] = maps\mp\gametypes\_mod_core::getWeaponClass(weapon);

         self.moveSpeedDefault = maps\mp\gametypes\_mod_core::getPlayerSpeedScale(self.pers["curClass"]);

         self SetMoveSpeedScale(self.moveSpeedDefault);
      }
   }
}

pickupWeapon(weapon, item)
{
   if(isSubStr(weapon,"_bipod_") || weapon == "ptrs41_mp")
      self.startedWithDeployableMG = true;
   
   if(weapon == "mortar_mp")
   {
      self.startedWithDeployableMortar = true;
      
      if(!isDefined(self.coordinates))
      {
         self.coordinates = [];
         self.coordinates["mortarbarrage"] = undefined;
      }
      
      if(!isDefined(self.mortarShells))
         self.mortarShells = randomint(getdvarint("bro_deploymortar_shells")+1);
   }    
   
   self.hasJam[weapon] = item.hasJam;
   
   if(self.hasJam[weapon])
   {
      self.jamAmmo[weapon] = item.jamAmmo;
      self.jamClip[weapon] = item.jamClip;
   }   

    
   self.weaponClips[weapon] = item.weaponClips;
	self.currentClipId[weapon] = item.currentClipId;
	self.numFullClips[weapon] = item.numFullClips;
	self.currentClipAmmo[weapon] = item.currentClipAmmo;
	self.ammoIcon[weapon] = item.ammoIcon;
	self.weaponState[weapon] = item.weaponState;
	self.clipSize[weapon] = item.clipsize;
	
	if(self.hasJam[weapon])
	{
      self.curStock[weapon] = self.clipSize[weapon] * (self.numFullClips[weapon] - 1);
      self SetWeaponAmmoClip(weapon, 0);
      self SetWeaponAmmostock(weapon, 0); 
      
   }
   else
   {
      self.curStock[weapon] = self.clipSize[weapon] * (self.numFullClips[weapon] - 1);   
      
      if(item.weaponState != "magazine")
         self SetWeaponAmmoStock( weapon, self.curStock[weapon] );
   }
   
   if(isPrimary(weapon))
   {
      self.pers["curClass"] = maps\mp\gametypes\_mod_core::getWeaponClass(weapon);

      self.moveSpeedDefault = maps\mp\gametypes\_mod_core::getPlayerSpeedScale(self.pers["curClass"]);

      self SetMoveSpeedScale(self.moveSpeedDefault);
   }
}

saveDoppedWeapon(weapon,player)
{
 //  iprintln("Saving dropped weapon -> " + weapon + " " + player.weaponState[weapon]);
   self.weaponClips = player.weaponClips[weapon];
	self.currentClipId = player.currentClipId[weapon];
	self.numFullClips = player.numFullClips[weapon];
	self.currentClipAmmo = player.currentClipAmmo[weapon];
	self.ammoIcon = player.ammoIcon[weapon];
	self.weaponState = player.weaponState[weapon];
	self.clipSize = player.clipsize[weapon];
	
	if(!isdefined(player.hasJam[weapon]) || player.hasJam[weapon] == false)
      self.hasJam = false;
   else
   {
      self.jamAmmo = player.jamAmmo[weapon];
      self.jamClip = player.jamClip[weapon];
      self.hasJam = true;
   }
	
	player.weaponClips[weapon] = undefined;
	player.currentClipId[weapon] = undefined;
	player.numFullClips[weapon] = undefined;
	player.currentClipAmmo[weapon] = undefined;
	player.ammoIcon[weapon] = undefined;
	player.weaponState[weapon] = undefined;
	player.clipsize[weapon] = undefined;
	player.hasJam[weapon] = false;

}

/*===============================//

   Assigns clips / ammo for  
   current weapon to new weapon
   
   - Bayonet Handling

//===============================*/

reassignMags(currentWeapon,nextWeapon)
{
   if(!isdefined(self.numFullClips[currentWeapon])) return;
   
    self.weaponClips[nextWeapon] = [];  // intialise array just to be safe :D
   
   for(y=0; y<self.weaponClips[currentWeapon].size; y++)      
      self.weaponClips[nextWeapon][y] = self.weaponClips[currentWeapon][y];
         
   self.currentClipId[nextWeapon] = self.currentClipId[currentWeapon];
 //  self.shotsFired[nextWeapon] = self.shotsFired[currentWeapon];
 
   self.numFullClips[nextWeapon] = self.numFullClips[currentWeapon];
   self.currentClipAmmo[nextWeapon] = self.currentClipAmmo[currentWeapon];
   self.ammoIcon[nextWeapon] = self.ammoIcon[currentWeapon];
   self.curStock[nextWeapon] = self.curStock[currentWeapon];
   self.weaponState[nextWeapon] = self.weaponState[currentWeapon]; 
   self.clipSize[nextWeapon] = self.clipSize[currentWeapon];
   
   self.currentPrimary = nextWeapon;
   self.equipedweapon = nextWeapon;
   
   self maps\mp\gametypes\_mod_core::giveBayonet(currentWeapon);
   
   self.curStock[currentWeapon] = undefined;   
   self.weaponClips[currentWeapon] = undefined;
   self.currentClipId[currentWeapon] = undefined;
 //  self.shotsFired[currentWeapon] = undefined;
   self.currentClipAmmo[currentWeapon] = undefined;
   self.numFullClips[currentWeapon] = undefined;
   self.ammoIcon[currentWeapon] = undefined;
   self.weaponState[currentWeapon] = undefined;
   self.clipSize[currentWeapon] = undefined;
}

/*============================//

   Finds the next empty clip

//============================*/

getNextClip(weapon)
{
 //  self endon("killed_player");
	self endon("spawned");
	//self endon("disconnect");
	
   self endon("death_or_disconnect");

   level endon("game_ended");
   
   loopCount = 0;
   found = false;
   nextID = 0;
   
   curClip = self.currentClipId[weapon];
   
   if(curClip >= (self.weaponClips[weapon].size - 1)) curClip = -1;
   
   while(!found && loopCount < 2)
   {
      for(i=(curClip + 1); i< self.weaponClips[weapon].size; i++)
      {
         if(self.weaponClips[weapon][i] > 0)
         {
            nextID = i;
            found = true;
           // self iprintln("Found Clip! # " + i);
            break;
         }
         
      }
      curClip = -1;
      loopCount++;
   }
   if(!found) self iprintln("^1Can't find clip - Report to Robbo!"); // exception handling - stops server crashing!
   return nextID;
}

/*=====================================//

   Increases clip arrays for weapons
   
   - Picked up ammo
   - New weapons

//=====================================*/

modifyClips(newClips, weapon, clipSize, fullclip)
{
   if(newClips <= 0)    
      return;
   
   for(i=0; i< newClips; i++)
   {
      if ( (level.inGracePeriod && !self.hasDoneCombat ) || self.isBeingRearmed || fullclip || isdefined(level.fortbhc2_initialized))
         fullChance = 0;
      else
         fullChance = randomint(4);
      
      if(!fullChance)
         clipAmmo = clipSize;
      else
      {
         if(clipSize > 1)
            clipAmmo = randomintrange(1,clipSize);
         else
            clipAmmo = 1;
      }   
      self.weaponClips[weapon][self.weaponClips[weapon].size] = clipAmmo;
   }
   
   self.numFullClips[weapon] += newClips;
}

//********************************//
/*

- counts rounds fire by each weapon and tracks empty magazines
- Adapted from code by Wanna Ganoush

*///*******************************//

shelltracker()
{
  // self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
   self endon("death_or_disconnect");
   
	level endon("game_ended");
	
	while(1)
	{
      currentWeapon = self GetCurrentWeapon();
      currentAmmo = self GetWeaponAmmoClip( currentWeapon);
      
      // this horrific statement could probably be optimised - skips shot tracking for weapons that don't need it
      if((isdefined(self.currentClipAmmo[currentWeapon]) && self.weaponState[currentWeapon]!="fullclip" && self.weaponState[currentWeapon]!="single")&&
      (!((isdefined(self.hasJam[currentWeapon]) && self.hasJam[currentWeapon] == true) 
      || (isdefined(self.clearingJam[currentWeapon]) && self.clearingJam[currentWeapon] == true))))
      {
         if(currentAmmo < self.currentClipAmmo[currentWeapon])
         {
           // self.weaponClips[currentWeapon][self.currentClipId[currentWeapon]]--;
            self.weaponClips[currentWeapon][self.currentClipId[currentWeapon]] = currentAmmo;
            
            if(self.weaponClips[currentWeapon][self.currentClipId[currentWeapon]] <=0) 
            { 
               self.numFullClips[currentWeapon]--;  
            }           
          //  self.shotsFired[currentWeapon]++;
            self.currentClipAmmo[currentWeapon] = currentAmmo;
            
            	/*==========================*/
               //    Spawn Protection - disable on weapon fired
               
	
               if(game["preMatch"])
                  self.protected = false;

               /*==========================*/
	
         }  
      }
      wait 0.1; // hope this is ok
	}
}

/*===========================//

   Handles Grenade Pickup (maybe not?)
   
  
//===========================*/

watchGrenades()
{
	self endon("spawned");
	self endon("death_or_disconnect");
	level endon("game_ended");

	team = getOtherTeam( self.pers["team"] );
	
	while(1)
	{
      if(self hasWeapon(level.smokeGrenade[team]))
      {
         ammo = self GetWeaponAmmoClip(level.smokeGrenade[team]);
         self takeweapon(level.smokeGrenade[team]);
         
         self setOffhandSecondaryClass("smoke");
         self giveWeapon( level.smokeGrenade[self.pers["team"]] );
         self SetWeaponAmmoClip( level.smokeGrenade[self.pers["team"]], 0 );
         self SetWeaponAmmoClip( level.smokeGrenade[self.pers["team"]], int(ammo) );
      }
      wait 0.25;
	}	
}

/*===========================//

   Writes out message describing 
   weight of magazine

//===========================*/

printWeight(fraction)
{
   self notify("new_mag_message");
   
   self endon("killed_player");
	self endon("spawned");
	self endon("disconnect");
	level endon("game_ended");
	self endon("new_mag_message");
/*
	if(fraction > 0.68) self iprintln("Magazine is heavy");
	else if(fraction > 0.36) self iprintln("Magazine is light");
	else self iprintln("Magazine is very light");
*/	
   if(fraction > 0.68) str = &"BRM_MAGAZINE_HEAVY";
	else if(fraction > 0.36) str = &"BRM_MAGAZINE_LIGHT";
	else str = &"BRM_MAGAZINE_VERY_LIGHT";
	
	self.weightMessage setText(str);
	self.weightMessage.alpha = 1;
	
	wait 3;
	
	self.weightMessage fadeOverTime( 1 );
   self.weightMessage.alpha = 0;
	
	
}

/*=============================//

   Draws hud icons showing clip 
   count and jam status

//=============================*/

update_hud()
{

  // self endon("killed_player");
	self endon("spawned");
	//self endon("disconnect");
	
	self endon("death_or_disconnect");
	
	level endon("game_ended");
	
   defineOriginX = -5;
   defineOriginY = -5;
   
	wait 0.15;

	if(!isDefined(self.weightMessage))
   {
      self.weightMessage = newClientHudElem(self);
      self.weightMessage.horzAlign = "right";
      self.weightMessage.vertAlign = "bottom";
      self.weightMessage.alignX = "right";
		self.weightMessage.alignY = "bottom";
      self.weightMessage.x = defineOriginX - 1; //-59;
      self.weightMessage.y = defineOriginY - 45; //-86;
      self.weightMessage.sort = 50;
      self.weightMessage.fontScale = 1.0;     
   }
   self.weightMessage.alpha = 0;
   

   self setclientdvars("ui_weaponjammed",0,
                        "ui_weapon_clip",-1,
                        "ui_clipcount",0);
   while(1)
   {
      wait 0.2;
      
      currentWeap = self GetCurrentWeapon();
      
      if(!isdefined(self.numFullClips[currentWeap])) 
      {
   //      iprintln("num clips not defined for: " + currentWeap);
         continue;
      }
      
      if(self.weaponState[currentWeap]=="single")
      {
         if(currentWeap == "m2_flamethrower_mp")
            displayVal = self GetWeaponAmmoClip( currentWeap );
         else if(currentWeap == "mortar_mp" && isDefined(self.mortarShells))
            displayVal = self.mortarShells;
         else
            displayVal = self GetWeaponAmmoStock( currentWeap );
      }
      else if(self.weaponState[currentWeap]=="fullclip")
      {
         displayVal = int(self GetWeaponAmmoStock( currentWeap ) / self.clipSize[currentWeap]);
      }
      else
         displayVal = self.numFullClips[currentWeap] - 1;
      
      if(displayVal < 1) 
         displayVal = 0;
      
    //  iprintln("^1" + currentWeap + " " + self.numFullClips[currentWeap]);
      
      self setclientdvars("ui_clipcount",displayVal);
      
      if(notSpecial(currentWeap) || currentWeap == "m2_flamethrower_mp")
         self setclientdvars("ui_weapon_clip",self.ammoIcon[currentWeap]);
      else
         self setclientdvars("ui_weapon_clip",-1);
         
      if(isdefined(self.hasJam[currentWeap]) && self.hasJam[currentWeap])
         self setclientdvars("ui_weaponjammed",1);
      else
         self setclientdvars("ui_weaponjammed",0);
   }
}

cleanHud()
{
   if(isDefined(self.hud_munitions))
      self.hud_munitions destroy();
   
   if(isDefined(self.clip_icon_back))
      self.clip_icon_back destroy();
	
	if(isDefined(self.clip_icon))
      self.clip_icon destroy();
	
	if(isDefined(self.jamOverlay))
      self.jamOverlay destroy();
      
   if(isDefined(self.weightMessage))
      self.weightMessage destroy();

}

magazineIcon2(weapon)
{
   // just gets the right icon for the magazine type
   
   switch(weapon)
   {
      case "30cal_bipod_mp":
      case "30cal_mp":
         return 0;

      case "gewehr43_mp":
      case "svt40_mp":
      case "bar_mp":
      case "bar_bipod_mp":
      case "bar_bipod_semi_mp":
      case "bar_semi_mp":
         return 2;
      case "m1carbine_mp":
      case "m1carbine_bayonet_mp":
      case "fg42_mp":
      case "fg42_semi_mp":
         return 3;
      case "m1garand_mp":
      case "m1garand_bayonet_mp":
         return 4;
      case "mg42_mp":
      case "mg42_bipod_mp":
         return 5;
      case "mp40_mp":
      case "thompson_mp":  
      case "thompson_semi_mp":  
      case "stg44_semi_mp":
      case "stg44_mp":
      case "type100smg_mp":
      case "ppsh_semi_mp":
      case "ppsh_mp":
      case "m3a1_mp":
         return 6;
      case "tokarev_mp":
      case "colt_mp":
      case "nambu_mp":
      case "walther_mp":
         return 7;
      case "ppsh_bigammo_semi_mp":
      case "ppsh_bigammo_mp":
      case "dp28_bipod_mp":
      case "dp28_mp":
         return 1;

      case "kar98k_mp":
      case "kar98k_bayonet_mp":
      case "mosinrifle_mp":
      case "mosinrifle_bayonet_mp":
      case "springfield_mp":
      case "springfield_bayonet_mp":
      case "type99rifle_mp":
      case "type99rifle_bayonet_mp":
         return 8;
      case "shotgun_mp":
      case "shotgun_bayonet":
      case "357magnum_mp":
         return 9;
      case "type99lmg_bipod_mp":
      case "type99lmg_mp":
      case "type99lmg_bipod_bayonetmp":
         return 10;
      case "kar98k_scoped_mp":
      case "kar98k_scoped_bayonet_mp":
      case "mosinrifle_scoped_mp":
      case "mosinrifle_scoped_bayonet_mp":
      case "springfield_scoped_mp":
      case "springfield_scoped_bayonet_mp":
      case "type99rifle_scoped_mp":
      case "type99rifle_scoped_bayonet_mp":
      case "ptrs41_mp":
         return 11;
      case "bazooka_mp":
      case "panzershrek_mp":
      case "mortar_mp":
         return 12;
      case "m2_flamethrower_mp":
         return 13;
      default:
         return 3;  
   }
}

weaponState(weapon)
{
   // gets the reload type of the weapon. Fullclip and single require much less checking
   switch(weapon)
   {
      case "kar98k_scoped_mp":
      case "kar98k_scoped_bayonet_mp":
      case "mosinrifle_scoped_mp":
      case "mosinrifle_scoped_bayonet_mp":
      case "springfield_scoped_mp":
      case "springfield_scoped_bayonet_mp":
      case "type99rifle_scoped_mp":
      case "type99rifle_scoped_bayonet_mp":
      case "shotgun_mp":
      case "shotgun_bayonet_mp":
      case "bazooka_mp":
      case "panzershrek_mp":
      case "ptrs41_mp":
      case "satchel_demo_mp":
      case "satchel_charge_mp":
      case "m2_flamethrower_mp":
      case "mortar_deployable_mp":
      case "mortar_mp":
      case "357magnum_mp":
//      case "arty_radio_mp":
         return "single";
      
      case "kar98k_mp":
      case "kar98k_bayonet_mp":
      case "mosinrifle_mp":
      case "mosinrifle_bayonet_mp":
      case "springfield_mp":
      case "springfield_bayonet_mp":
      case "type99rifle_mp":
      case "type99rifle_bayonet_mp":
      case "m1garand_mp":
      case "m1garand_bayonet_mp":
         return "fullclip";
      
      default:
         return "magazine";
   }
}

isPrimary(weapon) // Same as ispistol basically - wonder if thats built in?
{
   switch(weapon)
   {
      case "colt_mp":
      case "nambu_mp":
      case "walther_mp":
      case "tokarev_mp":
      case "357magnum_mp":
         return false;
      
      default:
         return true;   
   }
}