init()
{
   mapname = toLower(getdvar("mapname"));

   switch(mapname)
   {
      case "mp_506th":
      case "mp_bocage2":
         setDvar("bro_mortardisable_" + mapname,1); // mortar hits some kind of hidden clip 
         break;
      case "mp_fortbhc2":  // replace non-brm weapons with equivalent
         level thread replaceEnts();
         break;
      case "mp_myths_farm": // change weapon loadouts to russian to match player skins
         game["allies"] = "russian";
         break;
      case "mp_foy":
         setDvar("bro_maxmapheightoffset_mp_foy",-100); // strange hidden clip
         break;
      case "mp_hurtgen":
         setDvar("bro_maxmapheightoffset_mp_hurtgen",-100); 
         break;
      case "mp_78kwai":
         setDvar("bro_squads_sightingAdjustment_mp_78kwai", "1"); // quirky skybox
         break;
      case "mp_78lungariver":
         setDvar("bro_squads_sightingAdjustment_mp_78lungariver", "1"); // quirky skybox
         break;
      case "mp_amberville": // custom S&D objectives glitch the retrieval code
         setDvar("scr_ret_keepsdvisuals_mp_amberville",1);
         maps\mp\gametypes\_dvarsetup::initDvar("bro_moveobject_mp_amberville_ret_objective_1", "131,1439,63,-174");
         maps\mp\gametypes\_dvarsetup::initDvar("bro_moveobject_mp_amberville_ret_objective_2", "958,-619,230,137");
         break;     
   }
}

replaceEnts()
{
   wait 1;

   level thread replaceGuns("weapon_mg42_mp",false,"weapon_mg42_bipod_mp","weapon_mp_mg42_bipod_mg");
   level thread replaceGuns("weapon_30cal_mp",false,"weapon_30cal_bipod_mp","weapon_mp_30cal_bipod_lmg");
   level thread replaceGuns("weapon_dp28_mp",false,"weapon_dp28_bipod_mp","weapon_mp_dp28_bipod_lmg");
   level thread replaceGuns("weapon_357magnum_mp",false,"weapon_colt_mp","weapon_usa_colt45_pistol");
   level thread replaceGuns("weapon_doublebarreledshotgun_mp",false,"weapon_shotgun_mp","weapon_mp_trenchgun_rifle");
   level thread replaceGuns("weapon_frag_grenade_mp",false,"weapon_usa_grenade_mp","weapon_usa_mk2_grenade");
   
   level thread replaceGuns("weapon_sticky_grenade_mp",true,"","");
}

replaceGuns(classname, justDelete, newClassname, newModelname)
{
   guns = getentarray(classname,"classname");
   
   for(i=0; i < guns.size; i++)
   {
      angles = guns[i].angles;
      org = guns[i].origin;
      guns[i] delete();
      
      if(!justDelete)
      {
         newent = spawn(newClassname, org);
         newent.angles = angles;
         newent setmodel(newModelname); 
         newent thread monitor_weapon();
      }
   }
}

// Ninja'd from the map - code by Nip

monitor_weapon(){
	//[Nip] Note weapon props for recreation later
	classname = self.classname;
	model = self.model;
	angles = self.angles;
	org = self.origin;

	weapon = self;
	
	while (1){
		//[Nip] Wait to be picked up, then give player full ammo.
		weapon waittill("trigger", player);
		waittillframeend;
		player giveMaxAmmo(getsubstr(classname, 7));

		wait level.weaponRespawnDelay;

		//[Nip] After waiting, recreate the weapon with the original props
		weapon = spawn(classname, org);
		weapon.angles = angles;
		weapon setmodel(model); 
	}
}

addDom()
{
   locs = [];
   
  
   for(i=0; i<5; i++)
   {
      txt = getdvar("bro_dom_makecompatible_" + level.script + "_flag" + (i+1));

      if(txt != "")
      {
         p = strtok(txt,",");
         
         if(p.size != 3)
         {
            continue;
         }
         failed = false;
         
         for(y=0; y < 3 && !failed; y++)
         {
            if(p[y] == "")
               failed = true;
            
            p[y] = int(p[y]);
         }
         
         if(failed)
            continue;
         
         locs[locs.size] = (p[0],p[1],p[2]);
      }  
   }

   flags = [];
   
   if(locs.size < 2)
      return flags;
      
   for(i=0; i < locs.size && i < 5; i++)
   {
      flags[flags.size] = spawn("trigger_radius", locs[i], 0, 160, 128);
      flags[flags.size - 1].script_label = "_" + maps\mp\_utility::convToLetter(i);
      
      descriptor = spawn("script_origin",locs[i]);
      descriptor.targetname = "flag_descriptor";
      descriptor.script_linkname = "flag" + (i+1);
      
      if(i == 0) // first flag
         descriptor.script_linkto = "flag" + (i+2);
      else if(i < (locs.size -1)) // middle flag
         descriptor.script_linkto = "flag" + i + " flag" + (i+2);
   }
      
   return flags;

}
