#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;

init()
{     
   precacheString(&"BRM_HOLD_TO_HEAL");
   precacheString(&"BRM_HEALING");
   precacheString(&"BRM_BANDAGING");
   precacheString(&"BRM_DONE");
   precacheString(&"MSBRM_CALL_MEDIC");
   
   // medic dvars
   
   if(getdvar("bro_medic_kits") == "") setdvar("bro_medic_kits",7);  
   if(getdvar("bro_medic_kits_restore") == "") setdvar("bro_medic_kits_restore",30); // number of hit points restored by each medkit
   if(getdvar("bro_medic_maxRange") == "") setdvar("bro_medic_maxRange",1500); // number of inches for medic shout notify
   if(getdvar("bro_medic_memory") == "") setdvar("bro_medic_memory",30);      // number of seconds before medic forgets medic shouts
   if(getdvar("bro_medic_healcap") == "") setdvar("bro_medic_healcap",60);      // number of hitpoints a player can be healed up to if zero, no healing takes place
   if(getdvar("bro_medic_bandagetime") == "") setdvar("bro_medic_bandagetime",6);      // number of seconds to bandage a player
   if(getdvar("bro_medic_trackShouter") == "") setdvar("bro_medic_trackShouter",1);      // tracks the player who shouted for a medic
   
   if(getdvar("bro_medic_pointreward") == "") setdvar("bro_medic_pointreward",6);      // points to reward medics for bandaging / healing. bandage gives half these points
 
   if(getdvar("bro_bleedBaseRate") == "") setdvar("bro_bleedBaseRate",3); // hit points per second. precision to 1dp
   
   if(getdvar("bro_bleedMaxTime") == "") setdvar("bro_bleedMaxTime",30); // max time to bleed - 0 does not allow bleeding to stop automatically. Time in seconds
   if(getdvar("bro_bleedEnabled") == "") setdvar("bro_bleedEnabled",1); // max time to bleed - 0 does not allow bleeding to stop automatically. Time in seconds
      
   // head & neck are 1 shot kills 
   // 1 is the same as bro_bleeedBaseRate. Values more than 1 are faster and values less than 1 are slower. precision to 1dp
   if(getdvar("bro_bleedScaleLoc_chest") == "") setdvar("bro_bleedScaleLoc_chest",1.5); 
   if(getdvar("bro_bleedScaleLoc_stomach") == "") setdvar("bro_bleedScaleLoc_stomach",1.1);
   if(getdvar("bro_bleedScaleLoc_upperleg") == "") setdvar("bro_bleedScaleLoc_upperleg",1);
   if(getdvar("bro_bleedScaleLoc_lowerleg") == "") setdvar("bro_bleedScaleLoc_lowerleg",0.9);
   if(getdvar("bro_bleedScaleLoc_foot") == "") setdvar("bro_bleedScaleLoc_foot",0.6);
   if(getdvar("bro_bleedScaleLoc_upperarm") == "") setdvar("bro_bleedScaleLoc_upperarm",1);
   if(getdvar("bro_bleedScaleLoc_lowerarm") == "") setdvar("bro_bleedScaleLoc_lowerarm",0.7);
   if(getdvar("bro_bleedScaleLoc_hand") == "") setdvar("bro_bleedScaleLoc_hand",0.5);
   
   if(getdvar("bro_medic_allowSelfBandage") == "") setdvar("bro_medic_allowSelfBandage",1);                    // allow players to bandage themselves
   if(getdvar("bro_medic_selfBandageTime") == "") setdvar("bro_medic_selfBandageTime",10);                     // Time to bandage wounds
   if(getdvar("bro_medic_selfBandageEffectiveness") == "") setdvar("bro_medic_selfBandageEffectiveness",0.15);  // Bleed rate falloff while bandaging - suggested values between 0.05 and 0.25 - experiment
   if(getdvar("bro_medic_selfBandageMustComplete") == "") setdvar("bro_medic_selfBandageMustComplete",0);      // if bandaging not completed then bleeding rate returns to previous value ("1")
   if(getdvar("bro_medic_selfNumberBandages") == "") setdvar("bro_medic_selfNumberBandages",3);                // number of bandages
   
   if(getdvar("bro_medic_autoshout") == "") setdvar("bro_medic_autoshout",1);                // automatically shout for medic
   if(getdvar("bro_medic_pingshouter") == "") setdvar("bro_medic_pingshouter",1);            // Indicates player on minimap
   
   
   level.bleedData["autoshout"] = getdvarint("bro_medic_autoshout");
   level.bleedData["pingshouter"] = getdvarint("bro_medic_pingshouter");
   level.bleedData["trackshouter"] = getdvarint("bro_medic_trackShouter");
   
   level.bleedData["enabled"] = getdvarint("bro_bleedEnabled");
   
   if(level.bleedData["enabled"] == 0)
      level.bleedData["allowbandage"] = 0;
   else    
      level.bleedData["allowbandage"] = getdvarint("bro_medic_allowSelfBandage");
      
   level.bleedData["bandagetime"] = getdvarint("bro_medic_selfBandageTime") * 2;
   level.bleedData["mustcomplete"] = getdvarint("bro_medic_selfBandageMustComplete");
   level.bleedData["selfeffectiveness"] = getdvarfloat("bro_medic_selfBandageEffectiveness");
   level.bleedData["numberbandages"] = getdvarint("bro_medic_selfNumberBandages");
   
   level.bleedData["medic_bandagetime"] = getdvarint("bro_medic_bandagetime");
   
   level.bleedData["medic_bandagetime"] = limitVar(level.bleedData["medic_bandagetime"],1,1000);
//   if(level.bleedData["medic_bandagetime"] <= 1)
//      level.bleedData["medic_bandagetime"] = 1;

   
   level.medicKitCount = getdvarint("bro_medic_kits");
   level.medicKitPoints = getdvarint("bro_medic_kits_restore");
   
   level.medicKitPoints = limitVar(level.medicKitPoints,1,1000);
   
//   if(level.medicKitPoints < 1)
//      level.medicKitPoints = 1;
      
   
   
   if(getdvarint("bro_medic_memory") < 10) setdvar("bro_medic_memory",10);
   
   level.medicMemory = getdvarint("bro_medic_memory") * 1000;
   
   if(getdvarint("bro_medic_maxRange") < 400) setdvar("bro_medic_maxRange",400);
   
   level.maxNotifyRange = getdvarint("bro_medic_maxRange");
   
   if(getdvarint("bro_medic_healcap") < 0) setdvar("bro_medic_healcap",0);
   
   level.medicHealCap = getdvarint("bro_medic_healcap");

   level.bleedData["baserate"] = getdvarfloat("bro_bleedBaseRate");
   level.bleedData["maxtime"] = getdvarint("bro_bleedMaxTime");
   
   level.bleedData["baserate"] = limitVar(level.bleedData["baserate"],0.2,100);
 //  if(level.bleedData["baserate"] <=0)
//      level.bleedData["baserate"] = 0.2;
      
   level.bleedData["baserate"] = 1/level.bleedData["baserate"]; 
   
   rate = level.bleedData["baserate"];
   
   level.bleedData["torso_upper"] = level.bleedData["baserate"] * (1 / getdvarfloat("bro_bleedScaleLoc_chest"));
   level.bleedData["torso_lower"] = level.bleedData["baserate"] * (1 / getdvarfloat("bro_bleedScaleLoc_stomach"));
   level.bleedData["left_leg_upper"] = level.bleedData["baserate"] * (1 / getdvarfloat("bro_bleedScaleLoc_upperleg"));
   level.bleedData["right_leg_upper"] = level.bleedData["left_leg_upper"];
   level.bleedData["left_leg_lower"] = level.bleedData["baserate"] * (1 / getdvarfloat("bro_bleedScaleLoc_lowerleg"));
   level.bleedData["right_leg_lower"] = level.bleedData["left_leg_lower"];
   level.bleedData["left_foot"] = level.bleedData["baserate"] * (1 / getdvarfloat("bro_bleedScaleLoc_foot"));
   level.bleedData["right_foot"] = level.bleedData["left_foot"];
   level.bleedData["left_arm_upper"] = level.bleedData["baserate"] * (1 / getdvarfloat("bro_bleedScaleLoc_upperarm"));
   level.bleedData["right_arm_upper"] = level.bleedData["left_arm_upper"];
   level.bleedData["left_arm_lower"] = level.bleedData["baserate"] * (1 / getdvarfloat("bro_bleedScaleLoc_lowerarm"));
   level.bleedData["right_arm_lower"] = level.bleedData["left_arm_lower"];
   level.bleedData["left_hand"] = level.bleedData["baserate"] * (1 / getdvarfloat("bro_bleedScaleLoc_hand"));
   level.bleedData["right_hand"] = level.bleedData["left_hand"];
   
   thread waitSetScore();
}

waitSetScore()
{
   level endon("game_ended");
   wait 0.2;
   
   rewardPoints = getdvarint("bro_medic_pointreward");
   rewardRadioPoints = getdvarint("bro_radioman_pointreward");
   
   if(rewardPoints < 0)
   {
      rewardPoints_heal = 0;
      rewardPoints_bandage = 0;
   }
   else
   {
      if(rewardPoints % 2 == 0)
      {
         rewardPoints_bandage = int(rewardPoints / 2);
         rewardPoints_heal = rewardPoints_bandage;
      }
      else
      {
         divide = int((rewardPoints - 1) / 2);
         
         rewardPoints_bandage = divide;
         rewardPoints_heal = rewardPoints_bandage + 1;         
      }
   }
   
   rewardRadioPoints = limitVar(rewardRadioPoints,0,1000);
   
   maps\mp\gametypes\_rank::registerScoreInfo( "medicrewardbandage", rewardPoints_bandage);
   maps\mp\gametypes\_rank::registerScoreInfo( "medicrewardheal", rewardPoints_heal );
   maps\mp\gametypes\_rank::registerScoreInfo( "radiomanreward", rewardRadioPoints );
}
shoutForMedic()
{
   if(self.isBleeding || self.health < level.medicHealCap)
   {
      self sayTeam( "^1Medic!" );
      
      self notify("medicprompting");
       
      if(isDefined(self.medicShoutPrompt))
         self.medicShoutPrompt destroy();
         
      self.medicPromptOnscreen = undefined;
   
      
      if(level.bleedData["pingshouter"])
         self pingPlayer(); // ping!
          
      self.calledMedic = true;
      self.medicshouting = true;
      
      switch(game[self.pers["team"]])
      {
         case "marines":
            self playsound("US_medic_shout");
            break;
         case "german":
            self playsound("GER_medic_shout");
            break;
         case "russian":
            self playsound("RUS_medic_shout");
            break;
         case "japanese":
            self playsound("JAP_medic_shout");
            break;
         default:
          //  self playsound("US_medic_shout");
            break;
      }   
   }
   else
      self iprintlnbold(&"MSBRM_DONT_NEED_MEDIC");
}

preloadHud()
{
//	self endon("disconnect");
   self endon("spawned");
   self endon("new_loadout");
  // self endon("player_killed");
//   self endon("killed_player");

   self endon("death_or_disconnect");
   
  if(!isDefined( self.medicIcons))
      self.medicIcons = [];
      
   self setclientdvars("waypointIconHeight","15",
                     "waypointIconWidth","15",
                     "waypointOffscreenPadLeft", "0",
                     "waypointOffscreenPadBottom", "55",
                     "waypointOffscreenPointerDistance", "14",
                     "waypointOffscreenPointerHeight", "8",
                     "waypointOffscreenPointerWidth", "12");
                     
   // don't create unless needed - although potentially unstable - I think i'll keep for now
      
	for ( index = 0; index < 3; index++ ) // 5th icon is for auto marking nearby teamates - limit to 3 + 1
	{
		if ( !isDefined( self.medicIcons[index] ) )
			self.medicIcons[index] = newClientHudElem( self );

		self.medicIcons[index].x = 0;
		self.medicIcons[index].y = 0;
		self.medicIcons[index].z = 0;
		self.medicIcons[index].alpha = 0;
		self.medicIcons[index].archived = false;
		self.medicIcons[index] setShader( "waypoint_second_chance", 14, 14 );
		self.medicIcons[index] setWaypoint( false );
		self.medicIcons[index].targetPlayer = self;
		self.medicIcons[index].timePlaced = 0;
		self.medicIcons[index] thread trackPlayers(self);
	}
	
	self thread findNearInjured();
	
	wait 0.5;

	self thread forgetComrades();
	
	self thread watchMedicHandler();
			 
	while(1)
	{
  
      for ( i = 0; i < level.players.size; i++ )
      {
         if(isAlive(level.players[i]) &&
         level.players[i] != self &&
         level.players[i].pers["team"] == self.pers["team"] && 
         level.players[i].calledMedic &&
         distance2D(level.players[i].origin,self.origin) < level.maxNotifyRange)
         {  
            self thread showMedicIcon( level.players[i] );          
            wait 0.05; // allows muliple medics to be notified before removing status
            level.players[i].calledMedic = false;         
         }        
      }	
   
      wait 0.2;
	}	
}

trackPlayers(medic)
{
   self endon("spawned");
	self endon("new_loadout");
	self endon("death_or_disconnect");
	level endon("intermission");
	level endon("game_ended");
	self endon("perks_hidden");
	self endon("death");
	
	prevTarget = self.targetPlayer;
	
	while(1)
	{
      if(isDefined(self.targetPlayer) && isAlive(self.targetPlayer) && self.targetPlayer != medic)
      {
         if(prevTarget != self.targetPlayer)
         {
            self setWaypoint( true, "waypoint_second_chance");
            self fadeOverTime( 1 );
            self.alpha = 0.8;
            
            self setTargetEnt( self.targetPlayer ); 
            prevTarget = self.targetPlayer;
         }
      }     
      else
      {
         self fadeOverTime( 1 );
         self.alpha = 0;
         self setWaypoint( false );
         self ClearTargetEnt();
      }
      wait 0.2;
	}

}

medicIconCleanup()
{
   if(isdefined(self.useBarText))
      self.useBarText destroyElem();
      
   if(isdefined(self.useBar))
      self.useBar destroyElem();
      
   if(isDefined(self.medicShoutPrompt))
      self.medicShoutPrompt destroy();
            
   if ( !isDefined( self.medicIcons ) )
        return;
        
   for ( index = 0; index < self.medicIcons.size; index++ ) 
	{
      if(isDefined(self.medicIcons[index]))
         self.medicIcons[index] destroy();
	}
}


showMedicIcon( lastStandPlayer )
{
	self endon ("disconnect");

    if ( !isDefined( self.medicIcons[0] ) )
        return;
	
	for(i=0; i< (self.medicIcons.size - 1); i++)
   {
      if(self.medicIcons[i].targetPlayer == lastStandPlayer)
      {
      /*
         self.medicIcons[i].x = lastStandPlayer.origin[0];
         self.medicIcons[i].y = lastStandPlayer.origin[1];
         self.medicIcons[i].z = lastStandPlayer.origin[2]+70;
         */
         self.medicIcons[i].timePlaced = maps\mp\gametypes\_globallogic::getTimePassed();
         
   //      self.medicIcons[i] SetTargetEnt( lastStandPlayer );
         return;
      }
   }
   
   idx = self getNextIcon();
   
   self.medicIcons[idx].timePlaced = maps\mp\gametypes\_globallogic::getTimePassed();
   self.medicIcons[idx].targetPlayer = lastStandPlayer;
 /*        
	self.medicIcons[idx].x = lastStandPlayer.origin[0];
	self.medicIcons[idx].y = lastStandPlayer.origin[1];
	self.medicIcons[idx].z = lastStandPlayer.origin[2]+70;
	self.medicIcons[idx] setWaypoint( true, "waypoint_second_chance");

	self.medicIcons[idx].alpha = 0.8;
	self.medicIcons[idx].targetPlayer = lastStandPlayer;
	*/
	
}

getNextIcon()
{
   icon = 0;
   bestTime = 1000000;
   for(i=0; i< (self.medicIcons.size - 1); i++)
   {
      if(bestTime > self.medicIcons[i].timePlaced)
      {
         bestTime = self.medicIcons[i].timePlaced;
         icon = i;
      }  
   } 
   return icon;
}

forgetComrades()
{
  // self endon("disconnect");
   self endon("spawned");
 //  self endon("player_killed");
   self endon("perks_hidden");
   self endon("death_or_disconnect");
   
   while(1)
   {
      for(i=0; i< self.medicIcons[i].size; i++)
      {
         timePassed = maps\mp\gametypes\_globallogic::getTimePassed() ;
         
         if(timePassed - self.medicIcons[i].timePlaced > level.medicMemory && self.medicIcons[i].targetPlayer != self)
         {
            self.medicIcons[i].targetPlayer = self;
         //   self.medicIcons[i] fadeOverTime( 0.25 );
          //  self.medicIcons[i].alpha = 0;
          //  self.medicIcons[i] setWaypoint( false );
            self.medicIcons[i].timePlaced = 0;
         }   
         wait 0.2;
      }
   }
}

findNearInjured()
{
 //  self endon("disconnect");
   self endon("spawned");
  // self endon("player_killed");
 //  self endon( "killed_player" );
 self endon("new_loadout");  
   self endon("death_or_disconnect");
   self endon("perks_hidden");
   
   wait 0.1;
   
   while(self.sessionstate == "playing")
   {
      closestDist = 99999;
      closestPlr = self;
      targetPlr = self;
      targetDist = 99999;
      
      for ( i = 0; i < level.players.size; i++ )
      {
         plr = level.players[i];

         if(isAlive(plr) && plr.pers["team"] == self.pers["team"] && plr != self && ((plr.health < level.medicHealCap && self.totalRestorePoints > 0) || plr.isBleeding))
         {
            dist = DistanceSquared(plr.origin,self.origin);

            if(dist < closestDist)
            {
               found = false;
               for(y=0; y< (self.medicIcons.size - 1); y++)
               {
                  if(self.medicIcons[y].targetPlayer == plr)
                  {
                  /*
                     self.medicIcons[y].x = plr.origin[0];
                     self.medicIcons[y].y = plr.origin[1];
                     self.medicIcons[y].z = plr.origin[2]+70;
                     */
                     self.medicIcons[y].timePlaced = maps\mp\gametypes\_globallogic::getTimePassed();
                     
               //      self.medicIcons[y] SetTargetEnt( plr );
                     
                     found = true;
                     break;
                  }
               }

               if(!found)
               {
                  closestDist = dist;
                  closestPlr = plr;
               }          
            }
            
            if(dist < targetDist)
            {
               targetDist = dist;
               targetPlr = plr;
            }
         }
      }
    
      if(closestDist < 28000)
      {
         idx = self.medicIcons.size - 1;
         self.medicIcons[idx].targetPlayer = closestPlr;
         /*
         self.medicIcons[idx].x = closestPlr.origin[0];
         self.medicIcons[idx].y = closestPlr.origin[1];
         self.medicIcons[idx].z = closestPlr.origin[2]+70;
         */
      //   self.medicIcons[4] SetTargetEnt( closestPlr );
         
       /*  self.medicIcons[idx] setWaypoint( true, "waypoint_second_chance");
         self.medicIcons[idx].alpha = 0.8;   */  
         self.medicIcons[idx].timePlaced = 0; 
      }
      else
      {
         idx = self.medicIcons.size - 1;
         self.medicIcons[idx].targetPlayer = self;
         /*
         self.medicIcons[idx] fadeOverTime( 0.3 );
         self.medicIcons[idx].alpha = 0;
         self.medicIcons[idx] setWaypoint( false );    
         self.medicIcons[idx].timePlaced = 0;*/
      }
      
      if(targetDist < 3600)
      {
         self.medicTarget = targetPlr;
      }
      else
      {
         self.medicTarget = undefined;
      }  
      wait 0.2;
   }
}

watchMedicHandler()
{
   wait 1;
 //  self endon("disconnect");
   self endon("spawned");
   self endon("new_loadout");
   //self endon("player_killed");
  // self endon("killed_player");
   self endon("death_or_disconnect");
   self endon("perks_hidden");
  
   while(1)
   {
      
      if(isdefined(self.medicTarget) && self.medicTarget.maxhealth > self.medicTarget.health && ((self.medicTarget.health < level.medicHealCap && self.totalRestorePoints > 0) || self.medicTarget.isBleeding))
      {
         targ = self.medicTarget;
         
         if(!isdefined(self.useBarText))
            self.useBarText = createPrimaryProgressBarText();
            
         if(!isdefined(self.useBar))
            self.useBar = createPrimaryProgressBar();
            
         self.useBarText showElem(); 
         self.useBar hideElem();
         self.useBarText setText( &"BRM_HOLD_TO_HEAL" );
         
         if(self useButtonPressed())
         {
            self SetMoveSpeedScale(0);
            self AllowJump(false);
            self disableWeapons();
            targ.medic = self;
            self.isBandaging = true;
	
            if(targ.isBleeding)
            {
               time = level.bleedData["medic_bandagetime"];
               self.useBarText setText( &"BRM_BANDAGING" );
            }
            else
            {
               time = 0;
               self.useBarText setText( &"BRM_HEALING" );
            }
            
            if(self.totalRestorePoints > 0)
            {
               healthReq = level.medicHealCap - targ.health;
               
               if(healthReq > self.totalRestorePoints)
                  healthReq = self.totalRestorePoints;
                  
               time += (healthReq / 10);
            }
                     
            self.useBar showElem();
            self.useBar updateBar( 0, (1/time));
                        
            time = int(time * 10);
            self thread watchForMedicDeath(targ);
            targ iprintln(&"MSBRM_BEING_TREATED", self);
            targ.isBeingBandaged = true;
            
            if(self.isBandaging )
            {
               self.isBandaging = false;
            }
            
            if(targ.isBleeding)
            {
               timeoffset = time - 60;
               targ.isBleeding = false;
               
               while(self useButtonPressed() && time > timeoffset && isAlive(targ))
               {                  
                  wait 0.1;
                  self SetMoveSpeedScale(0);
                  self AllowJump(false);
                  self disableWeapons();
                  targ SetMoveSpeedScale(0); // hold still bitch!
                  targ AllowJump(false);
                  time--;
               }
               
               if(!self useButtonPressed() && time > timeoffset && isAlive(targ))
               {
                  targ.isBleeding = true;                 
               }
               else if(!isDefined(targ.lastAttack[0]) || targ.lastAttack[0] != self && isAlive(targ))
               {
                  maps\mp\gametypes\_globallogic::givePlayerScore( "medicrewardbandage", self );
                  self maps\mp\gametypes\_globallogic::incPersStat( "assists", 1 );
                  self.assists = self maps\mp\gametypes\_globallogic::getPersStat( "assists" );
               }
	

            }

            while(self useButtonPressed() && time > 0 && targ.health <  level.medicHealCap && isAlive(targ) && self.totalRestorePoints > 0)
            {     
               self.useBarText setText( &"BRM_HEALING" );               
               wait 0.1;
               self SetMoveSpeedScale(0);
               self AllowJump(false);
               self disableWeapons();
               targ SetMoveSpeedScale(0);
               targ AllowJump(false);
               targ.health+=1;
               self.totalRestorePoints--;
               time--;
            }
            if(self useButtonPressed() && isAlive(targ))
            {
               if(!isDefined(targ.lastAttack[0]) || targ.lastAttack[0] != self)
                  maps\mp\gametypes\_globallogic::givePlayerScore( "medicrewardheal", self );
            }
               
            self setWeaponAmmoClip( "syrette_mp", int(ceil(self.totalRestorePoints / level.medicKitPoints))); 
           
            targ.isBeingBandaged = false;
            targ SetMoveSpeedScale(targ.moveSpeedDefault);
            targ AllowJump(true);
            
            while(self useButtonPressed() && isAlive(targ))
            {                 
               self.useBarText setText( &"BRM_DONE" );
               wait 0.1;
            }
            self SetMoveSpeedScale(self.moveSpeedDefault);
            self AllowJump(true);
            self enableWeapons();   
                        
            targ.medic = undefined;    
            self.isBandaging = false;
            self.medicshouting = undefined;
            
            // forget this player needed a medic
            
            self thread forgetPlayer(targ);
         }            
      }
      else
      {
         if(!((isdefined(self.isDefusing) && self.isDefusing == true) || (isDefined(self.isPlanting) && self.isPlanting == true)) && !isdefined(self.standingNrBox) && !isDefined(self.canReloadMG))
         {
            if(isdefined(self.useBarText))
               self.useBarText hideElem();
         
            if(isdefined(self.useBar))
               self.useBar hideElem();     
         }
      }
      wait 0.1;
   }
}

autoMedicShout()
{
//   self endon("disconnect");
   self endon("spawned");
   
  // self endon("player_killed");
//   self endon("killed_player");

   self endon("death_or_disconnect");
      
   if(isDefined(self.medicshouting))
      return;
      
   self.medicshouting = true;
  
   
   wait 1.5;
   
   if(isPlayer(self) && isAlive(self) && self.isBleeding)
   {
      self sayTeam( "^1Medic!" );
	//	self pingPlayer(); // ping!
          
      self.calledMedic = true;
      
      switch(game[self.pers["team"]])
      {
         case "marines":
            self playsound("US_medic_shout");
            break;
         case "german":
            self playsound("GER_medic_shout");
            break;
         case "russian":
            self playsound("RUS_medic_shout");
            break;
         case "japanese":
            self playsound("JAP_medic_shout");
            break;
         default:
          //  self playsound("US_medic_shout");
            break;
      }   
   }
   
   self.medicshouting = undefined;
}

loadMedicShoutPrompt()
{
   self notify("medicprompting");
   self endon("spawned");
   self endon("death_or_disconnect");
   self endon("medicprompting");
   
   self.medicPromptOnscreen = true;
   
   wait 0.7;
     
   if(!isDefined(self.medicShoutPrompt))
   {
      self.medicShoutPrompt = createFontString("objective",1.2);
      self.medicShoutPrompt setPoint( "TOP", "LEFT", (13), -20 ); 
      self.medicShoutPrompt.alignX = "left";
      self.medicShoutPrompt.archived = false;
   } 
   self.medicShoutPrompt.sort = 4; 
   self.medicShoutPrompt setText( &"MSBRM_CALL_MEDIC");       
   self.medicShoutPrompt.alpha = 1;
   
   wait 3;
   
   if(isDefined(self.medicShoutPrompt))
   {
      self.medicShoutPrompt fadeOverTime( 1.5 );
      self.medicShoutPrompt.alpha = 0;
   }
   
   wait 1.5;
   
   if(isDefined(self.medicShoutPrompt))
      self.medicShoutPrompt destroy();
      
   self.medicPromptOnscreen = undefined;
   

}

/////////////////////////////////
//    MEDIC PAIRED BLEEDING
/////////////////////////////////

specialBleeding(iDamage, sMeansOfDeath, sHitLoc, sWeapon, eInflictor)
{
 //  self endon("disconnect");
   self endon("spawned");
 //  self endon("player_killed");
 //  self endon("killed_player");
 
   self endon("death_or_disconnect");
      
   if(level.bleedData["enabled"] == 0)
      return;
      
   wait 0.05;
   
   if(!isAlive(self))
      return;
      
   self.bleedtimer = 0;
      
   if(level.squadSystem["active"] > 0)
   {
      if(level.bleedData["autoshout"] == 1 && (iDamage > (self.maxhealth * 0.4) || self.health < 30))
         self thread autoMedicShout();
      else if(level.bleedData["autoshout"] == 2)
         self thread loadMedicShoutPrompt();
   
   } 
   
   if(self.isBleeding || self.isBeingBandaged) // check for bandaging?
   {
      self modBleedRate(sHitLoc);
      return; // many kills otherwise, lol
   }
   // smaller the bleedrate, the faster the bleeding (kinda converse, but makes loop very simple)
   if(isdefined(level.bleedData[sHitLoc]))
      self.bleedRate = level.bleedData[sHitLoc];
   else
      self.bleedRate = level.bleedData["baserate"];
      
   self.isBleeding = true;
      
   while(self.health >= 0 && (self.isBleeding || self.isBeingBandaged))
   {
      if(self.isBleeding)
         self.health--;
      
      if(self.health < 1)
         self thread killPlayerProperly();
       
       self.bleedtimer +=  self.bleedRate;
      
      if(level.bleedData["maxtime"] > 0 && self.bleedtimer > level.bleedData["maxtime"])
      {
         self.isBleeding = false;
         self iprintln(&"MSBRM_BLEEDING_STOPPED");
         break;
      }    
 //     iprintln(self.health);
      wait self.bleedRate;
   }
}

killPlayerProperly()
{         
   self.bledtodeath = true;
   
   scoreSub = maps\mp\gametypes\_tweakables::getTweakableValue( "game", "suicidepointloss" );
   curScore = maps\mp\gametypes\_globallogic::_getPlayerScore( self );
   maps\mp\gametypes\_globallogic::_setPlayerScore( self, curScore - scoreSub );
   self.isBleeding = false; 
   
   if(isdefined(self.lastAttack[0]) && self.lastAttack[0] != self && level.teamBased && self.pers["team"] != self.lastAttack[0].pers["team"] )
   {
      [[level.givePlayerScore]]( "kill", self.lastAttack[0], self );
      [[level.giveTeamScore]]( "kill", self.lastAttack[0].pers["team"], self.lastAttack[0], self );
      
      self.lastAttack[0] maps\mp\gametypes\_globallogic::incPersStat( "kills", 1 );

      self.lastAttack[0].kills = self.lastAttack[0] maps\mp\gametypes\_globallogic::getPersStat( "kills" );
      self.lastAttack[0] maps\mp\gametypes\_globallogic::updatePersRatio( "kdratio", "kills", "deaths" );
   } 
   self suicide(); // Bai2U!
}

modBleedRate(sHitLoc)
{
   if(isdefined(level.bleedData[sHitLoc]))
      modRate = level.bleedData[sHitLoc];
   else
      modRate = level.bleedData["baserate"];

   // halfway house it?
   
   self.bleedRate -= (modRate / 2);
   if(self.bleedRate < 0.05)
      self.bleedRate = 0.05;
}

watchForMedicDeath(target)
{
   self endon("spawned");
   
   while(isAlive(self) && self.isBandaging)
      wait 0.1;
   
   if(isdefined(target))
   {   
      target SetMoveSpeedScale(target.moveSpeedDefault);
      target AllowJump(true);
      target.medic = undefined;
   }
}

forgetPlayer(target)
{
   for(i=0; i<(self.medicIcons.size - 1); i++)
   {
      if(self.medicIcons[i].targetPlayer == target)
      {
         self.medicIcons[i].targetPlayer = self;
         self.medicIcons[i] fadeOverTime( 0.25 );
         self.medicIcons[i].alpha = 0;
         self.medicIcons[i] setWaypoint( false );
         self.medicIcons[i].timePlaced = 0;
         break;
      }
   }
}
