#include maps\mp\_utility;
#include maps\mp\gametypes\_sdutils;
#include maps\mp\gametypes\_admin;
#include maps\mp\gametypes\_competition;
#include maps\mp\gametypes\_hud_util;
#include maps\mp\gametypes\_objectivemover;
#include maps\mp\gametypes\_rearming;
#include maps\mp\gametypes\_weaponlimiter;
#include maps\mp\gametypes\_usefunctions;

initialise()
{
   // precache
   
 //  precacheModel("vehicle_cobra_helicopter_fly");

   precacheShader("specialty_extraammo");
   precacheString(&"Rearming");
   precacheString(&"Being Rearmed By");
   
   precacheShellshock("suppression_mp");
   		
   if(getdvar("bro_squadBased") == "") setdvar("bro_squadBased",2); // LOADOUT SWITCH
    

   level.squadSystem["active"] = limitvar(getdvarint("bro_squadBased"),0,2);
    
    
   if(!isdefined(game["bromode"])) 
      setdvar("bro_setupmode","0");

   game["bromode"] = getDvarInt("bro_setupmode");
   
   //start b3 poweradmin
	thread b3\_b3_main::Init();
	
	//start b3 brm
	thread b3\_b3_brm::init();
	
   
   maps\mp\gametypes\_mapcompatibility::init();
   
   maps\mp\gametypes\_command::initialise();
   
   initialiseMover();
      
// Create Dvar List
    
   maps\mp\gametypes\_dvarsetup::runSetup();
   
   
   
 //---------------------------  
 /*
 
   setdvar("bro_messageDelay","4");
   setdvar("bro_message_alive_0","testmsg0");
   setdvar("bro_message_alive_1","testmsg1");
   setdvar("bro_message_alive_2","testmsg2");
   setdvar("bro_message_alive_3","testmsg3");
   setdvar("bro_message_alive_4","testmsg4");
   setdvar("bro_message_alive_5","testmsg5");
   setdvar("bro_message_alive_6","testmsg6");
   setdvar("bro_message_alive_7","testmsg7");
   setdvar("bro_message_alive_8","testmsg8");
   
   setdvar("bro_message_dead_0","^5deadmsg0");
   setdvar("bro_message_dead_1","^5 deadmsg1");
   setdvar("bro_message_dead_2","^5 deadmsg2");
   setdvar("bro_message_dead_3","^5 deadmsg3");
   setdvar("bro_message_dead_4","^5 deadmsg4");
   setdvar("bro_message_dead_5","^5 deadmsg5");
   setdvar("bro_message_dead_6","^5 deadmsg6");
   setdvar("bro_message_dead_7","^5 deadmsg7");
   setdvar("bro_message_dead_8","^5 deadmsg8");
   
   */
   
 //---------------------------  
  
   makeDvarServerInfo("bro_limitWeapons");
     
   setdvar("bro_welcomeIcon","clan_icon");
 
   makeDvarServerInfo("bro_showMinimap");
 
     
 //  makeDvarServerInfo("bro_clanmsg");
   makeDvarServerInfo("bro_forceAutoAssign");
   makeDvarServerInfo("bro_squadBased");
   
  // ---------------------------
   
   setdvar("g_compassShowEnemies",0);
   
   // startup functions / threads
  
   initComp();
   
   level thread maps\mp\gametypes\_bipods::init();
   
   if(level.squadSystem["active"] > 0)
   {
      level maps\mp\gametypes\_extraloadout::setLimits();
      
      if(level.squadSystem["active"] == 1)
         level maps\mp\gametypes\_squadloadout::init();
      else
         level maps\mp\gametypes\_classloadout::init(); 
   }
   
   level maps\mp\gametypes\_medics::init();
   
   level maps\mp\gametypes\_runlimiter::precache();
   
   level thread maps\mp\gametypes\_dvarsetup::force_dvars_slow();
   
   level thread getAdmins();
      
   level thread adminTools();
   
   level thread maps\mp\gametypes\_personalisation::runPersonalisation();
   
   level thread messagesInitialisation();
   
   level thread maps\mp\gametypes\_maprotation::run();
   
  // thread maps\mp\gametypes\_maprotation::concatenateMapRotations();
   
   level maps\mp\gametypes\_handlesquads::initSquadRelations();
 //  thread monitorSquads();
   
  // level thread randomTest(); 
}

monitorSquads()
{
   wait 6;
   while(1)
   {
      if(isDefined(level.squads))
      {
         println("^3level.squads defined " + level.squads.size);
      /*   
         for(i=0; i<level.squads.size; i++)
         {
           // iprintln(level.squads[i]);
            for(y=0; y<level.squads[i].size; y++)
            {
               iprintln(level.squads[i][y]);
            }
         
         }
         */
         
         if(isDefined(level.squads["allies"]))
         {
            println("Allies defined: " + level.squads["allies"].size);
            iprintln("Allies defined: " + level.squads["allies"].size);
         }   
         offset = 0;
         for(i=0; i<level.squads["allies"].size; i++)
         {
            if(!isDefined(level.squads["allies"][i+offset]))
            {
               offset += 1;
               i--;
               continue;
            }
            if(isDefined(level.squads["allies"][i+offset][0]))
             iprintln(level.squads["allies"][i+offset][0]);
         }
            
      }
      wait 6;
   }
}

randomTest()
{
   random = [];
   total = [];
   lowest = 1000;
   highest = 1000;
   
   for(y=0; y<10; y++)
      total[y]=0;
      
   for(y=0; y<100; y++)
   {
      for(i=0; i<10; i++)
         random[i]=0;
         
      for(i=0; i<10000; i++)
      {
         random[randomint(10)]++;
          
         if(i%500 == 0)
            wait 0.05;
      }
      
      for(i=0; i<10; i++)
      {
         println("^3#"+i + " ^7" + random[i]);
         if(random[i] > highest)
            highest = random[i];
         if(random[i] < lowest)
            lowest = random[i];
         
         total[i]+=random[i];
      }
      println("");
   }
   
   println("-----------------\nAverages:");
   
   for(i=0;i<10;i++)
   {
      println("^3#"+i + " ^7" + (total[i] / 100));
   }
   
   println("\nLowest: " + lowest + "\nHighest: " + highest);
}


adminTools()
{
   setdvar("bro_testDmg","");
   setdvar("bro_debugDmg",20);
   setdvar("bro_switchPlayer","");
   
   game["bromode"] = getDvarInt("bro_setupmode");

   
   while(1)
   {
      wait 0.5;
      
      slot = getdvar("bro_testDmg");
      balancePlayer = getdvar("bro_switchPlayer");
      setupmode = getdvarint("bro_setupmode");
         
      if(slot != "")
      {
         target = undefined;
         
         for (i = 0; i < level.players.size; i++)
         {
            if(int(slot) == level.players[i] getEntityNumber() && isAlive(level.players[i]) && level.players[i].sessionstate == "playing")
            {
               target = level.players[i];
               break;
            }
         }
		
         setdvar("bro_testDmg","");
		
         if(isdefined(target))
            target thread hitEffects(getDvarint("bro_debugDmg"), "torso_upper", "mp40_mp", "MOD_RIFLE_BULLET");   
      }
      
      if(balancePlayer != "")
      {
         target = undefined;
         for(i=0;i<level.players.size;i++)
         {
            if(level.players[i] getEntityNumber() == int(balancePlayer))
            {
               target = level.players[i];
               break;
            }
         }
         
         if(isdefined(target))
         {
            if(target.pers["team"] == "allies")
            {
               self [[level.leavesquad]]();
               self [[level.axis]]();
            }
            else
            {
               self [[level.leavesquad]]();
               self [[level.allies]]();
            }
         }
         
         setdvar("bro_switchPlayer","");
      }
      
      if(game["bromode"] != setupmode)
      {
         iprintln("^2Setup Mode Status Changed");
         
         if(level.gametype == "sd" || level.gametype == "esd" || level.gametype == "twar" || level.gametype == "ret")
         {
            

            iprintlnbold("^3Restarting ...");

            wait 3;
            game["bromode"] = setupMode;
            maps\mp\gametypes\_competition::resetParams(true,false);
            
            map_restart(true);
            
         }
         else
         {
            iprintln("^3Supported Gametypes: sd, esd, twar");
            iprintln("^3Setup mode not activated");
            setDvar("bro_setupmode",game["bromode"]);
         }
      } 
      wait 2;
   }
}



loadConnectThreads()
{
   for(;;)
   {
      level waittill("connected",player);
   //   player setclientdvars("cg_hudChatPosition",getdvar("bro_movechatpos"));
      player thread setWelcomeScreen();  
      player setClanStatus();
      player setClanStatusDvars();
      player thread waitAndConnect();


   //   player thread checkName();
   //   player thread checkPing();
   }
}

waitAndConnect()
{
   self endon("death_or_disconnect");
   
   wait 7;
   
   self.pers["hasfullyconnected"] = true;
}

setClanStatus()
{
   self.pers["isClanMember"] = false;
   
   if(level.clanmode)
   {
      if(level.clanstringposition == 1) // at beginning
      {         
         if(GetSubStr( self.name, 0, level.clantagstring.size ) == level.clantagstring)
            self.pers["isClanMember"] = true;
      }
      else if(level.clanstringposition == 2) // at end
      {
         if(GetSubStr( self.name, (self.name.size - level.clantagstring.size), self.name.size  )  == level.clantagstring)
            self.pers["isClanMember"] = true;
     
      }
      else // anywhere
      {
         if(isSubStr(self.name,level.clantagstring))
            self.pers["isClanMember"] = true;
      }
   }
}

setClanStatusDvars()
{
   if(level.clanmode)
   {
      if(self.pers["isClanMember"])
         dvar = "bro_clanteam";
      else
         dvar = "bro_pubteam";   
         
      dvarVal = getDvar(dvar);
      dvarInt = getDvarInt(dvar);
      
      if(dvar == "allies" || dvarInt == 1) { self setClientDvars("bro_ui_allowallies", "1","bro_ui_allowaxis", "0", "bro_ui_forceteam", getDvarint("bro_clanforce")); return; }
      else if(dvar == "axis" || dvarInt == 2) { self setClientDvars("bro_ui_allowallies", "0","bro_ui_allowaxis", "1", "bro_ui_forceteam", getDvarint("bro_clanforce")); return; }
      else if(dvar == "both" || dvarInt == 0) { self setClientDvars("bro_ui_allowallies", "1","bro_ui_allowaxis", "1", "bro_ui_forceteam", getDvarint("bro_clanforce")); return; }
   }
   else
   {
      self setClientDvars("bro_ui_allowallies", "1","bro_ui_allowaxis", "1", "bro_ui_forceteam",0);
   }
}

checkClanTeam(team)
{
   if(level.clanmode)
   {
      if(self.pers["isClanMember"])
         dvar = "bro_clanteam";
      else
         dvar = "bro_pubteam";   
         
      dvarVal = getDvar(dvar);
      dvarInt = getDvarInt(dvar);
      if(isDefined(self.pers["team"]) && (self.pers["team"] == "allies" || self.pers["team"] == "axis") && getDvarInt("bro_clanforce") == 0 )
      {
         return true;
      }
      else
      {
         if(team == "allies" && (dvar == "allies" || dvarInt == 1))
            return true;
         else if(team == "axis" && (dvar == "axis" || dvarInt == 2))
            return true;
         else if(team == "autoassign" && (dvar == "both" || dvarInt == 0))
            return true;
         else
            return false;
      }       
   }
   else
      return true;
}



setWelcomeScreen()
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	
	self endon("death_or_disconnect");
	
      self setClientDvars("ui_bombhelptext","");
		
		self setClientDvars("bro_clanmsg", getDvar("bro_clanmsg"));
		self setClientDvars("bro_welcomescreen_header", getDvar("bro_welcomescreen_header"));
		self setClientDvars("bro_welcomeIcon", getDvar("bro_welcomeIcon"));
		wait 0.2;
		
		self setClientDvars("bro_clanrulestitle", getDvar("bro_clanrulestitle"),
                        "bro_clanrules1", getDvar("bro_clanrules1"),
                        "bro_clanrules2", getDvar("bro_clanrules2"));
                        wait 0.15;
      self setClientDvars("bro_clanrules3", getDvar("bro_clanrules3"),
                        "bro_clanrules4", getDvar("bro_clanrules4"),
                        "bro_clanrules5", getDvar("bro_clanrules5"));
                        wait 0.15;
      self setClientDvars("bro_clanrules6", getDvar("bro_clanrules6"),
                        "bro_clanrules7", getDvar("bro_clanrules7"),
                        "bro_clanrules8", getDvar("bro_clanrules8"));
                        wait 0.15;
      self setClientDvars("bro_clanrules9", getDvar("bro_clanrules9"),
                        "bro_clanrules10", getDvar("bro_clanrules10"),
                        "bro_clanrules11", getDvar("bro_clanrules11"));
                        wait 0.15;
      self setClientDvars("bro_clanrules12", getDvar("bro_clanrules12"),
                        "bro_clanrules13", getDvar("bro_clanrules13"),
                        "bro_clanrules14", getDvar("bro_clanrules14"));
                        wait 0.15;
                        
      self setClientDvars("bro_clanrules15", getDvar("bro_clanrules15"),
                        "bro_clanrules16", getDvar("bro_clanrules16"),
                        "bro_clanrules17", getDvar("bro_clanrules17"),
                        "bro_clanrules18", getDvar("bro_clanrules18"));
                        
              
      wait 5;
                
      self setClientDvars("ui_showclickcontinue" , 1);	
      self setClientDvars("bro_ui_onmortar" , 0);	
      
      
}

loadSpawnThreads()
{
   // Init vars
  // self.b_weap = undefined;
  
   self notify("radiohudcleaned");
   self.isBleeding = false;
   self.isBandaging = false;
   self.isBeingBandaged = false;
   self.fixingBayonet = false;
   self.switchingFireMode = false;
   self.isRearming = false;
   self.isBeingRearmed = false;
   self allowsprint(true);
   self AllowJump(true);
   self.beingPunished = false;
   self.hasBinoculars = false;
   self.isOnBipod = false;
   self.bledtodeath = false;
   self.bandages = level.bleedData["numberbandages"];
   self.lastAttack = [];
   self.isbeingwarned = [];
   self.coordinates = [];
   self.standinNrBox = undefined;
   self.calledMedic = false;
   self.beenMarked = false;
   self.medicshouting = undefined;
   self.runningBurn = undefined;
   self.hasBeenTanned = false;
   self.canReloadMG = undefined;
   self.medicPromptOnscreen = undefined;
  // self.startedWithDeployable = false;
   self.targetTurret = undefined;
   self.mortar = undefined;
   


   self setClientDvars("ui_bombhelptext","");
   self setClientDvars("bro_ui_onmortar" , 0,
                       "ui_statustext",0);	
   
   
      
  // self StopBurning();
   
   if(!isdefined(self.moveSpeedDefault)) self.moveSpeedDefault = 0.8;
   
   self thread maps\mp\gametypes\_magazines::magazine_monitor();
   
   // Run threads
   self clearperks();
   
   if(getDvarint("bro_DebugHealth") == 1) 
   self thread showHealth();
   
   
   self thread gunJamming();
   self thread sprintModifier();
   self thread bayonetWatcher();

 //  self thread firemodeWatcher();
 
 //self thread findOtherPlayer();
   
   if(getDvarInt("bro_hidescores_"+ level.gametype) > 0)
      self thread zeroScore();

   //self thread maps\mp\gametypes\_command::watchBinocularsCmd();
   
//   self thread avgSpeed();
   
   self thread spawnDisableWeapon();
   
   if(game["isMatch"] && !game["preMatch"] && getdvar("bro_match_forcerecord") == "1")
   {
    //  self iprintln("^3You are now ^1Auto Recording");
    //  self openmenunomouse(game["menu_forcerecord"]);
      self ExecClientCommand("record");
   }
   self thread attachEyeMarker();
   self thread maps\mp\gametypes\_runlimiter::runMonitor();
   /*
   if(level.clanmode)
   {
      if(self.pers["isClanMember"])
         iprintln("^2You're a clan member!");
      else
         iprintln("^1You're not a clan member!");
   }  
   */
  // iprintln(GetSubStr( self.name, (self.name.size - level.clantagstring.size), self.name.size  ));

  
}

attachEyeMarker()
{
   wait 0.05;
   if(!isdefined(self.eyemarker)) // geteye() is a bit borked :-S
   {
      self.eyemarker = spawn("script_origin",(0,0,0));
      self.eyemarker linkto (self, "tag_eye",(0,0,0),(0,0,0));
   }
}

findOtherPlayer()
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	
	self endon("death_or_disconnect");
	
	while(1)
	{
      for(i=0; i< level.players.size; i++)
      {
         if(level.players[i] != self)
         {
            if(isdefined(level.players[i].origin))
            {
               self iprintln("Distance: " + int(distance(level.players[i].origin,self.origin) / 36) + " yds ");
            
            }
         }
      }
      wait 0.3;	
	}
}

loadKilledThreads(attacker, iDamage, sMeansOfDeath, sWeapon, sHitLoc, eInflictor)
{
   self thread oBits(attacker, iDamage, sMeansOfDeath, sWeapon, sHitLoc, eInflictor);
   
   self.isRearming = false;
   self.isBeingRearmed = false;
   self.isOnBipod = false;
   self.isBleeding = false;
   self.isBandaging = false;
   self.calledMedic = false;
   self.beenMarked = false;
   self.isBeingBandaged = false;
   self.targetTurret = undefined;
   self.mortar = undefined;
   self.coordinates = [];
   
   // Threads
   
   self thread cleanRearmProgress();
   self thread maps\mp\gametypes\_medics::medicIconCleanup();
   self thread maps\mp\gametypes\_magazines::cleanHud();
   
   self thread maps\mp\gametypes\_extraloadout::radioCleanup();
   
   if(isdefined(self.reinforcementHud))
      self.reinforcementHud destroy();
   
   
   if(isdefined(self.eyemarker))
   {
      self.eyemarker unlink();
      self.eyemarker delete();
   }
   
   self setClientDvars("ui_bombhelptext","");
   self setClientDvars("bro_ui_onmortar" , 0);	
   
   self setclientdvars("ui_weaponjammed",0,
                        "ui_weapon_clip",-1,
                        "ui_clipcount",0,
                        "ui_statustext",0);
}

checkName()
{
   self endon("disconnect");

   name = self.name;
   
   while(1)
   {
      if(name != self.name)
      {
         self thread lookupName();
         name = self.name;
      }
   
      wait 5;
   }
}

zeroScore()
{
	self endon("disconnect");
//	level endon("game_ended");
	
	if(isdefined(self.isHidingScore) && self.isHidingScore == true)
      return;
	else
      self.isHidingScore = true;
      
   for(;;)
   {
      self.score = self.pers["tempscore"];
      self.kills = self.pers["tempkills"];
      self.deaths = self.pers["tempdeaths"];
      self.assists = self.pers["tempassists"];

      wait 0.1;
   }

}

checkPing()
{
	self endon("disconnect");
	level endon("game_ended");
	
	for(;;)
	{
      wait 30;
            
      timer = 0;
      self.pingResponse = false;
      self thread pingResponseMonitor();
      self OpenMenuNoMouse(game["menu_ping"]);
      
      while(!self.pingResponse)
      {
         timer++;
         
         if(timer % 20 == 0)
            wait 0.05;
            
         if(timer > 400)
            break;    
      }
      
      self notify("quit_ping_monitor");
      
      if(timer >= 400) self.ping = 999;
      else self.ping = timer;
   }
}

pingResponseMonitor()
{
  	self endon("disconnect");
	level endon("game_ended"); 
	self endon("quit_ping_monitor");
	
	for(;;)
	{
      self waittill("menuresponse", menu, response);
      
      if(response == "ping")
         break;
	}
	
	self.pingResponse = true;
}

spawnDisableWeapon()
{
	self endon("spawned");	
	self endon("death_or_disconnect");
	
   level endon("intermission");
	level endon("game_ended");
	
   time = 0;

   if(isdefined(game["isMatch"]) && game["isMatch"] && game["preMatch"] == false && game["strattime"] > 0 )
   {
      self SetMoveSpeedScale(0);
      self allowsprint(false);
      self AllowJump(false);
      self disableWeapons();  
      level waittill("strattimeover");
   }

   else
   {
      self SetMoveSpeedScale(self.moveSpeedDefault);
      self disableWeapons();
      
      if(!(isDefined(game["preMatch"]) || game["preMatch"] == true))
      {
         while(level.inPrematchPeriod)
            wait 0.1;
      }

      startorigin = self.origin;
      wait 1;
      
      if(level._roundWeaponDisable >  1)
      {
         while(time < ((level._roundWeaponDisable - 1) * 20))
         {
            wait 0.05;
            time++;
         }
      }
      else
      {
         while((self.origin == startorigin) && (time < 100))
         {
            wait 0.05;
            time++;
         }
      }
   }
   
   self AllowJump(true);
   self enableWeapons();
   self SetMoveSpeedScale(self.moveSpeedDefault);
   
   self thread useOptions();
   
   if(time > 20)
      self allowsprint(true);
   else
   {
      wait 1;
      self allowsprint(true);
   }

 //  c = spawn("script_model",(self.origin + (0,0,500)));
 //  c setModel("vehicle_cobra_helicopter_fly");
   
  // chopper = spawnHelicopter(self, self.origin + (0,0,500), (0,0,0), "cobra_mp", "vehicle_cobra_helicopter_fly" );
 //  chopper hide();
   
}

avgSpeed()
{
   // Random spawn loops - for testing
  // self endon("killed_player");
	self endon("spawned");
	//self endon("disconnect");
	
	self endon("death_or_disconnect");
	
   level endon("intermission");
	level endon("game_ended");
	
/*	while(1)
   {
      self openMenu(game["menu_forceprone"]);
      wait 5;
      self openMenu(game["menu_forcecrouch"]);
      wait 5;
      self openMenu(game["menu_forcestand"]);
      wait 5;
     
      
      self SetMoveSpeedScale( 0.5 );
      wait 5;
      self SetMoveSpeedScale( 1.5 );
      wait 5;
   }*/
/*   
   // Average speed measure
   cur_origin = self.origin;
   run_time = 0;
   t_distance = 0;
   while(1)
   {
      if(self.origin != cur_origin)
      {
         t_distance += distance(self.origin,cur_origin);
         cur_origin = self.origin;
         run_time += 0.1;
         
      }
      self iprintln("^3Distance: ^2" + t_distance + " ^3Time: ^2" + run_time + " ^3avg speed: ^2" + (t_distance / run_time)); 
      wait 0.1;
   
   } 
   */
   /*
   while(1)
   {  
      wait 1;
      self Ghost();
      wait 1;
      self show();
   }
   */
   /*
   while(1)
   {
      if(self hasWeapon("mortar_mp"))
         iprintln("^2Has Mortar!");

      else
         iprintln("^1No Mortar!");
      wait 0.5;
   }
   */
   /*
   while(1)
   {
      self iprintln(self.origin[2]);
      wait 0.5;
   
   }*/
}

showHealth()
{  
 //  self endon("killed_player");
	self endon("spawned");
	//self endon("disconnect");
	
	self endon("death_or_disconnect");
	
   while(1)
   {
      self iprintln("^1Health: ^3" + self.health);
      wait 0.3;
   }
}

/*============//
   Redundant
//============*/

handle_binoculars()
{
   self endon("killed_player");
	self endon("spawned");
	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	
   if(self.hasBinoculars == false)
   {
      self thread watchBinoculars();
   }
}

/*============//
   Redundant
//============*/

watchBinoculars()
{
   self endon("killed_player");
	self endon("spawned");
	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	current_weapon = self GetCurrentWeapon();
	replaced_weapon = current_weapon;
	self takeweapon(current_weapon);
   self giveweapon("binoculars_mp");
   self switchtoweapon("binoculars_mp");
   self.hasBinoculars = true;
   self showBlankLines(3);
   self iprintln("Aim down the sight to use binoculars");
   
   wait 0.6;
   
	while(1)
	{
      current_weapon = self GetCurrentWeapon();
      
      if(current_weapon != "binoculars_mp")
      {
         self takeweapon("binoculars_mp");
         self giveweapon(replaced_weapon);
        // self iprintln("Removing Binoculars");
         self.hasBinoculars = false;
         return;
      }
      wait 0.05;
	}

}

oBits2(attacker, iDamage, sMeansOfDeath, sWeapon, sHitLoc, eInflictor)
{
   str = "";
   glob = false;

   if(isDefined(attacker) && attacker == self && self.bledtodeath == false)
      str = &"MSBRM_OBIT_SELF_INFLICTED";
   else
   {

      switch(sMeansOfDeath)
      {
         case "MOD_FALLING":
            str = &"MSBRM_OBIT_FELLTODEATH";
            break;
            
         case "MOD_MELEE":
            if(isdefined(attacker))
            {
               str = "You were bashed by " + attacker.name;      
            }
            else 
               str = "You were based";

            break;
            
         case "MOD_BAYONET":
            if(isdefined(attacker))
            {
               name = " by " + attacker.name;
            }
            else 
               name = "";
               
            str = "You were bayoneted" + name;
            break;
            
         case "MOD_TRIGGER_HURT":
            str = "You were killed by the environment";
            break;
            
         case "MOD_SUICIDE":
            if(self.bledtodeath == false)
            {
               str = "Your fatal wound was self inflicted";
               break;
            }
         default:
            
            if(self.bledtodeath == true && isdefined(self.lastAttack[0]))
            {                    
               name = self.lastAttack[0].name;
               if(self.name == name)
               {
                  str = "Your fatal wound was self inflicted";
                //  return;
                     break;
               }
               if(self.lastAttack[1] == "m8_white_smoke_mp" || self.lastAttack[1] == "m8_green_smoke_mp" || self.lastAttack[1] == "m8_red_smoke_mp")
               {
                  if(game["isMatch"])  // disable global for matches
                     str = "You bled out from a smoke grenade thrown by " + name + " - ^1HUMILIATION!";
                  else
                  {
                     str = self.name + " bled out from a smoke grenade thrown by " + name + " - ^1HUMILIATION!"; 
                     glob = true;
                  }
                //  return;
                     break;
               }
               else if(issubstr(self.lastAttack[1],"grenade"))
                  str = "You bled out from a grenade thrown by " + name;
               else
               {
                  if(self.lastAttack[1] == "napalmbomb_mp" || self.lastAttack[1] == "bombingplane_mp" || self.lastAttack[1] == "none")
                     str = "You bled to death";
                  else
                  {
                     distance = " at " + self.lastAttack[3] + " yds ";
                     weapon = maps\mp\gametypes\_weapons::convertWeaponName(self.lastAttack[1]);
                     hitloc = " " + convertHitLoc(self.lastAttack[2]) + " shot";
                     str = "You bled out from a " + weapon + hitloc + " by " + name + distance;
                  }
               }
              // iprintln("You were killed by " + name + " with a " + weapon + hitloc + distance);
               break;
            }
            else if(isdefined(attacker))
            {
               if(isdefined(attacker.name))
                  name = " by " + attacker.name;
               else 
                  name = "";
                     
               if ( (sWeapon == "none" || sWeapon == "strafeplane_mp" || sWeapon == "napalmbomb_mp") && isDefined( eInflictor ) )
               {
                  if ( isDefined( eInflictor.targetname ) && eInflictor.targetname == "explodable_barrel" )
                     sWeapon = "explodable_barrel";
                  else if ( isDefined( eInflictor.destructible_type ) && isSubStr( eInflictor.destructible_type, "vehicle_" ) )
                     sWeapon = "destructible_car";
                  else if(isDefined(eInflictor.targetname))
                     sWeapon = eInflictor.targetname;    
               }
               else if(sWeapon == "bombingplane_mp")
                  sWeapon = "Bombing Run";
               
               if(sWeapon == "m8_white_smoke_mp" || sWeapon == "m8_green_smoke_mp"  || sWeapon == "m8_red_smoke_mp")
               {
                  if(game["isMatch"]) // disable global for matches
                     str = "You were killed with a smoke grenade thrown" + name + " - ^1HUMILIATION!"; 
                  else
                  {
                     glob = true;
                     str = self.name + " was killed with a smoke grenade thrown" + name + " - ^1HUMILIATION!"; 
                  }
               }
               else if(issubstr(sWeapon,"grenade"))
                  str = "You were killed by a grenade thrown" + name;
               else
               {
                  hitloc = convertHitLoc(sHitLoc);
                  
                  if(hitloc != "") 
                  {
                     distance = " at " + int(distance(attacker.origin,self.origin) / 36) + " yds ";
                     hitloc = hitloc + " shot" + distance;
                  }
                  weapon = maps\mp\gametypes\_weapons::convertWeaponName(sWeapon);
                  if(isdefined(attacker.name) && !(sWeapon == "napalmbomb_mp" || sWeapon == "bombingplane_mp"))
                     str = "You were killed" + name + " with a " + weapon + " " + hitloc;
                  else if(weapon != "none")
                     str = "You were killed by a " + weapon + " " + hitloc;
                  else
                     str = "You were killed by something explosive!";
              //    if(sWeapon == "napalmbomb_mp" || sWeapon == "bombingplane_mp")
               //      str += weapon;

               }
               break;
            }
            else if(self.bledtodeath == true)
            {
               str = "You bled to death";
            }       
      }
   }
   
   if(glob || getDvarint("bro_DebugOBit") == 1)
      iprintln(str);
   else
      self iprintln(str);

}

oBits(attacker, iDamage, sMeansOfDeath, sWeapon, sHitLoc, eInflictor)
{
   self endon("death_or_disconnect");
   
   wait 0.05;
   str = "";

   if(isDefined(attacker) && attacker == self && self.bledtodeath == false)
      self printObit(&"MSBRM_OBIT_SELF_INFLICTED",false);
   else
   {

      switch(sMeansOfDeath)
      {
         case "MOD_FALLING":
            self printObit(&"MSBRM_OBIT_FELLTODEATH",false);
            break;
            
         case "MOD_MELEE":
            if(isdefined(attacker))
               self printObit(&"MSBRM_OBIT_BASHED",false, &"MSBRM_OBIT_BY",attacker);      
            else 
               self printObit(&"MSBRM_OBIT_BASHED",false);
            break;
            
         case "MOD_BAYONET":
            if(isdefined(attacker))
               self printObit(&"MSBRM_OBIT_BAYONET",false,&"MSBRM_OBIT_BY",attacker);
            else 
               self printObit(&"MSBRM_OBIT_BAYONET",false);
            break;
            
         case "MOD_TRIGGER_HURT":
            self printObit(&"MSBRM_OBIT_ENVIRO",false);
            break;
            
         case "MOD_SUICIDE":
            if(self.bledtodeath == false)
            {
               self printObit(&"MSBRM_OBIT_SELF_INFLICTED",false);
               break;
            }
         default:
            
            if(self.bledtodeath == true && isdefined(self.lastAttack[0]))
            {                    
               name =  self.lastAttack[0].name;
               if(self.name == name)
               {
                  self printObit(&"MSBRM_OBIT_SELF_INFLICTED",false);
                //  return;
                     break;
               }
               if(self.lastAttack[1] == "m8_white_smoke_mp" || self.lastAttack[1] == "m8_green_smoke_mp" || self.lastAttack[1] == "m8_red_smoke_mp")
               {
                  if(game["isMatch"])  // disable global for matches
                 //    str = "You bled out from a smoke grenade thrown by " + name + " - ^1HUMILIATION!";
                     self printObit(&"MSBRM_OBIT_SMOKE_GRENADE", false, &"MSBRM_OBIT_BLED_OUT_PREFIX",self.lastAttack[0]);
                  else
                  {
                  //   str = self.name + " bled out from a smoke grenade thrown by " + name + " - ^1HUMILIATION!"; 
                     self printObit(&"MSBRM_OBIT_SMOKE_GRENADE_GLOB", true, self, self.lastAttack[0]);
                  }
                //  return;
                     break;
               }
               else if(issubstr(self.lastAttack[1],"grenade"))
                  self printObit(&"MSBRM_OBIT_FRAG_GRENADE", false, &"MSBRM_OBIT_BLED_OUT_PREFIX" , self.lastAttack[0]);
               else
               {
                  if(self.lastAttack[1] == "napalmbomb_mp" || self.lastAttack[1] == "bombingplane_mp" || self.lastAttack[1] == "none" || self.lastAttack[1] == "destructible_car" || self.lastAttack[1] == "explodable_barrel")
                     self printObit(&"MSBRM_OBIT_BLED",false);
                  else
                  {
                     weapon = maps\mp\gametypes\_weapons::convertWeaponName(self.lastAttack[1]);
                     hitloc = convertHitLoc(self.lastAttack[2]);             
                     self printObit(&"MSBRM_OBIT_FULL_BLEED",false,weapon,hitloc,self.lastAttack[0], self.lastAttack[3]);
                  }
               }
              // iprintln("You were killed by " + name + " with a " + weapon + hitloc + distance);
               break;
            }
            else if(isdefined(attacker))
            {
               if(isdefined(attacker.name))
                  name =  attacker.name;
               else 
                  name = "";

               if ( (sWeapon == "none" || sWeapon == "strafeplane_mp" || sWeapon == "napalmbomb_mp") && isDefined( eInflictor ) )
               {
                  if ( isDefined( eInflictor.targetname ) && eInflictor.targetname == "explodable_barrel" )
                     sWeapon = "explodable_barrel";
                  else if ( isDefined( eInflictor.destructible_type ) && isSubStr( eInflictor.destructible_type, "vehicle_" ) )
                     sWeapon = "destructible_car";
                  
                  else if(isDefined(eInflictor.targetname))
                     sWeapon = eInflictor.targetname;  
                  else if(self.lastAttack[1] == "bombingplane_mp")
                     sWeapon = "Bombing Run"; 
               }
               else if(sWeapon == "bombingplane_mp" )
                  sWeapon = "Bombing Run";

               if(sWeapon == "m8_white_smoke_mp" || sWeapon == "m8_green_smoke_mp"  || sWeapon == "m8_red_smoke_mp")
               {
                  if(game["isMatch"]) // disable global for matches
                     self printObit(&"MSBRM_OBIT_SMOKE_GRENADE", false, &"MSBRM_OBIT_KILLED_WITH_PREFIX",name);
                  else
                     self printObit(&"MSBRM_OBIT_SMOKE_GRENADE_KILL_GLOB", true, self, name);
               }
               else if(issubstr(sWeapon,"grenade"))
                  self printObit(&"MSBRM_OBIT_FRAG_GRENADE", false, &"MSBRM_OBIT_KILLED_WITH_PREFIX", name);
               else
               {
                  hitloc = convertHitLoc(sHitLoc);
                 
                  weapon = maps\mp\gametypes\_weapons::convertWeaponName(sWeapon);
                  if(isdefined(attacker.name) && !(sWeapon == "napalmbomb_mp" || sWeapon == "bombingplane_mp"))
                  {
                     if(hitloc != "") 
                     {
                        distance = int(distance(attacker.origin,self.origin) / 36);
                        self printobit(&"MSBRM_OBIT_FULL_KILL",false,name,weapon,hitloc,distance);
                     }
                     else
                        self printobit(&"MSBRM_OBIT_SHORT_KILL",false,name,weapon);
                  }
                  else if(weapon != "none")
                  {
                     if(hitloc != "") 
                     {
                        distance = int(distance(attacker.origin,self.origin) / 36);
                        self printobit(&"MSBRM_OBIT_FULL_KILL_NOATTACKER",false,weapon,hitloc,distance);
                     }
                     else
                        self printobit(&"MSBRM_OBIT_SHORT_KILL_NOATTACKER",false,weapon);
                  }
                  else
                     str = "You were killed by something explosive!";
              //    if(sWeapon == "napalmbomb_mp" || sWeapon == "bombingplane_mp")
               //      str += weapon;

               }
               break;
            }
            else if(self.bledtodeath == true)
            {
               self printObit(&"MSBRM_OBIT_BLED",false);
            }       
      }
   }
}

printObit(localise, global, param1, param2, param3, param4, param5)
{
   if(!isDefined(param1))
      param1 = "";
   if(!isDefined(param2))
      param2 = "";
   if(!isDefined(param3))
      param3 = "";
   if(!isDefined(param4))
      param4 = "";
      
 //  iprintln(localise,param1,param2,param3,param4);
   
  if(global || getDvarint("bro_DebugOBit") == 1)
      iprintln(localise,param1,param2,param3,param4);
   else
      self iprintln(localise,param1,param2,param3,param4); 

}

fallDmgEffects(damage)
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	self endon("death_or_disconnect");
	
	if(getdvarint("bro_fallPunish")==0) return;
	
	self shellshock("suppression_mp", 1);
	
   minThreshold = getdvarint("bro_minFallPunishThreshold");
   maxThreshold = getdvarint("bro_maxFallPunishThreshold");
   
   if(damage <= minThreshold) return;
   
   level thread [[level.adminSwitch]]("badjump",self, undefined);
   
 //  if(self.health > 0)
  //    self iprintln("^1You have sprained your ankle");
   
   if(damage >= maxThreshold)
   {
      // Punish to the max - what a nub!
      self thread fallPunish(1);
   }
   else
   {   
      pCent = (damage - minThreshold) / (maxThreshold - minThreshold);
      self thread fallPunish(pCent);
      // get linear punishment - naughty, naughty!
   }
}

fallPunish(pCent)
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	self endon("death_or_disconnect");
	
	crouchTime = int(ceil(getdvarint("bro_fallPunishCrouch") * pCent * 20));
	noSprintTime = int(ceil(getdvarint("bro_fallPunishSprint") * pCent * 20));
	
	self.punishTime = crouchTime;
	if(self.punishTime < noSprintTime) self.punishTime = noSprintTime;
	
//	self.punishTime *= 20;
	
	self.punishTimer = 0;
	
	
	
	if(self.beingPunished) return;
	
	self.beingPunished = true;
	
	while((self.beingPunished) && (  self.punishTimer <= self.punishTime ))
	{
      if(self.punishTimer <= crouchTime) self thread enforceStance("crouch");
      
      if(self.punishTimer <= noSprintTime) self allowSprint(false);
      else self allowSprint(true);
      self.punishTimer++;
      wait 0.05;
	}
		
   //	punishment finished
	self allowSprint(true);
	self.beingPunished = false;
}

hitEffects(iDamage, sHitLoc, sWeapon, sMeansOfDeath, vPoint, vDir)
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	self endon("death_or_disconnect");
		
	turretStatus = maps\mp\gametypes\_weapons::isTurret(self getcurrentweapon());
	
	if(turretStatus) 
      return;
	
   if(isFoot(sHitLoc)) self thread enforceStance("crouch");
   if(isLeg(sHitLoc)) self thread enforceStance("crouch");
//   self viewShift(int(iDamage));
   
   self hitSpin(iDamage, sHitLoc, sWeapon, sMeansOfDeath, vPoint, vDir);
   
   time = 0;
   maxtime = iDamage * level._impactTimeScale;
   increasespeedtime = maxtime * 0.25;
   step = 1 / (maxtime - increasespeedtime) ;
   
   if(level.brmShownHitBlur > 0)
      self setburn(level.brmShownHitBlur);
   
   while(time < maxtime)
   {
      self allowSprint(false);
      self AllowJump(false);
     
      if(time < iDamage * level._impactWeaponDropScale) self disableweapons();
      
      if(time >= increasespeedtime)
      { 
         self SetMoveSpeedScale((self.moveSpeedDefault / (2 - ((time - increasespeedtime) * step))));
      }
      
      time++;
      wait 0.05;
      
   }
   self enableweapons();
   self allowSprint(true);
   self AllowJump( true);
   self SetMoveSpeedScale(self.moveSpeedDefault);
}

hitSpin(iDamage, sHitLoc, sWeapon, sMeansOfDeath, vPoint, vDir)
{
   
   if(level.hitSpinAmount <= 0 || sWeapon == "strafeplane_mp")
      return;
   
   if(sMeansOfDeath != "MOD_RIFLE_BULLET" && sMeansOfDeath != "MOD_PISTOL_BULLET")
      return;
      
   pointVec = ((vPoint[0] - self.origin[0]),(vPoint[1] - self.origin[1]),0);
  
   pointVec_n = VectorNormalize( pointVec );

   plrAng = self GetPlayerAngles();
   plrAng = (0, plrAng[1], 0);
   
   plrVec = AnglesToForward( plrAng);
   
   ref = AnglesToForward(plrAng - (0,0.05,0));
   
   hitAng = vectorAngles(ref, pointVec_n);
   
   relAng = vectorAngles(plrVec, pointVec_n);
   
   if(hitAng > relAng)
      upDir = -1;
   else
      upDir = 1;
      
   upDir = self hitLocSpinEffect(sHitLoc,false, upDir);
 
   vDirAngles = VectorToAngles(vDir);
   
   vDirAngles = (0, vDirAngles[1], 0);
  
   vDir = AnglesToForward(vDirAngles);
   
   incidentAng = VectorAngles(pointVec_n,vDir);
   
   magnitude = cos(90 - incidentAng);
   
   
   
   upPower = relAng - 90;
   
   if(upPower < 0)
      upPower *= -1;
      
   len = Length( pointVec );
   
   if(sMeansOfDeath == "MOD_PISTOL_BULLET")
   {
      upPower *= 0.75;
      spinPower = magnitude * len * 0.75;
   }
   else
   {
      spinPower = magnitude * len;
   }
   
   if(spinPower > 20)
      spinPower = 20;
  // iprintln("Power: " + power);
   
   compareAng = VectorAngles(pointVec_n, AnglesToForward(vDirAngles + (0,0.05,0)));
   
   if(incidentAng > compareAng)
      horDir = -1;
   else
      horDir = 1;
      
   upAngle = level.hitSpinAmount * (upPower * 0.13) * horDir * upDir;
   
   horDir = self hitLocSpinEffect(sHitLoc,true, horDir);
   
   turnAngle = level.hitSpinAmount * spinPower * horDir; 
    
   self setPlayerAngles(self GetPlayerAngles() + (upAngle, turnAngle, 0));   
}

hitLocSpinEffect(sHitLoc,horiz, curDir)
{
   if(horiz)
   {
      switch(sHitLoc)
      {
         case "torso_upper":
         case "torso_lower":
            val = 2.75;
            break;
         case "left_arm_upper":
         case "right_arm_upper":
            val = 0.8;
            break;
         case "left_arm_lower":
         case "right_arm_lower":
            val = 0.4;
            break;
         case "left_hand":
         case "right_hand":
            val = 0;
            break;
         case "left_leg_upper":
         case "right_leg_upper":
            val = 0.65;
            break;
         case "left_leg_lower":
         case "right_leg_lower":
            val = 0.35;
            break;
         case "left_foot":
         case "right_foot":
            val = 0.1;
            break;    
         default:
            val = 0; 
      }
      
      return (val * curDir);
   }
   else
   {
      switch(sHitLoc)
      {
         case "torso_upper":
            val = 1.5;
            break;
         case "torso_lower":
            val = 0.9;
            break;
         case "left_arm_upper":
         case "right_arm_upper":
            val = 0.4;
            break;
         case "left_arm_lower":
         case "right_arm_lower":
            val = 0.4;
            break;
         case "left_hand":
         case "right_hand":
            val = 0;
            break;
         case "left_leg_upper":
         case "right_leg_upper":
            val = 0.9 * curDir;
            break;
         case "left_leg_lower":
         case "right_leg_lower":
            val = 0.4 * curDir;
            break;
         case "left_foot":
         case "right_foot":
            val = 0.2 * curDir;
            break;    
         default:
            val = 0; 
      }
      
      return (val * curDir);
   }
}

giveWeaponLoadout()
{
   if(level.squadSystem["active"] == 2)
      self thread giveClassLoadout();
   else if(level.squadSystem["active"] == 1)
      self thread giveSquadLoadout();
   else
      self thread stdLoadout();
      
   self.useOptions = [];
   self.useOptionFunction = [];
   self.useOptionArg = [];
   
   if(game["bromode"])
   {
      if(level.gametype == "sd" || level.gametype == "esd" || level.gametype == "twar" || level.gametype == "ret")
      {
         self moverOptions();
         return;
      }
      else
          self iprintln("^1SETUP MODE: ^3Requires S&D / ESD / TWAR / RET");
   }

   if(level.bleedData["allowbandage"] != 0)
   {   self.useOptions[self.useOptions.size + 1] = &"MSBRM_USE_BANDAGE"; self.useOptionFunction[self.useOptionFunction.size + 1] = ::selfBandaging; }

   if(level.gunJamStatus == 1)
   {
   //   if(level.bleedData["allowbandage"] == 0)
   //   {   
      self.useOptions[self.useOptions.size + 1] = &"MSBRM_USE_UNJAM"; self.useOptionFunction[self.useOptionFunction.size + 1] = ::handle_gunJam; 
      //}
 //     else
 //     {   self.useOptions[2] = "Unjam Weapon"; self.useOptionFunction[2] = ::handle_gunJam; }
   }

   if(!level.squadSystem["active"] && (self.pers["curClass"] == "lmg" || self.pers["curClass"] == "hmg") )
   {
      if(level.maxRearmAmmo > 10)
      {
         self.useOptions[self.useOptions.size + 1] = &"MSBRM_USE_REARM"; self.useOptionFunction[self.useOptionFunction.size + 1] = ::rearm_handler;
       /*  if(level.gunJamStatus == 1)
         {   self.useOptions[3] = "Rearm Teammate"; self.useOptionFunction[3] = ::rearm_handler; }
         else
         {   self.useOptions[2] = "Rearm Teammate"; self.useOptionFunction[2] = ::rearm_handler; }
         */
         self rearmHudInit();	
      }
   }
   /*
    if(getdvarint("bro_tanks_givecoax"))
    {
      self setperk("specialty_boost");
      self.extraPerks[ "specialty_boost" ] = 1;
   } */
   
   if(getdvarint("bro_tanks_givecoax"))
      self thread maps\mp\gametypes\_extraloadout::giveCoax();
}


stdLoadout()
{
   self takeAllWeapons();
   
	weapon = tolower(self.pers["pickweapon"]);

   pistol = maps\mp\gametypes\_weapons::factionPistol(game[self.pers["team"]]);
   self giveweapon(pistol);  
      
   self giveweapon(weapon);
   self setSpawnWeapon(weapon);
   
   self giveWeapon( "squadcommand_mp" );
   self SetActionSlot( 1, "weapon","squadcommand_mp" );
	  
   self GiveWeapon( "binoculars_mp" );
						
	self SetActionSlot( 3, "weapon", "binoculars_mp" );
	self SetActionSlot( 4, "" );
			
   self giveWeapon( "bayonet_mp" );
   self giveMaxAmmo( "bayonet_mp" );
   self setActionSlot( 4, "weapon", "bayonet_mp" );

   self.isAMedic = false;
   
	self maps\mp\gametypes\_teams_brm::playerModelForWeapon( weapon );
	
	self.pers["curClass"] = getWeaponClass(weapon);
	
   self thread giveNade();
	
	self.moveSpeedDefault = getPlayerSpeedScale(self.pers["curClass"]);
	
   self.startedWithDeployableMortar = false;
   
   if(isSubStr(weapon,"_bipod_") || weapon == "ptrs41_mp")
      self.startedWithDeployableMG = true;
   else
      self.startedWithDeployableMG = false;
      
   self thread maps\mp\gametypes\_extraloadout::bipodOpHud();
   
   self giveBayonet(weapon);
}

giveSquadLoadout()
{
   self takeAllWeapons();
   
   self thread maps\mp\gametypes\_extraloadout::radioCleanup();
   
	weapon = tolower(self.pers["pickweapon"]);
   team = self.pers["team"];
   /*
   if(int(game["squadsystem"][team][self.pers["chosensquad"]]["classdetails"][self.pers["chosenclass"]]["secondary"]) > 0)
   {
      pistol = maps\mp\gametypes\_weapons::factionPistol(game[team]);
   
      self giveweapon(pistol);  
   }  
   */
   if(isSubStr(weapon,"_bipod_") || weapon == "ptrs41_mp")
      self.startedWithDeployableMG = true;
   else
      self.startedWithDeployableMG = false;
      
   if(weapon == "mortar_mp")   
   {
      self.startedWithDeployableMortar = true;
      self.coordinates = [];
      self.coordinates["mortarbarrage"] = undefined;
      self.mortarShells = limitvar(getdvarint("bro_deploymortar_shells"),1,1000);
      
   }
   else
      self.startedWithDeployableMortar = false;
         
   self giveweapon(weapon);
   self setSpawnWeapon(weapon);
   
   self giveWeapon( "squadcommand_mp" );
   self SetActionSlot( 1, "weapon","squadcommand_mp" );
	
	self maps\mp\gametypes\_extraloadout::giveItem(int(game["squadsystem"][team][self.pers["chosensquad"]]["classdetails"][self.pers["chosenclass"]]["secondary"]));
	
	
   
	self SetActionSlot( 4, "" );
			
   self giveWeapon( "bayonet_mp" );
   self giveMaxAmmo( "bayonet_mp" );
   self setActionSlot( 4, "weapon", "bayonet_mp" );
   
  // self SetActionSlot( 2, "altMode" );
  
  


	self maps\mp\gametypes\_teams_brm::playerModelForWeapon( weapon );
	
	self.pers["curClass"] = getWeaponClass(weapon);
	
   frags = int(game["squadsystem"][team][self.pers["chosensquad"]]["classdetails"][self.pers["chosenclass"]]["frag"]);
   smokes = int(game["squadsystem"][team][self.pers["chosensquad"]]["classdetails"][self.pers["chosenclass"]]["smoke"]);
   
   if(smokes > 0)
   {	
      grenadeTypeSecondary = level.smokeGrenade[self.pers["team"]]; 
      self setOffhandSecondaryClass("smoke");
      self giveWeapon( level.smokeGrenade[self.pers["team"]] );
      self SetWeaponAmmoClip( level.smokeGrenade[self.pers["team"]], 0 );
      self SetWeaponAmmoClip( level.smokeGrenade[self.pers["team"]], smokes );
   }
   
   // give frags
   self thread giveFragDelay(frags);
	
	self.moveSpeedDefault = getPlayerSpeedScale(self.pers["curClass"]);
		         
   self thread maps\mp\gametypes\_extraloadout::bipodOpHud();

   self giveBayonet(weapon);
}

giveClassLoadout()
{
   self takeAllWeapons();
   
   self thread maps\mp\gametypes\_extraloadout::radioCleanup();
   
	weapon = tolower(self.pers["pickweapon"]);
   team = self.pers["team"];
   /*
   if(game["classsystem"][team][self.pers["chosenclass"]]["hasPistol"])
   {
      pistol = maps\mp\gametypes\_weapons::factionPistol(game[team]);
   
      self giveweapon(pistol);  
   }  
   */
   
   self maps\mp\gametypes\_extraloadout::giveItem(game["classsystem"][team][self.pers["chosenclass"]]["hasPistol"]);
   
   if(isSubStr(weapon,"_bipod_") || weapon == "ptrs41_mp")
      self.startedWithDeployableMG = true;
   else
      self.startedWithDeployableMG = false;
      
   if(weapon == "mortar_mp")   
   {
      self.startedWithDeployableMortar = true;
      self.coordinates = [];
      self.coordinates["mortarbarrage"] = undefined;
      self.mortarShells = limitvar(getdvarint("bro_deploymortar_shells"),1,1000);
      
   }
   else
      self.startedWithDeployableMortar = false;
         
   self giveweapon(weapon);
   self setSpawnWeapon(weapon);
   
   self giveWeapon( "squadcommand_mp" );
   self SetActionSlot( 1, "weapon","squadcommand_mp" );
	
	
   
	self SetActionSlot( 4, "" );
			
   self giveWeapon( "bayonet_mp" );
   self giveMaxAmmo( "bayonet_mp" );
   self setActionSlot( 4, "weapon", "bayonet_mp" );
   
   self SetActionSlot( 2, "altMode" );

	self maps\mp\gametypes\_teams_brm::playerModelForWeapon( weapon );
	
	self.pers["curClass"] = getWeaponClass(weapon);
	
   frags = game["classsystem"][team][self.pers["chosenclass"]]["frags"];
   smokes = game["classsystem"][team][self.pers["chosenclass"]]["smokes"];
   
   if(smokes > 0)
   {	
      grenadeTypeSecondary = level.smokeGrenade[self.pers["team"]]; 
      self setOffhandSecondaryClass("smoke");
      self giveWeapon( level.smokeGrenade[self.pers["team"]] );
      self SetWeaponAmmoClip( level.smokeGrenade[self.pers["team"]], 0 );
      self SetWeaponAmmoClip( level.smokeGrenade[self.pers["team"]], smokes );
   }
   
   // give frags
   self thread giveFragDelay(frags);
	
	self.moveSpeedDefault = getPlayerSpeedScale(self.pers["curClass"]);
		         
   self thread maps\mp\gametypes\_extraloadout::bipodOpHud();
      
   self giveBayonet(weapon);
}

bayonetWatcher()
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	self endon("death_or_disconnect");
	
	wait 0.1;
	
	lastrealweap = self getcurrentweapon();
   
   while(1)
   {
      curWeap = self getCurrentWeapon();
      
      notSpecial = maps\mp\gametypes\_magazines::notSpecial(curWeap);
      
      if(curWeap != "none" && notSpecial)
         lastrealweap = curWeap;       
       
      if(curWeap == "bayonet_mp")
      {
         self thread bayonet_switch(lastrealweap);        
         wait 0.5;
      }
      else if(curWeap == "firemode_mp")
      {
         self thread firemode_switch(lastrealweap);        
         wait 0.5;
      }
      else if(curWeap == "bomb_drop_mp") 
      {
         self takeweapon("bomb_drop_mp");
         
         if(isDefined(self.carryObject))
            self.carryObject thread maps\mp\gametypes\_gameobjects::setDropped();
         
         self switchtoweapon(lastrealweap);
    
         wait 0.5;
      }
      else if(curWeap == "radio_drop_mp")
      {
         self takeweapon("radio_drop_mp");
         
         if(isDefined(self.carryObject))
            self.carryObject thread maps\mp\gametypes\_gameobjects::setDropped();
         
         self switchtoweapon(lastrealweap);
    
         wait 0.5;
      }
      wait 0.1;  
   }
}

getPlayerSpeedScale(class)
{
   if(isdefined(level.classSpeedMod[class]))
      return level.classSpeedMod[class];
   else
      return 1;
}

giveBayonet(weapon)
{
   if(weapon == "bayonet_mp" || weapon == "firemode_mp")
      return;
      
   isBayonetWeap = bayonet_weapons(weapon);
   
   if(isBayonetWeap != "na")
   {
      if(self hasweapon("firemode_mp"))
         self takeweapon("firemode_mp");
         
      self giveWeapon( "bayonet_mp" );
      self giveMaxAmmo( "bayonet_mp" );
      self setActionSlot( 4, "weapon", "bayonet_mp" );
      
   }
   else
   {
      if(self hasweapon("bayonet_mp"))
         self takeweapon("bayonet_mp");   
         
      firemode = firemode_weapons(weapon);
      
      if(firemode != "na")
      {
         self giveWeapon( "firemode_mp" );
         self giveMaxAmmo( "firemode_mp" );
         self setActionSlot( 4, "weapon", "firemode_mp" ); 
      }
      else
      {
         if(self hasweapon("firemode_mp"))
         {
            self takeweapon("firemode_mp");
         }
      }
   }
}

bipod_handler()
{
   if(self.isOnBipod)
   {
      self.isOnBipod = false;
   }
   else
   {
      self.isOnBipod = true;
      self thread limitAngles(self GetPlayerAngles());
      self thread keepBipodStance(self GetStance());
   }
}

keepBipodStance(stance)
{
   while(self.isOnBipod)
   {
      self enForceStance(stance);
      wait 0.05;
   }
}

limitAngles(startAngles)
{
   self endon("killed_player");
	self endon("spawned");
	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	self SetMoveSpeedScale(0);
	
	
	toleranceVert = 30;
	toleranceSide = 50;
	
	maxLeft = startAngles[1] - 30; 
	maxRight = startAngles[1] + 30;
	
	maxUp = startAngles[0] - 30; 
	maxDown = startAngles[0] + 30;
	
   while(self.isOnBipod)
   {
      
      curAngles = self GetPlayerAngles();
      self iprintln(curAngles);
            
      if(curAngles[0] > maxDown)   
         setAngVert = maxDown;
      else if( curAngles[0] < maxUp)
         setAngVert = maxUp;
      else 
         setAngVert = curAngles[0];
         
      if(curAngles[1] > maxRight)
         setAngHoriz = maxRight;
      else if(curAngles[1] < maxLeft)
         setAngHoriz = maxLeft;
      else 
         setAngHoriz = curAngles[1];
         
     // setAngVert = 20;
     // setAngHoriz = 20;
      self SetPlayerAngles((setAngVert,setAngHoriz,0));
     wait 0.05;
        
   }
   self SetMoveSpeedScale(self.moveSpeedDefault);
}

giveNade()
{     
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	self endon("death_or_disconnect");
	
	if(isdefined(game["preMatch"]) && game["preMatch"] == true)
      return;
	
   if(level.inPrematchPeriod == true) wait level.prematchPeriod / 2;

   // Frag Grenades
   
   fragCount = getDvarint("bro_frags_" + self.pers["curClass"]);
   
   if(fragCount < 0) fragCount = 0;
   
   if(fragCount > 9) fragCount = int(fragCount / 10);   
   else if(fragCount > 0)
   {  
      tempCount = 0;
      fragChance = getDvarInt("bro_randomFragChance");
      
      if(fragChance > 100) 
         tempCount = fragCount;  
      else if(fragChance < 0) 
         tempCount = 0;
      else
      {
         for(i=0; i < fragCount; i++)
         {
            if(randomintrange(1,101) < fragChance)
               tempCount++;
         }
      }
      fragCount = tempCount;
   }
   
   // Smoke Grenades
   
   smokeCount = getDvarint("bro_smokes_" + self.pers["curClass"]);
   
   if(smokeCount < 0) smokeCount = 0;
   
   if(smokeCount > 9) smokeCount = int(smokeCount / 10);   
   else if(smokeCount > 0)
   {  
      tempCount = 0;
      smokeChance = getDvarInt("bro_randomSmokeChance");
      
      if(smokeChance >= 100) 
         tempCount = smokeCount;  
      else if(smokeChance < 0) 
         tempCount = 0;
      else
      {
         for(i=0; i < smokeCount; i++)
         {
            if(randomintrange(0,100) < smokeChance)
               tempCount++;
         }
      }
      smokeCount = tempCount;
   }
   
   // give smokes
   if(smokeCount > 0)
   {
      // give smoke grenade with no ammo		
      grenadeTypeSecondary = level.smokeGrenade[self.pers["team"]]; 
      self setOffhandSecondaryClass("smoke");
      self giveWeapon( grenadeTypeSecondary );
      self SetWeaponAmmoClip( grenadeTypeSecondary, 0 );
      self SetWeaponAmmoClip( grenadeTypeSecondary, int(smokeCount) );
   }
   
   // Wait if SD
   if(level.gametype=="sd" || level.gametype == "ret")
   {
      delay = getdvarfloat("bro_sd_nadeDelay");
      if(delay < 0.1) delay = 0.1;
      wait delay;
   }
   
   // give frags
   if(fragCount > 0)
   {
      // give frag grenade with no ammo
      grenadeTypePrimary = maps\mp\gametypes\_weapons::factionGrenade(game[self.pers["team"]]);  	
      self GiveWeapon( grenadeTypePrimary );
      self SetWeaponAmmoClip( grenadeTypePrimary, 0 );
      self SwitchToOffhand( grenadeTypePrimary );  
      self SetWeaponAmmoClip( grenadeTypePrimary, int(fragCount) );
   }
}

giveFragDelay(count)
{
//   self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	
	self endon("death_or_disconnect");
	
	level endon("intermission");
	level endon("game_ended");
	
   if(count <= 0)
      return;
      
      
   if(level.gametype == "sd" || level.gametype == "ret")
   {
      delay = getdvarfloat("bro_sd_nadeDelay");
      if(delay < 0.1) delay = 0.1;
      wait delay;
   }

   grenadeTypePrimary = maps\mp\gametypes\_weapons::factionGrenade(game[self.pers["team"]]);  	
   self GiveWeapon( grenadeTypePrimary );
   self SetWeaponAmmoClip( grenadeTypePrimary, 0 );
   self SwitchToOffhand( grenadeTypePrimary );  
   self SetWeaponAmmoClip( grenadeTypePrimary, count );
}

getWeaponClass(weapon)
{
   if(isSniper(weapon))
   {
      return "sniper";
   }
   else
   {
      class = getWeapClass(getWeaponRoot(weapon));
      if(class == "none") class = "boltaction";
      
      return class;
   }
}

modifyDamage(eAttacker, iDamage, sMeansOfDeath, sWeapon, eInflictor, sHitLoc)
{ 
   returnDmg = iDamage;
     
   // HitLoc Mod Pass
   
   if((sHitLoc == "head" || sHitLoc == "neck") && sMeansOfDeath != "MOD_IMPACT" && sWeapon != "shotgun_mp" && sWeapon != "shotgun_bayonet_mp")
   {
      return self.maxhealth;
   }
   
   // this bit handles the one stab in the back, two in the front thing.
   
   if(isDefined(sMeansOfDeath) && sMeansOfDeath == "MOD_MELEE")
   {
      if(isDefined(eAttacker))
      {
   /*
         vAngles = data.victim.anglesOnDeath[1];
         pAngles = player.anglesOnKill[1];
         angleDiff = AngleClamp180( vAngles - pAngles );
         if ( abs(angleDiff) < 30 )
            self.maxhealth
	*/	
         attackerForward = anglestoforward(eAttacker.angles);
         victimForward = anglestoforward(self.angles);
         
         if(abs(attackerForward[1] - victimForward[1]) < 0.4)        
            return self.maxhealth;
  
      }
   
   }
     
   return iDamage;
}

sprintModifier()
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	
	self endon("death_or_disconnect");
	
	level endon("intermission");
	level endon("game_ended");
	
	self.isSprinting = false;
	
	self thread sprintWatchDog();
	wait 0.05;
	maxSprintTime = getDvarfloat( "scr_player_sprinttime" );
	sprintScale = getDvarfloat( "player_sprintSpeedScale" );
	fullsprint = maxSprintTime / 2;

	decrement = (self.moveSpeedDefault - (self.moveSpeedDefault / sprintScale)) / (fullsprint * 10);
		
	while(1)
	{
      sprintTime = 0;
      newSpeed = self.moveSpeedDefault;
      
      while(self.isSprinting)
      {
         if(sprintTime >= fullsprint)
         {
            newSpeed -= decrement;
            self SetMoveSpeedScale(newSpeed);
         }
         
         sprintTime += .1;
         wait .1;
      }
      if( sprintTime > 0) 
      {
         self SetMoveSpeedScale(self.moveSpeedDefault);
      }
      wait 0.05;
	}
}

messagesInitialisation()
{
   level endon("game_ended");
   
   brm_messageDelay = getdvarint("bro_messageDelay");
   
   if(brm_messageDelay <= 0 || game["isMatch"]) // disabled
   
      return;
   
   println("message generator initialised");
   
   if(!isdefined(game["brm_messagepos_alive"]))
      game["brm_messagepos_alive"] = 0;
   if(!isdefined(game["brm_messagepos_dead"]))
      game["brm_messagepos_dead"] = 0;
      
   // initialise messages
   level.brmAliveMessages = [];
   level.brmDeadMessages = [];
   
   idx = 0;
   
   for(;;)
   {
      dvarVal = getdvar("bro_message_alive_" + idx);
      
      if(dvarVal != "")
         level.brmAliveMessages[idx] = dvarVal;
      else
         break;  
      
      idx++;     
      wait 0.05;
   }
   
   if(level.brmAliveMessages.size > 0) 
      thread runAliveMessages(brm_messageDelay);
      
   idx = 0;
   
   for(;;)
   {
      dvarVal = getdvar("bro_message_dead_" + idx);
      
      if(dvarVal != "")
         level.brmDeadMessages[idx] = dvarVal;
      else
         break;  
         
      idx++;   
      wait 0.05;
   }
       
   if(level.brmDeadMessages.size > 0) 
      thread runDeadMessages(brm_messageDelay);
}

runAliveMessages(delay)
{
   level endon("game_ended");
   
   wait 5;
   
   while(1)
   {
      msg = level.brmAliveMessages[game["brm_messagepos_alive"]];
      if(game["brm_messagepos_alive"] >= (level.brmAliveMessages.size -1))
         game["brm_messagepos_alive"] = 0;
      else
         game["brm_messagepos_alive"]++;
         
      if( tolower(msg) !=  "skip")
      {
         
         for (i = 0; i < level.players.size; i++)
         {
            if(level.players[i].sessionstate == "playing")
               level.players[i] iprintln (msg);     
    
         }    
      }     
      wait delay; 
   }
}

runDeadMessages(delay)
{
   
   level endon("game_ended");
   
   wait 5;
      
   while(1)
   {
      msg = level.brmDeadMessages[game["brm_messagepos_dead"]];
      if(game["brm_messagepos_dead"] >= (level.brmDeadMessages.size -1))
         game["brm_messagepos_dead"] = 0;
      else
         game["brm_messagepos_dead"]++;
      
      if( tolower(msg) !=  "skip")
      {
         for (i = 0; i < level.players.size; i++)
         {
            if(level.players[i].sessionstate == "dead" || level.players[i].sessionstate == "spectator" || level.players[i].pers["team"] == "spectator" )
               level.players[i] iprintln (msg);     
         }    
      }      
      wait delay;
   } 
}