#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;

init()
{
   level._effect["mortar_shell_trail"] = loadfx ("weapon/rocket/fx_lci_rocket_geotrail");
   //level._effect["mortar_shell_trail_launch"] = loadfx ("weapon/mortar/fx_mortar_launch_w_trail");
   level._effect["mortar_shell_trail_launch"] = loadfx ("weapon/mortar/fx_mortar_launch_brm");
   level._effect["mortar_smoke_barrage"] = loadfx ("weapon/grenade/fx_smoke_grenade_22sec_mp");
   level._effect["mortar_shell_explosion"] = loadfx ("explosions/grenadeExp_default");

   if(getdvar("bro_smokebarrageshells") == "") setdvar("bro_smokebarrageshells",4);
   
   if(getdvar("bro_mortar_accuracy") == "") setdvar("bro_mortar_accuracy",100);
   
   if(getdvar("bro_deploymortar_shells") == "") setdvar("bro_deploymortar_shells",20);
   
   precacheModel("static_peleliu_mortar_shell01");
   precacheModel("artillery_usa_mortar_81mm_static");

   precacheString(&"BRM2_MORTAR_READY");
   precacheString(&"BRM2_MORTAR_FIRING");
   precacheString(&"BRM2_MORTAR_NOSHELLS");
   precacheString(&"BRM2_MORTAR_USE");
   precacheString(&"BRM2_MORTAR_HELP");
 
   precacheString(&"BRM2_MORTAR_AWAITING_ORDERS");
   precacheString(&"BRM2_MORTAR_READY_SHELLS");
   
   level.deployedMortars = [];
   
   level.maxDeployedMortars = 8;
      
   thread cleanupRoutine();
   
   if(level.mapHeight > level.mapLength)
   { 
      level._mortarTargetAreaRad = (level._mortartargetrange / level.mapHeight) * 180;
   }
   else
   {
      level._mortarTargetAreaRad = (level._mortartargetrange / level.mapLength) * 180;
   }
}


smokeBarrage(targetpos,team, loc)
{  
   spreadAreaRadius = 500;
   shells = limitVar(getdvarint("bro_smokebarrageshells"),1,15);
     
   batteryLocation = (level.mapMidPoint[0], level.mapMidPoint[1], loc[2]) 
   - vector_scale(vectornormalize(((level.mapMidPoint[0] - loc[0]), (level.mapMidPoint[1] - loc[1]), 0)), 8000) - (0,0,-400); 
      
   wait 5;
   
   for(i=0; i < shells; i++)
   {
      level thread firemortar(randomLoc(targetpos,spreadAreaRadius,true), batteryLocation, "smoke", false);
      
      wait (4 + randomfloat(2));
   }
}

firemortar(targetpos, startpos, type, verifyTarget, morter)
{
   if(!isDefined(verifyTarget)) verifyTarget = true;
   
   if(verifyTarget)
   {
      trace = bullettrace( targetpos + (0,0,10000), targetpos + (0,0,-10000), false, undefined );
   
      if(level.checkSkyCap)
      {
         pos = (targetpos[0], targetpos[1], trace["position"][2] - 514);
         pos = bullettrace(pos, pos + (0,0,-10000), false, undefined);
         targetpos = pos["position"];
      }
      else
         targetpos = trace["position"];
   }
    
   if(type != "smoke")
   {  
      gravity = GetDvarInt( "g_gravity" ) * -1;
      delta = targetpos - startpos;
      drop = 0.5 * gravity * ( 16 * 16 );
      velocity = ( ( delta[0] / 16 ), ( delta[1] / 16 ), ( delta[2] - drop ) / 16 );
       
      self launchbomb( "mortar_mp", startpos + (0, 0, 40), velocity );
      
      thread playSoundinSpace("wpn_mortar_fire_brm",startpos,1);
      
      playfx( level._effect["mortar_shell_trail_launch"], startpos, vectornormalize((velocity)) );

      self thread mortarImpactEffects(15);
      return;
   }
   
   wait 0.05;
   mortarShell = spawn ("script_model", startpos);
	mortarShell setmodel ("static_peleliu_mortar_shell01");

	yaw_vec = vectortoangles(targetpos - mortarShell.origin);
			
	mortarShell.angles = (270, yaw_vec[1] ,0);
   
   playSoundinSpace("wpn_mortar_fire_brm",startpos,1);
   
 //  wait 0.2;
   
   dirvec = vector_scale(anglestoforward(mortarShell.angles),50);
   
  // playfx( level._effect["mortar_shell_trail_launch"], mortarShell.origin );
  // playfx( level._effect["mortar_shell_trail_launch"], mortarShell.origin, mortarShell.origin + dirvec );
   
   playfxontag( level._effect["mortar_shell_trail"], mortarShell, "static_peleliu_mortar_shell01_lod0" );
 //  playfxontag( level._effect["mortar_shell_trail"], mortarShell, "static_mp_shell_lod0" );
    
  // level thread throw_object_with_gravity(mortarShell, targetpos, 16, 178 ); // 13

      
      level thread throw_object_with_gravity(mortarShell, targetpos, 16, 178 ); 

   while(1)
	{

      lastpos = mortarShell.origin;
      wait 0.05;
      
      if(!isDefined(mortarShell))
         return;
         
      if(mortarShell.origin[2] < lastpos[2] && mortarShell.origin[2] < (targetpos[2] + 100))
	//	if (mortar.origin == targetpos[2] )
		{
         mortarShell delete();
			//	playfx(level._effect["lci_rocket_impact"], self.origin);	
				// lci rocket impact sound
		//		self stoploopsound(1);
		//		playsoundatposition ("rocket_impact", self.origin);
		
            if(type == "smoke")
            {
               PlayFx( level._effect["mortar_smoke_barrage"], targetpos );
               thread playSoundinSpace("smoke_grenade_explode", targetpos,5);
            }
           
				break;
		}
		wait (0.05);
	}	
}

deployMortar()
{
   if(self GetCurrentWeapon() != "mortar_mp" && self isOnGround())
      return;
      
   if( IsDefined(self GetVehicleOccupied()))
      return;
      
   angles = self.angles;
   
   plantPos = self getPlantPosition(45);
   
   if(distanceSquared(self.origin, plantPos) > 6000 )
   {  
      self iprintln(&"MSBRM_CANT_DEPLOY_MORTAR");
      return;
   }  
   else if(self getStance() == "prone")
   {
      self iprintln(&"MSBRM_CANT_DEPLOY_MORTAR_PRONE");
      return;
   }
    
   mortar = spawn("script_model",plantPos);
   mortar setModel("artillery_usa_mortar_81mm_static");
   mortar.angles = (0,int(angles[1]+90),0);
   mortar.targetdist = 3600;
   mortar.shells = 0;
   mortar.mode = 1;
   
   
    
   self takeWeapon(self GetCurrentWeapon());
   
   curWeaps = self maps\mp\gametypes\_weapons::getPlayerWeapons(true, false);
      
   if(curWeaps.size > 0)
   {
      self SwitchToWeapon(curWeaps[0]);
   }
   else
   {
      self giveWeapon("mgcarry_mp");
      self SwitchToWeapon("mgcarry_mp");
   }
      
   self.moveSpeedDefault = 1.15;	
   self SetMoveSpeedScale(self.moveSpeedDefault);
   
   mortar.lookup = level.deployedMortars.size;
   level.deployedMortars[level.deployedMortars.size] = mortar;
      
   self thread setupMortar(mortar);
    
   mortar thread checkNearbyPlayers();

   mortar thread checkDamage();
}

checkDamage()
{
   self endon("removed");
   
   for(;;)
   {
      self waittill("damage",iDamage);
 //     self.entity notify("damage", iDamage, eAttacker, (0,0,0), (0,0,0), "mod_explosive", "", "" );
      if(iDamage > 60)
      {
         thread damageEffects(self.origin,self.angles);
         cleanDeployedArray(self.lookup);
      //   self delete();
         return;
      }
   }
}

damageEffects(origin,angles)
{
   for(i=0; i<27; i++)
   {
      PlayFx( level._effect["plane_napalmstrike_groundfire"], origin );
      wait (randomfloat(1) + 0.3);
   }
}

setupMortar(mortar)
{
   self.mortar = mortar;
      
   if(!isDefined(self.coordinates["mortarbarrage"]))
   {
     
    //  self.coordinates["mortarbarrage"] = undefined;
  //    self.coordinates["mortarbarrage"] = self.origin;
	}
   mortar.owner = self;
   mortar.lastused = maps\mp\gametypes\_globallogic::getTimePassed();
   
   if(isDefined(self.mortarShells))
   {
      mortar.shells += self.mortarShells;
      
      self.mortarShells = 0;
   }

   self ExecClientCommand("exec custommortarbinds.cfg"); 
     
   self createMortarHUD();
   self thread monitorMortarUse();
 
   self setMiniMapTarg();
   
   self disableweapons();
   
   self setClientDvars("bro_ui_onmortar" , 1);	
   
   wait 0.1;

}

pickupMortar()
{
   self endon("death_or_disconnect");
   
   if( IsDefined(self GetVehicleOccupied()))
      return;
 
   if(isDefined(self.targetMortar) && self hasWeapon("mortar_mp") == false)
   { 
      if(!isDefined(self.targetMortar.owner) || (self.targetMortar.owner == self && self.startedWithDeployableMortar)) // nobody is on it so can pickup
      {
         // Get related weapon         
 
        // shells = self.targetMortar.shells;
         
         self maps\mp\gametypes\_magazines::setupNewWeapon("mortar_mp",0,0);
         
         self.mortarShells = self.targetMortar.shells;

         self cleanupMortarHud();
 
         // run cleanup (remove from array)
         cleanDeployedArray(self.targetMortar.lookup);
         
         if(self hasWeapon("mgcarry_mp"))
            self takeWeapon("mgcarry_mp");

         self giveWeapon("mortar_mp");
        // self GiveStartAmmo("mortar_mp");
                  
         self playLocalSound("ammo_pickup_plr");
         
         self destroyMortarUseHud();
         
         self.moveSpeedDefault  = maps\mp\gametypes\_mod_core::getPlayerSpeedScale(self.pers["curClass"]);
         self SetMoveSpeedScale(self.moveSpeedDefault);
         
         self.mortar = undefined;
         
         wait 0.15;
               
         if(self hasWeapon("mortar_mp"))
            self switchToWeapon("mortar_mp");
         
         self enableWeapons();   
         self.targetMortar = undefined;       
      }
   }
}

cleanupRoutine()
{
   level endon("intermission");
	level endon("game_ended");

	if(level.numLives == 1)
   {   
     return; // run only on > 1 life games?
   }
   
   wait 8;
	
   for(;;)
   {
      if(level.deployedMortars.size > level.maxDeployedMortars)
      {
         // search for unused - take empty turrets before older ones

         oldestMortar = undefined;
         emptyMortar = undefined;
         
         curTimeBias = maps\mp\gametypes\_globallogic::getTimePassed() - (15000);
         
         for(i=0; i < level.deployedMortars.size; i++)
         {
            Mortar = level.deployedMortars[i];
            
            if(!isDefined(Mortar.owner))
            {
               if(Mortar.shells <= 0 && Mortar.lastused < curTimeBias)
               {
                  if(!isDefined(emptyMortar))
                     emptyMortar = Mortar;
                  else if(Mortar.lastused < emptyMortar.lastused)
                     emptyMortar = Mortar;
               }
                  
               if(!isDefined(oldestMortar) && Mortar.lastused < curTimeBias) 
                  oldestMortar = Mortar;
               else if(Mortar.lastused < oldestMortar.lastused)
                  oldestMortar = Mortar;
            }
         }
         
         if(isDefined(emptyMortar))
            cleanDeployedArray(emptyMortar.lookup);
         else if(isDefined(oldestMortar))
            cleanDeployedArray(oldestMortar.lookup);
      }
      wait 4;
   }
}

cleanDeployedArray(removeID)
{
   tmpArray = [];
   
   if(isDefined(level.deployedMortars[removeID].owner))
   {  
      owner = level.deployedMortars[removeID].owner;
      owner.mortar = undefined;
      owner cleanupMortarHud();
      owner enableWeapons();
      owner setClientDvars("bro_ui_onmortar" , 0);	
   }
     
   tmpMortar = level.deployedMortars[removeID]; //notify("removed");
   
 //  iprintln("Notify");
  // level.deployedMortars[removeID] delete();
 //  iprintln("deleted " + removeID);
   
   for(i=0; i < level.deployedMortars.size; i++)
   {
      if(i != removeID)
      { 
         id = tmpArray.size;
         tmpArray[id] = level.deployedMortars[i];
         tmpArray[id].lookup = id;
      }
   }
   level.deployedMortars = tmpArray;
   
   tmpMortar delete();
   
   tmpMortar notify("removed");
}  


checkNearbyPlayers()
{
   self endon("removed");
   
   while(1)
   {
      while(!isDefined(self.owner) || !isAlive(self.owner))
      {
         self.owner = undefined;
         for(i=0;i<level.players.size;i++)
         {
            plr = level.players[i];
            
            if(isAlive(plr) && !isDefined(plr GetVehicleOccupied()) && distanceSquared(plr.origin, self.origin) < 5000 && !isDefined(self.mortar) && plr getStance() != "prone")
            {
               if(!isDefined(plr.mortarHudMenuUse))
               {
                  plr createMortarUseHud(self);
                  plr thread watchMortarActivate(self);
               }
            }
            else
            {
               if(isDefined(plr.mortarHudMenuUse) && plr.mortarHudMenuUse.relMortar == self)
                  plr destroyMortarUseHud();
            }
         }
         wait 0.15;
      }  
      
      if(isDefined(self.owner))
      {
         for(i=0;i<level.players.size;i++)
         {
            plr = level.players[i];
            
            if(isDefined(plr.mortarHudMenuUse) && plr.mortarHudMenuUse.relMortar == self)
                plr destroyMortarUseHud(); 
         }
      }
      wait 1;      
   }
}

monitorMortarUse()
{
   self endon("removed");
   
   self thread watchFire();
   self thread watchMelee();
   self thread watchPlayerPosition();
}

watchFire()
{
   self endon("death_or_disconnect");
   
   while(isDefined(self.mortar))
   {
      if(self AttackButtonPressed() && self.mortar.shells > 0)
      {
       //  self iprintln("^1Firing!");
       
         targetpos = self.mortar.origin + vector_scale(anglesToForward(self.mortar mortAng(false)),self.mortar.targetdist);
          
         if(getdvarint("bro_squads_mortar_officer") > 0 || getdvarint("bro_squads_mortar_nco") > 0)
         {
            if(isDefined(self.coordinates["mortarbarrage"]))
            {
             //  targetpos = randomLoc(self.mortar.origin + vector_scale(anglesToForward(self.mortar mortAng(false)),self.mortar.targetdist),getdvarint("bro_mortar_accuracy"), false);
           //    iprintln(distance2D(self.coordinates["mortarbarrage"],targetpos));
           
           // remove one from mortarbarrage count at start and sub 1 allowed shell
           
               if(distance2D(self.coordinates["mortarbarrage"],targetpos) > level._mortartargetrange)
               {
                  self iprintlnbold(&"MSBRM_MORTAR_NOT_AIMED");
                  while(self AttackButtonPressed())
                     wait 0.1;
                  continue;
               }
               if(self._mortarBarrageShells == level._mortarBarrageShells)
                  self thread barrageTimeCountdown();
               self._mortarBarrageShells--;
               
               if(self._mortarBarrageShells <= 0)
               {
                  self notify("end_barrage");
                  self.coordinates["mortarbarrage"] = undefined;
                  self setClientDvars("bro_ui_mortar_targareasize",-1);
               }
            }
            else
            {
               while(self AttackButtonPressed())
                  wait 0.1;
               continue;
            }
         }
         
         targetpos = randomLoc(targetpos,getdvarint("bro_mortar_accuracy"), false);
  
         self.mortar.shells--;
                
         if(self.mortar.mode == 1)
            self setClientDvars("bro_ui_mortar_data","Shells: " + self.mortar.shells + "\n^3> ^7Range: ^3" + (self.mortar.targetdist / 36) + " yds\n^7   Angle: " + self.mortar mortAng(true) + "*");
         else
            self setClientDvars("bro_ui_mortar_data","Shells: " + self.mortar.shells + "\n   Range: " + (self.mortar.targetdist / 36) + " yds\n^3> ^7Angle: ^3" + self.mortar mortAng(true) + "*");
            
         self thread firemortar(targetpos, getnosepoint(self.mortar), "shell",true);
         
         self.mortarHudMenuStatus setText( &"BRM2_MORTAR_FIRING");
         
         for(y=0; isDefined(self.mortar) && y<3; y++)
         {          
            self.mortarHudMenuStatus.color = (0.66,0,0);
            
            self.mortarHudMenuStatus.alpha = 0.2;
            
            for(i=0; isDefined(self.mortar) && i<10; i++)
            {
               self.mortarHudMenuStatus.alpha += 0.08;
               wait 0.05;
               
            }
            for(i=0;isDefined(self.mortar) && i<10; i++)
            {
               self.mortarHudMenuStatus.alpha -= 0.08;
               wait 0.05;
               
            }                        
         }
         
         if(!isDefined(self.mortar))
            return;
         
         self.mortarHudMenuStatus.alpha = 1; 
         
         if(self.mortar.shells < 1)
         {
            self.mortarHudMenuStatus.color = (0.66,0,0);
            self.mortarHudMenuStatus.alpha = 1;     
            self.mortarHudMenuStatus setText( &"BRM2_MORTAR_NOSHELLS");
         }
         else if(getdvarint("bro_squads_mortar_officer") > 0 || getdvarint("bro_squads_mortar_nco") > 0)
         {
            if(isDefined(self.coordinates["mortarbarrage"]))
            {
               self.mortarHudMenuStatus.color = (0.35, 1, 0);
               self.mortarHudMenuStatus setText( &"BRM2_MORTAR_READY_SHELLS",self._mortarBarrageShells);
            }
            else
            {
               self.mortarHudMenuStatus.color = (1, 0.47, 0.22);
               self.mortarHudMenuStatus setText( &"BRM2_MORTAR_AWAITING_ORDERS");
            }
         }
         else
         {
            self.mortarHudMenuStatus.color = (0.35, 1, 0);
            self.mortarHudMenuStatus.alpha = 1;     
            self.mortarHudMenuStatus setText( &"BRM2_MORTAR_READY");
         }
         
         while(self AttackButtonPressed())
            wait 0.1;
      }  
      
      wait 0.05;   
   }
}

barrageTimeCountdown()
{
   self endon("death_or_disconnect");
   self endon("end_barrage");
   
   if(game["mortarbarrage"][self.pers["team"]]["max"] > 0)
   {
      game["mortarbarrage"][self.pers["team"]]["max"]--;
   
      wait level._mortarBarrageTime;
   }

   self._mortarBarrageShells = 0;
   self.coordinates["mortarbarrage"] = undefined;
   self setClientDvars("bro_ui_mortar_targareasize",-1);
   
   self.mortarHudMenuStatus.color = (1, 0.47, 0.22);
   self.mortarHudMenuStatus setText( &"BRM2_MORTAR_AWAITING_ORDERS");
}

watchMelee()
{
   self endon("death_or_disconnect");
   
   while(isDefined(self.mortar))
   {
      if(self meleeButtonPressed())
      {      
         self.mortar.owner = undefined;
         self.mortar = undefined;
         self cleanupMortarHud();
         self enableWeapons();
         self setClientDvars("bro_ui_onmortar" , 0);	
         return;
      }
      wait 0.05;
   }
}
watchPlayerPosition()
{
   self endon("death_or_disconnect");
   
   while(isDefined(self.mortar))
   {
      if(distanceSquared(self.origin, self.mortar.origin) > 6000 || self getStance() == "prone")
      {
         self.mortar.owner = undefined;
         self.mortar = undefined;
         self cleanupMortarHud();
         self enableWeapons();
         self setClientDvars("bro_ui_onmortar" , 0);	
         return;
      }
      else
         self disableweapons();
      
      wait 0.1;
   }
}

watchMortarActivate(mortar)
{
   self endon("death_or_disconnect");
   mortar endon("removed");
   
   while(isDefined(self.mortarHudMenuUse))
   {
      if(self useButtonPressed() && !isDefined(mortar.owner) && self getStance() != "prone")
      {
         self thread setupMortar(mortar);
      //   self thread destroyMortarUseHud();
         level thread cleanUseHudAll(mortar);
         return;
      }
      wait 0.05;
   }
}

modPos(dir)
{
   if(isDefined(self.mortar))
   {
      if(self.mortar.mode == 1)
      {
         if(dir > 0)
         {
            if(self.mortar.targetdist < 100800)
               self.mortar.targetdist += 72;     
          //  self.mortarHudMenuRange setText( &"BRM2_MORTAR_RANGE", (self.mortar.targetdist / 36) );
         //   self.mortarHudMenuHelp setText( &"BRM2_MORTAR_HELP_RANGE", (self.mortar.targetdist / 36), self.mortar mortAng(true),self.mortar.shells);  
        //    self setClientDvars("bro_ui_mortar_data","Shells: " + self.mortar.shells + "\n^3> ^7Range: ^3" + (self.mortar.targetdist / 36) + " yds\n^7   Angle: " + self.mortar mortAng(true) + "*");
         }
         else
         {
            if(self.mortar.targetdist > 0)
               self.mortar.targetdist -= 72;
               
           // self.mortarHudMenuRange setText( &"BRM2_MORTAR_RANGE", (self.mortar.targetdist / 36) );
         //   self.mortarHudMenuHelp setText( &"BRM2_MORTAR_HELP_RANGE", (self.mortar.targetdist / 36), self.mortar mortAng(true),self.mortar.shells);  
         }
         self setClientDvars("bro_ui_mortar_data","Shells: " + self.mortar.shells + "\n^3> ^7Range: ^3" + (self.mortar.targetdist / 36) + " yds\n^7   Angle: " + self.mortar mortAng(true) + "*");
    //                          "bro_ui_mortar_range",(self.mortar.targetdist / 36));
    
         self setMiniMapTarg();
      }
      else
      {
         if(dir > 0)
         {
            self.mortar.angles = self.mortar.angles + (0, -1, 0);     
         }
         else
         {
            self.mortar.angles = self.mortar.angles + (0, 1, 0);               
         }
       //  self.mortarHudMenuYaw setText( &"BRM2_MORTAR_YAW", self.mortar mortAng(true) );
      //   self.mortarHudMenuHelp setText( &"BRM2_MORTAR_HELP_YAW", (self.mortar.targetdist / 36), self.mortar mortAng(true),self.mortar.shells);  
         self setClientDvars("bro_ui_mortar_data","Shells: " + self.mortar.shells + "\n   Range: " + (self.mortar.targetdist / 36) + " yds\n^3> ^7Angle: ^3" + self.mortar mortAng(true) + "*");
         self setMiniMapTarg();
      }
   }
}

toggleMode()
{
   if(isDefined(self.mortar))
   {
      if(self.mortar.mode == 1)
      {
         self.mortar.mode = 0;
      //   self.mortarHudMenuRange.color = (1,1,1);
      //   self.mortarHudMenuYaw.color = (1,1,0);
      //   self.mortarHudMenuHelp setText( &"BRM2_MORTAR_HELP_YAW", (self.mortar.targetdist / 36), self.mortar mortAng(true),self.mortar.shells);  
         self setClientDvars("bro_ui_mortar_data","Shells: " + self.mortar.shells + "\n   Range: " + (self.mortar.targetdist / 36) + " yds\n^3> ^7Angle: ^3" + self.mortar mortAng(true) + "*");
        
      }
      else
      {
         self.mortar.mode = 1;
       //  self.mortarHudMenuRange.color = (1,1,0);
       //  self.mortarHudMenuYaw.color = (1,1,1);
      //   self.mortarHudMenuHelp setText( &"BRM2_MORTAR_HELP_RANGE", (self.mortar.targetdist / 36), self.mortar mortAng(true),self.mortar.shells);  
         self setClientDvars("bro_ui_mortar_data","Shells: " + self.mortar.shells + "\n^3> ^7Range: ^3" + (self.mortar.targetdist / 36) + " yds\n^7   Angle: " + self.mortar mortAng(true) + "*");

      }
   }
}

createMortarHUD()
{
   if(!isDefined(self.mortarHudMenuStatus))
   {
      self.mortarHudMenuStatus = createFontString("objective",1.2);
     // self.mortarHudMenuStatus setPoint( "TOP", "LEFT", (13), -60 ); // + 15 for each option
      self.mortarHudMenuStatus setPoint( "TOP", "LEFT", (183), -205 ); // + 15 for each option
      self.mortarHudMenuStatus.alignX = "left";
   } 
   self.mortarHudMenuStatus.sort = 4; 
   
   if(self.mortar.shells < 1)
   {
      self.mortarHudMenuStatus.color = (0.66,0,0);    
      self.mortarHudMenuStatus setText( &"BRM2_MORTAR_NOSHELLS");
   }
   else
   {
      if(getdvarint("bro_squads_mortar_officer") > 0 || getdvarint("bro_squads_mortar_nco") > 0)
      {
         if(isDefined(self.coordinates["mortarbarrage"]))
         {
            self.mortarHudMenuStatus.color = (0.35, 1, 0);
            self.mortarHudMenuStatus setText( &"BRM2_MORTAR_READY_SHELLS",self._mortarBarrageShells);
         }
         else
         {
            self.mortarHudMenuStatus.color = (1, 0.47, 0.22);
            self.mortarHudMenuStatus setText( &"BRM2_MORTAR_AWAITING_ORDERS");
         }
      }
      else
      {
         self.mortarHudMenuStatus.color = (0.35, 1, 0);
         self.mortarHudMenuStatus setText( &"BRM2_MORTAR_READY");
      }
   }
    
   self.mortarHudMenuStatus.alpha = 1;

  /* 
   if(!isDefined(self.mortarHudMenuYaw))
   {
      self.mortarHudMenuYaw = createFontString("objective",1.0);
      self.mortarHudMenuYaw setPoint( "TOP", "LEFT", (13), -37 ); // + 15 for each option
      self.mortarHudMenuYaw.alignX = "left";
   } 
   self.mortarHudMenuYaw.sort = 4; 
   self.mortarHudMenuYaw setText( &"BRM2_MORTAR_YAW", self.mortar mortAng(true) );       
   self.mortarHudMenuYaw.alpha = 1;
   */
   if(!isDefined(self.mortarHudMenuHelp))
   {
      self.mortarHudMenuHelp = createFontString("objective",1.0);
     // self.mortarHudMenuHelp setPoint( "TOP", "LEFT", (13), -15 ); // + 15 for each option
      self.mortarHudMenuHelp setPoint( "TOP", "LEFT", (183), -148 ); // + 15 for each option
      self.mortarHudMenuHelp.alignX = "left";
   } 
   self.mortarHudMenuHelp.sort = 4; 
  // self.mortarHudMenuHelp setText( &"BRM2_MORTAR_HELP");       
   
   if(self.mortar.mode == 1)
   {
      self setClientDvars("bro_ui_mortar_data","Shells: " + self.mortar.shells + "\n^3> ^7Range: ^3" + (self.mortar.targetdist / 36) + " yds\n^7   Angle: " + self.mortar mortAng(true) + "*");

     // self.mortarHudMenuHelp setText( &"BRM2_MORTAR_HELP_RANGE", (self.mortar.targetdist / 36), self.mortar mortAng(true),self.mortar.shells);       
   }
   else
   {
      self setClientDvars("bro_ui_mortar_data","Shells: " + self.mortar.shells + "\n   Range: " + (self.mortar.targetdist / 36) + " yds\n^3> ^7Angle: ^3" + self.mortar mortAng(true) + "*");
        
   //   self.mortarHudMenuHelp setText( &"BRM2_MORTAR_HELP_YAW", (self.mortar.targetdist / 36), self.mortar mortAng(true),self.mortar.shells);       
   }
   
   if(isDefined(self.coordinates["mortarbarrage"]))
   {
      point = getRelMapPoint(self.coordinates["mortarbarrage"]);
      self setClientDvars("bro_ui_mortar_targareax",limitvar(point[0],0,180) - level._mortarTargetAreaRad,
                        "bro_ui_mortar_targareay",limitvar(point[1],0,180) - level._mortarTargetAreaRad,
                        "bro_ui_mortar_targareasize",(level._mortarTargetAreaRad * 2));
   }
   else
      self setClientDvars("bro_ui_mortar_targareasize",-1);
   
   self.mortarHudMenuHelp setText( &"BRM2_MORTAR_HELP");       
   
   self.mortarHudMenuHelp.alpha = 1;
   
   self destroyMortarUseHud();

}

cleanupMortarHud()
{
   if(isdefined(self.mortarHudMenuStatus))
      self.mortarHudMenuStatus destroy();

      
   if(isdefined(self.mortarHudMenuHelp))
      self.mortarHudMenuHelp destroy();
}

createMortarUseHud(mortar)
{
   if(!isDefined(self.mortarHudMenuUse))
   {
      self.mortarHudMenuUse = createFontString("objective",1.2);
      self.mortarHudMenuUse setPoint( "TOP", "LEFT", (13), -20 ); // + 15 for each option
      self.mortarHudMenuUse.alignX = "left";
   } 
   self.mortarHudMenuUse.sort = 4; 
   self.mortarHudMenuUse setText( &"BRM2_MORTAR_USE");       
   self.mortarHudMenuUse.alpha = 1;
   
   self.mortarHudMenuUse.relMortar = mortar;
}

cleanUseHudAll(mortar)
{
   for(i=0; i<level.players.size; i++)
   {
      plr = level.players[i];
      
      if(isDefined(plr.mortarHudMenuUse) && 
      isDefined(plr.mortarHudMenuUse.relMortar) && 
      plr.mortarHudMenuUse.relMortar == mortar)        
         plr destroyMortarUseHud();
   }
}

destroyMortarUseHud()
{
   if(isDefined(self.mortarHudMenuUse))
   {
      self.mortarHudMenuUse.relMortar = undefined;
      self.mortarHudMenuUse destroy();
   }   
}

///////////////////////////
//    Helper Functions
//////////////////////////

playSoundinSpace( alias, origin, timer )
{
	org = spawn( "script_origin", origin );
	org.origin = origin;
	org playSound( alias  );
	wait timer; // MP doesn't have "sounddone" notifies =(
	org delete();
}

randomLoc(pos, radius, doTrace)
{
   randloc = ((int(randomInt(radius * 2) - radius + pos[0])), (int(randomInt(radius * 2) - radius + pos[1])), int(pos[2] + 1000));
   
   if(doTrace)
   {
      trace = bullettrace(  randloc,  randloc - (0,0,3000), 0, undefined );
   
      return trace["position"];
   }
   else
      return randloc;
}

mortAng(normaliseYaw)
{
   if(normaliseYaw)
   {

      dispAngle = 360 - (self.angles[1] - 90) + getNorthYaw();
      
      if(dispAngle < 0)
         dispAngle += 360;
      
      while(dispAngle > 360)
         dispAngle -= 360;
      
      return dispAngle;
   }   
   else
      return (self.angles[0], (self.angles[1] - 90), self.angles[2]);
}

force_mortar_dvar()
{
   while(!isdefined(level.players))   
      wait 0.1;
   
   for(;;)
   {
      for (i = 0; i < level.players.size; i++)
      {    
         if(!isDefined(level.players[i].mortar))
         {
            
            level.players[i] setClientDvars("bro_ui_onmortar",0);
         }
      }
         wait 1;
   }
}

setMiniMapTarg()
{
   if(getdvar("bro_debug_mortar") == "1")
      target = self.mortar.origin;
   
   else
      target = self.mortar.origin + vector_scale(anglesToForward(self.mortar mortAng(false)),self.mortar.targetdist);
   
//   iprintln(target);
//   iprintln(level.mortarTopLeft);
 //  iprintln("Len: " +level.mapLength);
 //  iprintln("Height: " +level.mapHeight);
 //  iprintln("NY: " +getNorthYaw());
    /*
   if(getdvar("bro_debug_m_angle") == "") setdvar("bro_debug_m_angle",0);

   angle = getNorthYaw() + getdvarint("bro_debug_m_angle");

   if(getNorthYaw() > 180)
      angle = getNorthYaw() + 270;
   else
      angle = getNorthYaw() + 90;

   if(level.mapHeight > level.mapLength)
   {
      yM = 180;  
      xM = (level.mapLength / level.mapHeight) * 180;
   }
   else
   {
      xM = 180;  
      yM = (level.mapHeight / level.mapLength) * 180;
   }
   ///////////////////////////

   hyp = distance2D(target, level.mortarTopLeft);

   absX = target[0] - level.mortarTopLeft[0];
   absY = level.mortarTopLeft[1] - target[1];

   absTAng = atan(absX / absY);

   angle = 180 - angle + absTAng;

   xPos = sin(angle) * hyp;

   xPos /= level.mapLength;
   xPos *= xM;

   yPos = cos(angle) * hyp;
   yPos /= level.mapHeight;
   yPos *= yM;
    */
   point = getRelMapPoint(target);
   
   self setClientDvars("bro_ui_mortar_targx",limitvar(point[0],0,180) - 5,
                        "bro_ui_mortar_targy",limitvar(point[1],0,180) - 5);
                       
}

getRelMapPoint(target)
{  
   data = [];
   
   angle = getNorthYaw();

   if(getNorthYaw() > 180)
      angle = getNorthYaw() + 270;
   else
      angle = getNorthYaw() + 90;

   if(level.mapHeight > level.mapLength)
   {
      yM = 180;  
      xM = (level.mapLength / level.mapHeight) * 180;
   }
   else
   {
      xM = 180;  
      yM = (level.mapHeight / level.mapLength) * 180;
   }
   ///////////////////////////

   hyp = distance2D(target, level.mortarTopLeft);

   absX = target[0] - level.mortarTopLeft[0];
   absY = level.mortarTopLeft[1] - target[1];

   absTAng = atan(absX / absY);

   angle = 180 - angle + absTAng;

   data[0] = sin(angle) * hyp;

   data[0] /= level.mapLength;
   data[0] *= xM;

   data[1] = cos(angle) * hyp;
   data[1] /= level.mapHeight;
   data[1] *= yM;
   
   return data;
}

mortarImpactEffects(waitTime)
{
	self endon("disconnect");
	self endon("spawned");

   wait waitTime;
   
   self waittill("projectile_impact", weapon, position, radius );
   
   if ( weapon == "mortar_mp" )
   {
      playRumbleOnPosition( "artillery_rumble", position );
      maps\mp\gametypes\_hardpoints::radiusArtilleryShellshock( position, radius * 1.1, 3, 1.5, self );
      mortarDamage("mortar_mp",position,radius);
   //	earthquake( 0.7, 0.75, position, 1000 );
      earthquake( 0.5, 1.5, position, 1400 );
   }
}

getnosepoint(mortar)
{
   return mortar.origin + vector_scale(anglesToForward(mortar mortAng(false)),6) + (0,0,39);
}

mortarDamage(weapon,position,radius)
{
   if(!isDefined(level.deployedMortars))
      return;
      
   if(getdvarint("bro_destroyable_mortars") == 0)
   {
      return;
   }   

   mortars = level.deployedMortars;

	for (i = 0; i < mortars.size; i++)
	{
		entpos = mortars[i].origin + (0,0,30);
		dist = distance(position, entpos);
		if (dist < radius && (maps\mp\gametypes\_weapons::weaponDamageTracePassed(position + (0,0,25), entpos, radius, mortars[i])))
		{
			mortars[i] notify("damage", int((1 - (dist / radius)) * 150), (0,0,0), (0,0,0), "mod_explosive", "", "" );
		}
	}
}