
/* 

   Objective Mover script originally by Bionic_Nipple as part of the openwarfare mod project
   
   Tweaked and adjusted (with new admin controls and working collision) by |Brothers|-Robinson
   
   TWAR moving capabilities added v2.0.3
   RET moving capabilities added v2.0.8

*/

#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;

initialiseMover()
{  
   gt = getdvar("g_gametype");
   mapname = toLower(getDvar("mapname"));
   
   if(!isDefined(game["objmoveridxs"]))
      getIDXSetup(gt,mapname);
   
   if(getDvar("bro_objectiveMover_randomise") == "") setDvar("bro_objectiveMover_randomise",0);
   if(getDvar("bro_objectiveMover_rename_twar") == "") setDvar("bro_objectiveMover_rename_twar",0);
      
   if(!isDefined(game["objmoverset"]) || getDvarInt("bro_objectiveMover_randomise") == 1)
      game["objmoverset"] = getIDX();
   
   if(gt == "sd" || gt == "esd")
   {      
      if(game["bromode"])
      {
         level.objMoverOptionLabels = [];
         
         level.objMoverOptionLabels[0] = &"BRM2_A_BOMBSITE";
         level.objMoverOptionLabels[1] = &"BRM2_B_BOMBSITE";
         level.objMoverOptionLabels[2] = &"BRM2_TNT_BUNDLE";
        
         precacheString(&"BRM_MOVER_TITLE");
         precacheString(&"BRM2_A_BOMBSITE");
         precacheString(&"BRM2_B_BOMBSITE");
         precacheString(&"BRM2_TNT_BUNDLE");
         precacheString(&"BRM2_BOUNCE");
         precacheString(&"BRM2_MOVER_SD_ATTACKER_SPAWNS");
         precacheString(&"BRM2_MOVER_SD_DEFENDER_SPAWNS");
         precacheString(&"MENU_BACK");
         precacheString(&"BRM_SAVE_ALL_DATA");
         precacheString(&"BRM_SET_POSITION");
         precacheString(&"BRM_RESET_POSITION");
         precacheString(&"BRM_UNDO");
         
         if(game["allies"] == "marines") precacheModel("prop_flag_american");
         else precacheModel("prop_flag_russian");
         
         precacheModel("prop_flag_" + game["axis"]);
            
         precacheShader("compass_waypoint_defend_f");
         
         level.objectiveMoverDataSpawns = [];
         
         level.objectiveMoverDataSpawns["allies"] = [];
         level.objectiveMoverDataSpawns["axis"] = [];
         
         level.moverCurrentFlagIdx = [];
         
         level.moverCurrentFlagIdx["allies"] = 0;
         level.moverCurrentFlagIdx["axis"] = 0;
         
        
         level.moverLastOp = [];

         level.moverLastOp["allies"] = undefined;
         level.moverLastOp["axis"] = undefined;
      }   
      
      if(gt == "sd") 
         moveBomb(mapname);
         
      moveSpawns("attacker",gt,mapname);
      moveSpawns("defender",gt,mapname);
      moveBombsites(gt,mapname);
   }
   if(gt == "ret")
   {      
      if(game["bromode"])
      {
         level.objMoverOptionLabels = [];
         
         level.objMoverOptionLabels[0] = &"RET_CHANGE_A_LOCATION";
         level.objMoverOptionLabels[1] = &"RET_CHANGE_B_LOCATION";
         level.objMoverOptionLabels[2] = &"RET_CHANGE_RETURNLOC";
        
         precacheString(&"BRM_MOVER_TITLE");
         precacheString(&"RET_CHANGE_A_LOCATION");
         precacheString(&"RET_CHANGE_B_LOCATION");
         precacheString(&"RET_CHANGE_RETURNLOC");

         precacheString(&"BRM2_MOVER_SD_ATTACKER_SPAWNS");
         precacheString(&"BRM2_MOVER_SD_DEFENDER_SPAWNS");
         precacheString(&"MENU_BACK");
         precacheString(&"BRM_SAVE_ALL_DATA");
         precacheString(&"BRM_SET_POSITION");
         precacheString(&"BRM_RESET_POSITION");
         precacheString(&"BRM_UNDO");
         
         if(game["allies"] == "marines") precacheModel("prop_flag_american");
         else precacheModel("prop_flag_russian");
         
         precacheModel("prop_flag_" + game["axis"]);
            
         precacheShader("compass_waypoint_defend_f");
         
         level.objectiveMoverDataSpawns = [];
         
         level.objectiveMoverDataSpawns["allies"] = [];
         level.objectiveMoverDataSpawns["axis"] = [];
         
         level.moverCurrentFlagIdx = [];
         
         level.moverCurrentFlagIdx["allies"] = 0;
         level.moverCurrentFlagIdx["axis"] = 0;
         
        
         level.moverLastOp = [];

         level.moverLastOp["allies"] = undefined;
         level.moverLastOp["axis"] = undefined;
      }   
      /*
      if(gt == "sd") 
         moveBomb(mapname);
         */
      moveSpawns("attacker",gt,mapname);
      moveSpawns("defender",gt,mapname);
      moveRetObjectives(mapname);
      moveCaptureLoc(mapname);
    
   }
   else if(gt == "twar")
   {
      // precache strings
      if(game["bromode"])
      {
         level.objMoverOptionLabels = [];
         
         level.objMoverOptionLabels[0] = &"BRM_1_FLAG";
         level.objMoverOptionLabels[1] = &"BRM_2_FLAG";
         level.objMoverOptionLabels[2] = &"BRM_3_FLAG";
         level.objMoverOptionLabels[3] = &"BRM_4_FLAG";
         level.objMoverOptionLabels[4] = &"BRM_5_FLAG";
         
         precacheString(&"BRM_MOVER_TITLE");
         precacheString(&"BRM_1_FLAG");
         precacheString(&"BRM_2_FLAG");
         precacheString(&"BRM_3_FLAG");
         precacheString(&"BRM_4_FLAG");
         precacheString(&"BRM_5_FLAG");
         precacheString(&"BRM_MOVER_TWAR_ALLIED_SPAWNS");
         precacheString(&"BRM_MOVER_TWAR_AXIS_SPAWNS");
     //    precacheString(&"BRM_MOVER_TWAR_SPAWNS");
         precacheString(&"MENU_BACK");
         precacheString(&"BRM_SAVE_ALL_DATA");
         precacheString(&"BRM_SET_POSITION");
         precacheString(&"BRM_RESET_POSITION");
         precacheString(&"BRM_UNDO");
         
         precacheShader("compass_waypoint_defend_a");
         precacheShader("compass_waypoint_defend_b");
         precacheShader("compass_waypoint_defend_c");
         precacheShader("compass_waypoint_defend_d");
         precacheShader("compass_waypoint_defend_e");
         
       //  precacheShader("compass_waypoint_captureneutral_c");
         precacheShader("compass_waypoint_defend_f");
         
         level.objectiveMoverDataSpawns = [];
         
         level.objectiveMoverDataSpawns["allies"] = [];
         level.objectiveMoverDataSpawns["axis"] = [];
         
         level.moverCurrentFlagIdx = [];
         
         level.moverCurrentFlagIdx["allies"] = 0;
         level.moverCurrentFlagIdx["axis"] = 0;
         
        // level thread showTwarSpawns();
        
        level.moverLastOp = [];
        
        level.moverLastOp["allies"] = undefined;
        level.moverLastOp["axis"] = undefined;
      }

      moveFlags(mapname);
      moveSpawns("allies",gt,mapname);
      moveSpawns("axis",gt,mapname);
   }
}

getIDXSetup(gt,mapname)
{
   game["objmoveridxs"] = [];
   
   switch(gt)
   {
      case "sd":
      case "esd":
         baseDvar = "bro_moveobject_" + mapname + "_" + gt + "_bombzoneA";
         break;    
      case "twar":
         baseDvar = "bro_moveobject_" + mapname + "_twar_flag_a";
         break;
      case "ret":
         baseDvar = "bro_moveobject_" + mapname + "_ret_objective_1";
         break;
      default:
         return;
   } 
   curID = 0;
   for(i=0; i<20; i++)
   {
      if(getDvar(baseDvar + "_" + i) != "")
      {
         game["objmoveridxs"][curId] = i;
         curID++;
      }
   }  
}

getIDX()
{
   if(game["objmoveridxs"].size > 0)
      return "_" + game["objmoveridxs"][randomInt(game["objmoveridxs"].size)];
   else
      return "";
}

moveFlags(mapname)
{

   flags = getEntArray( "flag_primary_linked", "targetname" );
   desc = getentarray( "twar_flag_descriptor", "targetname" ); // move this - how to relate?? - check origins?
    
   for(i=0; i<flags.size; i++)
   {
      dvarVal = getDvar("bro_moveobject_" + mapname + "_twar_flag" + flags[i].script_label + game["objmoverset"]);
  //    println(">>> Checking flag " + flags[i].script_label + " dvarVal: " + dvarVal);
      if(dvarVal != "")
      {
         dataAr = StrTok( dvarVal, "," );
            
         if(dataAr.size < 3) // [Robbo] Not enough bits of info in the dvar - abort and log
         {
            continue; 
         }
         
         closest = undefined;
         closestDesc = undefined;
         for(y=0; y<desc.size; y++)
         {
            dist = distance(flags[i].origin, desc[y].origin);
            if (!isdefined(closest) || dist < closest) 
            {
               closest = dist;
               closestDesc = desc[y];
            }
         }
         if(isdefined(closestDesc))
         {
            dataAr = intCoords(dataAr);
            descPos = dataAr + (0,0,(closestDesc.origin[2] - flags[i].origin[2]));
            flags[i].origin = dataAr;
            closestDesc.origin = descPos;
         }
      }
   }
 
   if(getDvar("bro_objectiveMover_rename_twar") == "1")
      _twarlocations::init();
}

moveRetObjectives(mapname)
{  
   level.objectMoverOrigin = [];
   level.objectMoverAngles = [];
         
   bombzone_triggers = getEntArray("bombzone", "targetname");
   
	for (i=0;i<bombzone_triggers.size;i++)
	{
		trigger = bombzone_triggers[i];

		visuals = getEntArray(trigger.target, "targetname" );
		label = "_"+ (i+1);
		dvarVal = getdvar("bro_moveobject_" + mapname + "_ret_" + getObjEnglish(label) + game["objmoverset"]);
		
		if(dvarVal == "") // [Robbo] Dvar not defined - print to log
		{  
       //  logprint("OBJECTIVE MOVER - " + getObjEnglish(label) + " " + game["objmoverset"] + " Not Defined for " +  mapname + " (" + gt + ")\n");  
         continue;
      }
         
      dataAr = StrTok( dvarVal, "," );
         
      if(dataAr.size < 4) // [Robbo] Not enough bits of info in the dvar - abort and log
      {
         logprint(">>>>> OBJECTIVE MOVER PROBLEM - " + getObjEnglish(label) + " " + game["objmoverset"] + " objective incorrectly configured for " +  mapname + " (Retrieval)\n");  

         continue; 
      }
			
			// [Robbo] Cast data strings to ints
			 
         for(d=0;d<dataAr.size; d++)
            dataAr[d] = int(dataAr[d]);
            
			origin = (dataAr[0],dataAr[1],dataAr[2]);
			angles = (0,dataAr[3],0);
			
				
			//[Nip] Move the defuse trigger
			defuse = getent(visuals[0].target, "targetname");
			defuse.origin = origin;
			defuse.angles = angles;
							
			//[Nip] Move the plant trigger
			trigger.origin = origin;
			trigger.angles = angles;	
	}	
}

moveBombsites(gt,mapname)
{  
   level.objectMoverOrigin = [];
   level.objectMoverAngles = [];
         
   bombzone_triggers = getEntArray("bombzone", "targetname");
   
	for (i=0;i<bombzone_triggers.size;i++)
	{
		trigger = bombzone_triggers[i];
		label = trigger.script_label;
		visuals = getEntArray(trigger.target, "targetname" );
		
		dvarVal = getdvar("bro_moveobject_" + mapname + "_" + gt + "_" + getObjEnglish(label) + game["objmoverset"]);
		
		if(dvarVal == "") // [Robbo] Dvar not defined - print to log
		{  
       //  logprint("OBJECTIVE MOVER - " + getObjEnglish(label) + " " + game["objmoverset"] + " Not Defined for " +  mapname + " (" + gt + ")\n");  
         continue;
      }
         
      dataAr = StrTok( dvarVal, "," );
         
      if(dataAr.size < 4) // [Robbo] Not enough bits of info in the dvar - abort and log
      {
         logprint(">>>>> OBJECTIVE MOVER PROBLEM - " + getObjEnglish(label) + " " + game["objmoverset"] + " objective incorrectly configured for " +  mapname + " (" + gt + ")\n");  

         continue; 
      }
			
			// [Robbo] Cast data strings to ints
			 
         for(d=0;d<dataAr.size; d++)
            dataAr[d] = int(dataAr[d]);
            
			origin = (dataAr[0],dataAr[1],dataAr[2]);
			angles = (0,dataAr[3],0);
			
			//[Nip] Move the expodey bits (Although it's usually just 1)
			for(j=0;j<visuals.size;j++)
			{
				visuals[j].origin = origin;
				visuals[j].angles = angles;
			}
				
			//[Nip] Move the defuse trigger
			defuse = getent(visuals[0].target, "targetname");
			defuse.origin = origin;
			defuse.angles = angles;
			
			//[Nip] Move the clip 
			//[Robbo] delete and recreate!
			brushmodels = getentarray("script_brushmodel", "classname");
			for(j=0;j<brushmodels.size;j++)
			{
				if (isDefined(brushmodels[j].script_gameobjectname) && brushmodels[j].script_gameobjectname == "bombzone" && distance(brushmodels[j].origin, trigger.origin) < 64)	
               brushmodels[j] delete();
			}
			
			// [Robbo] create clip:
			// need some trig :-/
			
			if(getdvar("bro_moveobject_" + mapname + "_" + gt + "_" + getObjEnglish(label) + "collision") != "0" && !game["bromode"])
			{
			
            Xcos = cos(angles[1]);
            Ysin = sin(angles[1]);
            
            deltaX = Xcos * 15;
            deltaY = Ysin * 15;
            
            offsetOrigin = origin + (Xcos * 10, Ysin * 10,0);

            paraX = Xcos * -36;
            paraY = Ysin * -36;
            
            
            spawncollision("collision_wall_64x64x10","collider",( origin + (-1 * deltaX,-1 * deltaY,25)), angles + (0,90,0));
            spawncollision("collision_wall_64x64x10","collider",( origin + (deltaX,deltaY,25)), angles + (0,90,0));
            
            spawncollision("collision_geo_64x64x10","collider",( offsetOrigin + (paraX,paraY,4)), angles);
         }
		//	sdBombModel = spawn( "script_model", offsetOrigin + (paraX,paraY,4));
       //  sdBombModel setModel( "weapon_explosives" );
			
			
			// [Robbo] make the bomb clip higher or the planted bomb will be put under the bombsite if planted from above 
			// [Robbo] have changed sd.gsc to use playerorigin as the bomb place - avoids this issue.
			
		//	spawncollision("collision_wall_64x64x10","collider",( origin + (-1 * deltaX,-1 * deltaY,65)), angles + (0,90,0));
		//	spawncollision("collision_wall_64x64x10","collider",( origin + (deltaX,deltaY,65)), angles + (0,90,0));
			
			//[Nip] Move the destroyed objective
			des = getentarray("exploder", "targetname");
			for(j=0;j<des.size;j++)
			{
				if (isDefined(des[j].script_exploder) && des[j].script_exploder == visuals[0].script_exploder)
				{
					des[j].origin = origin;
					des[j].angles = angles;
				}
			}
				
			//[Nip] Move the plant trigger
			trigger.origin = origin;
			trigger.angles = angles;	
	}	
}

moveCaptureLoc(mapname)
{
   // Source code by BionicNipple
         
   dvarVal = getdvar("bro_moveobject_" + mapname + "_ret_capture_location" + game["objmoverset"]);
		
   if(dvarVal == "") // [Robbo] Dvar not defined - print to log
	{  
  //    logprint("OBJECTIVE MOVER - TnT Not Defined for " +  mapname + " " + game["objmoverset"] + "\n");  
      return;
   }
         
   dataAr = StrTok( dvarVal, "," );
         
   if(dataAr.size < 3) // [Robbo] Not enough bits of info in the dvar - abort and log
   {
      logprint("\n>>>>> OBJECTIVE MOVER PROBLEM - Capture Location " + game["objmoverset"] + " incorrectly configured for " +  mapname + "\n");  

      return; 
   }
      
  	for(d=0;d<dataAr.size; d++)
      dataAr[d] = int(dataAr[d]);
            
	parts = [];
	parts[parts.size] = getent("sd_bomb", "targetname");
	parts[parts.size] = getent("sd_bomb_pickup_trig", "targetname");
	
	for (i=0;i<parts.size;i++)
	{
		parts[i].origin = (dataAr[0],dataAr[1],dataAr[2]);
	}
}

moveBomb(mapname)
{
   // Source code by BionicNipple
         
   dvarVal = getdvar("bro_moveobject_" + mapname + "_sd_tnt" + game["objmoverset"]);
		
   if(dvarVal == "") // [Robbo] Dvar not defined - print to log
	{  
  //    logprint("OBJECTIVE MOVER - TnT Not Defined for " +  mapname + " " + game["objmoverset"] + "\n");  
      return;
   }
         
   dataAr = StrTok( dvarVal, "," );
         
   if(dataAr.size < 4) // [Robbo] Not enough bits of info in the dvar - abort and log
   {
      logprint("\n>>>>> OBJECTIVE MOVER PROBLEM - TnT objective " + game["objmoverset"] + " incorrectly configured for " +  mapname + "\n");  

      return; 
   }
      
  	for(d=0;d<dataAr.size; d++)
      dataAr[d] = int(dataAr[d]);
            
	parts = [];
	parts[parts.size] = getent("sd_bomb", "targetname");
	parts[parts.size] = getent("sd_bomb_pickup_trig", "targetname");
	
	for (i=0;i<parts.size;i++)
	{
		parts[i].origin = (dataAr[0],dataAr[1],dataAr[2]);
		parts[i].angles = (0,dataAr[3],0);
	}
}

moveSpawns(team,gt,mapname)
{
   dvarVal = getdvar("bro_moveobject_" + mapname + "_" + gt + "_" + getObjEnglish(team) + game["objmoverset"]);
		
	if(dvarVal == "") // [Robbo] Dvar not defined - print to log
	{  
     // logprint("OBJECTIVE MOVER - " + getObjEnglish(team) + " " + game["objmoverset"] + " Not Defined for " +  mapname + " (" + gt + ")\n");  
      return;
   }
   
   dataSpawnsAr = StrTok( dvarVal, "/" );
   
   switch(gt)
   {
      case "esd":
      case "sd":
      case "ret":
         spawnPointName = "mp_sd_spawn_" + team;
         break;
      case "twar":
         spawnPointName = "mp_twar_spawn_" + team + "_start";
         break;
      default:
         return;        
   }
    
   spawnPoints = getentarray(spawnPointName,"classname");
   
   for(i=0; i<dataSpawnsAr.size; i++)
   {
      
      dataAr = StrTok( dataSpawnsAr[i], "," );
         
      if(dataAr.size < 4) // [Robbo] Not enough bits of info in the dvar - abort and log
      {
         logprint(">>>>> OBJECTIVE MOVER PROBLEM - " + team + " spawnpoint #" + i + " incorrectly configured for " +  mapname + " (" + gt + ")\n");  
         continue; 
      }
      
      for(d=0;d<dataAr.size; d++)
         dataAr[d] = int(dataAr[d]);
      
      if(i >= spawnPoints.size)
      {
         logprint(">>>>> OBJECTIVE MOVER PROBLEM - too many " + team + " spawnpoints placed for " +  mapname + " (" + gt + ")\n");  
         break;
      }
      
      spawnPoints[i].origin = (dataAr[0],dataAr[1],dataAr[2]);
		spawnPoints[i].angles = (0,dataAr[3],0);   
   }
}

moverOptions()
{  
   if(level.gametype == "sd")
   {
      self.objectiveMoveOptions = [];
      
      i = 0;
      while(i < 3)
      {
         self.objectiveMoveOptions[i] = [];
       //  self.objectiveMoveOptions[i]["title"] = &"BRM_" + (i + 1) + "_FLAG";
         self.objectiveMoveOptions[i]["title"] = level.objMoverOptionLabels[i];
         self.objectiveMoveOptions[i]["options"] = [];
         
            self.objectiveMoveOptions[i]["options"][0] = &"BRM_SET_POSITION";
            self.objectiveMoveOptions[i]["options"][1] = &"BRM_RESET_POSITION";
            self.objectiveMoveOptions[i]["options"][2] = &"BRM2_BOUNCE";
            
         self.objectiveMoveOptions[i]["actions"] = [];  
            
            self.objectiveMoveOptions[i]["actions"][0] = ::moverMoveBombsite;
            self.objectiveMoveOptions[i]["actions"][1] = ::moverResetBombsite;
            self.objectiveMoveOptions[i]["actions"][2] = ::moverBouncePlayer;
            
         self.objectiveMoveOptions[i]["colors"] = [];  
            
            self.objectiveMoveOptions[i]["colors"][0] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][1] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][2] = (1,0,0);
            
            self.objectiveMoveOptions[i]["colors"][3] = (1,0,0); // Main menu color

         i++;    
      }
      self.endFlagOptions = i;
      
      self.objectiveMoveOptions[i] = [];
         self.objectiveMoveOptions[i]["title"] = &"BRM2_MOVER_SD_ATTACKER_SPAWNS";
         
         self.objectiveMoveOptions[i]["options"] = [];
            self.objectiveMoveOptions[i]["options"][0] = &"BRM_SET_POSITION";
            self.objectiveMoveOptions[i]["options"][1] = &"BRM_UNDO";
            self.objectiveMoveOptions[i]["options"][2] = &"BRM_RESET_POSITION";
            
         self.objectiveMoveOptions[i]["actions"] = [];  
            
            self.objectiveMoveOptions[i]["actions"][0] = ::moverMoveSpawns;
            self.objectiveMoveOptions[i]["actions"][1] = ::moverUndoSpawns;
            self.objectiveMoveOptions[i]["actions"][2] = ::moverResetSpawns;
            
            self.objectiveMoveOptions[i]["actions"][3] = ::moverShowSpawns;
            self.objectiveMoveOptions[i]["actions"][4] = ::moverHideSpawns;
            
         self.objectiveMoveOptions[i]["colors"] = [];  
            
            self.objectiveMoveOptions[i]["colors"][0] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][1] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][2] = (1,0,0);
            
            self.objectiveMoveOptions[i]["colors"][3] = (0,0.2,0.9); // Main menu color
      
      i++;
        
      self.objectiveMoveOptions[i] = [];  
         self.objectiveMoveOptions[i]["title"] = &"BRM2_MOVER_SD_DEFENDER_SPAWNS";
         
         self.objectiveMoveOptions[i]["options"] = [];
            self.objectiveMoveOptions[i]["options"][0] = &"BRM_SET_POSITION";
            self.objectiveMoveOptions[i]["options"][1] = &"BRM_UNDO";
            self.objectiveMoveOptions[i]["options"][2] = &"BRM_RESET_POSITION";
            
         self.objectiveMoveOptions[i]["actions"] = [];  
            
            self.objectiveMoveOptions[i]["actions"][0] = ::moverMoveSpawns;
            self.objectiveMoveOptions[i]["actions"][1] = ::moverUndoSpawns;
            self.objectiveMoveOptions[i]["actions"][2] = ::moverResetSpawns;
            
            self.objectiveMoveOptions[i]["actions"][3] = ::moverShowSpawns;
            self.objectiveMoveOptions[i]["actions"][4] = ::moverHideSpawns;
            
         self.objectiveMoveOptions[i]["colors"] = [];  
            
            self.objectiveMoveOptions[i]["colors"][0] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][1] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][2] = (1,0,0);
            
            self.objectiveMoveOptions[i]["colors"][3] = (0,0.2,0.9); // Main menu color
      
      i++;
  
      self.objectiveMoveOptions[i] = [];
      self.objectiveMoveOptions[i]["title"] = &"BRM_SAVE_ALL_DATA";
      
      self.objectiveMoveOptions[i]["actions"] = ::saveAndLog;
            
      /////////////////
         
      self drawMenu();
   
   }
   else if(level.gametype == "ret")
   {
      self.objectiveMoveOptions = [];
      
      i = 0;
      while(i < 3)
      {
         self.objectiveMoveOptions[i] = [];
         self.objectiveMoveOptions[i]["title"] = level.objMoverOptionLabels[i];
         self.objectiveMoveOptions[i]["options"] = [];
         
            self.objectiveMoveOptions[i]["options"][0] = &"BRM_SET_POSITION";
            self.objectiveMoveOptions[i]["options"][1] = &"BRM_RESET_POSITION";
            
         self.objectiveMoveOptions[i]["actions"] = [];  
            
            self.objectiveMoveOptions[i]["actions"][0] = ::moverMoveObjective;
            self.objectiveMoveOptions[i]["actions"][1] = ::moverResetObjective;
            
         self.objectiveMoveOptions[i]["colors"] = [];  
            
            self.objectiveMoveOptions[i]["colors"][0] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][1] = (1,0,0);
            
            self.objectiveMoveOptions[i]["colors"][2] = (1,0,0); // Main menu color

         i++;    
      }
      self.endFlagOptions = i;
      
      self.objectiveMoveOptions[i] = [];
         self.objectiveMoveOptions[i]["title"] = &"BRM2_MOVER_SD_ATTACKER_SPAWNS";
         
         self.objectiveMoveOptions[i]["options"] = [];
            self.objectiveMoveOptions[i]["options"][0] = &"BRM_SET_POSITION";
            self.objectiveMoveOptions[i]["options"][1] = &"BRM_UNDO";
            self.objectiveMoveOptions[i]["options"][2] = &"BRM_RESET_POSITION";
            
         self.objectiveMoveOptions[i]["actions"] = [];  
            
            self.objectiveMoveOptions[i]["actions"][0] = ::moverMoveSpawns;
            self.objectiveMoveOptions[i]["actions"][1] = ::moverUndoSpawns;
            self.objectiveMoveOptions[i]["actions"][2] = ::moverResetSpawns;
            
            self.objectiveMoveOptions[i]["actions"][3] = ::moverShowSpawns;
            self.objectiveMoveOptions[i]["actions"][4] = ::moverHideSpawns;
            
         self.objectiveMoveOptions[i]["colors"] = [];  
            
            self.objectiveMoveOptions[i]["colors"][0] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][1] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][2] = (1,0,0);
            
            self.objectiveMoveOptions[i]["colors"][3] = (0,0.2,0.9); // Main menu color
      
      i++;
        
      self.objectiveMoveOptions[i] = [];  
         self.objectiveMoveOptions[i]["title"] = &"BRM2_MOVER_SD_DEFENDER_SPAWNS";
         
         self.objectiveMoveOptions[i]["options"] = [];
            self.objectiveMoveOptions[i]["options"][0] = &"BRM_SET_POSITION";
            self.objectiveMoveOptions[i]["options"][1] = &"BRM_UNDO";
            self.objectiveMoveOptions[i]["options"][2] = &"BRM_RESET_POSITION";
            
         self.objectiveMoveOptions[i]["actions"] = [];  
            
            self.objectiveMoveOptions[i]["actions"][0] = ::moverMoveSpawns;
            self.objectiveMoveOptions[i]["actions"][1] = ::moverUndoSpawns;
            self.objectiveMoveOptions[i]["actions"][2] = ::moverResetSpawns;
            
            self.objectiveMoveOptions[i]["actions"][3] = ::moverShowSpawns;
            self.objectiveMoveOptions[i]["actions"][4] = ::moverHideSpawns;
            
         self.objectiveMoveOptions[i]["colors"] = [];  
            
            self.objectiveMoveOptions[i]["colors"][0] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][1] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][2] = (1,0,0);
            
            self.objectiveMoveOptions[i]["colors"][3] = (0,0.2,0.9); // Main menu color
      
      i++;
  
      self.objectiveMoveOptions[i] = [];
      self.objectiveMoveOptions[i]["title"] = &"BRM_SAVE_ALL_DATA";
      
      self.objectiveMoveOptions[i]["actions"] = ::saveAndLog;
            
      /////////////////
         
      self drawMenu();
      
   }
   else if(level.gametype == "twar")
   {
      self.objectiveMoveOptions = [];
      
      i = 0;
      while(i < level.flags.size)
      {
         self.objectiveMoveOptions[i] = [];
         self.objectiveMoveOptions[i]["title"] = level.objMoverOptionLabels[i];
         self.objectiveMoveOptions[i]["options"] = [];
         
            self.objectiveMoveOptions[i]["options"][0] = &"BRM_SET_POSITION";
            self.objectiveMoveOptions[i]["options"][1] = &"BRM_RESET_POSITION";
            
         self.objectiveMoveOptions[i]["actions"] = [];  
            
            self.objectiveMoveOptions[i]["actions"][0] = ::moverMoveFlag;
            self.objectiveMoveOptions[i]["actions"][1] = ::moverResetFlag;
            
         self.objectiveMoveOptions[i]["colors"] = [];  
            
            self.objectiveMoveOptions[i]["colors"][0] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][1] = (1,0,0);
            
            self.objectiveMoveOptions[i]["colors"][2] = (1,0,0); // Main menu color

         i++;    
      }
      self.endFlagOptions = i;
      
      self.objectiveMoveOptions[i] = [];
         self.objectiveMoveOptions[i]["title"] = &"BRM_MOVER_TWAR_ALLIED_SPAWNS";
         
         self.objectiveMoveOptions[i]["options"] = [];
            self.objectiveMoveOptions[i]["options"][0] = &"BRM_SET_POSITION";
            self.objectiveMoveOptions[i]["options"][1] = &"BRM_UNDO";
            self.objectiveMoveOptions[i]["options"][2] = &"BRM_RESET_POSITION";
            
         self.objectiveMoveOptions[i]["actions"] = [];  
            
            self.objectiveMoveOptions[i]["actions"][0] = ::moverMoveSpawns;
            self.objectiveMoveOptions[i]["actions"][1] = ::moverUndoSpawns;
            self.objectiveMoveOptions[i]["actions"][2] = ::moverResetSpawns;
            
            self.objectiveMoveOptions[i]["actions"][3] = ::moverShowSpawns;
            self.objectiveMoveOptions[i]["actions"][4] = ::moverHideSpawns;
            
         self.objectiveMoveOptions[i]["colors"] = [];  
            
            self.objectiveMoveOptions[i]["colors"][0] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][1] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][2] = (1,0,0);
            
            self.objectiveMoveOptions[i]["colors"][3] = (0,0.2,0.9); // Main menu color
      
      i++;
        
      self.objectiveMoveOptions[i] = [];  
         self.objectiveMoveOptions[i]["title"] = &"BRM_MOVER_TWAR_AXIS_SPAWNS";
         
         self.objectiveMoveOptions[i]["options"] = [];
            self.objectiveMoveOptions[i]["options"][0] = &"BRM_SET_POSITION";
            self.objectiveMoveOptions[i]["options"][1] = &"BRM_UNDO";
            self.objectiveMoveOptions[i]["options"][2] = &"BRM_RESET_POSITION";
            
         self.objectiveMoveOptions[i]["actions"] = [];  
            
            self.objectiveMoveOptions[i]["actions"][0] = ::moverMoveSpawns;
            self.objectiveMoveOptions[i]["actions"][1] = ::moverUndoSpawns;
            self.objectiveMoveOptions[i]["actions"][2] = ::moverResetSpawns;
            
            self.objectiveMoveOptions[i]["actions"][3] = ::moverShowSpawns;
            self.objectiveMoveOptions[i]["actions"][4] = ::moverHideSpawns;
            
         self.objectiveMoveOptions[i]["colors"] = [];  
            
            self.objectiveMoveOptions[i]["colors"][0] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][1] = (1,0,0);
            self.objectiveMoveOptions[i]["colors"][2] = (1,0,0);
            
            self.objectiveMoveOptions[i]["colors"][3] = (0,0.2,0.9); // Main menu color
      
      i++;
  
      self.objectiveMoveOptions[i] = [];
      self.objectiveMoveOptions[i]["title"] = &"BRM_SAVE_ALL_DATA";
      
      self.objectiveMoveOptions[i]["actions"] = ::saveAndLog;
            
      /////////////////
         
      self drawMenu();
      
   }
}

drawMenu()
{
   if(!isdefined(self.objectiveMoverMenu))
      self.objectiveMoverMenu = [];
      
   self.objectiveMenuOption = -1;
   self.objectiveMenuCurrent = 0;
      
   for(i=0; i < self.objectiveMoveOptions.size; i++)
   {
      if(!isdefined(self.objectiveMoverMenu[i]))
      {
         self.objectiveMoverMenu[i] = createFontString("objective",1.0);
         self.objectiveMoverMenu[i] setPoint( "TOP", "LEFT", (13), (-52 + (i * 15))  );
         self.objectiveMoverMenu[i].alignX = "left";
      }  
      self.objectiveMoverMenu[i].sort = 4; 
      self.objectiveMoverMenu[i] setText( self.objectiveMoveOptions[i]["title"] );       
      self.objectiveMoverMenu[i].alpha = 1; 
      
      if(isDefined(self.objectiveMoveOptions[i]["options"]) && isDefined(self.objectiveMoveOptions[i]["colors"][self.objectiveMoveOptions[i]["options"].size]))
         self.objectiveMoverMenu[i].color = self.objectiveMoveOptions[i]["colors"][self.objectiveMoveOptions[i]["options"].size];        
   }
   
   if(!isdefined(self.objectiveMoverMenu[i]))
   {
      self.objectiveMoverMenu[i] = createIcon( "black", 155, ((i + 1) * 15) );    
      self.objectiveMoverMenu[i] setPoint( "TOP", "LEFT", (50), (-69)  );
      self.objectiveMoverMenu[i].alpha = 0.8;
      self.objectiveMoverMenu[i].sort = 2; 
   }
   i++;
   if(!isdefined(self.objectiveMoverMenu[i]))
   {      
      self.objectiveMoverMenu[i] = createFontString("objective",1.1);
      self.objectiveMoverMenu[i] setPoint( "TOP", "LEFT", (13), (-68)  );
      self.objectiveMoverMenu[i].alignX = "left";    
      self.objectiveMoverMenu[i].sort = 3; 
   }
   self.objectiveMoverMenu[i] setText( &"BRM_MOVER_TITLE" ); 
   self.objectiveMoverMenu[i].alpha = 1; 
   self.objectiveMoverMenu[i].color = (0,1,0);     
   i++;
   if(!isdefined(self.objectiveMoverMenu[i]))
   {
      self.objectiveMoverMenu[i] = createIcon( "compass_waypoint_defend_f", 14, 14 );    
      self.objectiveMoverMenu[i] setPoint( "TOP", "LEFT", (5), (-54)  );
      self.objectiveMoverMenu[i].alpha = 0.5;
      self.objectiveMoverMenu[i].sort = 3; 
   }
   
   self thread watchMenu();
   
}

updateOptions(goBack)
{
   self.objectiveMenuCurrent = 0;
   
   if(goBack)
   {
      self.objectiveMenuOption = -1;
      
      for(i=0; i < self.objectiveMoveOptions.size; i++)
      {
         self.objectiveMoverMenu[i] setText( self.objectiveMoveOptions[i]["title"] );       
         self.objectiveMoverMenu[i].alpha = 1;       
         
         if(isDefined(self.objectiveMoveOptions[i]["options"]) && isDefined(self.objectiveMoveOptions[i]["colors"][self.objectiveMoveOptions[i]["options"].size]))
            self.objectiveMoverMenu[i].color = self.objectiveMoveOptions[i]["colors"][self.objectiveMoveOptions[i]["options"].size]; 
      }
      self.objectiveMoverMenu[self.objectiveMoverMenu.size - 2] setText(&"BRM_MOVER_TITLE");
      self.objectiveMoverMenu[self.objectiveMoverMenu.size - 2].alpha = 1;
   }
   else
   {
      for(i=0; i < self.objectiveMoveOptions.size; i++)
      {
         if(i < self.objectiveMoveOptions[self.objectiveMenuOption]["options"].size)
         {
            self.objectiveMoverMenu[i] setText( self.objectiveMoveOptions[self.objectiveMenuOption]["options"][i] );       
            self.objectiveMoverMenu[i].alpha = 1; 
            
            if(isDefined(self.objectiveMoveOptions[i]["colors"][i]))
               self.objectiveMoverMenu[i].color = self.objectiveMoveOptions[i]["colors"][i]; 
         }
         else if(i == self.objectiveMoveOptions[self.objectiveMenuOption]["options"].size)
         {
            self.objectiveMoverMenu[i] setText( &"MENU_BACK" );       
            self.objectiveMoverMenu[i].alpha = 1;
            self.objectiveMoverMenu[i].color = (1,1,1);       
         }
         else
         {       
            self.objectiveMoverMenu[i].alpha = 0;      
         }
      }
      self.objectiveMoverMenu[self.objectiveMoverMenu.size - 2] setText(self.objectiveMoveOptions[self.objectiveMenuOption]["title"]);
      self.objectiveMoverMenu[self.objectiveMoverMenu.size - 2].alpha = 1;
   }
   self updateSelectionMarker();
}

watchMenu()
{
   self endon("killed_player");
	self endon("spawned");
	self endon("disconnect");
	self endon("new_loadout");
	level endon("intermission");
	level endon("game_ended");
	
	while(1)
	{
      while(isdefined(self.using_spawnchoice) || !self useButtonPressed())
         wait 0.05;
         
      ticker = 0;
      
      for(ticker = 0; self useButtonPressed() && ticker < 10; ticker++)
			wait(0.05);
			
	   if(ticker < 10)
	   {
         // select next option
         self.objectiveMenuCurrent++;
         
         if(self.objectiveMenuOption < 0)
         {
            if(self.objectiveMenuCurrent > (self.objectiveMoveOptions.size - 1))
               self.objectiveMenuCurrent = 0;
         }
         else
         {
            if(self.objectiveMenuCurrent > (self.objectiveMoveOptions[self.objectiveMenuOption]["options"].size))
               self.objectiveMenuCurrent = 0;
         }

         self updateSelectionMarker();
	   }
	   else
	   {
         // choose current
         self thread pulseSelect();
         if(self.objectiveMenuOption >= 0)
         {
            if(self.objectiveMenuCurrent == self.objectiveMoveOptions[self.objectiveMenuOption]["options"].size)
            {
               if(isDefined(self.objectiveMoveOptions[self.objectiveMenuOption]["actions"][self.objectiveMoveOptions[self.objectiveMenuOption]["options"].size + 1]))
                  self thread [[self.objectiveMoveOptions[self.objectiveMenuOption]["actions"][self.objectiveMoveOptions[self.objectiveMenuOption]["options"].size + 1]]]();
                  
               self.objectiveMenuOption = -1;
               self updateOptions(true);
            }
            else
            {
               self thread [[self.objectiveMoveOptions[self.objectiveMenuOption]["actions"][self.objectiveMenuCurrent]]]();
            }       
         }
         else
         {
            if(!isDefined(self.objectiveMoveOptions[self.objectiveMenuCurrent]["options"]))
            {
               self thread [[self.objectiveMoveOptions[self.objectiveMenuCurrent]["actions"]]]();
            }
            else
            {
               self.objectiveMenuOption = self.objectiveMenuCurrent; 
               
               if(isDefined(self.objectiveMoveOptions[self.objectiveMenuCurrent]["actions"][self.objectiveMoveOptions[self.objectiveMenuCurrent]["options"].size]))
                  self thread [[self.objectiveMoveOptions[self.objectiveMenuCurrent]["actions"][self.objectiveMoveOptions[self.objectiveMenuCurrent]["options"].size]]]();
                      
               self updateOptions(false);    
            }
         }
	   }
	   
	   while(self useButtonPressed())
         wait 0.05;
         
      wait 0.05;
	}
}  

pulseSelect()
{
   self playLocalSound("gr_m1gren_click");
}

updateSelectionMarker()
{
   //self.objectiveMoverMenu[self.objectiveMoverMenu.size - 1] setPoint( "TOP", "LEFT", (10), (-50 + (self.objectiveMenuCurrent * 15))  );
   self.objectiveMoverMenu[self.objectiveMoverMenu.size - 1] moveOverTime( 0.2 );
   self.objectiveMoverMenu[self.objectiveMoverMenu.size - 1].y = -54 + (self.objectiveMenuCurrent * 15);
}

getObjEnglish(obj)
{
   switch(obj)
   {
      case "_a":
         return "bombzoneA";
      case "_b":
         return "bombzoneB";
      case "_1":
         return "objective_1";
      case "_2":
         return "objective_2";
      case "capture":
         return "capture_location";
      case "bomb":
         return "tnt";
      case "attacker":
         return "attackerSpawn";
      case "defender":
         return "defenderSpawn";
      case "allies":
         return "allies_startspawns";
      case "axis":
         return "axis_startspawns";
      default:
         return obj;
   }
}


//////////////////////////
// SD FUNCTIONS (new)
//////////////////////////

moverMoveBombsite()
{
   playerAngles = self GetPlayerAngles();
   self moveBombsite(intCoords(self.origin),(0,int(playerAngles[1]),0));
}

moverResetBombsite()
{
   if(self.objectiveMenuOption == 2)
      bombsite = level.sdBomb;
   else
      bombsite = level.bombZones[self.objectiveMenuOption];
      
   self moveBombsite(bombsite.visuals[0].baseOrigin,bombsite.visuals[0].baseAngles);
}

moveBombsite(pos,angles)
{
   if(self.objectiveMenuOption == 2)
      bombsite = level.sdBomb;
   else
      bombsite = level.bombZones[self.objectiveMenuOption];
   
   bombsite.trigger.origin = pos; 
   bombsite.curOrigin = pos; 
   
   for ( index = 0; index < bombsite.visuals.size; index++ )
	{
		bombsite.visuals[index].origin = pos;
		bombsite.visuals[index].angles = angles;
	}
	
	bombsite.objPoints["allies"].x = pos[0];
	bombsite.objPoints["allies"].y = pos[1];
	bombsite.objPoints["allies"].z = pos[2] + bombsite.offset3d[2]; 
	
	bombsite.objPoints["axis"].x = pos[0];
	bombsite.objPoints["axis"].y = pos[1];
	bombsite.objPoints["axis"].z = pos[2] + bombsite.offset3d[2]; 
	
	Objective_Position( bombsite.objIDAllies, pos );
	Objective_Position( bombsite.objIDAxis, pos );
}

moverBouncePlayer()
{
   mod = spawn("script_origin",self.origin);
   wait 0.05;
   self linkto(mod);
   wait 0.05;
   thread throw_object_with_gravity( mod, self.origin + (randomintrange(-60,60),randomintrange(-60,60),150),1 );
   wait 1;
   self unlink();
   mod delete();
}

//////////////////////////
// RET FUNCTIONS
//////////////////////////

moverMoveObjective()
{
   playerAngles = self GetPlayerAngles();
   self moveObjective(intCoords(self.origin),(0,int(playerAngles[1]),0));
}

moverResetObjective()
{
   if(self.objectiveMenuOption == 2)
   {
      obj = level.retCaptureZone;
      self moveObjective(obj.trigger.baseOrigin,(0,0,0));
   }   
   else
   {
      obj = level.retObjectMove[self.objectiveMenuOption];
      self moveObjective(obj.visuals[0].baseOrigin,obj.visuals[0].baseAngles);
   }
   
}

moveObjective(pos,angles)
{
   if(self.objectiveMenuOption == 2)
      obj = level.retCaptureZone;
   else
      obj = level.retObjectMove[self.objectiveMenuOption];
   
   obj.trigger.origin = pos; 
   obj.curOrigin = pos; 
   
   for ( index = 0; index < obj.visuals.size; index++ )
	{
		obj.visuals[index].origin = pos;
		obj.visuals[index].angles = angles;
	}
	
	if(isDefined(obj.glow))
	{
      obj.glow.origin = pos;
      obj.glow.angles = angles;
	}
	
	obj.objPoints["allies"].x = pos[0];
	obj.objPoints["allies"].y = pos[1];
	obj.objPoints["allies"].z = pos[2] + obj.offset3d[2]; 
	
	obj.objPoints["axis"].x = pos[0];
	obj.objPoints["axis"].y = pos[1];
	obj.objPoints["axis"].z = pos[2] + obj.offset3d[2]; 
	
	Objective_Position( obj.objIDAllies, pos );
	Objective_Position( obj.objIDAxis, pos );
	
	if(isDefined(obj.baseeffect))
	{      
      obj.baseeffectpos = pos + (0,0,3);	

      obj maps\mp\gametypes\ret::resetBaseEffect();
	}
	
}

//////////////////////////
// TWAR FUNCTIONS
//////////////////////////

moverMoveFlag()
{
   self moveFlag(intCoords(self.origin));
}

moverResetFlag()
{
   flag = level.flags[self.objectiveMenuOption];
   self moveFlag(flag.useObj.visuals[0].baseOrigin);
}

moveFlag(pos)
{
   flag = level.flags[self.objectiveMenuOption];
   
   flag.useObj.trigger.origin = pos; 
   
   for ( index = 0; index < flag.useObj.visuals.size; index++ )
	{
		flag.useObj.visuals[index].origin = pos;
	}
	
	flag.useObj.objPoints["allies"].x = pos[0];
	flag.useObj.objPoints["allies"].y = pos[1];
	flag.useObj.objPoints["allies"].z = pos[2] + 100; 
	
	flag.useObj.objPoints["axis"].x = pos[0];
	flag.useObj.objPoints["axis"].y = pos[1];
	flag.useObj.objPoints["axis"].z = pos[2] + 100; 
	
	Objective_Position( flag.useObj.objIDAllies, pos );
	Objective_Position( flag.useObj.objIDAxis, pos );
	
	flag.useObj.baseeffect delete();	
	fxid = level.flagBaseFXid["neutral"];

	flag.useObj.baseeffect = spawnFx( fxid, pos, flag.useObj.baseeffectforward, flag.useObj.baseeffectright );
	triggerFx( flag.useObj.baseeffect );
}

//////////////////////////
// GENERIC SPAWN FUNCTIONS
//////////////////////////

moverMoveSpawns()
{
   if(self.objectiveMenuOption == self.endFlagOptions)
      team = "allies";
   else if(self.objectiveMenuOption == (self.endFlagOptions + 1))
      team = "axis";
   else
      return;
   
   spawnItem = level.objectiveMoverDataSpawns[team][level.moverCurrentFlagIdx[team]];
   
   spawnItem.undoPos = spawnItem.visuals.origin;  
   spawnItem.undoAngles = spawnItem.visuals.angles;
   
   playerAngles = self GetPlayerAngles();
   
   spawnItem.visuals.origin = intCoords(self.origin) + (0,0,35);  

   spawnItem.visuals.angles = intCoords((0,playerAngles[1],0));  
   
   level.moverCurrentFlagIdx[team]++;
   
   iprintln("^2Moved " + team + " start spawn #" + level.moverCurrentFlagIdx[team] + " / " + (level.objectiveMoverDataSpawns[team].size));
   
   level.moverLastOp[team] = -1;
   
   if(level.moverCurrentFlagIdx[team] >= level.objectiveMoverDataSpawns[team].size)
      level.moverCurrentFlagIdx[team] = 0; 
}

moverUndoSpawns()
{
   if(self.objectiveMenuOption == self.endFlagOptions)
      team = "allies";
   else if(self.objectiveMenuOption == (self.endFlagOptions + 1))
      team = "axis";
   else
      return;
   
   if(!isDefined(level.moverLastOp[team]))
   {
      iprintln("^3Can't undo a previous " + team + " start spawn operation");
   }
   else if(level.moverLastOp[team] < 0)
   {
      level.moverCurrentFlagIdx[team]--;
      
      if(level.moverCurrentFlagIdx[team] < 0)
         level.moverCurrentFlagIdx[team] = level.objectiveMoverDataSpawns[team].size - 1;
       //  level.moverCurrentFlagIdx[team] = level.moverCurrentFlagIdx[team].size - 1;
         
      spawnItem = level.objectiveMoverDataSpawns[team][level.moverCurrentFlagIdx[team]];
      
      if(spawnItem.visuals.origin != spawnItem.undoPos || spawnItem.visuals.angles != spawnItem.undoAngles)
      {
         spawnItem.visuals.origin = intCoords(spawnItem.undoPos);  
         spawnItem.visuals.angles = intCoords(spawnItem.undoAngles);  
      }
      else
      {
         iprintln("^3Can't undo a previous " + team + " start spawn placement");
         level.moverCurrentFlagIdx[team]++;
         
         if(level.moverCurrentFlagIdx[team] >= level.objectiveMoverDataSpawns[team].size)
            level.moverCurrentFlagIdx[team] = 0;
      }
   }
   else
   {
      iprintln("Undoing reset");
      for(i=0; i<level.objectiveMoverDataSpawns[team].size; i++)
      {
         spawnItem = level.objectiveMoverDataSpawns[team][i];
         
         spawnItem.visuals.origin = intCoords(spawnItem.undoPos);  
         spawnItem.visuals.angles = intCoords(spawnItem.undoAngles);  
      }
      level.moverCurrentFlagIdx[team] = level.moverLastOp[team];
      level.moverLastOp[team] = undefined;
      
   }
}

moverResetSpawns()
{
   if(self.objectiveMenuOption == self.endFlagOptions)
      team = "allies";
   else if(self.objectiveMenuOption == (self.endFlagOptions + 1))
      team = "axis";
   else
      return;
   
   level.moverLastOp[team] = level.moverCurrentFlagIdx[team];
   
   level.moverLastOp[team]++;
   
   if(level.moverCurrentFlagIdx[team] >= level.objectiveMoverDataSpawns[team].size)
      level.moverCurrentFlagIdx[team] = 0; 
      
   for(i=0; i<level.objectiveMoverDataSpawns[team].size; i++)
   {
      spawnItem = level.objectiveMoverDataSpawns[team][i];
      spawnItem.undoPos = spawnItem.visuals.origin;  
      spawnItem.undoAngles = spawnItem.visuals.angles;   
      spawnItem.visuals.origin = intCoords(spawnItem.startOrigin);  
      spawnItem.visuals.angles = intCoords(spawnItem.startAngles); 
   }
   level.moverCurrentFlagIdx[team] = 0;
   
   iprintln(team + " spawns reset");
}

moverShowSpawns()
{
   if(self personInMenu(self.objectiveMenuOption))
      return;
   
   if(level.gametype == "sd" || level.gametype == "esd" || level.gametype == "ret")
      gt = "sd";
   else
      gt = level.gametype;
      
   spawnPointName = "mp_tdm_spawn"; team = ""; flag = "";
   
   if(self.objectiveMenuOption == self.endFlagOptions)
   {
      if(gt == "sd")
         spawnPointName = "mp_sd_spawn_attacker";
      else
         spawnPointName = "mp_" + gt + "_spawn_allies_start"; 
      team = "allies";
      if(game["allies"] == "marines")
         flag = "american";
      else
         flag = "russian";
   }
   else if(self.objectiveMenuOption == (self.endFlagOptions + 1))
   {
      if(gt == "sd")
         spawnPointName = "mp_sd_spawn_defender";
      else
         spawnPointName = "mp_" + gt + "_spawn_axis_start";
      
      team = "axis";
      
      flag = game[team];
   }
   else
      return;
   
   spawnPoints = getentarray(spawnPointName,"classname");
      
   for(i=0;i<spawnPoints.size; i++)
   { 
      if(!isDefined(level.objectiveMoverDataSpawns[team][i]))
      {
         org = intCoords(spawnPoints[i].origin + (0,0,35));
         
         level.objectiveMoverDataSpawns[team][i] = spawnStruct(); 
         level.objectiveMoverDataSpawns[team][i].visuals = spawn( "script_model", org );      
         level.objectiveMoverDataSpawns[team][i].visuals setModel( "prop_flag_" + flag );   
         level.objectiveMoverDataSpawns[team][i].visuals.angles = intCoords(spawnPoints[i].angles);   
         
         level.objectiveMoverDataSpawns[team][i].startOrigin = org;        
         level.objectiveMoverDataSpawns[team][i].startAngles = intCoords(spawnPoints[i].angles);
         level.objectiveMoverDataSpawns[team][i].undoPos = org;
         level.objectiveMoverDataSpawns[team][i].undoAngles = intCoords(spawnPoints[i].angles);
      }     
      level.objectiveMoverDataSpawns[team][i].visuals Show();
   }
}

moverHideSpawns()
{  
   if(self personInMenu(self.objectiveMenuOption))
      return;

   team = "";
   
   if(self.objectiveMenuOption == self.endFlagOptions)
   {
      team = "allies";
   }
   else if(self.objectiveMenuOption == (self.endFlagOptions + 1))
   {
      team = "axis";
   }
   else
      return;
   
   for(i=0; i<level.objectiveMoverDataSpawns[team].size;i++)
   {
      level.objectiveMoverDataSpawns[team][i].visuals hide();
   }   
}


saveAndLog()
{
      string = "\n\n>>>>> OBJECTIVE MOVEMENT " + level.gametype + " DVARS ("+ level.script + ") " + self.name + "'s Set\n\n";
   
   if(level.gametype == "twar")
   {
      for(i=0; i < level.flags.size; i++)
      {
         dvarVal = level.flags[i].useObj.visuals[0].origin[0] + "," + level.flags[i].useObj.visuals[0].origin[1] + "," + level.flags[i].useObj.visuals[0].origin[2] + "," + level.flags[i].useObj.visuals[0].angles[1];
         setdvar("bro_moveobject_" + level.script + "_twar_flag" + level.flags[i].script_label, dvarVal);
         
         string += "set bro_moveobject_" + level.script + "_twar_flag" + level.flags[i].script_label + " \"" + dvarVal + "\"\n";
      }
   }
   else if(level.gametype == "ret")
   {
      for(i = 0; i< 2; i++)
      {
         if(level.retObjectMove[i].visuals[0].origin != level.retObjectMove[i].visuals[0].baseOrigin || level.retObjectMove[i].visuals[0].angles[1] != level.retObjectMove[i].visuals[0].baseAngles[1])
         {
            if(i==0) label = "_1";
            else label = "_2";
            
            dvarVal = level.retObjectMove[i].visuals[0].origin[0] + "," + level.retObjectMove[i].visuals[0].origin[1] + "," + level.retObjectMove[i].visuals[0].origin[2] + "," + level.retObjectMove[i].visuals[0].angles[1];
            setdvar("bro_moveobject_" + level.script + "_" + level.gametype + "_" + getObjEnglish(label), dvarVal);      
            string += "set bro_moveobject_" + level.script + "_" + level.gametype + "_" + getObjEnglish(label) + " \"" + dvarVal + "\"\n";
         }
      }
      if(level.retCaptureZone.curOrigin != level.retCaptureZone.trigger.baseOrigin)
      {
         dvarVal = level.retCaptureZone.curOrigin[0] + "," + level.retCaptureZone.curOrigin[1] + "," + level.retCaptureZone.curOrigin[2];
         setdvar("bro_moveobject_" + level.script + "_" + level.gametype + "_" + getObjEnglish("capture"), dvarVal);      
         string += "set bro_moveobject_" + level.script + "_" + level.gametype + "_" + getObjEnglish("capture") + " \"" + dvarVal + "\"\n";
      }
   }
   else
   {  
      for(i = 0; i< 2; i++)
      {
         if(level.bombZones[i].visuals[0].origin != level.bombZones[i].visuals[0].baseOrigin || level.bombZones[i].visuals[0].angles[1] != level.bombZones[i].visuals[0].baseAngles[1])
         {
            if(i==0) label = "_a";
            else label = "_b";
            
            dvarVal = level.bombZones[i].visuals[0].origin[0] + "," + level.bombZones[i].visuals[0].origin[1] + "," + level.bombZones[i].visuals[0].origin[2] + "," + level.bombZones[i].visuals[0].angles[1];
            setdvar("bro_moveobject_" + level.script + "_" + level.gametype + "_" + getObjEnglish(label), dvarVal);      
            string += "set bro_moveobject_" + level.script + "_" + level.gametype + "_" + getObjEnglish(label) + " \"" + dvarVal + "\"\n";
         }
      }
      if(level.sdBomb.visuals[0].origin != level.sdBomb.visuals[0].baseOrigin || level.sdBomb.visuals[0].angles[1] != level.sdBomb.visuals[0].baseAngles[1])
      {
         dvarVal = level.sdBomb.visuals[0].origin[0] + "," + level.sdBomb.visuals[0].origin[1] + "," + level.sdBomb.visuals[0].origin[2] + "," + level.sdBomb.visuals[0].angles[1];
         setdvar("bro_moveobject_" + level.script + "_" + level.gametype + "_" + getObjEnglish("bomb"), dvarVal);      
         string += "set bro_moveobject_" + level.script + "_" + level.gametype + "_" + getObjEnglish("bomb") + " \"" + dvarVal + "\"\n";
      }
   }
   
   logprint(string);
   
   logprint("\n " + getSpawnData("allies"));
   logprint("\n " + getSpawnData("axis"));

   iprintln("^3Saved " + level.gametype + " Move Data! ^7(by " + self.name + ")");
}

getSpawnData(team)
{
   if(level.gametype == "twar")
      header = "bro_moveobject_" + level.script + "_twar_" + team + "_startspawns";
   else
   {
      if(team == "allies") header = "bro_moveobject_" + level.script + "_" + level.gametype + "_attackerSpawn"; 
      else header = "bro_moveobject_" + level.script + "_" + level.gametype + "_defenderSpawn";
   }
   if(isDefined(level.objectiveMoverDataSpawns[team][0]))
      str = level.objectiveMoverDataSpawns[team][0].visuals.origin[0] + "," + level.objectiveMoverDataSpawns[team][0].visuals.origin[1] + "," + level.objectiveMoverDataSpawns[team][0].visuals.origin[2] + "," + level.objectiveMoverDataSpawns[team][0].visuals.angles[1]; 
   else
      return "";
   
   for(i=1; i< level.objectiveMoverDataSpawns[team].size; i++)
   {
      str += "/" + level.objectiveMoverDataSpawns[team][i].visuals.origin[0] + "," + level.objectiveMoverDataSpawns[team][i].visuals.origin[1] + "," + level.objectiveMoverDataSpawns[team][i].visuals.origin[2] + "," + level.objectiveMoverDataSpawns[team][i].visuals.angles[1]; 
   }
   
   setdvar(header, str);
   
   str = "set " + header + " \"" + str + "\"\n";
   return str;
}

///////////////////

personInMenu(idx)
{
   for(i=0; i<level.players.size; i++)
   {  
      plr = level.players[i];
      
      if(isAlive(plr) && self != plr && isDefined(plr.objectiveMenuOption) && plr.objectiveMenuOption == idx)
         return true;
   }
   return false;
}

intCoords(coordinates)
{
   return (int(coordinates[0]),int(coordinates[1]),int(coordinates[2]));
}

