init()
{
 // precache shaders
 
   precacheShader("hud_icon_sticky_grenade");         // radio
   precacheShader("hud_icon_molotov");        // at ammo
   precacheShader("hud_icon_tabun_gasgrenade");         // support ammo
   
   precacheString(&"BRM2_WAYPOINT_NCO");
   precacheString(&"BRM2_WAYPOINT_OFFICER");
   precacheString(&"BRM2_WAYPOINT_RADIOMAN");
   precacheString(&"BRM2_WAYPOINT_MORTAR");
   precacheString(&"BRM2_WAYPOINT_HEAVYMG");
   precacheString(&"BRM2_WAYPOINT_LIGHTMG");
   precacheString(&"BRM2_WAYPOINT_ANTITANK");
 
   
}


setup()
{
   
   if(self.hasArtyBinoculars || self.hasNcoBinoculars || game["bromode"])
   {
      self setclientdvars("waypointIconHeight","20",
                     "waypointIconWidth","20",
                     "waypointOffscreenPadLeft", "0",
                     "waypointOffscreenPadBottom", "55",
                     "waypointOffscreenPointerDistance", "14",
                     "waypointOffscreenPointerHeight", "8",
                     "waypointOffscreenPointerWidth", "12");

   }
   else if(self.isAMedic)
   {
      self setclientdvars("waypointIconHeight","15",
                     "waypointIconWidth","15",
                     "waypointOffscreenPadLeft", "0",
                     "waypointOffscreenPadBottom", "55",
                     "waypointOffscreenPointerDistance", "14",
                     "waypointOffscreenPointerHeight", "8",
                     "waypointOffscreenPointerWidth", "12");
                     
      return;
   
   }
   else
   {
      self setclientdvars("waypointIconHeight","18",
                     "waypointIconWidth","18",
                     "waypointOffscreenPadLeft", "0",
                     "waypointOffscreenPadBottom", "55",
                     "waypointOffscreenPointerDistance", "14",
                     "waypointOffscreenPointerHeight", "8",
                     "waypointOffscreenPointerWidth", "12");

   }
   
   if(game["bromode"])
      return;
   
   if(self.hasArtyBinoculars || self.hasNcoBinoculars)
      self.helpPointsShader = "hud_icon_sticky_grenade";
   else if(self hasWeapon("support_ammo_mp"))
      self.helpPointsShader = "hud_icon_tabun_gasgrenade";
   else if(self hasWeapon("at_ammo_mp"))
      self.helpPointsShader = "hud_icon_molotov";
   else
      self.helpPointsShader = "hud_icon_flare";
   
   if(!isdefined(self.helpPoints))                  
      self.helpPoints = [];
   
   for ( index = 0; index < 1; index++ ) 
	{
		if ( !isDefined( self.helpPoints[index] ) )
			self.helpPoints[index] = newClientHudElem( self );

		self.helpPoints[index].x = 0;
		self.helpPoints[index].y = 0;
		self.helpPoints[index].z = 0;
		self.helpPoints[index].alpha = 0;
		self.helpPoints[index].archived = false;
		self.helpPoints[index] setShader( self.helpPointsShader, 14, 14 );
		
		self.helpPoints[index].font = "default";
      self.helpPoints[index].fontscale = 1.6; //2.0;
      self.helpPoints[index].fontstyle3d = "shadowedmore";
      self.helpPoints[index].glowcolor = (1, 1, 1);
      self.helpPoints[index].glowalpha = 1;
      self.helpPoints[index].font3duseglowcolor = 1;

		if(self.hasArtyBinoculars || self.hasNcoBinoculars)
         self.helpPoints[index].color = (0.93,0.17,0.17);
      else if(self hasWeapon("at_ammo_mp") || self hasWeapon("support_ammo_mp"))
         self.helpPoints[index].color = (0.99, 0.77, 0.32);
      else
         self.helpPoints[index].color = (0.14, 0.14, 1);

	//	self.helpPoints[index].color = (0.14, 0.14, 1);
		self.helpPoints[index] setWaypoint( false );
	}
	
//	self thread testLimit();

   if(self.hasArtyBinoculars || self.hasNcoBinoculars)
      self thread lookForRadio();
   else if(self hasWeapon("arty_radio_mp"))
      self thread lookForOfficer(); 
   else if(self hasWeapon("support_ammo_mp"))
      self thread lookForSupport();
   else if(self hasWeapon("at_ammo_mp"))
      self thread lookForAntiTank();
}

testLimit()
{
   for ( index = 0; index < 1024; index++ ) 
	{

      helpPoints[index] = newClientHudElem( self );

		helpPoints[index].alpha = 1;
		helpPoints[index].archived = false;
		
		println("## Count: " + index);
		wait 0.05;

	}
}

hudCleanup()
{
   if(!isDefined(self.helpPoints))
      return;
      
   for(i=0; i < self.helpPoints.size; i++)
   {
      if(isDefined(self.helpPoints[i]))
         self.helpPoints[i] destroy();
   }
   
}

lookForRadio()
{
   self endon("killed_player");
	self endon("spawned");
	self endon("new_loadout");
	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	self endon("perks_hidden");
	
	self.helpPointTarget = self;
	self thread markTarget();
	
	wait 0.5;
	
   while(1)
   {
      closest = 0;
      target = self;
      
      if(self GetCurrentWeapon() == "binoculars_mp")
      {

         for(i=0; i<level.players.size; i++)
         {
            plr = level.players[i];
            
            if(plr.pers["team"] == self.pers["team"] &&
            plr != self &&
            isAlive(plr) && 
            plr hasWeapon("arty_radio_mp"))
            {
               dist = DistanceSquared( self.origin, plr.origin );
               
               if(closest == 0 || dist < closest)
               {  
                  closest = dist;
                  target = plr;
               }
            }
         }
      }
      self.helpPointTarget = target;

      wait 3;
   }
}


lookForOfficer()
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
   self endon("death_or_disconnect");
	level endon("intermission");
	self endon("new_loadout");
	level endon("game_ended");
	self endon("perks_hidden");
	self.helpPointTarget = self;
	self thread markTarget();
	
	wait 0.5;
	
   while(1)
   {
      closest = 0;
      target = self;
      
      if(self GetCurrentWeapon() == "arty_radio_mp")
      {

         for(i=0; i<level.players.size; i++)
         {
            plr = level.players[i];
            
            if(plr.pers["team"] == self.pers["team"] &&
            plr != self &&
            isAlive(plr) && 
            (plr.hasArtyBinoculars ||
            plr.hasNcoBinoculars))
            {
               dist = Distance2D( self.origin, plr.origin );
               
               if(closest == 0 || dist < closest)
               {  
                  closest = dist;
                  target = plr;
               }
            }
         }         
      }
      self.helpPointTarget = target;

      wait 3;
   }
}

lookForSupport()
{
 //  self endon("killed_player");
	self endon("spawned");
	//self endon("disconnect");
	self endon("death_or_disconnect");
	level endon("intermission");
	self endon("new_loadout");
	self endon("perks_hidden");
	level endon("game_ended");
	
	self.helpPointTarget = self;
	self.helpPointTargetDistance = 4900;
	
	self thread markTarget();
	self thread maps\mp\gametypes\_rearming::watchSupportHandler("support");
	
	wait 0.5;
	
   while(1)
   {
      closest = 0;
      target = self;
        
      if(self GetCurrentWeapon() == "support_ammo_mp")
      {
         for(i=0; i<level.players.size; i++)
         {
            plr = level.players[i];

            if(plr.pers["team"] == self.pers["team"] &&
            plr != self &&
            isAlive(plr) && 
            (plr.pers["curClass"] == "lmg" || plr.pers["curClass"] == "hmg"))
            {
               dist = DistanceSquared( self.origin, plr.origin );
               
               if(closest == 0 || dist < closest)
               {  
                  closest = dist;
                  target = plr;    
               }
            }
         }
 
        
      }
    //  self iprintln("targeting: " + target.name);
      self.helpPointTarget = target;
      
      if(closest > 0 && closest < 4900)
         self.helpPointTargetDistance = closest;
      else
         self.helpPointTargetDistance = 4900;

      wait 0.3;
   }  
}

lookForAntiTank()
{
 ///  self endon("killed_player");
	self endon("spawned");
	//self endon("disconnect");
	self endon("death_or_disconnect");
	level endon("intermission");
	self endon("perks_hidden");
	level endon("game_ended");
	self endon("new_loadout");
	
	self.helpPointTarget = self;
	self.helpPointTargetDistance = 4900;
	
	self thread markTarget();
	self thread maps\mp\gametypes\_rearming::watchSupportHandler("at");
	
	wait 0.5;
	
   while(1)
   {
      closest = 0;
      target = self;
      
      if(self GetCurrentWeapon() == "at_ammo_mp")
      {
         for(i=0; i<level.players.size; i++)
         {
            plr = level.players[i];
            
            if(plr.pers["team"] == self.pers["team"] &&
            plr != self &&
            isAlive(plr) && 
            (plr.pers["curClass"] == "antitank" || isDefined(plr.mortar)))
            {
               dist = DistanceSquared( self.origin, plr.origin );
               
               if(closest == 0 || dist < closest)
               {  
                  closest = dist;
                  target = plr;
               }
            }
         }
      }

      self.helpPointTarget = target;

      if(closest > 0 && closest < 4900)
         self.helpPointTargetDistance = closest;
      else
         self.helpPointTargetDistance = 4900;

      wait 0.3;
   }  
}

markTarget()
{
 //  self endon("killed_player");
	self endon("spawned");
	self endon("new_loadout");
//	self endon("disconnect");
	self endon("death_or_disconnect");
	level endon("intermission");
	level endon("game_ended");
	self endon("perks_hidden");
	
	currentTarget = undefined;
	
   while(1)
   {      
      if(self.helpPointTarget != self && isDefined(self.helpPointTarget.origin) && isAlive(self.helpPointTarget))
      {      
         if(!isDefined(currentTarget) || currentTarget != self.helpPointTarget)
         {
            self.helpPoints[0] setWaypoint( true, self.helpPointsShader);
            
            
            if(self.hasArtyBinoculars || self.hasNcoBinoculars)
               self.helpPoints[0].alpha = 1; 
            else
               self.helpPoints[0].alpha = 0.8;   
            
            self.helpPoints[0] SetTargetEnt( self.helpPointTarget );
     
            if(self.helpPointTarget.hasArtyBinoculars)
               self.helpPoints[0].label = &"BRM2_WAYPOINT_OFFICER";
               
            else if(self.helpPointTarget.hasNcoBinoculars)
               self.helpPoints[0].label = &"BRM2_WAYPOINT_NCO";
               
            else if(self.helpPointTarget hasWeapon("arty_radio_mp"))
               self.helpPoints[0].label = &"BRM2_WAYPOINT_RADIOMAN";
               
            else if(isDefined(self.helpPointTarget.mortar) || self.helpPointTarget hasWeapon("mortar_mp"))
               self.helpPoints[0].label = &"BRM2_WAYPOINT_MORTAR";
               
            else if(self.helpPointTarget.pers["curClass"] == "lmg")
               self.helpPoints[0].label = &"BRM2_WAYPOINT_LIGHTMG";
               
            else if(self.helpPointTarget.pers["curClass"] == "hmg")
               self.helpPoints[0].label = &"BRM2_WAYPOINT_HEAVYMG";
               
            else if(self.helpPointTarget.pers["curClass"] == "antitank")
               self.helpPoints[0].label = &"BRM2_WAYPOINT_ANTITANK";
            else
               self.helpPoints[0].label = &"";
               
            currentTarget = self.helpPointTarget;
         }
      }
      else
      {  
         self.helpPoints[0] fadeOverTime( 0.25 );
         self.helpPoints[0].alpha = 0;
         self.helpPoints[0] setWaypoint( false );
         self.helpPoints[0] ClearTargetEnt();
         currentTarget = undefined;
      }
      
      wait 0.1;
   }
}

