#include maps\mp\_utility;

precache()
{
   precacheString(&"BRM2_RUNNING_PROMPT");  // Stay crouched when moving!
   precacheString(&"BRM2_PUNISH_RUNNING");  // ^1You have been punished for Running
}

runMonitor()
{
   self endon("death_or_disconnect");
   self endon("spawned");

   if(!level.scr_limit_run)
      return;

   curOrigin = self.origin;
   
   if(!isDefined(self.totalRunTime))
      self.totalRunTime = 0;
   else
      self.totalRunTime = level.scr_run_interval * 10;
   
   self.RunPunished = false;
   
   if( !isDefined( self.moveScaleDefault ) )
      self.moveScaleDefault = 1;
      
   if(!isDefined(self.pers["RunViolations"]))
      self.pers["RunViolations"] = 0;

   if( !isDefined( self.runMonitorHud ) )
   { 
      self.runMonitorHud = newClientHudElem(self);
      self.runMonitorHud.horzAlign = "center";
      self.runMonitorHud.vertAlign = "top";
      self.runMonitorHud.x = 0;
      self.runMonitorHud.y = 30;
      self.runMonitorHud.alignX = "center";
      self.runMonitorHud.alignY = "top";
      self.runMonitorHud.font = "default";
      self.runMonitorHud.fontscale = 1.8;
      self.runMonitorHud.archived = false;
   }
   
   self.runMonitorHud setText(&"");
   
   while(1)
   {
       wait (0.1);
       
      if ( self.origin != curOrigin  && self getStance() == "stand" && self depthInWater() < 20 && self isOnGround() && !self playerAds() &&!self IsOnLadder() && !self IsMantling()) 
      {
         if( self.totalRunTime < (level.scr_run_interval * 30) )
            self.totalRunTime += 3;

         if ( self.totalRunTime > (level.scr_run_interval * 30) )
            self.totalRunTime = (level.scr_run_interval * 30);             
      }
      else if(self.totalRunTime > 0)
      {
         self.totalRunTime--;
      }

      if( self.totalRunTime <= (level.scr_run_interval * 10) && !self.RunPunished)
      {
         self.runMonitorHud.color = (1,1,1);
         self.runMonitorHud setText(&"");
      }
      else if( self.totalRunTime <= 2 )
      {
         self.RunPunished = false;
         self.totalRunTime = 0;
         self setMoveSpeedScale( self.moveScaleDefault );
         self.runMonitorHud setText(&"");
      } 
      else if( self.totalRunTime >= (level.scr_run_interval * 30) || self.RunPunished)
      {
         if(self getstance() == "stand")
         self execClientCommand( "gocrouch" );

         self.runMonitorHud.color = (1,1,1);
         self.runMonitorHud setText( &"BRM2_PUNISH_RUNNING" );

         self.RunPunished = true;    

         if( level.scr_limit_run == 1)
         {
            self setMoveSpeedScale( self.moveScaleDefault / 2 );
         }
         else if (level.scr_limit_run == 2) // punish player somehow
         { 
            self.pers["RunViolations"]++;  

            //
            // Prepare for logging to identify repeat offenders who may need further admin attention
            //

            self.totalRunTime = level.scr_run_interval * 22; // cut down to avoid this loop repeating constantly

            lpselfnum  = self getEntityNumber();
            lpselfname = self.name;
            lpselfguid = self getGuid(); 

            switch ( self.pers["RunViolations"] )
            {
               case 2:
                  self iPrintLnBold("^1Seriously.... Running Allowed for only a FEW SECONDS!!");
                  self iPrintLnBold("^2You need to ^3STAY^2 crouched until penalty time has passed");
                  iprintln("^1" + self.name + " thinks he is Forrest Gump");       
                  self freezeControls( true );
                  wait (1.5);
                  self freezeControls( false );
                  wait (1.0);
                  break;

               case 3:
                  self iPrintLnBold("Limited Running is Auto-Enforced on this server!!");
                  self iPrintLnBold("^1This is ^2NOT^1 a joke.... Run allowed for a couple of seconds ONLY!!");
                  self iPrintLnBold("^2Not ^3STAYING^2 crouched during penalty time increases penalties");
                  iprintln("^1" + self.name + " is trying to beat Usain Bolt");   
                  self freezeControls( true );
                  wait (2.5);  
                  self freezeControls( false );
                  wait (1.5);
                  break;

               case 4:
                  self iPrintLnBold("Limited Running is Auto-Enforced on this Server!!");
                  self iPrintLnBold("^2Next Penalty ^3WILL^2 Be Auto Kick");
                  iprintln("^1 Poor " + self.name + " ran himself to death.....");
                  logPrint( "RUN;" + lpselfguid + ";" + lpselfnum + ";" +  lpselfname + "; ran himself to death\n" ); 
                  wait (0.5);
                  self suicide();         
                  break;

               case 5:
                  self iPrintLnBold("You were ^1WARNED^7 about Limited Running!!");
                  self iPrintLnBold("^2You are ^3NOW^2 being ^1KICKED^2!!  Say goodnight Gracy");
                  self iprintln("^1" + self.name + " is being Kicked for excessive running");  
                  logPrint( "RUN;" + lpselfguid + ";" + lpselfnum + ";" +  lpselfname + "; Kicked for excessive running\n" ); 
                  wait (3.0);
                  self iPrintLnBold("Goodnight Gracy");
                  wait (0.5);
                  kick(self getEntityNumber());
                  break; 

               default:
                  self iPrintLnBold("^1Running Allowed only for a FEW SECONDS");
                  self iPrintLnBold("Move Crouched Now and Rest!! ^2Move Crouched 99 percent of the Time");
                  iprintln("^1" + self.name + " is running");
                  wait (1.5);
            }

            self.RunPunished = false;
         }
      }
      else if( self.totalRunTime > (level.scr_run_interval * 15))
      {
         if ( !self.RunPunished )
         {
            self.runMonitorHud setText( &"BRM2_RUNNING_PROMPT" );
            t = (level.scr_run_interval * 15);
            c =  1 - ((1 / t) * (self.totalRunTime - t));
            
            if(c < 0.5)
            {
               c1 = c * 2;
               c2 = 0;
            }
            else
            {
               c1 = 1;
               c2 = c * c;
            }
            self.runMonitorHud.color = (1,c1,c2);
         }
      }

      curOrigin = self.origin;
   }
}