#include maps\mp\_utility;

//============//
// SD Threads //
//============//

sd_give_bomb()
{
   // Gives SD bomb to a random player instead of them picking up the bomb
   // Snipers are last choice - pick another class first.
   
   level endon("game_ended");
   
   alreadyPaused = false;
   sniperIdx = 0;
   supportArr = 0;
   otherIdx = 0;   
   sniperArr = [];
   supportArr = [];
   otherArr = [];
   
   for ( index = 0; index < self.visuals.size; index++ )
	{			
			self.visuals[index] hide();
	}
	self.trigger.origin = self.trigger.origin + (0,0,-400);
		
	self.curOrigin = self.trigger.origin;
	
   if(level.inPrematchPeriod == true) wait level.prematchPeriod;
   
  // if(!isdefined(level.sdBomb)) { iprintln("^1Returning"); return; }
   
   arrayBuilt = false;
   
   while(arrayBuilt == false)
   {
      sniperIdx = 0;
      supportIdx = 0;
      otherIdx = 0;   
      sniperArr = [];
      supportArr = [];
      otherArr = [];
   
      players = get_players();
      
      while(players.size == 0) { wait 0.1; players = get_players(); }
     
     // if(alreadyPaused == true) wait 1;
     // else { alreadyPaused = true; wait 7; iprintln("waiting 2");}
      
      wait 1;
      
      players = get_players();
      
      if(players.size == 0) { continue; }
      
      for (i = 0; i < players.size; i++)
      {
         //iprintln(players[i].name + " " +game[game["attackers"]] + " " + game["attackers"]);
         if((players[i].sessionstate == "playing")&&(players[i].pers["team"] == game["attackers"]))
         {
            if(isDefined(players[i].pers["curClass"]) && players[i].pers["curClass"] == "sniper")
            {
               sniperArr[sniperIdx] = players[i];
               sniperIdx++;
               arrayBuilt = true;
            }
            else if((isDefined(players[i].pers["curClass"]) && players[i].pers["curClass"] == "lmg") || (isDefined(players[i].pers["curClass"]) && players[i].pers["curClass"] == "hmg"))
            {
               supportArr[supportIdx] = players[i];
               supportIdx++;
               arrayBuilt = true;
            } 
            else
            {
               otherArr[otherIdx] = players[i];
               otherIdx++; 
               arrayBuilt = true;
            }
            
            // iprintln("Found Player: " + players[i].name + " Team: " + players[i].pers["team"] + " Class: " + players[i].pers["curClass"]);
         }
      }
           
      
   }

   choiceArray = [];
   
   if(otherArr.size > 0) { pickedId = randomInt(otherArr.size);  choiceArray = otherArr; }
   else if (supportArr.size > 0) { pickedId = randomInt(supportArr.size ); choiceArray = supportArr; }
   else  { pickedId = randomInt(sniperArr.size ); choiceArray = sniperArr; }
 //  else return; if(sniperArr.size > 0)
   
   
   //pickedId = randomInt(choiceArray.size);
 //  iprintln(pickedId + " Player: " + choiceArray[pickedId].name);
 
 //  choiceArray[pickedId] enableWeapons();
   wait 0.1;
   playerOrigin = choiceArray[pickedId].origin + (0,0,20);
   
      for ( index = 0; index < self.visuals.size; index++ )
		{
			self.visuals[index].origin = playerOrigin;
			
			self.visuals[index] show();
		}
		self.trigger.origin = playerOrigin;
		
		self.curOrigin = self.trigger.origin;
}

sd_startRoundDamagePrevention()
{
   level endon("game_ended");
   
   if(getdvar("g_gametype") != "sd")
      game["allowdamage"] = true;
   
   else
   {
      game["allowdamage"] = false;
   
      startTime = getdvarint("bro_sd_startDamagePrevention");
      
      if(startTime > 1)
      {
         timer = 0;
         
         while(timer < startTime)
         {
            timer++;
            wait 1;
         }    
      //   iprintln("Allowing Damage");
         game["allowdamage"] = true;
      }
      else
      {
         game["allowdamage"] = true;
      }  
   }
}

modifyScoreWeightings(gt)
{
   maps\mp\gametypes\_rank::registerScoreInfo( "win", 2 );
	maps\mp\gametypes\_rank::registerScoreInfo( "loss", 1 );
	maps\mp\gametypes\_rank::registerScoreInfo( "tie", 1.5 );
	maps\mp\gametypes\_rank::registerScoreInfo( "headshot", 3);
	
	if(isDefined(gt) && gt == "ret")
	{
      if(getdvar("bro_ret_scoreMod_kill") == "") setdvar("bro_ret_scoreMod_kill",50);
      if(getdvar("bro_ret_scoreMod_capture") == "") setdvar("bro_ret_scoreMod_capture",100);
      if(getdvar("bro_ret_scoreMod_assist") == "") setdvar("bro_ret_scoreMod_assist",25);
      
      maps\mp\gametypes\_rank::registerScoreInfo( "kill", getdvarint("bro_ret_scoreMod_kill") );	
      maps\mp\gametypes\_rank::registerScoreInfo( "capture", getdvarint("bro_ret_scoreMod_capture") );
      
      assistPoints = getdvarint("bro_ret_scoreMod_assist");
         
      maps\mp\gametypes\_rank::registerScoreInfo( "assist_75", assistPoints );
      maps\mp\gametypes\_rank::registerScoreInfo( "assist_50", assistPoints );
      maps\mp\gametypes\_rank::registerScoreInfo( "assist_25", assistPoints );
      maps\mp\gametypes\_rank::registerScoreInfo( "assist", assistPoints );
      return;
	}
		
   if(getdvar("bro_sd_scoreMod_kill") == "") setdvar("bro_sd_scoreMod_kill",50);
   if(getdvar("bro_sd_scoreMod_plant") == "") setdvar("bro_sd_scoreMod_plant",100);
   if(getdvar("bro_sd_scoreMod_defuse") == "") setdvar("bro_sd_scoreMod_defuse",100);
   if(getdvar("bro_sd_scoreMod_assist") == "") setdvar("bro_sd_scoreMod_assist",25);
   
	maps\mp\gametypes\_rank::registerScoreInfo( "kill", getdvarint("bro_sd_scoreMod_kill") );	
	maps\mp\gametypes\_rank::registerScoreInfo( "plant", getdvarint("bro_sd_scoreMod_plant") );
	maps\mp\gametypes\_rank::registerScoreInfo( "defuse", getdvarint("bro_sd_scoreMod_defuse"));	
	
	assistPoints = getdvarint("bro_sd_scoreMod_assist");
		
	maps\mp\gametypes\_rank::registerScoreInfo( "assist_75", assistPoints );
	maps\mp\gametypes\_rank::registerScoreInfo( "assist_50", assistPoints );
	maps\mp\gametypes\_rank::registerScoreInfo( "assist_25", assistPoints );
	maps\mp\gametypes\_rank::registerScoreInfo( "assist", assistPoints );

}