#include maps\mp\_utility;

init()
{   
   if(mfDvars("bro_mortardisable",0,"int") != 0)
      level.noDelployableMortars = true;
   else  
      level.noDelployableMortars = false;
      
   if(mfDvars("bro_atweaponsdisable",0,"int") != 0)
      level.noATWeapons = true;
   else  
      level.noATWeapons = false;
   
   weaponTags();
   
   level thread squadWatcher();
   level thread classWatcher("allies");
   level thread classWatcher("axis");
   
   if(getdvarint("bro_tint_smokegrenades") > 0)
   {
      level.smokeGrenade["allies"] = "m8_green_smoke_mp";
      level.smokeGrenade["axis"] = "m8_red_smoke_mp";
   }
   else
   {
      
      level.smokeGrenade["allies"] = "m8_white_smoke_mp";  
      level.smokeGrenade["axis"] = "m8_white_smoke_mp";
   }
    
   if(!isDefined(game["squadsystem"]))
      game["squadsystem"] = [];
          
   else if(game["squadsystem"]["setup"] == true)
   {
      return;
   }
   
   level._tempWeaponArray = [];
   level._tempWeaponidxArray = [];
    
   game["squadsystem"]["alliessquads"] = 0;
   game["squadsystem"]["axissquads"] = 0;
   game["squadsystem"]["maxplayers"] = 14;
      
   setupSquads("allies");
   setupSquads("axis");
   
   if(getdvarint("bro_tint_smokegrenades") > 0)
   {
      addWeapon("m8_red_smoke_mp");
      addWeapon("m8_green_smoke_mp");
   }
   else
   {
      addWeapon("m8_white_smoke_mp");
   }
   
   addWeapon("bayonet_mp");  
   
   if(level.gametype == "sd" || level.gametype == "esd")  
      addWeapon("bomb_drop_mp");  
   
   if(level.gametype == "ret")
      addWeapon("radio_drop_mp");
      
   addWeapon("satchel_charge_mp");  
   addWeapon("binoculars_mp");
   addWeapon("m2_flamethrower_mp");
   addWeapon("arty_radio_mp");
   addWeapon("mine_bouncing_betty_mp");
   addWeapon("firemode_mp");
   addWeapon("mgcarry_mp");
   addWeapon("357magnum_mp");
   
   if(isdefined(level.fortbhc2_initialized))
   {
      addWeapon("dp28_bipod_mp");
   }
   
   addWeapon(maps\mp\gametypes\_weapons::factionGrenade(game["allies"]));
   addWeapon(maps\mp\gametypes\_weapons::factionGrenade(game["axis"]));
   
   addWeapon(maps\mp\gametypes\_weapons::factionPistol(game["allies"]));
   addWeapon(maps\mp\gametypes\_weapons::factionPistol(game["axis"]));
      
   game["squadsystem"]["weapons"] = level._tempWeaponidxArray;

   level._tempWeaponidxArray = [];
   level._tempWeaponArray = [];
 
   game["squadsystem"]["setup"] = true;  
}

setupSquads(team)
{
   if(!isDefined(game["squadsystem"][team]))
   {
      game["squadsystem"][team] = [];
      game["squadsystem"][team]["squadplayers"] = [];
      game["squadsystem"][team]["classactive"] = [];
      game["squadsystem"][team]["classdisabled"] = [];
   }
   
   switch(game[team])
   {
      case "marines":
         squads\_americanconfig::americanSquads(team);
         
         game["squadsystem"][team + "_grenadetype"] = 0;
         break;
      case "russian":
         squads\_russianconfig::russianSquads(team);
         
         game["squadsystem"][team + "_grenadetype"] = 2;
         break;
      case "german":
         squads\_germanconfig::germanSquads(team);
         
         game["squadsystem"][team + "_grenadetype"] = 1;
         
         break;
      case "japanese":
         squads\_japaneseconfig::japaneseSquads(team);
         
         game["squadsystem"][team + "_grenadetype"] = 3;
         break;
      default:
         squads\_americanconfig::americanSquads(team);
        
         game["squadsystem"][team + "_grenadetype"] = 1;
   }
  
   for(i=1;i<=5; i++)
   {
      if(!isdefined(game["squadsystem"][team]["squadplayers"][i]))
         game["squadsystem"][team]["squadplayers"][i] = 0;
      
      if(isdefined(game["squadsystem"][team]["active"][i]) && game["squadsystem"][team]["active"][i] == 1)
         game["squadsystem"][team + "squads"]++;
      else
         break;
      
      printLn(team + " Squads #"+i);
      
      game["squadsystem"][team]["classactive"][i] = []; 
      game["squadsystem"][team]["classdisabled"][i] = []; 
      lastLoadout = 0;
      
      classOffset = 0;
      
      for(y=0; y < game["squadsystem"][team][i]["classdetails"].size; y++)
      {     
         if(!isdefined(game["squadsystem"][team]["classdisabled"][i][y]))
            game["squadsystem"][team]["classdisabled"][i][y] = 0;
            
         if(!isdefined(game["squadsystem"][team]["classactive"][i][y]))
            game["squadsystem"][team]["classactive"][i][y] = 1;
                
         
         if(isdefined(game["squadsystem"][team][i]["classdetails"][y]["primaries"]))
         {
            weapons = StrTok(game["squadsystem"][team][i]["classdetails"][y]["primaries"],",");    
            lastLoadout = y;
         }
         else
         {
            if(isdefined(game["squadsystem"][team][i]["classdetails"][lastLoadout]["primaries"]))
               weapons = StrTok(game["squadsystem"][team][i]["classdetails"][lastLoadout]["primaries"],",");  
            else
               weapons[0] = "4";
         }
         
         extras = [];
         
         if(isdefined(game["squadsystem"][team][i]["classdetails"][y]["extras"]))
         {
            extras = StrTok(game["squadsystem"][team][i]["classdetails"][y]["extras"],",");
         }
            
         for(z=0;z<weapons.size;z++)
         {  
            weap = int(weapons[z]);
            
            if(weap == 44 && level.noDelployableMortars)
            {
               game["squadsystem"][team]["classactive"][i][y] = 0;
               game["squadsystem"][team]["classdisabled"][i][y] = 1;
               println("## BRM DEBUG: disabling Mortar Weapon in " + team + " Squad #" + i +" class #" + y);
               break;
            }
            
            if((weap == 2 || weap == 17) && level.noATWeapons)
            {
               println("## BRM DEBUG: disabling AT Weapon in " + team + " Squad #" + i +" class #" + y);
               game["squadsystem"][team]["classactive"][i][y] = 0;
               game["squadsystem"][team]["classdisabled"][i][y] = 1;;
               continue;
            }    
              
            if(isdefined(level.squadSystemWeapons[weap]))
            {
               game["squadsystem"][team]["primaries"][i][y][z] = weap;
               
               addWeapon(weap);
              
               
               if(isdefined(extras[z]) && extras[z] != " ")
                  game["squadsystem"][team]["extras"][i][y][z] = int(extras[z]);
               else
                  game["squadsystem"][team]["extras"][i][y][z] = 0;     
            }
            else
               break;
         }
         
         if(!isdefined(game["squadsystem"][team][i]["classdetails"][y]["frag"]))
            game["squadsystem"][team][i]["classdetails"][y]["frag"] = game["squadsystem"][team][i]["classdetails"][lastLoadout]["frag"];
         
         if(!isdefined(game["squadsystem"][team][i]["classdetails"][y]["smoke"]))
            game["squadsystem"][team][i]["classdetails"][y]["smoke"] = game["squadsystem"][team][i]["classdetails"][lastLoadout]["smoke"];
            
         if(!isdefined(game["squadsystem"][team][i]["classdetails"][y]["secondary"]))
            game["squadsystem"][team][i]["classdetails"][y]["secondary"] = game["squadsystem"][team][i]["classdetails"][lastLoadout]["secondary"];
         
         if(game["squadsystem"][team][i]["classdetails"][y]["secondary"] == "")
            game["squadsystem"][team][i]["classdetails"][y]["secondary"] = "-1";
            
         if(game["squadsystem"][team][i]["classdetails"][y]["secondary"] == "1" && isdefined(level.squadSystemSecondary[game[team]]))
            game["squadsystem"][team]["secondary"][i][y] = level.squadSystemSecondary[game[team]];
         else
            game["squadsystem"][team]["secondary"][i][y] = 0;
      }
   }
}

squadWatcher()
{
   level endon("game_ended");
   level endon("comp_map_restarting");
   data = [];
   wait 0.1;
   
   while(1)
   {
      data["allies"] = [];
      data["axis"] = [];
      
      for (i = 0; i < level.players.size; i++)
      {
         if(isdefined(level.players[i].pers["team"]) && (level.players[i].pers["team"] == "allies" || level.players[i].pers["team"] == "axis") && isdefined(level.players[i].pers["chosensquad"]))
         {
            if(!isdefined(data[level.players[i].pers["team"]][level.players[i].pers["chosensquad"]]))
            {
               data[level.players[i].pers["team"]][level.players[i].pers["chosensquad"]] = 1;
            }
            else
            {
               data[level.players[i].pers["team"]][level.players[i].pers["chosensquad"]]++;
            }
         }   
      } 
      
      for(i=1; i<=game["squadsystem"]["alliessquads"]; i++)
      {
         if(isdefined(data["allies"][i]))
            game["squadsystem"]["allies"]["squadplayers"][i] = data["allies"][i];
         else
            game["squadsystem"]["allies"]["squadplayers"][i] = 0;
      }
      
      for(i=1; i<=game["squadsystem"]["axissquads"]; i++)
      {
         if(isdefined(data["axis"][i]))
            game["squadsystem"]["axis"]["squadplayers"][i] = data["axis"][i];
         else
            game["squadsystem"]["axis"]["squadplayers"][i] = 0;
      }
      
      wait 1;   
   }
}

classWatcher(team)
{
   level endon("game_ended");
   level endon("comp_map_restarting");
   
   level._squadWatcherData[team] = [];
      
   wait 0.2;
     
   if(team == "axis")
      wait 0.2;
   
   while(1)
   {
     // level._squadWatcherData[team] = [];
      
      for(i=1; i <= game["squadsystem"][team + "squads"]; i++)
      {
         level._squadWatcherData[team][i] = [];
      }
      
      for (i = 0; i < level.players.size; i++)
      {
         plr = level.players[i];
         
         if(isDefined(plr.pers["team"]) && plr.pers["team"] == team)
         {
            if(isdefined(plr.pers["chosensquad"]) && isdefined(plr.pers["chosenclass"]))
            {
               level._squadWatcherData[team][plr.pers["chosensquad"]][plr.pers["chosenclass"]] = plr;  
            }
         } 
      }
         
      for(i=1; i <= game["squadsystem"][team + "squads"]; i++)
      {
         for(y=0; y < game["squadsystem"][team][i]["classdetails"].size; y++)
         { 
            if((isdefined(level._squadWatcherData[team][i]) && isdefined(level._squadWatcherData[team][i][y]) ) || game["squadsystem"][team]["classdisabled"][i][y] == 1)
            {
               game["squadsystem"][team]["classactive"][i][y] = 0;               
            }
            else
            {
               game["squadsystem"][team]["classactive"][i][y] = 1;   
            }     
         }
      }
      wait 10;  
   }
}

menuLoad()
{
   self endon("disconnect");
   self endon("squadselected");
   team = self.pers["team"];
 
   self setclientdvars("ui_maxnum_squads",game["squadsystem"][team + "squads"]);
   
   wait 0.05;
                  
   for(i=1;i<=game["squadsystem"][team + "squads"]; i++)
   {
      if(game["squadsystem"][team]["active"][i] == 1)
      {
      
         squadcount = game["squadsystem"][team]["squadplayers"][i];
                 
         self setclientdvars("ui_squad" + i + "_players","(" + squadcount + "/" + game["squadsystem"][team][i]["classdetails"].size + ")",
                           "ui_squad" + i + "_active",1,
                           "ui_squadname_" + i, game["squadsystem"][team][i]["name"]);
                        
      }
      else
      {
         self setclientdvars("ui_squad" + i + "_players","",
                           "ui_squad" + i + "_active",0,
                           "ui_squadname_" + i, game["squadsystem"][team][i]["name"]);
      }
   }
     
   if(isDefined(self.pers["loadoutsubmitted"]))
   {
      self.pers["tempsquad"] = self.pers["chosensquad"];
      self.pers["tempclass"] = self.pers["chosenclass"];
      self.pers["tempweapon"] = self.pers["chosenweapon"];
      
      squad = self.pers["chosensquad"];
      class = self.pers["chosenclass"];
      weapon = self.pers["chosenweapon"];
      
      for(i=1;i<=game["squadsystem"][team + "squads"]; i++)
      {
         if(game["squadsystem"][team]["active"][i] == 1)
            self setclientdvars("ui_squad" + i + "_players","(" + game["squadsystem"][team]["squadplayers"][i] + "/" + game["squadsystem"][team][i]["classdetails"].size + ")");
      }
      
      self setClientDvars("ui_selectedSquadName",game["squadsystem"][team][squad]["name"],
                        "ui_maxnum_classes",game["squadsystem"][team][squad]["classdetails"].size,
                        "ui_maxnum_primaries",0,
                        "ui_selectedWeapon",99);

      self thread refreshAvailClasses(squad, false);
      
      for(i=0; i < game["squadsystem"][team][squad]["classdetails"].size; i++)
      {

         self setclientdvars("ui_className_" + i,game["squadsystem"][team][squad]["classdetails"][i]["name"]); 

         if(i == class)
            self setclientdvars("ui_classactive_" + i,1);
         else
            self setclientdvars("ui_classactive_" + i,game["squadsystem"][team]["classactive"][squad][i]);    
         
         wait 0.05;
      }
   
      self setclientdvars("ui_selectedSquad", squad);
      
      self setclientdvars("ui_selectedClass", class);
      
      
      self setclientdvars("ui_className",game["squadsystem"][team][squad]["classdetails"][class]["name"]);
   
      for(i=0; i<game["squadsystem"][team]["primaries"][squad][class].size; i++)
      {
         self setclientdvars("ui_primary_" + i, game["squadsystem"][team]["primaries"][squad][class][i]);
         wait 0.05;
      }
         
      self setclientdvars("ui_maxnum_primaries",game["squadsystem"][team]["primaries"][squad][class].size);
      
      self setclientdvars( // "ui_selectedWeapon",game["squadsystem"][team]["primaries"][squad][class][weapon],
                     "ui_selectedWeapon",weapon,
                           "ui_hassecondary",int(game["squadsystem"][team]["secondary"][squad][class]),
                           "ui_numfrags",int(game["squadsystem"][team][squad]["classdetails"][class]["frag"]),
                           "ui_numsmokes",int(game["squadsystem"][team][squad]["classdetails"][class]["smoke"]),
                           "ui_extras", int(game["squadsystem"][team]["extras"][squad][class][weapon]));
                           
    //  self setClientDvars("ui_selectedWeapon",self.pers["chosenweapon"]);
  //    self setClientDvars("ui_selectedWeapon",game["squadsystem"][team]["primaries"][squad][class][weapon]);
   }
   else
   {
      self.pers["show_player_names"] = false;
      self setclientdvars("ui_squadmenu_shownames",0);
   }
   
   wait 0.05;
   self setclientdvars("ui_grenadetype",game["squadsystem"][team + "_grenadetype"]);
}

squad_select(response)
{
   self notify("squadselected");
   self endon("squadselected");
   self endon("disconnect");
   
   
   team = self.pers["team"];
   selected = int(getsubstr(response,12));
   
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {
      self.pers["chosensquad"] = selected;
      
      if(!isdefined(self.pers["previoussquad"]))
      {
         self.pers["previoussquad"] = selected; 
      }
   }
   else
   {
      self.pers["tempsquad"] = selected;
   }
   
   self setclientdvars("ui_selectedSquad", 0);
   self setclientdvars("ui_selectedClass", 999);
   
   self setClientDvars("ui_selectedSquadName",game["squadsystem"][team][selected]["name"],
                        "ui_maxnum_classes",game["squadsystem"][team][selected]["classdetails"].size,
                        "ui_maxnum_primaries",0,
                        "ui_selectedWeapon",99);
 
   self thread displayNames(selected);
   
   for(i=0; i < game["squadsystem"][team][selected]["classdetails"].size; i++)
   {
      self setclientdvars("ui_className_" + i,game["squadsystem"][team][selected]["classdetails"][i]["name"]); 
 
      self setclientdvars("ui_classactive_" + i,game["squadsystem"][team]["classactive"][selected][i]);    
      
      wait 0.05;
   }
   
   self setclientdvars("ui_selectedSquad", selected);
   
   self thread refreshAvailClasses(selected, false);
}

refreshAvailClasses(selectedsquad, once)
{
   self endon("squadselected");
   self endon("kill_squad_thread");
   self endon("disconnect");
   self endon("spawned");
   
   team = self.pers["team"];
   
   while(1)
   {
      self thread displayNames(selectedsquad);
      for(i=0; i < game["squadsystem"][team][selectedsquad]["classdetails"].size; i++)
      { 
         if(isdefined(self.pers["chosensquad"]) && isdefined(self.pers["chosenclass"]))
         {
            if(i == self.pers["chosenclass"] && self.pers["chosensquad"] == selectedsquad)
               self setclientdvars("ui_classactive_" + i,1);    
            else
               self setclientdvars("ui_classactive_" + i,game["squadsystem"][team]["classactive"][selectedsquad][i]);
         }
         else
         {       
            self setclientdvars("ui_classactive_" + i,game["squadsystem"][team]["classactive"][selectedsquad][i]);
         }

         wait 0.1;
      }
         
      for(i=1;i<=game["squadsystem"][team + "squads"]; i++)
      {
         if(game["squadsystem"][team]["active"][i] == 1)
         {
            squadcount = game["squadsystem"][team]["squadplayers"][i];
            
            self setclientdvars("ui_squad" + i + "_players","(" + squadcount + "/" + game["squadsystem"][team][i]["classdetails"].size + ")",
                           "ui_squad" + i + "_active",1);
         }
         else
         {
            self setclientdvars("ui_squad" + i + "_players","",
                           "ui_squad" + i + "_active",0);
         }
      }
         
      wait 0.4;
      
      if(once == true)
         break;
   }
}

class_select(response)
{
   self endon("disconnect");
   
   team = self.pers["team"];

   selected = int(getsubstr(response,12));
   
   self setclientdvars("ui_squadmenu_shownames",0);
   
   self.pers["show_player_names"] = false;
   
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {
      if(isdefined(self.pers["chosenclass"]))
         game["squadsystem"][team]["classactive"][self.pers["previoussquad"]][self.pers["chosenclass"]] = 1;
        
      self.pers["chosenclass"] = selected;
      self.pers["previoussquad"] = self.pers["chosensquad"];
      selectedsquad = self.pers["chosensquad"];
      
      game["squadsystem"][team]["classactive"][selectedsquad][selected] = 0;
      
      if(game["squadsystem"][team]["classactive"][self.pers["previoussquad"]][selected] == 0 && isDefined(level._squadWatcherData[team][self.pers["previoussquad"]][selected]) && level._squadWatcherData[team][self.pers["previoussquad"]][selected] != self)
      {
         self setclientdvars("ui_classactive_" + selected,0);
         return;
      }
   }
   else
   {
      if(!isdefined(self.pers["tempsquad"]))
         self.pers["tempsquad"] = self.pers["chosensquad"];
         
      selectedsquad = self.pers["tempsquad"];
      self.pers["tempclass"] = selected;
         
      if(game["squadsystem"][team]["classactive"][self.pers["tempsquad"]][selected] == 0 && !(self.pers["tempsquad"] == self.pers["chosensquad"] && self.pers["chosenclass"] == selected))
      {
         self setclientdvars("ui_classactive_" + selected,0);
         self iprintln("^1Class not active");
         return;
      }
   }   
   /*
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {   
      if(isdefined(self.pers["chosenclass"]))
         game["squadsystem"][team]["classactive"][self.pers["previoussquad"]][self.pers["chosenclass"]] = 1;
        
      self.pers["chosenclass"] = selected;
      self.pers["previoussquad"] = self.pers["chosensquad"];
      selectedsquad = self.pers["chosensquad"];
      
      game["squadsystem"][team]["classactive"][selectedsquad][selected] = 0;
   }
   else
   {
      selectedsquad = self.pers["tempsquad"];
      self.pers["tempclass"] = selected;
   }
  */
   self setclientdvars("ui_selectedClass", selected,
                        "ui_maxnum_primaries",0,
                        "ui_selectedWeapon",99);
   
   self setclientdvars("ui_className",game["squadsystem"][team][selectedsquad]["classdetails"][selected]["name"]);
   
   for(i=0; i<game["squadsystem"][team]["primaries"][selectedsquad][selected].size; i++)
   {
      self setclientdvars("ui_primary_" + i, game["squadsystem"][team]["primaries"][selectedsquad][selected][i]);
      wait 0.05;
   }
      
   self setclientdvars("ui_maxnum_primaries",game["squadsystem"][team]["primaries"][selectedsquad][selected].size);
   
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {
      self.pers["chosenweapon"] = 0;
   }
   else
   {
      self.pers["tempweapon"] = 0;
   }
   
   self setclientdvars( //"ui_selectedWeapon",game["squadsystem"][team]["primaries"][selectedsquad][selected][0],
                  "ui_selectedWeapon",0,
                        "ui_hassecondary",int(game["squadsystem"][team]["secondary"][selectedsquad][selected]),
                        "ui_numfrags",int(game["squadsystem"][team][selectedsquad]["classdetails"][selected]["frag"]),
                        "ui_numsmokes",int(game["squadsystem"][team][selectedsquad]["classdetails"][selected]["smoke"]),
                        "ui_extras", int(game["squadsystem"][team]["extras"][selectedsquad][selected][0]));
}

weapon_select(response)
{
   weapon = int(getsubstr(response,13));
   
   team = self.pers["team"];
   
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {
      selectedsquad = self.pers["chosensquad"];
      selectedclass = self.pers["chosenclass"];
      self.pers["chosenweapon"] = weapon;
   }
   else
   {  
      selectedsquad = self.pers["tempsquad"];
      selectedclass = self.pers["tempclass"];
      self.pers["tempweapon"] = weapon;
   }
   
   self setclientdvars( //"ui_selectedWeapon",game["squadsystem"][team]["primaries"][selectedsquad][selectedclass][weapon],
                  "ui_selectedWeapon",weapon,
                        "ui_extras", int(game["squadsystem"][team]["extras"][selectedsquad][selectedclass][weapon]));
}

displayNames(squad)
{
   self endon("squadselected");
   
   if(!isDefined(self.pers["show_player_names"]))
      self.pers["show_player_names"] = false;
      
   if(!isDefined(squad))
      return;
      
   if(!self.pers["show_player_names"])
      return;
      
   team = self.pers["team"];

   for(i=0; i < 14; i++)
   {
      if(isDefined(level._squadWatcherData[team][squad]) && isDefined(level._squadWatcherData[team][squad][i]))
         self setclientdvars("ui_squadmenu_name_" + i,level._squadWatcherData[team][squad][i].name);
      else
         self setclientdvars("ui_squadmenu_name_" + i,"");
         
      wait 0.05;
   } 
}

showNames()
{
   self.pers["show_player_names"] = true;
   
   self setclientdvars("ui_squadmenu_shownames",1);
   
   if(isDefined(self.pers["chosensquad"]))
      self thread displayNames(self.pers["chosensquad"]);
}

hideNames()
{
   self.pers["show_player_names"] = false;
   
   self setclientdvars("ui_squadmenu_shownames",0);
}

weaponTags()
{
   for( i = 0; i <= 44; i++ )
	{
		weapon_name = tablelookup( "mp/weapondata.csv", 0, i, 5 );
		
		if(weapon_name != "")
         level.squadSystemWeapons[i] = weapon_name;	
         
   }
   
   level.squadSystemSecondary["marines"] = 4;
   level.squadSystemSecondary["german"] = 32;
   level.squadSystemSecondary["russian"] = 27;
   level.squadSystemSecondary["japanese"] = 16;   
}

addWeapon(weapId)
{
   if(!isDefined(level.squadSystemWeapons[weapId]))
   {
      level._tempWeaponArray[weapId] = true;
      level._tempWeaponidxArray[level._tempWeaponidxArray.size] = weapId;
   }
   else if(!isDefined(level._tempWeaponArray[level.squadSystemWeapons[weapId]]))
   {
      level._tempWeaponArray[level.squadSystemWeapons[weapId]] = true;
      level._tempWeaponidxArray[level._tempWeaponidxArray.size] = level.squadSystemWeapons[weapId];
      
      // get variants

      weapon_attachments = tablelookup( "mp/weapondata.csv", 0, weapId, 6 );

      if(weapon_attachments != "")
      {
         attachments = strtok(weapon_attachments," ");
         
         baseWeap = getSubStr(level.squadSystemWeapons[weapId],0,level.squadSystemWeapons[weapId].size - 2);
              
         for(i=0; i < attachments.size; i++)
         {
            w = baseWeap + attachments[i] + "_mp";
            level._tempWeaponArray[w] = true;
            level._tempWeaponidxArray[level._tempWeaponidxArray.size] = w;
         }
      }
   }
}

loadout_confirm()
{
   prevSquad = undefined;
   
   if(!isDefined(self.pers["loadoutsubmitted"]))
   {
      selectedsquad = self.pers["chosensquad"];
      selectedclass = self.pers["chosenclass"];
      selectedweapon = self.pers["chosenweapon"];
   }
   else
   {  
      selectedsquad = self.pers["tempsquad"];
      selectedclass = self.pers["tempclass"];
      selectedweapon = self.pers["tempweapon"];
      prevSquad = self.pers["chosensquad"];
   }
   
   if(!isdefined(selectedweapon))
   {
      return;
   }

   self notify("squadselected");
   
   team = self.pers["team"];
   
   posWeapon = game["squadsystem"][team]["primaries"][selectedsquad][selectedclass][selectedweapon];
   
   if(isdefined(level.squadSystemWeapons[posWeapon]))
   {
      if(!isDefined(self.pers["loadoutsubmitted"]))
         self.pers["loadoutsubmitted"] = true;
      else
      {
       // this lot needs sorting out - need previous vars for class as well as squad
         if(isdefined(self.pers["chosenclass"]))
            game["squadsystem"][team]["classactive"][selectedsquad][self.pers["chosenclass"]] = 1;
      
         game["squadsystem"][team]["classactive"][self.pers["previoussquad"]][self.pers["chosenclass"]] = 1;
               
         self.pers["previousclass"] = selectedclass;
         self.pers["previoussquad"] = selectedsquad;
         self.pers["chosenclass"] = selectedclass;
         self.pers["chosenweapon"] = selectedweapon;
         self.pers["chosensquad"] = selectedsquad;
         
         game["squadsystem"][team]["classactive"][selectedsquad][selectedclass] = 0;
      }
         
      self.selectedClass = true;
      self [[level.class]](level.squadSystemWeapons[posWeapon]);
      
   //  self maps\mp\gametypes\_handlesquads::classSelected(prevSquad, self.pers["chosensquad"]);
   //  createsquad(self);
     //iprintln("Created Squad");
 //    iprintln(getplayersquad(self));
 //   iprintln(getplayersquadid(self));
     
	}
}

resetClass()
{
   if(isdefined(self.pers["chosenclass"]) && isdefined(self.pers["chosensquad"]))
   {
      if(self.pers["team"] == "allies")
         team = "axis";
      else
         team = "allies";
      
      if(game["squadsystem"][team]["squadplayers"][self.pers["chosensquad"]] > 0)
         game["squadsystem"][team]["squadplayers"][self.pers["chosensquad"]]--;
      
      game["squadsystem"][team]["classactive"][self.pers["chosensquad"]][self.pers["chosenclass"]] = 1;
   }   
   
   self.pers["loadoutsubmitted"] = undefined;
   self.pers["previoussquad"] = undefined;
   self.pers["chosensquad"] = undefined;
   self.pers["chosenclass"] = undefined;
   self.pers["chosenweapon"] = undefined;
   self.pers["tempsquad"] = undefined;
   self.pers["tempclass"] = undefined;
   self.pers["tempweapon"] = undefined;

}
