#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;

doSupplyDrop(position)
{
   level endon("game_ended");
    
   flightHeight = 2400;
   
   fallrate = 100; // units / second;
   
   team = self.pers["team"];
   
   trace = bullettrace( position + (0,0,10000), position + (0,0,-3000), false, undefined );
   
   if(level.checkSkyCap)
   {
      pos = (position[0], position[1], trace["position"][2] - 514);
      pos = bullettrace(pos, pos + (0,0,-10000), false, undefined);
      tracepos = pos["position"];
   }
   else
      tracepos = trace["position"];

   dropPoint = tracepos + (0,0,flightHeight);
   
   self iprintlnbold(&"MSBRM_SUPPLIES_INBOUND");
   
   dir = randomint(360);
   
   wait 10;
   
   thread flyPlane(dropPoint, dir, team);
   
   wait 10.5;
         
   weaponDrop = spawn( "script_model", (0,0,0) );
   weaponDrop setModel( "clutter_okinawa_prchute_drpbox" );
   
   supplyBox = spawn( "script_model", (0,0,0) );
   supplyBox setModel( "static_berlin_wood_ammobox_04" );
   
   weaponDrop.origin = dropPoint;
   supplyBox.origin = weaponDrop.origin;
   
   supplyBox linkto(weaponDrop,"tag_origin",(0,0,-5),(0,0,0));
   
   weaponDrop moveTo(tracepos + (0,0,5),(flightHeight / fallrate));
   
   weaponDrop.dropping = true;
   
   weaponDrop thread randomSpin();
      
   weaponDrop waittill("movedone");
   
   weaponDrop rotateto(weaponDrop.angles,0.05);
   
   weaponDrop.dropping = false;
 
   supplyBox unlink();
   
   supplyBox playSound( "supply_crate_drop" );
   
   supplyBox thread watchRearm();
   
   weaponDrop delete();  
}

flyPlane(dropPoint, dir, team)
{
   dir = 0;
   
   level endon("game_ended");
   
   cosVal = cos(dir);
   sinVal = sin(dir);
   
   flightLength = 50000;
   flightTime = 20;
   
   curveDeviation = 10000;
   
   scaleFactor = curveDeviation / ((flightLength / 2) * (flightLength / 2));
   
   flightPoints = [];
   
   if(cosVal < 0.001 && cosVal > -0.001)
   {
      xVar = 0;
      yVar = flightLength;
   }
   else
   {
      xVar = flightLength * cosVal;
      yVar = flightLength * (sinVal);
   }
   
   height = 350;
   flightSector = flightLength / 40;
   
   origin = dropPoint;
   
   for(i=0;i<20; i++)
   {
      xdist = flightSector * (-1 * (19-i));
      
      flightPoints[i] = ( xdist,(xdist * xdist * scaleFactor),height) + origin;    
   }
   wait 0.1;
   
   flightPoints[20] = flightPoints[19] + (flightSector, 0,0);
   
   for(i=0;i<20; i++)
   {
      xdist = flightSector * (i + 2);
      
      flightPoints[i + 21] = ((xdist + origin[0]),flightPoints[19-i][1], height + origin[2]); 
   }
      
   startPoint = flightPoints[0]; 

   if(!isdefined(level.supplyPlane[team]))
   {
      level.supplyPlane[team] = spawn( "script_model",startPoint);      
   }
   
   level.supplyPlane[team] setModel(level.plane[team]);
      
   level.supplyPlane[team].origin = startPoint;
   
   level.supplyPlane[team].angles = (0,( (-1 * dir) - 30),-30);
   
   level.supplyPlane[team] show();
     
   pause = flightTime / flightPoints.size;
   
   level.supplyPlane[team] thread play_loop_sound_on_entity( "ambient_corsair" );
   
   level.supplyPlane[team] rotateYaw(60,flightTime);
   
   for(i=0; i<flightPoints.size; i++)
   {
      level.supplyPlane[team] moveto(flightPoints[i], pause );
  //    println(flightPoints[i][0] + "," + flightPoints[i][1]);      
      wait (pause );
   }

   level.supplyPlane[team] notify ( "stop sound" + "ambient_corsair" );
   level.supplyPlane[team] hide();
}

watchRearm()
{  
   self.supplies["clips"] = level.supplyBox["clips"];
   self.supplies["support"] = level.supplyBox["support"];
   self.supplies["antitank"] = level.supplyBox["antitank"];
   self.supplies["grenades"] = level.supplyBox["grenades"];
   self.supplies["smokes"] = level.supplyBox["smokes"];
   self.supplies["medkits"] = level.supplyBox["medkits"];
   
   self.alive = true;
   
   trig = spawn("trigger_radius", self.origin, 0, level.supplyBoxRadius, 50);
  // trig.special = "supplybox";

 //  self thread watchForEmpty();
   
   while(self.alive)
   {
      trig waittill("trigger",player);
      
      if(!isdefined(player.standingNrBox) && !isdefined(self.medicTarget))
      {
         player thread watchPlayerRearm(self);     
      }
   }
   
   trig delete();
}

checkEmpty()
{
/*
   while(self.supplies["clips"] > 0 || self.supplies["support"] > 0 || self.supplies["antitank"] > 0 ||  self.supplies["medkits"] > 0)
   {
     // iprintln("Supplies: Clips: " + self.supplies["clips"] + " Support: " + self.supplies["support"] + " Anti-tank: " + self.supplies["antitank"]);
      wait 0.2;
   }
   */
   
   if(self.supplies["clips"] > 0 
      || self.supplies["support"] > 0 
      || self.supplies["antitank"] > 0 
      ||  self.supplies["medkits"] > 0)
      return;
   
   self.alive = false;
   
   wait 0.2;
   
   self playsound("bulletspray_large_wood");
   playfx(level.supplyBoxDeath, self.origin);	
   
   wait 0.2;
   
   self delete();
}

watchPlayerRearm(box)
{
   self endon("player_killed");
   self endon("spawned");
   self endon("disconnect");
   
   self.standingNrBox = true;
   
   if(!isdefined(self.useBar))
      self.useBar = createPrimaryProgressBar();
   
   if(!isdefined(self.useBarText))
      self.useBarText = createPrimaryProgressBarText();
	
   useBar = self.useBar;
   useBarText = self.useBarText;
   
   rearmData = self GetRearmData(self getCurrentWeapon());
   
   self.curProgress = 0;

   useTime = rearmData[2];
   
   while(distance2D(self.origin,box.origin) < level.supplyBoxRadius && box.alive )
   {
      if(!isdefined(rearmData[0]) || rearmData[1] <=0)
      {
         self.useBar hideElem();
         self.useBarText hideElem();
         rearmData = self GetRearmData(self getCurrentWeapon());
         
         if(self ableToRearm(false))
         {
            self enableWeapons();
            self SetMoveSpeedScale(self.moveSpeedDefault);
            self AllowJump(true);
         }
      }
      else if(box.supplies[rearmData[5]] <= 0)
      {
         self.useBar hideElem();
         self.useBarText setText( &"BRM_NO_MORE_AMMO" );
         self.useBarText showElem();
         
         if(self ableToRearm(false))
         {
            self enableWeapons();
            self SetMoveSpeedScale(self.moveSpeedDefault);
            self AllowJump(true);
         }
      }
      else if(self useButtonPressed() && (self.curProgress < rearmData[2]) && ableToRearm(true))
      {
         self.useBar showElem();
         self.useBarText showElem();
         self.curProgress += 1;
         rate = useTime / (rearmData[2] / rearmData[1]);
         self.useBar updateBar( self.curProgress / useTime, rate);
         self.useBarText setText( &"BRM_REARMING" );  
         self disableWeapons();  
         self SetMoveSpeedScale(0);
         self AllowJump(false);
         
         if((self.curProgress % rearmData[4]) == 0)
         {
            self playLocalSound("ammo_pickup_plr");
                 
            box.supplies[rearmData[5]]--;
            
            if(rearmData[0] == "syrette_mp")
            {
               if(!self hasWeapon("syrette_mp"))
               {
                  self giveWeapon( "syrette_mp" );
                  self SetActionSlot(3,"weapon","syrette_mp");
                  self setWeaponAmmoClip( "syrette_mp", 1 );
               }
               else
               {
                  self setWeaponAmmoClip( "syrette_mp", self GetWeaponAmmoClip("syrette_mp") + 1);
               }
               self.totalRestorePoints += level.medicKitPoints;
            } 
            else if(rearmData[0] == "mortar_mp")
            {
               if(isDefined(self.mortarShells))
                  self.mortarShells += 3;
            }                 
            else if(self.weaponState[rearmData[0]]!="fullclip" && self.weaponState[rearmData[0]]!="single")
            {
               self maps\mp\gametypes\_magazines::modifyClips(1, rearmData[0], rearmData[3], true);
                             
               self.curStock[rearmData[0]] = rearmData[3] * (self.numFullClips[rearmData[0]] - 1);
           
               if(!isdefined(self.hasJam[rearmData[0]]) || self.hasJam[rearmData[0]] == false)            
                  self SetWeaponAmmoStock(rearmData[0], self.curStock[rearmData[0]] );
            }
            else
            {
               if(isdefined(self.hasJam[rearmData[0]]) && self.hasJam[rearmData[0]] == true) 
               {
                  self.jamAmmo[rearmData[0]] += rearmData[3];
               }
               else
               { 
                  curAmmo = self GetWeaponAmmoStock(rearmData[0]);   
                  self SetWeaponAmmostock(rearmData[0], (curAmmo + rearmData[3])); 
               }
            }
            
            if(rearmData[6] && box.supplies["smokes"] > 0)
            {
               box.supplies["smokes"]--;
               self SetWeaponAmmoClip( level.smokeGrenade[self.pers["team"]], 1 );
               rearmData[6] = false;
            }
            
            if(isdefined(rearmData[7]) && box.supplies["grenades"] > 0)
            {
               box.supplies["grenades"]--;
               if(!self HasWeapon(rearmData[7]))
               {
                  self GiveWeapon( rearmData[7] );
                  self SetWeaponAmmoClip( rearmData[7], 0 );
                  self SwitchToOffhand( rearmData[7] );             
               }
               self SetWeaponAmmoClip( rearmData[7], 1 );
               rearmData[7] = undefined;
            }
            
            box checkEmpty();
         } 
         
         if(self.curProgress >= useTime)
         {
            while(self useButtonPressed() && box.alive)
               wait 0.1;
         }
      }
      else
      {
         self.curProgress = 0;
         self.useBarText setText( &"BRM_PRESS_TO_REARM" );
         self.useBar hideElem();
         self.useBarText showElem();
         rearmData = self GetRearmData(self getCurrentWeapon());

         useTime = rearmData[2];
     
         if(self ableToRearm(false))
         {
            self enableWeapons();
            self SetMoveSpeedScale(self.moveSpeedDefault);
            self AllowJump(true);
         }
      }   
      wait 0.05;
   }
   
   if(self ableToRearm(false))
   {
      self enableWeapons();
      self SetMoveSpeedScale(self.moveSpeedDefault);
      self AllowJump(true);
   }

   if(!self.isBandaging)
   {
      useBar destroyElem();
      useBarText destroyElem();
   }
   self.standingNrBox = undefined;
}

GetRearmData(weapon)
{
   data = [];
   
   if(weapon == "none" || (!maps\mp\gametypes\_magazines::notSpecial(weapon) && weapon != "syrette_mp"))
      return data;
   
   data[0] = weapon;
   
   secsperClip = 1;
   
   if(weapon == "syrette_mp")
   {
      data[1] = WeaponClipSize(weapon) - self GetWeaponAmmoClip(weapon);
      
      data[2] = secsperClip * 20 * data[1];
      
      if(data[1] > 0)
         data[4] = int(data[2] / data[1]);
         
      
      data[3] = 20;
      data[5] = "medkits";
   }
   else
   {
      clipsize = WeaponClipSize(weapon);
      maxammo = WeaponMaxAmmo(weapon);
      
      if(isdefined(self.hasJam[weapon]) && self.hasJam[weapon]) 
         stock = self.jamAmmo[weapon];
      else
         stock = self GetWeaponAmmoStock(weapon);

      
      numClips = int(floor((maxAmmo - stock) / clipSize));
      data[1] = numClips;
      data[2] = secsperClip * 20 * numClips;
      data[3] = clipsize;
      
      if(data[1] > 0)
         data[4] = int(data[2] / data[1]);
     
      ammoType = maps\mp\gametypes\_mod_core::getWeaponClass(weapon);
      
      switch(ammoType)
      {
         case "hmg":
            data[5] = "support";
            break;
         case "antitank":
            data[5] = "antitank";
            break;
         default:
            data[5] = "clips";
            break;
      }
   }
   
   fragType = maps\mp\gametypes\_weapons::factionGrenade(game[self.pers["team"]]);
   
   if(self HasWeapon(level.smokeGrenade[self.pers["team"]]) && self GetWeaponAmmoClip(level.smokeGrenade[self.pers["team"]]) < 1)
      data[6] = true;  
   else
      data[6] = false;
      
   if(self HasWeapon(fragType) && self GetWeaponAmmoClip(fragType) > 0)
      data[7] = undefined;
   else
      data[7] = fragType;
     
   return data;
}

ableToRearm(ctchBleeding)
{
   if((isdefined(self.isPlanting) && self.isPlanting == true) || (isdefined(self.isDefusing) && self.isDefusing == true))
      return false;
   else if(self.isBandaging || self.fixingBayonet || self.switchingFireMode || (ctchBleeding && self.isBleeding) || self.isRearming)
      return false;
   else
      return true;
}

randomSpin() // WIBBLE! - was going to have a random decent but decided not to as too annoying for players
{
   while(self.dropping)
   {
      a = randomintrange(60,360);
      ta = (a*0.05);
      if(randomint(2) == 0)
         self rotateyaw(a,(a*0.18),ta,ta);
      else
         self rotateyaw((a * -1),(a*0.18),ta,ta);
   
      self waittill("rotatedone");    
   }
}

delete_on_death (ent)
{
	ent endon ("death");
	self waittill ("death");
	if (isdefined (ent))
		ent delete();
}

play_loop_sound_on_entity(alias, offset) // SP nickage ftw
{
	org = spawn ("script_origin",(0,0,0));
	org endon ("death");
	thread delete_on_death (org);
	if (isdefined (offset))
	{
		org.origin = self.origin + offset;
		org.angles = self.angles;
		org linkto (self);
	}
	else
	{
		org.origin = self.origin;
		org.angles = self.angles;
		org linkto (self);
	}

	org playloopsound (alias);
//	println ("playing loop sound ", alias," on entity at origin ", self.origin, " at ORIGIN ", org.origin);
	self waittill ("stop sound" + alias);

	org delete();
}